unit CAPRISupport;

interface

uses Controls, Windows, TRPCB, Forms, Messages, ActnMenus, ComCtrls, StdCtrls, Classes,
  CCOWRPCBrokerCAPRI,
  ShlObj, ActiveX, FMCntrls, DiTypLib,                                          //CodeCR129 - rpm 10/14/10
  SysUtils;
type
  TVerInfoType = (companyname, filedescription, fileversion, internalname,
    legalcopyright, legaltrademarks, originalfilename, productname, productversion, comments);
  TFMDateTime = Double;
  EFMDateTimeError = class(Exception);

const
  IconArray: array[0..5] of PChar = (
    IDI_APPLICATION,
    IDI_ASTERISK,
    IDI_EXCLAMATION,
    IDI_HAND,
    IDI_QUESTION,
    IDI_WINLOGO);

  InfoStr: array[TVerInfoType] of string = ('CompanyName', 'FileDescription', 'FileVersion', 'InternalName',
    'LegalCopyright', 'LegalTradeMarks', 'OriginalFileName', 'ProductName', 'ProductVersion', 'Comments');

function Piece(Const S: String; Delim: char; PieceNum: Integer = 1): String;
function IsPatchInstalled(aPatch: String): Boolean;

function CallRPC(BrokerConnection: TCCOWRPCBrokerCapri; RPC: string;
  callingParams: array of string; MultList: TStrings; IsReference: Boolean = False;
  TrapNoResults: Boolean = False; NoDisplayAndExitOnErrors: Boolean = True): boolean;
function BrokerErrorMessages(errorCode: integer; defString: string): string;
function GetVariableValue(Broker: TCCOWRPCBrokerCapri; varName: String; var retVal: String): Boolean; // CodeCR??? - LMS 2014-07-15

function GetVistATimestampUTC(Broker: TCCOWRPCBrokerCapri): String;             // CodeCR568 - LMS 2014-07-15  At the server midnight, the security code expires, so using this timestamp to handle the expiration.
function GetXusUserInfo: TStringList;

function ConvertCalendarDateToDelphiDate(DateTimeST: String): String;
function FMDateTimeConvert(DateTimeST: String): String;
function FMDateTimeConvert2(DateTimeST: String): String;
function FMDateTimeConvert3(DateTimeST: String): String;
function FMEditFilePrepare(Sender: TObject): boolean;
function FMFile: boolean;
function FMToDateConvert(DateTimeST: String): String;
function FMTimeConvert(FMTimeSt: String): String;

function FMDateTimeToDateTime(ADateTime: TFMDateTime): TDateTime;
function MakeFMDateTime(const AString: string): TFMDateTime;


function GetMonthName(month: Integer): String;
function GetMonthNumber(month: Integer): String;

function GetWindowsDir: String;
function GetWindowsSysDir: String;

function OrListBoxSelectAll(Sender: TObject): boolean;

function IsSetFocusValid(aControl: TControl): Boolean;

procedure RecordAudit(auditMsg: String; auditType: String);
function GetVersionInfo(FileInfo: TVerInfoType): String; overload;
function GetVersionInfo(FileInfo: TVerInfoType; FileName: String): String; overload;

function GetSystemPath(Folder: Integer): String;                                //CodeCR129 - rpm 10/14/10
function SendNotification(MsgText: TStrings;
  SenderDUZ, Subject, MailGroup: String;
  RequestIEN: String = ''): Boolean;                                            //CodeCR266
function SendNotificationTwo(ExamIENs: TStrings;
  SenderDUZ: string;
  RequestIEN: String = ''): Boolean;                                            // CodeCR471 JRL 4/26/13
procedure GetExamResults(anIENS: string; anFMMemo: TFMMemo; aRichText: TRichEdit); //CodeCR319 - rpm 6/25/12

Function ActivateMenu(aForm: TForm; var Message: TWMMenuChar): Boolean;
procedure CapriQuickCopy(AFrom, ATo: TObject);


implementation

uses
  dialogs,
  Fmcmpnts,
  mfunstr,
  main,
  ORCtrls,
//  sysutils,
  pncsmain;

function FMDateTimeConvertDetail(DateTimeST: String; v: Integer): String;
var
  Code: Integer;
  DateInt: Integer;
  FMDate: String;
  fmMonth: Integer;
  fmYear: Integer;
  sgDay: String;
  sgMonth: String;
  sgTime: String;
  sgYear: String;
begin
  Result := '';
  if v < 1 then
    v := 1;
  if v > 3 then
    v := 3;
  DateTimeST := Trim(DateTimeST);
  if DateTimeST <> '' then
  begin
    sgDay := '';
    sgMonth := '';
    sgTime := '';
    sgYear := '';
    FMDate := Piece(DateTimeST, '.', 1);
    {validate Date string}
    Val(FMDate, DateInt, code);
    if (code = 0) and
      (DateInt >= 1000000) and
      (DateInt <= 9991231) then                                                 //valid
    begin
      {get year}
      Val(Copy(DateTimeST, 1, 3), fmYear, code);
      fmYear := fmYear + 1700;
      Str(fmYear, sgYear);

      {get month}
      Val(Copy(DateTimeST, 4, 2), fmMonth, code);
      if code <> 0 then
        fmMonth := 0;

      {get day}
      sgDay := Copy(DateTimeST, 6, 2);

      case v of
        1:                                                                      {Format:  JAN 01, 2001@12:35}
          begin
          {convert month}
            sgMonth := GetMonthName(fmMonth);
          {filter day}
            if sgDay = '00' then
              sgDay := ''
            else if sgDay[1] = '0' then
              sgDay := Copy(sgDay, 2, 1);
          {get time}
            sgTime := FMTimeConvert(Piece(DateTimeSt, '.', 2));

          {format result}
            if sgDay <> '' then
              Result := sgMonth + ' ' + sgDay + ', ' + sgYear
            else if Trim(sgMonth) <> '' then
              Result := sgMonth + ', ' + sgYear
            else
              Result := sgYear;
            if sgTime <> '' then
              Result := Result + '@' + sgTime;
          end;                                                                  {v = 1}
        2:                                                                      {Format: 01/01/2001@12:35}
          begin
          {convert month}
            sgMonth := GetMonthNumber(fmMonth);
          {get time}
            sgTime := FMTimeConvert(Piece(DateTimeSt, '.', 2));
          {format result}
            if sgTime <> '' then
              Result := sgMonth + '/' + sgDay + '/' + sgYear + '@' + sgTime
            else
              Result := sgMonth + '/' + sgDay + '/' + sgYear;
          end;                                                                  {v = 2}
        3:                                                                      {Format: 01/01/2001}
          begin
          {convert month}
            sgMonth := GetMonthNumber(fmMonth);
            Result := sgMonth + '/' + sgDay + '/' + sgYear;
          end;                                                                  {v = 3}
      end;                                                                      {case v}
    end                                                                         {valid FM DateTimeSt}
    else
      Result := DateTimeST;
  end;                                                                          {DateTimeSt <> ''}
end;

function GetMonthName(month: Integer): String;
var
  sgMonth: String;
begin
  case Month of
    1: sgMonth := 'JAN';
    2: sgMonth := 'FEB';
    3: sgMonth := 'MAR';
    4: sgMonth := 'APR';
    5: sgMonth := 'MAY';
    6: sgMonth := 'JUN';
    7: sgMonth := 'JUL';
    8: sgMonth := 'AUG';
    9: sgMonth := 'SEP';
    10: sgMonth := 'OCT';
    11: sgMonth := 'NOV';
    12: sgMonth := 'DEC';
  else                                                                          {default}
    sgMonth := '   ';
  end;
  Result := sgMonth;
end;

function GetMonthNumber(Month: Integer): String;
var
  sgMonth: String;
begin
  case Month of
    1: sgMonth := '01';
    2: sgMonth := '02';
    3: sgMonth := '03';
    4: sgMonth := '04';
    5: sgMonth := '05';
    6: sgMonth := '06';
    7: sgMonth := '07';
    8: sgMonth := '08';
    9: sgMonth := '09';
    10: sgMonth := '10';
    11: sgMonth := '11';
    12: sgMonth := '12';
  else                                                                          {default}
    sgMonth := '00';
  end;
  Result := sgMonth;
end;

function FMTimeConvert(FMTimeSt: String): String;
var
  Pad, Hours, Minutes: String;
  FMTimeInt, code: Integer;
begin
  Result := '';
  Val(FMTimeSt, FMTimeInt, code);
  if (code = 0) and (FMTimeInt > 0) then
  begin
    Pad := StringOfChar('0', 6);
    FMTimeSt := FMTimeSt + Copy(Pad, 1, 6 - Length(FMTimeSt));
    Hours := Copy(FMTimeSt, 1, 2);
    Minutes := Copy(FMTimeSt, 3, 2);
    Result := Hours + ':' + Minutes;
  end;
end;


function FMDateTimeToDateTime(ADateTime: TFMDateTime): TDateTime;
{ converts a Fileman date/time (type double) to a Delphi date/time }
var
  ADate, ATime: TDateTime;
  DateTimeStr, DatePart, TimePart: string;
begin
  DateTimeStr := FloatToStrF(ADateTime, ffFixed, 14, 6);
  DatePart := Piece(DateTimeStr, '.', 1);
  TimePart := Piece(DateTimeStr, '.', 2) + '000000';
  if Length(DatePart) <> 7 then
    raise EFMDateTimeError.Create('Invalid Fileman Date');
  if Copy(TimePart, 1, 2) = '24' then
    TimePart := '23595959';
  ADate := EncodeDate(StrToInt(Copy(DatePart, 1, 3)) + 1700,
    StrToInt(Copy(DatePart, 4, 2)),
    StrToInt(Copy(DatePart, 6, 2)));

  if TimePart = '000000000000' then                                             // rpk 5/26/2015
    ATime := 0.0                                                                // rpk 5/26/2015
  else                                                                          // rpk 5/26/2015
    ATime := EncodeTime(StrToInt(Copy(TimePart, 1, 2)),
      StrToInt(Copy(TimePart, 3, 2)),
      StrToInt(Copy(TimePart, 5, 2)), 0);
  Result := ADate + ATime;
end;

function IsFMDateTime(x: string): Boolean;
var
  i: Integer;
begin
  Result := False;
  if Length(x) < 7 then
    Exit;
  for i := 1 to 7 do
    if not (x[i] in ['0'..'9']) then
      Exit;
  if (Length(x) > 7) and (x[8] <> '.') then
    Exit;
  if (Length(x) > 8) and not (x[9] in ['0'..'9']) then
    Exit;
  Result := True;
end;

function MakeFMDateTime(const AString: string): TFMDateTime;
begin
  Result := -1;
  if (Length(AString) > 0) and IsFMDateTime(AString) then
    Result := StrToFloat(AString);
end;


function GetVistATimestampUTC(Broker: TCCOWRPCBrokerCapri): String;             // CodeCR570 - LMS 2014-07-15
begin
  if not GetVariableValue(Broker, '$ZDT($ZTS,3,7,3)', result) then
    Exception.Create('Error: Unable to get VistA server timestamp');
end;

function GetXusUserInfo: TStringList;
var
  FMGetsUserInfo: TFMGets;
  i: Integer;
begin
  Result := TStringList.Create;

  frmMain.RPCBroker1.Results.Clear;
  frmMain.RPCBroker1.Param.Clear;

  frmMain.RPCBroker1.RemoteProcedure := 'XUS GET USER INFO';
  frmMain.RPCBrokerCall;
  frmMain.RPCBroker1.Call;

  if frmMain.RPCBroker1.Results.Count > 0 then
    Result.Capacity := frmMain.RPCBroker1.Results.Count;

  for i := 0 to frmMain.RPCBroker1.Results.Count - 1 do
    Result.Insert(i, frmMain.RPCBroker1.Results[i]);

  FMGetsUserInfo := TFMGets.Create(Nil);
  FMGetsUserInfo.RPCBroker := frmMain.RPCBroker1;
  FMGetsUserInfo.FileNumber := '200';
  FMGetsUserInfo.FieldNumbers.Add('9');
  FMGetsUserInfo.IENS := Result[0];
  FMGetsUserInfo.GetData;

  if FMGetsUserInfo.Results.Count > 0 then
    Result.Insert(8, FMGetsUserInfo.GetField('9').FMDBExternal);
end;

function FMEditFilePrepare(Sender: TObject): boolean;
begin
  with Sender as TFMEdit do
  begin
    if FMModified then
      if Validate then
      begin
        frmMain.FMFiler1.AddChgdControl(Sender as TFMEdit);
        Text := FMCtrlExternal;
      end
      else
      begin
        frmMain.FMValidator1.DisplayErrors;
        Text := FMTag;
      end;
  end;

  result := true;
end;

function FMFile;
var
  probs: boolean;
begin
  result := false;
  probs := false;
  if frmMain.FMFiler1.AnythingToFile = false then
    exit;

  try
    if frmMain.FMFiler1.DataProblemCheck then
      probs := true;
  except
  end;

  if Probs = True then
    frmMain.FMFiler1.ProcessDataProblemList;

  if Probs = False then
    if frmMain.FMFiler1.Update then
    begin
      Result := True;
      //Do Stuff here if need to
    end
    else
      frmMain.FMFiler1.DisplayErrors;
end;

function Piece(Const S: String; Delim: char; PieceNum: Integer = 1): String;
{ returns the Nth piece (PieceNum) of a string delimited by Delim }
// Completely unnecessary redirect, without explanation. Should be removed. Probably a historical reason.
//  However it's spread out throughout CAPRI code in many uses clauses and conflicts with use of
//   the same named function in MFunStr where only S and Delim are specified in the call.
// So not so easy to remove. Hence to workaround, adding the default parameter values here as well to match MFunStr original function. No matter which unit's version gets called, result is identical.
// function Piece(x: string; del: string; piece1: integer = 1; piece2: integer=0) : string;

begin
  Result := MFunStr.Piece(S, Delim, PieceNum, PieceNum);
end;

function FMDateTimeConvert3(DateTimeST: String): String;
begin
  // Formats in mm/dd/yyyy but no time
  Result := FMDateTimeConvertDetail(DateTimeST, 3);
end;

function FMToDateConvert(DateTimeST: String): String;
var
  Month, Day, Year: String;
  Year2: String;
begin
  // Converts mm/dd/yyyy to a Fileman date
  Month := Copy(DateTimeSt, 1, Pos('/', DateTimeSt) - 1);
  DateTimeSt := Copy(DateTimeSt, Pos('/', DateTimeSt) + 1, 7);
  Day := Copy(DateTimeSt, 1, Pos('/', DateTimeSt) - 1);
  Year := Copy(DateTimeSt, Pos('/', DateTimeSt) + 1, 4);
  //if StrToInt(Year) < 20 then Year := '20' + year;
  //if ((StrToInt(Year) > 19) and (StrToInt(Year) < 100)) then Year := '19' + year;
  Year2 := Year[1] + Year[2] + '00';
  Result := IntToStr((StrToInt(Year2) - 1700) Div 100);
  Result := Result + Year[3] + year[4] + Month + Day;
end;

function FMDateTimeConvert2(DateTimeST: String): String;
begin
  // Formats in mm/dd/yyyy@tt:ss format
  Result := FMDateTimeConvertDetail(DateTimeST, 2);
end;

function FMDateTimeConvert(DateTimeST: String): String;
begin
  Result := FMDateTimeConvertDetail(DateTimeST, 1);
end;

function ConvertCalendarDateToDelphiDate(DateTimeST: String): String;
var
  Month, Day, Year: String;
begin
  Month := Uppercase(Piece(DateTimeST, ' ', 1));
  Day := Piece(Piece(DateTimeST, ' ', 2), ',', 1);
  Year := Piece(DateTimeST, ' ', 3);
  if Pos(Month, 'JAN') = 1 then
    Month := '01';
  if Pos(Month, 'FEB') = 1 then
    Month := '02';
  if Pos(Month, 'MAR') = 1 then
    Month := '03';
  if Pos(Month, 'APR') = 1 then
    Month := '04';
  if Pos(Month, 'MAY') = 1 then
    Month := '05';
  if Pos(Month, 'JUN') = 1 then
    Month := '06';
  if Pos(Month, 'JUL') = 1 then
    Month := '07';
  if Pos(Month, 'AUG') = 1 then
    Month := '08';
  if Pos(Month, 'SEP') = 1 then
    Month := '09';
  if Pos(Month, 'OCT') = 1 then
    Month := '10';
  if Pos(Month, 'NOV') = 1 then
    Month := '11';
  if Pos(Month, 'DEC') = 1 then
    Month := '12';
  if Length(Day) = 1 then
    Day := '0' + Day;
  Result := Month + '/' + Day + '/' + Year;
end;

function GetWindowsSysDir: String;
const
  (* The length of the directoy buffer. Usually 64 or even 32 is enough:)
  **
  ** Must be DWORD type.
  *)
  dwLength: WORD = 255;
var
  pcSysDir: PChar;
begin
  GetMem(pcSysDir, dwLength);
  GetSystemDirectory(pcSysDir, dwLength);
  Result := String(pcSysDir);
  FreeMem(pcSysDir, dwLength);
end;

function GetWindowsDir: String;
const
  (* The length of the directoy buffer. Usually 64 or even 32 is enough:)
  **
  ** Must be DWORD type.
  *)
  dwLength: WORD = 255;
var
  pcSysDir: PChar;
begin
  GetMem(pcSysDir, dwLength);
  GetWindowsDirectory(pcSysDir, dwLength);
  Result := String(pcSysDir);
  FreeMem(pcSysDir, dwLength);
end;

function OrListBoxSelectAll(Sender: TObject): boolean;
var
  ORListBox: TORListBox;
  x: integer;
begin
  Result := False;
  try
    if not (Sender is TORListBox) then
      Exit;
    ORListBox := TORListBox(Sender);
    if ORListBox.Items.Count = 0 then
      Exit;
    for x := 0 to (ORListBox.Items.Count - 1) do
      ORListBox.Selected[x] := True;
    Result := True;
  except
  end;
end;

function IsSetFocusValid(aControl: TControl): Boolean;
var
  tempControl: TControl;
begin
  Result := False;

  tempControl := AControl;
  while tempControl <> nil do
  begin
    if NOT tempControl.visible or NOT tempControl.Enabled then Exit;
    tempControl := tempControl.Parent
  end;

  Result := True;
end;

{=================================================================
 IsPatchInstalled
 This function determines whether a given patch is installed on
 the server or not.

 Input:  aPatch: String - patch identifier (ex. 'DVBA*2.7*142')
 Output: Returns TRUE when given patch is installed;
          otherwise returns FALSE
 rpm 9/30/09
 ================================================================}

function IsPatchInstalled(aPatch: String): Boolean;
begin
  Result := False;
  frmMain.RPCBroker1.RemoteProcedure := 'DVBA CHECK PATCH';
  frmMain.RPCBroker1.Param[0].PType := literal;     
  frmMain.RPCBroker1.Param[0].Value := aPatch;
  try
    frmMain.RPCBrokerCall;
    frmMain.RPCBroker1.Call;
    if frmMain.RPCBroker1.Results.Count > 0 then
      if piece(frmMain.RPCBroker1.Results[0], '^', 1) = '1' then
        Result := True;
  except
    Result := False;
  end;
end;

procedure RecordAudit(auditMsg: String; auditType: String);
var
  logName: String;
  logDate: String;
  logRecordIEN: String;
  auditFile: TextFile;
  appVersion: String;
begin
  DateTimeToString(logDate, 'dd_mm_yy', Date);
  appVersion := VersionUser;
  appVersion := StringReplace(appVersion, '*', '_', [rfReplaceAll]);
  logName := TempDir + 'CAPRI' + auditType + appVersion + '_' + logDate + '.Txt';
  logRecordIEN := '';
  Assign(auditFile, logName);

  try
    try
      if FileExists(logName) then
        Append(auditFile)
      else
        ReWrite(auditFile);
      if Assigned(PNCSForm) then
        logRecordIEN := PNCSForm.xFMEdit2.IENS;

      WriteLn(auditFile, DateTimeToStr(Now) + ':' + AuthorName
        + ':' + logRecordIEN
        + ':' + auditMsg);
    except
      on E: EInOutError do
      begin
        ShowMessage('Unable to create audit log entry: ' + E.Message);
      end;
    end;
  finally
    Flush(auditFile);
    Close(auditFile);
  end;
end;

{===========================================================================
 GetVersionInfo - overloaded
 This function returns file version info for a given info type and filename.

  Input:  FileInfo: TVerInfoType (ex. fileversion, internalname, etc.)
          FileName: String - full path name
 Output:  Returns the file version info as a string.

 rpm 2/4/10
 ===========================================================================}

function GetVersionInfo(FileInfo: TVerInfoType; FileName: String): String;
var
  VerInfoSize: DWORD;
  VerInfo: Pointer;
  LangCharStr, VerInfoStr: String;
  LangCharValueSize, VerValueSize: DWORD;
  LangCharValue: ^DWORD;
  VerValue: PChar;

  Dummy: DWORD;
begin
  Result := '';
  VerInfoSize := GetFileVersionInfoSize(PChar(FileName), Dummy);
  if VerInfoSize > 0 then
  begin
    VerInfo := AllocMem(VerInfoSize);
    try
      GetFileVersionInfo(PChar(FileName), 0, VerInfoSize, VerInfo);
      //retrieve the language-codepage
      if VerQueryValue(VerInfo, '\VarFileInfo\Translation', Pointer(LangCharValue), LangCharValueSize) then
        LangCharStr := IntToHex(LoWord(LangCharValue^), 4) + IntToHex(HiWord(LangCharValue^), 4)
      else
        LangCharStr := '040904E4';                                              //failover to US English

      VerInfoStr := 'StringFileInfo\' + LangCharStr + '\' + InfoStr[FileInfo];

      if VerQueryValue(VerInfo, PChar(VerInfoStr), Pointer(VerValue), VerValueSize) then
        Result := VerValue;
    finally
      FreeMem(VerInfo, VerInfoSize);
    end;
  end;
end;

{===========================================================================
 GetVersionInfo - overloaded
 This function returns the application's file version info for a given info type.

  Input:  FileInfo: TVerInfoType (ex. fileversion, internalname, etc.)
 Output:  Returns the file version info as a string.

 rpm 2/4/10
 ===========================================================================}

function GetVersionInfo(FileInfo: TVerInfoType): String;
begin
  Result := GetVersionInfo(FileInfo, Application.ExeName);
end;


{==============================================================================
 This corrects issues when using shortcut keys on menus on any sub forms
 launched from the main form.

 CAPRI_CodeCR96 - jcs - 03/16/10 - Comments below were from the original
 code borrowed from the Borland web site, leaving author's name to give credit.
 As an additional note, in order for the Windows message to trigger this event,
 the form must have the system menu enabled in the border icons option.

 Author: Aaron Murgatroyd

 Purpose:
   Alt+(x) shortcut keys were not working with TActaionMainMenuBar
   when there were no MDI Children. It was determined that for
   some reason (still unknown) the program was not recognising
   the accelerator characters on the menu item when there was no
   MDI Clients runnning.

   Therefore we need to intercept the WM_MENUCHAR message that
   Windows sends when an unhandled Menu Accelerator (Alt-x) is pressed and
   then emulate the menu activation ourselves. Because this
   message is not sent when the acllerator is handled, there is no
   need to make sure we dont have any MDI Clients running.

   Steps to complete this process include:

     1. Locate a TActionMainMenuBar component, if it is not
        found, then call inherited

     2. Scan through main menu items seeing if an AccelChar
        matches the char press, if not then call inherited

     3. Activate menu by calling the Keyed procedure and return
        1 in the Hi Order word of Result to indicate to windows
        that the key was handled so there are no annoying beeps
 ==============================================================================}

Function ActivateMenu(aForm: TForm; var Message: TWMMenuChar): Boolean;
Var iCounter: integer;
  cmiItem: TCustomMenuButton;
  mmbMain: TActionMainMenuBar;

  Function GetAccelChar(sString: String): Char;
  Var iPos: Integer;
  Begin
    iPos := Pos('&', sString);
    If (iPos = 0) OR (iPos = Length(sString)) Then
      Result := #0 Else Result := UpCase(sString[iPos + 1]);
  End;

begin
  Result := True;
  with aForm do
  begin
    // Step 1 - Locate a TActionMainMenuBar component
    mmbMain := nil;
    For iCounter := 0 To ComponentCount - 1 Do
      If Components[iCounter] IS TActionMainMenuBar Then
      Begin
        mmbMain := TActionMainMenuBar(Components[iCounter]);
        Break;
      End;

    If Assigned(mmbMain) Then
    Begin
      // Step 2 - Scan through main menu items
      iCounter := 0;
      Repeat
        If mmbMain.ActionControls[iCounter] IS TCustomMenuButton Then
        Begin
          cmiItem := TCustomMenuButton(mmbMain.ActionControls[iCounter]);
          If UpCase(Message.User) = GetAccelChar(cmiItem.Caption) Then
          Begin
            // Step 3 - Activate menu by calling the Keyed procedure
            cmiItem.Keyed;
            Message.Result := 1 SHL 16;
            Exit;
          End;
        End Else
          cmiItem := nil;
        Inc(iCounter);
      Until cmiItem = nil;
    End;
  end;
  Result := False;
End;

type
  QuickCopyError = class(Exception);


{===========================================================================
CAPRI_CodeCR101 - jcs - 05/02/2010
This is an exact copy of the CPRS Quickcopy that is currently used in CAPR.
However, CPRS made a change to the Quickcopy procedure that now causes
Quickcopy to hang for a substantial amount of time when a large quantity of
data is passed in to the procedure, specifically, when numerous reports
are ran in CAPRI. The offending lines of code have been commented out, below,
and do not alter functionality of the procedure.
===========================================================================}

procedure CapriQuickCopy(AFrom, ATo: TObject);
var
  ms: TMemoryStream;
  idx: integer;
  str: array[0..1] of TStrings;
  fix: array[0..1] of boolean;

  procedure GetStrings(obj: TObject);
  begin
    if (CompareText(obj.ClassName, 'TRichEditStrings') = 0) then
      raise QuickCopyError.Create('You must pass the TRichEdit object into QuickCopy, NOT it''s Lines property.');
    if obj is TStrings then
      str[idx] := TStrings(obj)
    else
      if obj is TMemo then
        str[idx] := TMemo(obj).Lines
      else
        if obj is TORListBox then
          str[idx] := TORListBox(obj).Items
        else
          if obj is TListBox then
            str[idx] := TListBox(obj).Items
          else
            if obj is TORComboBox then
              str[idx] := TORComboBox(obj).Items
            else
              if obj is TComboBox then
                str[idx] := TComboBox(obj).Items
              else
                if obj is TRichEdit then
                begin
                  with TRichEdit(obj) do
                  begin
                    str[idx] := Lines;
                    if not PlainText then
                    begin
                      fix[idx] := TRUE;
                      PlainText := TRUE;
                    end;
                  end;
                end
                else
                  raise QuickCopyError.Create('Unsupported object type (' + obj.ClassName +
                    ') passed into QuickCopy.');
    inc(idx);
  end;

begin
  fix[0] := FALSE;
  fix[1] := FALSE;
  idx := 0;
  GetStrings(AFrom);
  GetStrings(ATo);
  ms := TMemoryStream.Create;
  try
    str[0].SaveToStream(ms);
    ms.Seek(0, soFromBeginning);
    str[1].LoadFromStream(ms);
  finally
    ms.Free;
  end;
  if fix[0] then TRichEdit(AFrom).PlainText := FALSE;
  if fix[1] then TRichEdit(ATo).PlainText := FALSE;

  // jcs - Offending lines of code that cause a huge hang, there appears to be
  // an issue with the Length function with a large quantity of data.
  //  if ATo is TRichEdit then
  //    TRichEdit(ATo).SelStart := Length(TRichEdit(ATo).Lines.Text); //CQ: 16461
end;

{===========================================================================
CAPRI_CodeCR95  - jcs - 05/20/2010
Function to be used for making broker calls. The purpose is to wrap up the
RPC call into any easy to call method and trap any errors that may occur.

Input:
  BrokerConnection - This is the specific instance of the broker we are working with
  RPC - The RPC that we intended on calling
  callingParams - This is an array of strings that represent the paramters
    we are passing into the RPC. Normally this is a paramter list of 'literals'
  MultList - This is a 'list' of data that needs sent to the RPC.
  isReference - defaults to False. Set to true of the parameter passed in via
    callingParams is a reference to a variable on the M system.
  TrapNoResults - defaults to false. Normally this would be set to true to trap
    an instance where an RPC call returns no data after the RPC is completed when
    it should have returned data. There are instances where some RPCs return
    nothing even though it completed successfully.
  TrapErrors - defaults to True. Normally this function will trap any errors that
    occur, handle the error, and re-raise the error so it falls in the global
    error handler, which in turn forces a shut down. In the rare instance that
    would want to ignore an error and continue, this option allows for the error
    to be ignored, but at the same time return a false to indicate the RPC failed.
Output:
  Returns a boolean, True if the RPC was successfull, false if it failed.

===========================================================================}

function CallRPC(BrokerConnection: TCCOWRPCBrokerCapri; RPC: string;
  callingParams: array of string; MultList: TStrings; isReference: Boolean = False;
  TrapNoResults: Boolean = False; NoDisplayAndExitOnErrors: Boolean = True): boolean;
var
  i, j: integer;
  Msg: string;
  numstr: String;
begin
  result := False;

  Try
    frmMain.RPCBrokerCall;                                                      // if hardCoded on frmMain, then what's the point of passing in BrokerConnection
    with BrokerConnection do
    begin
      if (socket = -1) or (connected = false) then
        raise Exception.Create('No VistA server connection');

      Screen.Cursor := crHourglass;

      RemoteProcedure := RPC;

      if Length(callingParams) <> 0 then
        for i := 0 to High(callingParams) do
        begin
          Param[i].Value := callingParams[i];
          if isReference then Param[i].PType := Reference
          else Param[i].PType := Literal
        end;

      i := Param.Count;

      if MultList <> nil then
      begin
        for j := 0 to MultList.Count - 1 do
        begin
          numstr := IntToStr(j);
          Param[i].Mult[IntToStr(j)] := MultList[j];
//          Param[i].Mult[numstr] := MultList[j];
        end;
        Param[i].PType := List;
      end;

      //To easily test and ensure the code calling this function exits gracefully when
      //an error occurs, place a break here, and set CALLRPCErrorTest := True
      If CallRPCErrorTest = true then
        raise Exception.Create('CallRPC Mock Error Test');

      call;

      if TrapNoResults and (Results.Count = 0) then
        raise Exception.Create('Error: data was expected from a RPC call, but none was returned');

      result := True;
    end;                                                                        //end with block
  except
    on E: Exception do
    begin
      result := False;

        //if we choose to ignore the error, exit. Result will still be set to false
        //to indicate the RPC failed.
      If NoDisplayAndExitOnErrors = False then exit;

      Msg := 'RPC Broker Call: ' + RPC + #13#10;
      if e.ClassType = EBrokerError then
        Msg := Msg + BrokerErrorMessages((e as EBrokerError).Code, (e as EBrokerError).Mnemonic);
      e.Message := e.Message + #13#10 + 'Additional Info: ' + Msg;
      Screen.Cursor := crDefault;
      Raise
    end;
  end;                                                                          // End Try Block
  Screen.Cursor := crDefault;
end;

{===========================================================================
CAPRI_CodeCR95  - jcs - 05/20/2010
Function to obtain a readable version of the broker error if applicable.
===========================================================================}

function BrokerErrorMessages(errorCode: integer; defString: string): string;
begin
  case ErrorCode of
    10013: result := 'Winsock Error!' + #13 + 'Permission denied.';
    10048: result := 'Winsock Error!' + #13 + 'Address already in use.';
    10049: result := 'Winsock Error!' + #13 + 'Cannot assign requested address.';
    10047: result := 'Winsock Error!' + #13 + 'Address family not supported by protocol family.';
    10037: result := 'Winsock Error!' + #13 + 'Operation already in progress.';
    10053: result := 'Winsock Error!' + #13 + 'Connection aborted by host.';
    10061: result := 'Winsock Error!' + #13 + 'Connection refused by host.';
    10054: result := 'Winsock Error!' + #13 + 'Connection reset by host.';
    10039: result := 'Winsock Error!' + #13 + 'Destination address required.';
    10014: result := 'Winsock Error!' + #13 + 'Bad address.';
    10064: result := 'Winsock Error!' + #13 + 'Host is down.';
    10065: result := 'Winsock Error!' + #13 + 'No route to host.';
    10036: result := 'Winsock Error!' + #13 + 'Operation now in progress.';
    10004: result := 'Winsock Error!' + #13 + 'Interrupted function call.';
    10022: result := 'Winsock Error!' + #13 + 'Invalid argument.';
    10056: result := 'Winsock Error!' + #13 + 'Socket already connected.';
    10024: result := 'Winsock Error!' + #13 + 'Too many open files.';
    10040: result := 'Winsock Error!' + #13 + 'Message too long.';
    10050: result := 'Winsock Error!' + #13 + 'Network is down.';
    10052: result := 'Winsock Error!' + #13 + 'Network dropped connection on reset.';
    10051: result := 'Winsock Error!' + #13 + 'Network is unreachable.';
    10055: result := 'Winsock Error!' + #13 + 'No buffer space available.';
    10042: result := 'Winsock Error!' + #13 + 'Bad protocol option.';
    10057: result := 'Winsock Error!' + #13 + 'Socket is not connected.';
    10038: result := 'Winsock Error!' + #13 + 'Socket operation on non-socket.';
    10045: result := 'Winsock Error!' + #13 + 'Operation not supported.';
    10046: result := 'Winsock Error!' + #13 + 'Protocol family not supported.';
    10067: result := 'Winsock Error!' + #13 + 'Too many processes.';
    10043: result := 'Winsock Error!' + #13 + 'Protocol not supported.';
    10041: result := 'Winsock Error!' + #13 + 'Protocol wrong type for socket.';
    10058: result := 'Winsock Error!' + #13 + 'Cannot send after socket shutdown.';
    10044: result := 'Winsock Error!' + #13 + 'Socket type not supported.';
    10060: result := 'Winsock Error!' + #13 + 'Connection timed out.';
    10035: result := 'Winsock Error!' + #13 + 'Resource temporarily unavailable.';
    11001: result := 'Winsock Error!' + #13 + 'Host not found.';
    10093: result := 'Winsock Error!' + #13 + 'Successful WSAStartup() not yet performed.';
    11004: result := 'Winsock Error!' + #13 + 'Valid name, no data record of requested type.';
    11003: result := 'Winsock Error!' + #13 + 'This is a non-recoverable error.';
    10091: result := 'Winsock Error!' + #13 + 'Network subsystem is unavailable.';
    11002: result := 'Winsock Error!' + #13 + 'Non-authoritative host not found.';
    10092: result := 'Winsock Error!' + #13 + 'WINSOCK.DLL version out of range.';
    10094: result := 'Winsock Error!' + #13 + 'Graceful shutdown in progress.';
  else
    result := defString;
  end;
end;

{===========================================================================
CAPRI_CodeCR???  - LMS - 2014-07-15
Generic Function to obtain a string result of a vista/cache server side variable.
===========================================================================}

function GetVariableValue(Broker: TCCOWRPCBrokerCapri; varName: String; var retVal: String): Boolean; // CodeCR??? - LMS 2014-07-15
begin
  result := false;
  if CallRPC(Broker, 'XWB GET VARIABLE VALUE', [varName], nil, True) then begin
    result := true;
    retVal := Broker.Results[0];
  end;
end;

{==============================================================================
 GetSystemPath
 Input: Folder: Integer (ex. CSIDL_DESKTOP, CSIDL_PROGRAMS full list in ShlObj.pas
 Output: Path name - String
 This function returns the system path string for a given system path ID

 //CodeCR129 - rpm 10/14/10
 ==============================================================================}

function GetSystemPath(Folder: Integer): String;
var
  PIDL: PItemIDList;
  Path: LPSTR;
  AMalloc: IMalloc;
begin
  Path := StrAlloc(MAX_PATH);
  SHGetSpecialFolderLocation(Application.Handle, Folder, PIDL);
  if SHGetPathFromIDList(PIDL, Path) then
    Result := Path;
  SHGetMalloc(AMalloc);
  AMalloc.Free(PIDL);
  StrDispose(Path);
end;

{==============================================================================
 SendNotification
 This function provides a wrapper around the DVBAB SEND MSG remote procedure
 call that is used to send notification messages.

 Input: MsgText: TStrings   Message text
        SenderDUZ: String   Current user's NEW PERSON file IEN
        Subject: String     Used for the email subject
        MailGroup: String   Used for sending MailMan bulletins
        RequestIEN: String - (default='') optional 2507 REQUEST (#396.3) record#

 Output: Returns TRUE on success; otherwise returns FALSE

 //CodeCR266 - rpm 01/10/12
 ==============================================================================}

function SendNotification(MsgText: TStrings; SenderDUZ, Subject, MailGroup: String; RequestIEN: String = ''): Boolean;
var
  I: Integer;
  IsPatch179Installed: Boolean;
begin
  Result := False;

  IsPatch179Installed := IsPatchInstalled('DVBA*2.7*179');
  frmMain.RPCBroker1.Results.Clear;
  frmMain.RPCBroker1.RemoteProcedure := 'DVBAB SEND MSG';
  frmMain.RPCBroker1.Param[0].Value := SenderDUZ;                               //Sender
  frmMain.RPCBroker1.Param[0].PType := literal;
  frmMain.RPCBroker1.Param[1].Value := Copy(Subject, 1, 45);                    //Subject Max 45 Chars
  frmMain.RPCBroker1.Param[1].PType := literal;
  frmMain.RPCBroker1.Param[2].PType := list;
  for I := 0 to MsgText.Count - 1 do
    frmMain.RPCBroker1.Param[2].Mult[IntToStr(I + 1)] := MsgText[I];
  frmMain.RPCBroker1.Param[3].Value := MailGroup;                               //Mail Group Name
  frmMain.RPCBroker1.Param[3].PType := literal;

  {Patch 179 modified the DVBAB SEND MSG remote procedure to use a new optional
   RequestIEN parameter to retrieve the requestor and their associated EMAIL
   ADDRESS (#.151) field value in the NEW PERSON (#200) file.}
  if IsPatch179Installed then
  begin
    frmMain.RPCBroker1.Param[4].Value := RequestIEN;                            //2507 Request IEN
    frmMain.RPCBroker1.Param[4].PType := literal;
  end;

  frmMain.RPCBrokerCall;
  try
    frmMain.RPCBroker1.Call;
    if (frmMain.RPCBroker1.Results.Count > 0) then
      if (frmMain.RPCBroker1.Results[0] = 'MESSAGE SENT') then
        Result := True;
  except
    on EBrokerError do
      Result := False;
  end;
end;

{======================================l========================================
 SendNotificationTwo
 This function provides a wrapper around the DVBAB SEND MSG remote procedure
 call that is used to send notification messages.

 Input: ExamIENs : TStrings - Exam IENs
        SenderDUZ: String - Current user's NEW PERSON file IEN
        RequestIEN: String - 2507 REQUEST (#396.3) record#

 Output: Returns TRUE on success; otherwise returns FALSE

 //CodeCR471 - JRL 04/11/13
 ==============================================================================}

function SendNotificationTwo(ExamIENs: TStrings; SenderDUZ: string; RequestIEN: String = ''): Boolean;
var
  I: Integer;
begin
  Result := False;
//  If not IsPatchInstalled('DVBA*2.7*185') then
//    Exit;
  frmMain.RPCBroker1.Results.Clear;
  frmMain.RPCBroker1.RemoteProcedure := 'DVBAB SEND MSG TWO';
  frmMain.RPCBroker1.Param[0].Value := SenderDUZ;                               //Sender
  frmMain.RPCBroker1.Param[0].PType := literal;
  frmMain.RPCBroker1.Param[1].Value := RequestIEN;                              //2507 Request IEN
  frmMain.RPCBroker1.Param[1].PType := literal;
  frmMain.RPCBroker1.Param[2].PType := list;                                    //list of Exam IENs
  for I := 0 to ExamIENs.Count - 1 do
    frmMain.RPCBroker1.Param[2].Mult[IntToStr(I + 1)] := ExamIENs[I];
  try
    frmMain.RPCBroker1.Call;
    if (frmMain.RPCBroker1.Results.Count > 0) then
      if (frmMain.RPCBroker1.Results[0] = 'MESSAGE SENT') then
        Result := True;
  except
    on EBrokerError do
      Result := False;
  end;
end;

{===========================================================================
 GetExamResults
 This procedure retrieves the Exam Results from the 2507 EXAM (#396.4) file
 separately from the FMDC GetAndFill operations to reduce the chance of
 <STORE> errors occurring on the server.

 The results are initially retrieved from the EXAM RESULTS RTF (#71) field,
 which contains rich text formatted results.  If no results are available,
 then the results are retrieved from the EXAM RESULTS (#70) plain text field.

 The TFMMemo.FMField property is set to the field that contained the results,
 because the report formatting in main.pas conditionally depends on the value.

 Input:
   anIENS - IENS of the selected 396.4 record
   anFMMemo - Hidden FMDC TFMMemo control to set FMField to data retrieval field
   aRichText - RichText control used for output display destination

 Output:  none

 //CodeCR319 - rpm 6/25/12
 ===========================================================================}

procedure GetExamResults(anIENS: string; anFMMemo: TFMMemo; aRichText: TRichEdit);
var
  FMGetsExamResults: TFMGets;
  FMExamResultsObj: TFMFieldObj;
  tempMemoryStream: TMemoryStream;
begin
  FMGetsExamResults := TFMGets.Create(nil);
  FMGetsExamResults.RPCBroker := frmMain.RPCBroker1;
  try
    FMGetsExamResults.IENS := anIENS;
    FMGetsExamResults.FileNumber := '396.4';
    FMGetsExamResults.FieldNumbers.Add('71');
    FMGetsExamResults.GetData;
    FMExamResultsObj := FMGetsExamResults.GetField('71');
    if (FMExamResultsObj.FMWPTextLines.Count > 0) then
    begin                                                                       // EXAM RESULTS RTF contained data
      anFMMemo.FMField := '71';
      aRichText.Visible := True;
      tempMemoryStream := tMemoryStream.Create;
      try
        FMExamResultsObj.FMWPTextLines.SaveToStream(tempMemoryStream);
        tempMemoryStream.Position := 0;
        aRichText.MaxLength := Length(FMExamResultsObj.FMWPTextLines.Text);
        aRichText.PlainText := False;
        aRichText.Lines.LoadFromStream(tempMemoryStream);
      finally
        FreeAndNil(tempMemoryStream);
      end;
    end
    else                                                                        //EXAM RESULTS RTF is empty so get the plain text field.
    begin
      FMGetsExamResults.Results.Clear;
      FMGetsExamResults.FieldNumbers.Add('70');
      FMGetsExamResults.GetData;
      FMExamResultsObj := FMGetsExamResults.GetField('70');
      anFMMemo.FMField := '70';
      aRichText.Visible := True;
      aRichText.Lines := FMExamResultsObj.FMWPTextLines;
    end;
  finally
    FMGetsExamResults.RPCBroker := nil;
    FreeAndNil(FMGetsExamResults);
  end;
end;
end.

