unit FHIEGraph;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  DialogsCAPRI,
  Dialogs,
  StdCtrls,
  ORCtrls,
  TeEngine,
  Series,
  TeeProcs,
  Chart,
  ExtCtrls,
  ORDtTm,
  CAPRISupport;

type
  TfrmGraphFHIE = class(TForm)
    Panel1: TPanel;
    checkboxValues: TCheckBox;
    checkboxZoom: TCheckBox;
    Button1: TButton;
    chartFHIEData: TChart;
    Series1: TLineSeries;
    Series2: TLineSeries;
    Series3: TLineSeries;
    Panel2: TPanel;
    listboxTests: TORListBox;
    ListBoxData: TListBox;
    CCOWTimer: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure listboxTestsClick(Sender: TObject);
    procedure checkboxValuesClick(Sender: TObject);
    procedure Series1GetMarkText(Sender: TChartSeries; ValueIndex: Longint; var MarkText: string);
    procedure checkboxZoomClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure CCOWTimerTimer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmGraphFHIE: TfrmGraphFHIE;

implementation

uses main;

{$R *.DFM}

procedure TfrmGraphFHIE.Button1Click(Sender: TObject);
begin
  ChartFHIEData.CopyToClipBoardBitmap;
end;

procedure TfrmGraphFHIE.listboxTestsClick(Sender: TObject);
var
  testname, startDate, endDate: string;
  x: integer;
  spot: integer;
  lasthigh, lastlow: real;
begin
  spot := 0;
  lasthigh := 0;
  lastlow := 0;

  ChartFHIEData.Series[0].Clear;
  ChartFHIEData.Series[1].Clear;
  ChartFHIEData.Series[2].Clear;
  ChartFHIEData.SeriesList[0].Title := ' ';
  ChartFHIEData.Title.Text.Clear;

  startDate := UpperCase(FormatDateTime('mmm d, yyyy', frmMain.dtpDODStartDate.Date));  //CodeCR102 - rpm 4/12/10
  endDate := UpperCase(FormatDateTime('mmm d, yyyy', frmMain.dtpDODEndDate.Date));  //CodeCR102 - rpm 4/12/10
  testname := listboxTests.Items[listboxTests.ItemIndex];
  frmGraphFHIE.ChartFHIEData.Title.Text.Add(TestName);
  frmGraphFHIE.ChartFHIEData.Title.Text.Add(startDate + ' to ' + endDate);

  ListBoxData.Items.Clear;

  // Find Matches
  for x := frmMain.VAWrapGridDOD.RowCount - 1 downto 0 do
    if frmMain.VAWrapGridDOD.Cells[1, x] = testname then begin
      //Check if can graph this one
      //found a hit
      inc(spot);

      // Update Ref Ranges
      try
        if spot = 1 then
          ChartFHIEData.SeriesList[0].Title := 'Ref Low: ' + frmMain.VAWrapGridDOD.Cells[6, x] + '    Ref High: ' + frmMain.VAWrapGridDOD.Cells[7, x];
        // Graph
        ListBoxData.Items.Add(frmMain.VAWrapGridDOD.Cells[2, x]);
        //      ChartFHIEData.Series[0].AddXY(spot,strtofloat(frmMain.VAWrapGridDOD.Cells[2,x]),
        //            Piece(frmMain.VAWrapGridDOD.Cells[0,x],'@',1),
        //            clTeeColor);

              // Low range
                // Next line screens out incomplete high/low ref ranges
                // There appears to be inconsistency with ref ranges
        if (frmMain.VAWrapGridDOD.Cells[6, x] <> '') and (frmMain.VAWrapGridDOD.Cells[7, x] <> '') then begin
          try
            ChartFHIEData.Series[1].AddXY(StrToDate(Piece(frmMain.VAWrapGridDOD.Cells[0, x], '@', 1)), strtofloat(frmMain.VAWrapGridDOD.Cells[6, x]),
              Piece(frmMain.VAWrapGridDOD.Cells[0, x], '@', 1),
              clTeeColor);
          except;
            ChartFHIEData.Series[1].AddXY(StrToDate(ConvertCalendarDateToDelphiDate(Piece(frmMain.VAWrapGridDOD.Cells[0, x], '@', 1))), strtofloat(frmMain.VAWrapGridDOD.Cells[6, x]),
              Piece(frmMain.VAWrapGridDOD.Cells[0, x], '@', 1),
              clTeeColor);
          end;
          lastlow := strtofloat(frmMain.VAWrapGridDOD.Cells[6, x]);
        end
        else
          // Check if last set had high/low ref data in case of failure
          if frmMain.VAWrapGridDOD.RowCount - 1 > 1 then
            if x <> frmMain.VAWrapGridDOD.RowCount - 1 then try
                ChartFHIEData.Series[1].AddXY(StrToDate(Piece(frmMain.VAWrapGridDOD.Cells[0, x], '@', 1)), lastlow,
                  Piece(frmMain.VAWrapGridDOD.Cells[0, x], '@', 1),
                  clTeeColor)
              except ChartFHIEData.Series[1].AddXY(StrToDate(ConvertCalendarDateToDelphiDate(Piece(frmMain.VAWrapGridDOD.Cells[0, x], '@', 1))), lastlow,
                  Piece(frmMain.VAWrapGridDOD.Cells[0, x], '@', 1),
                  clTeeColor)
              end;
        // Upper Range
          // Next line screens out incomplete high/low ref ranges
          // There appears to be inconsistency with ref ranges
        if (frmMain.VAWrapGridDOD.Cells[6, x] <> '') and (frmMain.VAWrapGridDOD.Cells[7, x] <> '') then begin
          try
            ChartFHIEData.Series[2].AddXY(StrToDate(Piece(frmMain.VAWrapGridDOD.Cells[0, x], '@', 1)), strtofloat(frmMain.VAWrapGridDOD.Cells[7, x]),
              Piece(frmMain.VAWrapGridDOD.Cells[0, x], '@', 1),
              clTeeColor);
          except ChartFHIEData.Series[2].AddXY(StrToDate(ConvertCalendarDateToDelphiDate(Piece(frmMain.VAWrapGridDOD.Cells[0, x], '@', 1))), strtofloat(frmMain.VAWrapGridDOD.Cells[7, x]),
              Piece(frmMain.VAWrapGridDOD.Cells[0, x], '@', 1),
              clTeeColor);
          end;
          lasthigh := strtofloat(frmMain.VAWrapGridDOD.Cells[7, x]);
        end
        else
          // Check if last set had high/low ref data in case of failure
          if frmMain.VAWrapGridDOD.RowCount - 1 > 1 then
            if x <> frmMain.VAWrapGridDOD.RowCount - 1 then try
                ChartFHIEData.Series[2].AddXY(StrToDate(Piece(frmMain.VAWrapGridDOD.Cells[0, x], '@', 1)), lasthigh,
                  Piece(frmMain.VAWrapGridDOD.Cells[0, x], '@', 1),
                  clTeeColor)
              except ChartFHIEData.Series[2].AddXY(StrToDate(ConvertCalendarDateToDelphiDate(Piece(frmMain.VAWrapGridDOD.Cells[0, x], '@', 1))), lasthigh,
                  Piece(frmMain.VAWrapGridDOD.Cells[0, x], '@', 1),
                  clTeeColor)
              end;
      except
        ChartFHIEData.SeriesList[0].Title := 'Ref Ranges Unavailable.';
      end;
      //Data is in mm/dd/yyyy format
      try
        ChartFHIEData.Series[0].AddXY(StrToDate(Piece(frmMain.VAWrapGridDOD.Cells[0, x], '@', 1)), strtofloat(frmMain.VAWrapGridDOD.Cells[2, x]),
          Piece(frmMain.VAWrapGridDOD.Cells[0, x], '@', 1),
      clTeeColor)except begin
          // Data is in Month Day, Year format
          ChartFHIEData.Series[0].AddXY(StrToDate(ConvertCalendarDateToDelphiDate(Piece(frmMain.VAWrapGridDOD.Cells[0, x], '@', 1))),
            strtofloat(frmMain.VAWrapGridDOD.Cells[2, x]),
            Piece(frmMain.VAWrapGridDOD.Cells[0, x], '@', 1),
            clTeeColor);
        end;
      end;
    end;
end;

procedure TfrmGraphFHIE.checkboxValuesClick(Sender: TObject);
begin
  if CheckBoxValues.Checked = True then
    ChartFHIEData.SeriesList[0].Marks.Visible := True
  else
    ChartFHIEData.SeriesList[0].Marks.Visible := False;
  //ChartLab.Series[0].Title:=' ';
  Series1.OnGetMarkText := Series1GetMarkText;
end;

procedure TfrmGraphFHIE.Series1GetMarkText(Sender: TChartSeries; ValueIndex: Longint; var MarkText: string);
begin
  MarkText := ListBoxData.Items[ValueIndex];
end;

procedure TfrmGraphFHIE.checkboxZoomClick(Sender: TObject);
begin
  if checkboxZoom.Checked = True then begin
    chartFHIEData.AllowZoom := True;
  end
  else begin
    chartFHIEData.BottomAxis.Automatic := True;
    chartFHIEData.LeftAxis.Automatic := True;
    chartFHIEData.AllowZoom := False;
  end;
end;

procedure TfrmGraphFHIE.FormActivate(Sender: TObject);
begin
  CCOWTimer.Enabled := True;
end;

procedure TfrmGraphFHIE.CCOWTimerTimer(Sender: TObject);
begin
  if ShutdownCAPRIModalDialogs = true then begin
    CCOWTimer.Enabled := False;
    frmGraphFHIE.Visible := False;
    ContextorChangeMessage := '';
    ModalResult := mrCancel;
  end;
end;

end.
