unit FrmVlerGetExam;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, ComCtrls, StdCtrls, Grids, Mask, xmldom, XMLIntf, msxmldom,
  XMLDoc, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient, IdHTTP,
  Diaccess, Fmcmpnts, Fmcntrls, TRPCB, DialogsCAPRI
  , frmVlerGetExamDocs
  ;

type
  TVLERGetDocSearch = record
    strPatientId: string;
    strPhysicianFnm: string;
    strPhysicianMnm: string;
    strPhysicianLnm: string;
    strfacilityID: string;
    strExamstatus: string;
    strCreationStartDT: string;
    strCreationEndDt: string;
  end;

  TVISTAGetAllFacility = record
    strInstitutionName: string;
    strType: string;
    strStationNumber: string;
    strOfficialVAName: string;
    strIEN: string;
  end;


type
  TfrmVlerGetExams = class(TForm)
    grpbxExmSrchCriteria: TGroupBox;
    pnlMultiSelect: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    cmbxExmStatus: TComboBox;
    btnMultiSrch: TButton;
    cmbxPhysicianFnm: TComboBox;
    dttmepckrCreateStrtDT: TDateTimePicker;
    dttmepckrCreateEndDT: TDateTimePicker;
    IdHTTPVLERExamRESTful: TIdHTTP;
    XMLDocumentVLERExamRESTful: TXMLDocument;
    lblPatientSSN: TLabel;
    cmbxFcltyLoc: TComboBox;
    cmbxPhysicianMnm: TComboBox;
    cmbxPhysicianLnm: TComboBox;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    btnClose: TButton;
    edtTPatientSSN: TEdit;
    Panel1: TPanel;
    btnClearFields: TButton;
    txtDocSrchCriteria: TStaticText;
    lblPhysician: TStaticText;
    lblCrtEndDT: TStaticText;
    lblCreationStrtDT: TStaticText;
    procedure FormDestroy(Sender: TObject);
    procedure btnMultiSrchClick(Sender: TObject);
    procedure setSearchExamparams;
    function convertDateToGMTStr(InDate: TDateTime; StartDt: Boolean): string;
    procedure FormCreate(Sender: TObject);
    procedure setExamStatus(Status: TStrings);
    procedure dttmepckrCreateEndDTExit(Sender: TObject);
    procedure dttmepckrCreateStrtDTExit(Sender: TObject);
    procedure edtTPatientSSNExit(Sender: TObject);
    procedure btnClearFieldsClick(Sender: TObject);
    procedure dttmepckrCreateStrtDTEnter(Sender: TObject);
    procedure dttmepckrCreateEndDTEnter(Sender: TObject);
  private
    { Private declarations }
    strlstFacilityandDateRange: TStringList;
    strlstPhysicianDateRange: TStringList;
    strlstExamStatusDateRange: TstringList;
    strlstMultiSelect: TstringList;
    GetExamParams: TVLERGetDocSearch;
  public
    { Public declarations }
//    aAttachNodeList: TList;
    class function FreeTList(var aTList: TList): Boolean;
  end;

const
  IGNORE: string = 'SKIP';

var
  frmVlerGetExams: TfrmVlerGetExams;
  aAttachNodeList: TList;

implementation

{$R *.dfm}
uses
  Main,
  CCOWRPCBrokerCAPRI,
  eCrud,
  untMiscMthds,
  VA508AccessibilityRouter;


procedure TfrmVlerGetExams.btnClearFieldsClick(Sender: TObject);
begin
  edtTPatientSSN.Clear;
  cmbxFcltyLoc.Clear;
  cmbxPhysicianFnm.Clear;
  cmbxPhysicianMnm.Clear;
  cmbxPhysicianLnm.Clear;
  cmbxExmStatus.ItemIndex := 0;
  dttmepckrCreateStrtDT.Date := Now;
  dttmepckrCreateEndDT.Date := Now;
end;

procedure TfrmVlerGetExams.btnMultiSrchClick(Sender: TObject);
var
  srchECRUD: TeCRUD;
  queryResult: TStringList;
  eCRUDParams: TStringList;
  exQry: boolean;
  frmVlerRtrvExamDocs: TfrmVlerRetrievalExamDocs;                               // rpk 8/26/2014
  strHdrWarning: string;
begin
  frmVlerRtrvExamDocs := nil;                                                   // rpk 8/26/2014

 // check that selection criteria includes one item
 // in addition to the date range
  if (edtTPatientSSN.Text = '') and
    (cmbxFcltyLoc.Text = '') and
    (cmbxPhysicianFnm.Text = '') and
    (cmbxPhysicianMnm.Text = '') and
    (cmbxPhysicianLnm.Text = '') and
    (cmbxExmStatus.Text = '') then
  begin
    ShowMessageCAPRI('Must Choose One Other Search Criteria');
    Exit;
  end;

  self.btnMultiSrch.Enabled := False;
  exQry := false;

  eCRUDParams := TStringList.Create();                                          // rpk 8/26/2014
  queryResult := TStringList.Create();                                          // rpk 8/26/2014

  if aAttachNodeList <> nil then
    TfrmVlerGetExams.FreeTList(aAttachNodeList);

  aAttachNodeList := TList.create;

 //*** Determine Exam search Paramaters ***//
  setSearchExamparams;

 //*** RESTful call to VLER eCRUD
 //Create TeCrud object. This object sets URL, Query and issues RESTful GET
  SrchECRUD := TeCRUD.Create(self, frmMain.RPCBroker1);                         // IdHTTPVLERExamRESTful,XMLDocumentVLERExamRESTful);  // TODO

  try                                                                           // rpk 8/26/2014
    srchECRUD.XMLDocument := XMLDocumentVLERExamRESTful;
    SrchECRUD.eCRUDVersion := 'v1';
    SrchECRUD.dbName := 'core';
    SrchECRUD.collectionName := 'disabilityBenefitsQuestionnaires';
    SrchECRUD.maxRecords := '100';
    SrchECRUD.SpecifyResponseFields := '%7b%22cld:Claim.cld:CommonData.nc:Document%22:1,%22cld:Claim.cld:CommonData.vler:Client%22:1,%22cld:Claim.cld:CommonData.nc:Person%22:1%7d';
    SrchECRUD.Sort := '%7b%22cld:Claim.cld:CommonData.nc:Document.nc:DocumentCreationDate.nc:DateTime%22:-1%7d';
    SrchECRUD.setExamAttachmentList(aAttachNodeList);                           // rpk 9/12/2014
    screen.cursor := crHourglass;
    //Search by SSN?
    if (Trim(GetExamParams.strPatientId) <> '') and                             // SSN = YES
      (GetExamParams.strPhysicianFnm = IGNORE) and                              // Physician = NO
      (GetExamParams.strPhysicianMnm = IGNORE) and
      (GetExamParams.strPhysicianLnm = IGNORE) and
      (GetExamParams.strfacilityID = IGNORE) and                                // Facility = NO
      (GetExamParams.strExamstatus = IGNORE) and                                // ExamStatus = NO
      (GetExamParams.strCreationStartDT <> IGNORE) and                          // Date Range = YES
      (GetExamParams.strCreationStartDT <> IGNORE) then
    begin
      eCRUDParams.Add(GetExamParams.strPatientId);                              // SSN
      eCRUDParams.Add(GetExamParams.strCreationStartDT);                        // Start Date
      eCRUDParams.Add(GetExamParams.strCreationEndDt);                          // End Date
      //query by SSN begin
      exQry := SrchECRUD.getExamBy('SSN', eCRUDParams, queryResult);
      //query by SSN end

    end
    else                                                                        //Search by Facility?
      if (GetExamParams.strPatientId = IGNORE) and                              // SSN = NO
        (GetExamParams.strPhysicianFnm = IGNORE) and                            // Physician = NO
        (GetExamParams.strPhysicianMnm = IGNORE) and
        (GetExamParams.strPhysicianLnm = IGNORE) and
        (Trim(GetExamParams.strfacilityID) <> '') and                           // Facility = YES
        (GetExamParams.strExamstatus = IGNORE) and                              // ExamStatus = NO
        (GetExamParams.strCreationStartDT <> IGNORE) and                        // Date Range = YES
        (GetExamParams.strCreationStartDT <> IGNORE) then
      begin
        eCRUDParams.Add(GetExamParams.strfacilityID);                           // Facility
        eCRUDParams.Add(GetExamParams.strCreationStartDT);                      // Start Date
        eCRUDParams.Add(GetExamParams.strCreationEndDt);                        // End Date
        //query by Facility begin
        SrchECRUD.getExamBy('FACILITY', eCRUDParams, queryResult);
        //query by Facility end
        exQry := True;
      end
      else                                                                      //Search by Physician?
        if (GetExamParams.strPatientId = IGNORE) and                            // SSN = NO
          (Trim(GetExamParams.strPhysicianFnm) <> '') and                       // Physician = YES
          (Trim(GetExamParams.strPhysicianMnm) <> '') and
          (Trim(GetExamParams.strPhysicianLnm) <> '') and
          (GetExamParams.strfacilityID = IGNORE) and                            // Facility = NO
          (GetExamParams.strExamstatus = IGNORE) and                            // ExamStatus = NO
          (GetExamParams.strCreationStartDT <> IGNORE) and                      // Date Range = YES
          (GetExamParams.strCreationStartDT <> IGNORE) then
        begin
          if GetExamParams.strPhysicianFnm <> IGNORE then                       // Physician - allow each part of the physician name to be blank
            eCRUDParams.Add(GetExamParams.strPhysicianFnm)
          else
            eCrudParams.Add('');
          if GetExamParams.strPhysicianMnm <> IGNORE then
            eCRUDParams.Add(GetExamParams.strPhysicianMnm)
          else
            eCrudParams.Add('');
          if GetExamParams.strPhysicianLnm <> IGNORE then
            eCRUDParams.Add(GetExamParams.strPhysicianLnm)
          else
            eCrudParams.Add('');
          eCRUDParams.Add(GetExamParams.strCreationStartDT);                    // Start Date
          eCRUDParams.Add(GetExamParams.strCreationEndDt);                      // End Date
          //query by Physician begin
          SrchECRUD.getExamBy('PHYSICIAN', eCRUDParams, queryResult);           //500950188
          //query by Physician end
          exQry := True;
        end
        else                                                                    //Search by Exam Status?
          if (GetExamParams.strPatientId = IGNORE) and                          // SSN = NO
            (GetExamParams.strPhysicianFnm = IGNORE) and                        // Physician = NO
            (GetExamParams.strPhysicianMnm = IGNORE) and
            (GetExamParams.strPhysicianLnm = IGNORE) and
            (GetExamParams.strfacilityID = IGNORE) and                          // Facility = NO
            (Trim(GetExamParams.strExamstatus) <> '') and                       // ExamStatus = YES
            (GetExamParams.strCreationStartDT <> IGNORE) and                    // Date Range = YES
            (GetExamParams.strCreationStartDT <> IGNORE) then
          begin
            eCRUDParams.Add(GetExamParams.strExamstatus);                       // ExamStatus
            eCRUDParams.Add(GetExamParams.strCreationStartDT);                  // Start Date
            eCRUDParams.Add(GetExamParams.strCreationEndDt);                    // End Date
            //query by Exam Status begin
            SrchECRUD.getExamBy('EXAMSTATUS', eCRUDParams, queryResult);        //500950188
            //query by Exam Status end
            exQry := True;
          end
          else                                                                  //Search by Physician and Facility?
            if (GetExamParams.strPatientId = IGNORE) and                        // SSN = NO
              (Trim(GetExamParams.strPhysicianFnm) <> '') and                   // PHYSICIAN = YES
              (Trim(GetExamParams.strPhysicianMnm) <> '') and
              (Trim(GetExamParams.strPhysicianLnm) <> '') and
              (Trim(GetExamParams.strfacilityID) <> '') and                     // FACILITY = YES
              (GetExamParams.strExamstatus = IGNORE) and                        // EXAMSTATUS = NO
              (GetExamParams.strCreationStartDT <> IGNORE) and                  // DATE RANGE = YES
              (GetExamParams.strCreationStartDT <> IGNORE) then
            begin
              if GetExamParams.strPhysicianFnm <> IGNORE then                   // Physician - allow each part of the physician name to be blank
                eCRUDParams.Add(GetExamParams.strPhysicianFnm)
              else
                eCrudParams.Add('');
              if GetExamParams.strPhysicianMnm <> IGNORE then
                eCRUDParams.Add(GetExamParams.strPhysicianMnm)
              else
                eCrudParams.Add('');
              if GetExamParams.strPhysicianLnm <> IGNORE then
                eCRUDParams.Add(GetExamParams.strPhysicianLnm)
              else
                eCrudParams.Add('');
              eCRUDParams.Add(GetExamParams.strfacilityID);                     // Facility
              eCRUDParams.Add(GetExamParams.strCreationStartDT);                // Start Date
              eCRUDParams.Add(GetExamParams.strCreationEndDt);                  // End Date
              //query by Physician and Facility begin
              SrchECRUD.getExamBy('PHYSICIAN_FACILITY', eCRUDParams, queryResult);
              //query by Physician and Facility end
              exQry := True;
            end
            else                                                                //Search by Physician and Exam Status?
              if (GetExamParams.strPatientId = IGNORE) and                      // SSN = NO
                (Trim(GetExamParams.strPhysicianFnm) <> '') and                 // PHYSICIAN = YES
                (Trim(GetExamParams.strPhysicianMnm) <> '') and
                (Trim(GetExamParams.strPhysicianLnm) <> '') and
                (GetExamParams.strfacilityID = IGNORE) and                      // FACILITY = NO
                (Trim(GetExamParams.strExamstatus) <> '') and                   // EXAMSTATUS = YES
                (GetExamParams.strCreationStartDT <> IGNORE) and                // DATE RANGE = YES
                (GetExamParams.strCreationStartDT <> IGNORE) then
              begin
                if GetExamParams.strPhysicianFnm <> IGNORE then                 // Physician - allow each part of the physician name to be blank
                  eCRUDParams.Add(GetExamParams.strPhysicianFnm)
                else
                  eCrudParams.Add('');
                if GetExamParams.strPhysicianMnm <> IGNORE then
                  eCRUDParams.Add(GetExamParams.strPhysicianMnm)
                else
                  eCrudParams.Add('');
                if GetExamParams.strPhysicianLnm <> IGNORE then
                  eCRUDParams.Add(GetExamParams.strPhysicianLnm)
                else
                  eCrudParams.Add('');
                eCRUDParams.Add(GetExamParams.strExamstatus);                   // Exam Status
                eCRUDParams.Add(GetExamParams.strCreationStartDT);              // Start Date
                eCRUDParams.Add(GetExamParams.strCreationEndDt);                // End Date
                //query by Physician and Exam Status begin
                SrchECRUD.getExamBy('PHYSICIAN_EXAMSTATUS', eCRUDParams, queryResult);
                //query by Physician and Exam Status end
                exQry := True;
              end
              else                                                              //Search by Facility and Exam Status?
                if (GetExamParams.strPatientId = IGNORE) and                    // SSN = NO
                  (GetExamParams.strPhysicianFnm = IGNORE) and                  // PHYSICIAN = NO
                  (GetExamParams.strPhysicianMnm = IGNORE) and
                  (GetExamParams.strPhysicianLnm = IGNORE) and
                  (Trim(GetExamParams.strfacilityID) <> '') and                 // FACILITY = YES
                  (Trim(GetExamParams.strExamstatus) <> '') and                 // EXAMSTATUS = YES
                  (GetExamParams.strCreationStartDT <> IGNORE) and              // DATE RANGE = YES
                  (GetExamParams.strCreationStartDT <> IGNORE) then
                begin
                  eCRUDParams.Add(GetExamParams.strfacilityID);                 // Facility
                  eCRUDParams.Add(GetExamParams.strExamstatus);                 // Exam Status
                  eCRUDParams.Add(GetExamParams.strCreationStartDT);            // Start Date
                  eCRUDParams.Add(GetExamParams.strCreationEndDt);              // End Date
                  //query by Facility and Exam Status begin
                  SrchECRUD.getExamBy('FACILITY_EXAMSTATUS', eCRUDParams, queryResult);
                  //query by Facility and Exam Status end
                  exQry := True;
                end
                else                                                            // Search by SSN and Facility
                  if (GetExamParams.strPatientId <> IGNORE) and                 // SSN = YES
                    (Trim(GetExamParams.strfacilityID) <> '') and               // FACILITY = YES
                    (GetExamParams.strPhysicianLnm = IGNORE) and                // PHYSICIAN = NO
                    (GetExamParams.strPhysicianFnm = IGNORE) and
                    (GetExamParams.strPhysicianMnm = IGNORE) and
                    (GetExamParams.strExamStatus = IGNORE) then                 // EXAMSTATUS = NO
                  begin
                    eCRUDParams.Add(GetExamParams.strPatientID);                // SSN
                    eCRUDParams.Add(GetExamParams.strfacilityID);               // FACILITY
                    eCRUDParams.Add(GetExamParams.strCreationStartDT);          // START DATE
                    eCRUDParams.Add(GetExamParams.strCreationEndDt);            // END DATE
                    //query by SSN and Facility begin
                    SrchECRUD.getExamBy('SSN_FACILITY', eCRUDParams, queryResult);
                    //query by SSN and Facility end
                    exQry := True;
                  end
                  else                                                          // Search by SSN and Physician
                    if (GetExamParams.strPatientId <> IGNORE) and               // SSN = YES
                      (Trim(GetExamParams.strPhysicianFnm) <> '') and           // PHYSICIAN = YES
                      (Trim(GetExamParams.strPhysicianMnm) <> '') and
                      (Trim(GetExamParams.strPhysicianLnm) <> '') and
                      (Trim(GetExamParams.strfacilityID) = IGNORE) and          // FACILITY = NO
                      (GetExamParams.strExamstatus = IGNORE) and                // EXAMSTATUS = NO
                      (GetExamParams.strCreationStartDT <> IGNORE) and
                      (GetExamParams.strCreationStartDT <> IGNORE) then
                    begin
                      eCRUDParams.Add(GetExamParams.strPatientId);              // SSN
                      if GetExamParams.strPhysicianFnm <> IGNORE then           // Physician - allow each part of the physician name to be blank
                        eCRUDParams.Add(GetExamParams.strPhysicianFnm)
                      else
                        eCrudParams.Add('');
                      if GetExamParams.strPhysicianMnm <> IGNORE then
                        eCRUDParams.Add(GetExamParams.strPhysicianMnm)
                      else
                        eCrudParams.Add('');
                      if GetExamParams.strPhysicianLnm <> IGNORE then
                        eCRUDParams.Add(GetExamParams.strPhysicianLnm)
                      else
                        eCrudParams.Add('');
                      eCRUDParams.Add(GetExamParams.strCreationStartDT);        // Start Date
                      eCRUDParams.Add(GetExamParams.strCreationEndDt);          // End Date
                      //query by SSN and Physician begin
                      SrchECRUD.getExamBy('SSN_PHYSICIAN', eCRUDParams, queryResult);
                      //query by SSN and Physician end
                      exQry := True;
                    end
                    else                                                        // Search by SSN and Exam Status
                      if (GetExamParams.strPatientId <> IGNORE) and             // SSN = YES
                        (GetExamParams.strPhysicianFnm = IGNORE) and            // Physician = NO
                        (GetExamParams.strPhysicianMnm = IGNORE) and
                        (GetExamParams.strPhysicianLnm = IGNORE) and
                        (GetExamParams.strfacilityID = IGNORE) and              // Facility = NO
                        (Trim(GetExamParams.strExamstatus) <> '') and           // Exam Status = YES
                        (GetExamParams.strCreationStartDT <> IGNORE) and        // Date Range = YES
                        (GetExamParams.strCreationStartDT <> IGNORE) then
                      begin
                        eCRUDParams.Add(GetExamParams.strPatientId);            // SSN
                        eCRUDParams.Add(GetExamParams.strExamstatus);           // ExamStatus
                        eCRUDParams.Add(GetExamParams.strCreationStartDT);      // Start Date
                        eCRUDParams.Add(GetExamParams.strCreationEndDt);        // End Date
                        //query by SSN and ExamStatus begin
                        SrchECRUD.getExamBy('SSN_EXAMSTATUS', eCRUDParams, queryResult);
                        //query by SSN and ExamStatus end
                        exQry := True;
                      end
                      else                                                      // Search by SSN, Physician, and Exam Status
                        if (GetExamParams.strPatientId <> IGNORE) and           // SSN = YES
                          (Trim(GetExamParams.strPhysicianFnm) <> '') and       // PHYSICIAN = YES
                          (Trim(GetExamParams.strPhysicianMnm) <> '') and
                          (Trim(GetExamParams.strPhysicianLnm) <> '') and
                          (Trim(GetExamParams.strfacilityID) = IGNORE) and      // FACILITY = NO
                          (Trim(GetExamParams.strExamstatus) <> '') and         // Exam Status = YES
                          (GetExamParams.strCreationStartDT <> IGNORE) and
                          (GetExamParams.strCreationStartDT <> IGNORE) then
                        begin
                          eCRUDParams.Add(GetExamParams.strPatientId);          // SSN
                          if GetExamParams.strPhysicianFnm <> IGNORE then       // Physician - allow each part of the physician name to be blank
                            eCRUDParams.Add(GetExamParams.strPhysicianFnm)
                          else
                            eCrudParams.Add('');
                          if GetExamParams.strPhysicianMnm <> IGNORE then
                            eCRUDParams.Add(GetExamParams.strPhysicianMnm)
                          else
                            eCrudParams.Add('');
                          if GetExamParams.strPhysicianLnm <> IGNORE then
                            eCRUDParams.Add(GetExamParams.strPhysicianLnm)
                          else
                            eCrudParams.Add('');
                          eCRUDParams.Add(GetExamParams.strExamstatus);         // ExamStatus
                          eCRUDParams.Add(GetExamParams.strCreationStartDT);    // Start Date
                          eCRUDParams.Add(GetExamParams.strCreationEndDt);      // End Date
                          //query by SSN, Physician, Exam Status begin
                          SrchECRUD.getExamBy('SSN_PHYSICIAN_EXAMSTATUS', eCRUDParams, queryResult);
                          //query by SSN, Physician, Exam Status end
                          exQry := True;
                        end
                        else                                                    // Search by Facility and Physician and Exam Status
                          if (GetExamParams.strPatientId = IGNORE) and          // SSN = NO
                            (Trim(GetExamParams.strPhysicianFnm) <> '') and     // Physician = YES
                            (Trim(GetExamParams.strPhysicianMnm) <> '') and
                            (Trim(GetExamParams.strPhysicianLnm) <> '') and
                            (Trim(GetExamParams.strfacilityID) <> '') and       // Facility = YES
                            (Trim(GetExamParams.strExamstatus) <> '') and       // Exam Status = YES
                            (GetExamParams.strCreationStartDT <> IGNORE) and    // Date Range = YES
                            (GetExamParams.strCreationStartDT <> IGNORE) then
                          begin
                            eCRUDParams.Add(GetExamParams.strfacilityID);       // Facility
                            if GetExamParams.strPhysicianFnm <> IGNORE then     // Physician - allow each part of the physician name to be blank
                              eCRUDParams.Add(GetExamParams.strPhysicianFnm)
                            else
                              eCrudParams.Add('');
                            if GetExamParams.strPhysicianMnm <> IGNORE then
                              eCRUDParams.Add(GetExamParams.strPhysicianMnm)
                            else
                              eCrudParams.Add('');
                            if GetExamParams.strPhysicianLnm <> IGNORE then
                              eCRUDParams.Add(GetExamParams.strPhysicianLnm)
                            else
                              eCrudParams.Add('');
                            eCRUDParams.Add(GetExamParams.strExamstatus);       // ExamStatus
                            eCRUDParams.Add(GetExamParams.strCreationStartDT);  // Start Date
                            eCRUDParams.Add(GetExamParams.strCreationEndDt);    // End Date
                          //query by Facility and Physician and and ExamStatus begin
                            SrchECRUD.getExamBy('FACILITY_PHYSICIAN_EXAMSTATUS', eCRUDParams, queryResult);
                          //query by Facility and Physician and and ExamStatus end
                            exQry := True;
                          end
                          else                                                  // Search by SSN and Facility and Physician
                            if (GetExamParams.strPatientId <> IGNORE) and       // SSN = YES
                              (Trim(GetExamParams.strPhysicianFnm) <> '') and   // Physician = YES
                              (Trim(GetExamParams.strPhysicianMnm) <> '') and
                              (Trim(GetExamParams.strPhysicianLnm) <> '') and
                              (Trim(GetExamParams.strfacilityID) <> '') and     // Facility = YES
                              (GetExamParams.strExamstatus = IGNORE) and        // Exam Status = NO
                              (GetExamParams.strCreationStartDT <> IGNORE) and  // Date Range = YES
                              (GetExamParams.strCreationStartDT <> IGNORE) then
                            begin
                              eCRUDParams.Add(GetExamParams.strPatientId);      // SSN
                              eCRUDParams.Add(GetExamParams.strfacilityID);     // Facility
                              if GetExamParams.strPhysicianFnm <> IGNORE then   // Physician - allow each part of the physician name to be blank
                                eCRUDParams.Add(GetExamParams.strPhysicianFnm)
                              else
                                eCrudParams.Add('');
                              if GetExamParams.strPhysicianMnm <> IGNORE then
                                eCRUDParams.Add(GetExamParams.strPhysicianMnm)
                              else
                                eCrudParams.Add('');
                              if GetExamParams.strPhysicianLnm <> IGNORE then
                                eCRUDParams.Add(GetExamParams.strPhysicianLnm)
                              else
                                eCrudParams.Add('');
                              eCRUDParams.Add(GetExamParams.strCreationStartDT); // Start Date
                              eCRUDParams.Add(GetExamParams.strCreationEndDt);  // End Date
                            //query by SSN and Facility and Physician and ExamStatus begin
                              SrchECRUD.getExamBy('SSN_FACILITY_PHYSICIAN', eCRUDParams, queryResult);
                            //query by SSN and Facility and Physician and ExamStatus end
                              exQry := True;
                            end
                            else                                                // Search by SSN and Facility and Physician and Exam Status
                              if (GetExamParams.strPatientId <> IGNORE) and     // SSN = YES
                                (Trim(GetExamParams.strPhysicianFnm) <> '') and // Physician = YES
                                (Trim(GetExamParams.strPhysicianMnm) <> '') and
                                (Trim(GetExamParams.strPhysicianLnm) <> '') and
                                (Trim(GetExamParams.strfacilityID) <> '') and   // Facility = YES
                                (Trim(GetExamParams.strExamstatus) <> '') and   // Exam Status = YES
                                (GetExamParams.strCreationStartDT <> IGNORE) and // Date Range = YES
                                (GetExamParams.strCreationStartDT <> IGNORE) then
                              begin
                                eCRUDParams.Add(GetExamParams.strPatientId);    // SSN
                                eCRUDParams.Add(GetExamParams.strfacilityID);   // Facility
                                if GetExamParams.strPhysicianFnm <> IGNORE then // Physician - allow each part of the physician name to be blank
                                  eCRUDParams.Add(GetExamParams.strPhysicianFnm)
                                else
                                  eCrudParams.Add('');
                                if GetExamParams.strPhysicianMnm <> IGNORE then
                                  eCRUDParams.Add(GetExamParams.strPhysicianMnm)
                                else
                                  eCrudParams.Add('');
                                if GetExamParams.strPhysicianLnm <> IGNORE then
                                  eCRUDParams.Add(GetExamParams.strPhysicianLnm)
                                else
                                  eCrudParams.Add('');
                                eCRUDParams.Add(GetExamParams.strExamstatus);   // ExamStatus
                                eCRUDParams.Add(GetExamParams.strCreationStartDT); // Start Date
                                eCRUDParams.Add(GetExamParams.strCreationEndDt); // End Date
                              //query by SSN and Facility and Physician and ExamStatus begin
                                SrchECRUD.getExamBy('SSN_FACILITY_PHYSICIAN_EXAMSTATUS', eCRUDParams, queryResult);
                              //query by SSN and Facility and Physician and ExamStatus end
                                exQry := True;
                              end;


    if exQry then begin
      if queryResult.Count > 0 then begin
        strHdrWarning := srchECRUD.HTTPServer.ManagedIdHTTP.Response.RawHeaders.Values['Warning']; // rpk 9/29/2014
        if strHdrWarning > '' then                                              // 100 Max Record Limit Exceeded - rpk 9/29/2014
          ShowMessageCAPRI(strHdrWarning + '; Please revise your search criteria to select fewer records.'); // rpk 9/29/2014
        //Display XML Results to user
        frmVlerRtrvExamDocs := TfrmVlerRetrievalExamDocs.Create(self);
        try
          TfrmVlerRetrievalExamDocs.InitializeExamDocsGridHeader(frmVlerRtrvExamDocs);
          TfrmVlerRetrievalExamDocs.FillExamDocsFromResultList(frmVlerRtrvExamDocs, queryResult);

          frmVlerRtrvExamDocs.ShowModal;
        finally
          FreeAndNil(frmVlerRtrvExamDocs);
        end;                                                                    //end try
      end;                                                                      // if count > 0
    end                                                                         // if exQry

  finally                                                                       // rpk 8/26/2014
    FreeAndNilTStringsWithObjects(TStrings(eCRUDParams));
    FreeAndNilTStringsWithObjects(TStrings(queryResult));
    SrchECRUD.Free;
  end;                                                                          // rpk 8/26/2014

  screen.cursor := crDefault;
  self.btnMultiSrch.Enabled := True;

end;                                                                            // btnMultiSrchClick


function TfrmVlerGetExams.convertDateToGMTStr(InDate: TDateTime; StartDt: Boolean): string;
var
  GMT: string;
begin
  // If you put in the same day for date range, the start time should be at 00:00:00
  // and the end time should be 23:59:59 in order to return any results
  if StartDt then
    GMT := FormatDateTime('yyyy-mm-dd"T00:00:00-00:00"', InDate)
  else
    GMT := FormatDateTime('yyyy-mm-dd"T23:59:59-00:00"', InDate);
//GMT:=FormatDateTime('yyyy-mm-dd"T"hh:nn:ss"Z"', InDate);
  result := GMT;

end;

procedure TfrmVlerGetExams.dttmepckrCreateEndDTEnter(Sender: TObject);
begin
  GetScreenReader.Speak('Creation End Date');
end;

procedure TfrmVlerGetExams.dttmepckrCreateEndDTExit(Sender: TObject);
begin
  if (dttmepckrCreateEndDT.DateTime < dttmepckrCreateStrtDT.DateTime) then
  begin
    MessageDlg('Creation End Date Cannot be less than Creation Start Date!', mtError, [mbOK], -1);
    dttmepckrCreateEndDT.DateTime := Now;
  end;
end;

procedure TfrmVlerGetExams.dttmepckrCreateStrtDTEnter(Sender: TObject);
begin
  GetScreenReader.Speak('Creation Start Date');
end;

procedure TfrmVlerGetExams.dttmepckrCreateStrtDTExit(Sender: TObject);
begin
  if (dttmepckrCreateStrtDT.DateTime > dttmepckrCreateEndDT.DateTime) then
  begin
    MessageDlg('Creation Start Date Cannot be greater than Creation End Date!', mtError, [mbOK], -1);
    dttmepckrCreateStrtDT.DateTime := Now;
  end;
end;

procedure TfrmVlerGetExams.edtTPatientSSNExit(Sender: TObject);
const
  SSN_NOT_VALID = 'SSN is not valid';
  SSN_OK = 'SSN OK';
var
  TestSSN: Integer;
  Pseudo: string;
  ErrorMsg: string;
begin
  ErrorMsg := SSN_OK;
  if length(edtTPatientSSN.Text) = 9 then                                       // valid length, test for #
  begin
    TestSSN := StrToIntDef(edtTPatientSSN.Text, -1);
    if TestSSN = -1 then
      ErrorMsg := SSN_NOT_VALID;
  end
  else if length(edtTPatientSSN.Text) = 10 then                                 // allow SSN + P indicating PseudoSSN
  begin
    TestSSN := StrToIntDef(Copy(edtTPatientSSN.Text, 1, 9), -1);
    Pseudo := Copy(edtTPatientSSN.Text, 10, 1);
    if TestSSN = -1 then
      ErrorMsg := SSN_NOT_VALID;
    if UpperCase(Pseudo) <> 'P' then
      ErrorMsg := SSN_NOT_VALID;
  end
  else if length(edtTPatientSSN.Text) = 0 then                                  // blank SSN is fine
  begin
    ErrorMsg := SSN_OK;
  end
  else                                                                          // isn't 0 or 9 or 10 characters so must be invalid
    ErrorMsg := SSN_NOT_VALID;

  if ErrorMsg = SSN_NOT_VALID then
  begin
    ShowMessageCAPRI(ErrorMsg);
    edtTPatientSSN.Clear;
    edtTPatientSSN.SetFocus;
  end;
end;

class function TfrmVlerGetExams.FreeTList(var aTList: TList): Boolean;
var
  I: Integer;
begin
  result := true;
  if assigned(aTList) then begin
    try
      try
        for I := 0 to aTList.Count - 1 do
      // aTList[i] = new(pVLERAttachNodeValue)
          dispose(PVLERAttachNodeVal(aTList[i]));
        aTlist.Clear;
//    aTlist.Free;
      except
        on E: Exception do
          result := False;
      end;
    finally
//    aTlist.Clear;
      FreeAndNil(aTList);
    end;
  end;                                                                          // if assigned
end;



procedure TfrmVlerGetExams.FormCreate(Sender: TObject);
begin
 //Set Exam status value for cmbxExmStatus
  setExamStatus(cmbxExmStatus.Items);
  dttmepckrCreateStrtDT.DateTime := Now;
  dttmepckrCreateEndDT.DateTime := Now;
end;

procedure TfrmVlerGetExams.FormDestroy(Sender: TObject);
begin
  strlstFacilityandDateRange.Free;
  strlstPhysicianDateRange.Free;
  strlstExamStatusDateRange.Free;
  strlstMultiSelect.Free;
end;


procedure TfrmVlerGetExams.setExamStatus(Status: TStrings);
begin
  //Query VLER to obtain list of Exam status - TO DO
  //Stub the data values
  Status.Add('Completed');
  Status.Add('Rejected');
end;


procedure TfrmVlerGetExams.setSearchExamparams;
begin

  if Trim(edtTPatientSSN.Text) <> '' then
    GetExamParams.strPatientId := edtTPatientSSN.Text
  else
    GetExamParams.strPatientId := IGNORE;

  if Trim(cmbxFcltyLoc.Text) <> '' then
    GetExamParams.strfacilityID := cmbxFcltyLoc.Text
  else
    GetExamParams.strfacilityID := IGNORE;

  if Trim(cmbxPhysicianFnm.Text) <> '' then
    GetExamParams.strPhysicianFnm := cmbxPhysicianFnm.Text
  else
    GetExamParams.strPhysicianFnm := IGNORE;

  if Trim(cmbxPhysicianMnm.Text) <> '' then
    GetExamParams.strPhysicianMnm := cmbxPhysicianMnm.Text
  else
    GetExamParams.strPhysicianMnm := IGNORE;

  if Trim(cmbxPhysicianLnm.Text) <> '' then
    GetExamParams.strPhysicianLnm := cmbxPhysicianLnm.Text
  else
    GetExamParams.strPhysicianLnm := IGNORE;

  if Trim(cmbxExmStatus.Text) <> '' then
    GetExamParams.strExamstatus := cmbxExmStatus.Text
  else
    GetExamParams.strExamstatus := IGNORE;

  if Trim(DateToStr(dttmepckrCreateStrtDT.DateTime)) <> '' then
    GetExamParams.strCreationStartDT := convertDateToGMTStr(dttmepckrCreateStrtDT.DateTime, TRUE)
  else
    GetExamParams.strCreationStartDT := IGNORE;

  if Trim(DateToStr(dttmepckrCreateEndDT.DateTime)) <> '' then
    GetExamParams.strCreationEndDt := convertDateToGMTStr(dttmepckrCreateEndDT.DateTime, FALSE)
  else
    GetExamParams.strCreationEndDt := IGNORE;

 (* showmessage('GetExamParams: ' +  GetExamParams.strPatientId + ' : ' +
               GetExamParams.strPhysicianFnm + ' : ' +
               GetExamParams.strPhysicianMnm + ' : '+
               GetExamParams.strPhysicianLnm + ' : '+GetExamParams.strfacilityID + ' : ' +
               GetExamParams.strExamstatus + ' : '  + GetExamParams.strCreationStartDT +
               ' : ' + GetExamParams.strCreationEndDt); *)

end;

initialization

finalization
  TfrmVlerGetExams.FreeTList(aAttachNodeList);

end.

