unit PNCSPanelLoader;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Diaccess, Fmcmpnts, Fmcntrls, ZipMcpt, ComCtrls, Main,
  CCOWRPCBrokerCAPRI, TRPCB, DialogsCAPRI, ORFn, PNCSMain, Unsigned, Wait,
  UUCode, XsdEngineLite, XmlConfig, MergePScripts;

type
  TPNCSPanelLoaderForm = class(TForm)
    Label1: TLabel;
    FmGets_CapriTemplateFile: TFMGets;
    FmMemo_TemplatesUtilized: TFMMemo;
    FmGets_CapriTemplateDefinitionFile: TFMGets;
    MiniZip: TMiniZip;
    FormDefinition: TRichEdit;
    Report: TRichEdit;
    ReportDefinition: TRichEdit;
    ScriptDefinition: TRichEdit;
    FmMemo_Comments: TFMMemo;
    FmMemo_FormData: TFMMemo;
  private
  public
    procedure TryLoad(CapriTemplateIEN: String);
  end;

var
  PNCSPanelLoaderForm: TPNCSPanelLoaderForm;

implementation

{$R *.dfm}

procedure TPNCSPanelLoaderForm.TryLoad(CapriTemplateIEN: String);
var
  i, j: Integer;
  formToMergeIEN: String;
  totalObjectCount: Integer;
  numberOfTemplates: Integer;
  formFilename: String;
  formFileNameHandle: Integer;

  codeLines, fileLines, reportLines: TStringList;

  pascalScript: TStringList;

  xmlMapFile: TStringList;
  xmlConfigFile: TStringList;
begin
  if CapriTemplateIEN = '' then
    Exit;

  If Not frmMain.IsRPCBrokerConnected() Then Exit;
  If ANURemoteProcedureCallInProgress = True Then Exit;
  If frmMain.IsPNCSOpen() Then Exit;

  FmGets_CapriTemplateFile.IENS := CapriTemplateIEN;
  FmGets_CapriTemplateFile.GetAndFill;

  FormDefinition.Lines.Clear;
  ScriptDefinition.Lines.Clear;
  ReportDefinition.Lines.Clear;
  Report.Lines.Clear;

  frmMain.RPCBroker1.RemoteProcedure := 'DVBAB LOAD FORM';
  frmMain.RPCBroker1.Param[0].Value := CapriTemplateIEN;
  frmMain.RPCBroker1.Param[0].PType := literal;
  frmMain.RPCBrokerCall;
  Try
    frmMain.RPCBroker1.Call;
  Except
    On EBrokerError Do
    Begin
      ANURemoteProcedureCallInProgress := False;
      frmMain.AnimateLogo(False);
      Application.ProcessMessages;
      ShowMessageCAPRI('DVBAB LOAD FORM could not be accessed!');
      Exit;
    End;
  End;

  FmMemo_FormData.Lines.Clear;
  QuickCopy(frmMain.RPCBroker1.Results, FmMemo_FormData.Lines);

  pncsForm := TPNCSForm.Create(Application);

  pncsForm.xEditMode.Text            := 'OPEN';
  pncsForm.xEditFormNum.Text         := '0';
  pncsForm.xPatientIENS.Caption      := FmGets_CapriTemplateFile.GetField('.01').FMDBInternal;
  pncsForm.xFMEdit2.IENS             := FmGets_CapriTemplateFile.IENS;
  pncsForm.xFMEdit4.IENS             := FmGets_CapriTemplateFile.IENS;
  pncsForm.xFMEdit5.IENS             := FmGets_CapriTemplateFile.IENS;
  pncsForm.xFMEdit6.IENS             := FmGets_CapriTemplateFile.IENS;
  pncsForm.xFMEdit7.IENS             := FmGets_CapriTemplateFile.IENS;
  pncsForm.xFMEdit8.IENS             := FmGets_CapriTemplateFile.IENS;
  pncsForm.xFMEdit10.IENS            := FmGets_CapriTemplateFile.IENS;
  pncsForm.xFMEdit11.IENS            := FmGets_CapriTemplateFile.IENS;
  pncsForm.xFMEditReviewStatus.IENS  := FmGets_CapriTemplateFile.IENS;
  pncsForm.xFormData.IENS            := FmGets_CapriTemplateFile.IENS;
  pncsForm.xFMTemplatesUtilized.IENS := FmGets_CapriTemplateFile.IENS;

  If Not pncsForm.DoLock Then
  Begin
    pncsForm.TemplateAction := '~CLOSE~';  //CodeCR107 - rpm 5/12/10
    pncsForm.Hide;
    If Assigned(UnsignedView) Then
      UnsignedView.FormatFormList1;
    WaitForm.Hide;
    Exit;
  End;

  FmMemo_Comments.Lines.Clear;

  pascalScript := TStringList.Create;
  pascalScript.Clear;

  totalObjectCount := 0;
  numberOfTemplates := -1;

  for i := 0 To FmMemo_TemplatesUtilized.Lines.Count - 1 Do
  Begin
    formToMergeIEN := Piece(FmMemo_TemplatesUtilized.Lines[i], '^', 1);

    If (FmMemo_TemplatesUtilized.Lines[i]) = '' Then
    Begin
      ShowMessageCAPRI('The template definition info is missing.  Closing CAPRI to prevent data corruption.');
      Exit;
    End;

    FmGets_CapriTemplateDefinitionFile.IENS := formToMergeIEN;
    FmGets_CapriTemplateDefinitionFile.GetData;

    InfoComment := InfoComment + Uppercase(Piece(FmMemo_TemplatesUtilized.Lines[i], '^', 2)) + ':' + char(13);

    If FmMemo_Comments.Lines.Count > 0 Then
    Begin
      For j := 0 To FmMemo_Comments.Lines.Count - 1 Do
        InfoComment := InfoComment + FmMemo_Comments.Lines[j] + char(13);
    End
    Else
    Begin
      InfoComment := InfoComment + '[NO COMMENT FOUND]' + char(13);
    End;

    InfoComment := InfoComment + 'Object Count: ' + FmGets_CapriTemplateDefinitionFile.GetField('8').FMDBExternal + char(13);
    InfoComment := InfoComment + char(13);
    Try
      totalObjectCount := totalObjectCount + StrToInt(FmGets_CapriTemplateDefinitionFile.GetField('8').FMDBExternal);
    Except
    End;

    WaitForm.BringToFront;
    WaitForm.Label1.Caption := 'Loading ' + Piece(FmMemo_TemplatesUtilized.Lines[i], '^', 2);
    waitform.imagedisk.visible := false;
    waitform.imagenetwork.visible := false;
    waitform.imagedisk.repaint;
    waitform.imagenetwork.repaint;
    WaitForm.Repaint;

    formFilename := TempDir;
    formFilename := formFilename + FmGets_CapriTemplateDefinitionFile.GetField('.01').FMDBExternal + '^';
    formFilename := formFilename + FmGets_CapriTemplateDefinitionFile.GetField('5').FMDBInternal + '.zip';

    If FileExists(formFilename) = False Then
    Begin
      waitform.imagenetwork.visible := True;
      waitform.imagenetwork.repaint;
      waitform.repaint;

      frmMain.RPCBroker1.RemoteProcedure := 'DVBAB TEMPLATE DEFINITION';
      frmMain.RPCBroker1.Param[0].Value := formToMergeIEN;
      frmMain.RPCBroker1.Param[0].PType := literal;
      frmMain.RPCBroker1.Param[1].Value := '1';
      frmMain.RPCBroker1.Param[1].PType := literal;
      WaitForm.StaticText1.Caption := 'Loading definition...';
      Waitform.StaticText1.Repaint;
      frmMain.RPCBrokerCall;
      Try
        frmMain.RPCBroker1.Call;
      Except
        On EBrokerError Do
        Begin
          ANURemoteProcedureCallInProgress := False;
          frmMain.AnimateLogo(False);
          Application.ProcessMessages;
          ShowMessageCAPRI('DVBAB TEMPLATE DEFINITION could not be accessed!');
        End;
      End;

      If frmMain.RPCBroker1.Results.Count = 0 Then
      Begin
        ShowmessageCAPRI('The template definition needed for ' + Piece(FmMemo_TemplatesUtilized.Lines[i], '^', 2) + ' (IEN #' + formToMergeIEN + ') is no longer available in the file.');
        exit;
      End;

      screen.cursor := crhourglass;
      WaitForm.StaticText1.Caption := 'Decoding...';
      Waitform.StaticText1.Repaint;
      TempFileName := Copy(frmMain.RPCBroker1.Results[0], 11, 999);
      If TempFileName = '' Then
      Begin
        ShowMessageCAPRI('There was a problem with the definition file.');
        Exit;
      End;

      If FileExists(TempDir + TempFileName + '.uue') Then
      Begin
        Try
          DeleteFile(PAnsiChar(TempDir + TempFileName + '.uue'))
        Except
          Begin
            ShowMessageCAPRI('You have an outdated definition that cannot be deleted.');
            Exit;
          End;
        End;
      End;

      If FileExists(TempDir + TempFileName) Then
      Begin
        Try
          DeleteFile(PAnsiChar(TempDir + TempFileName))
        Except
          Begin
            ShowMessageCAPRI('You have an outdated definition that cannot be deleted.');
            Exit;
          End;
        End;
      End;

      frmMain.RPCBroker1.Results.SaveToFile(TempDir + TempFileName + '.uue');
      UUDecode(TempDir + TempFileName + '.uue');
      DeleteFile(PAnsiChar(TempDir + TempFileName + '.uue'));
      RenameFile(TempDir + TempFileName, formfilename);

      MiniZip.UnZipFile := formfilename;
      MiniZip.UnzipAllTo(TempDir);
      MiniZip.UnZipFile := '';

      TempFileName := Piece(TempFilename, '.', 1);

      RenameFile(TempDir + TempFileName + '.pnl.frm', formfilename + '.pnl.frm');
      RenameFile(TempDir + TempFileName + '.pnl.cde', formfilename + '.pnl.cde');
      RenameFile(TempDir + TempFileName + '.pnl.rep', formfilename + '.pnl.rep');

      if FileExists(TempDir + TempFileName + TXsdEngineLite.FILE_EXTENSION) then
        RenameFile(TempDir + TempFileName + TXsdEngineLite.FILE_EXTENSION, formfilename + TXsdEngineLite.FILE_EXTENSION);

      if FileExists(TempDir + TempFileName + TXmlConfig.FILE_EXTENSION) then
        RenameFile(TempDir + TempFileName + TXmlConfig.FILE_EXTENSION, formfilename + TXmlConfig.FILE_EXTENSION);      
      
    End
    Else
    Begin // end of file not found on disk yet
      waitform.imagedisk.visible := true;
      waitform.imagedisk.repaint;
      waitform.repaint
    End;

    // Touch form date/time
    formFileNameHandle := FileOpen(formFileName, fmOpenReadWrite);
    If formfileNamehandle > -1 Then
      FileSetDate(formfilename, DateTimeToFileDate(now));
    FileClose(formFileNameHandle);

    FormDefinition.Lines.LoadFromFile(formfilename + '.pnl.frm');
    ScriptDefinition.Lines.LoadFromFile(formfilename + '.pnl.cde');
    ReportDefinition.Lines.LoadFromFile(formfilename + '.pnl.rep');

    if FileExists(formfilename + TXsdEngineLite.FILE_EXTENSION) then
    begin
      xmlMapFile := TStringList.Create;
      xmlMapFile.LoadFromFile(formfilename + TXsdEngineLite.FILE_EXTENSION);
    end;

    if FileExists(formfilename + TXmlConfig.FILE_EXTENSION) then
    begin
      xmlConfigFile := TStringList.Create;
      xmlConfigFile.LoadFromFile(formfilename + TXmlConfig.FILE_EXTENSION);
    end;

    // Might need to convert to Pascal
    If ReportDefinition.Lines.Count > 0 Then
      If Pos('PROGRAM ', Trim(Uppercase(ReportDefinition.Lines[0]))) <> 1 Then
      Begin
        PNCSForm.ConvertOldStyleScriptToPascalScript(ReportDefinition);
      End;

    If ANURemoteProcedureCallInProgress = True Then
      Repeat application.processMessages Until
      ANURemoteProcedureCallInProgress = False;

    codeLines   := TStringList.Create;
    fileLines   := TStringList.Create;
    reportLines := TStringList.Create;

    Try
      QuickCopy(FormDefinition, fileLines);
      QuickCopy(ScriptDefinition, codeLines);
      QuickCopy(ReportDefinition, reportLines);

      // Check if PScript Type and do merge
      If POS('PROGRAM ', trim(uppercase(CodeLines[0]))) = 1 Then
      Begin
        MergePScript(pascalScript, CodeLines);
        codelines.clear;
        codelines.add('');
        codelines.add('');
      End;
                          //form def, script def, temp file name
      PNCSForm.LoadBaseExam(fileLines, codeLines, TempFileName,
                            xmlMapFile, xmlConfigFile);

    Finally
      FreeAndNil(codeLines  );
      FreeAndNil(fileLines  );
      FreeAndNil(reportLines);
	  
	  xmlMapFile := Nil;
	  xmlConfigFile := Nil;
    End;
    //************************************************************

    PNCSForm.localExam := PNCSForm.Exams[0];

    PNCSForm.xOutputDesign.Lines.Add('// // // //!@#$FORMSTART$#@!');
    // Apppend the report to the existing one
    PNCSForm.xOutputDesign.Lines.Add(ReportDefinition.Lines.Text);
    PNCSForm.xOutputDesign.Lines.Add('// // // //!@#$FORMEND$#@!');

    Inc(numberOfTemplates);

    If numberOfTemplates = 0 Then // Special case if only 1 Exam
      PNCSForm.localExam.Merge(Nil) // Merge with nothing
    Else
      PNCSForm.localExam.Merge(PNCSForm.Exams[numberOfTemplates]);
  End;      // insert return
  InfoComment := InfoComment + char(13);
  InfoComment := InfoComment + 'Total Object Count: ' + IntToStr(totalObjectCount) + char(13);
  WaitForm.StaticText1.Caption := 'Initializing...';
  Waitform.StaticText1.Repaint;
  waitform.imagedisk.visible := false;
  waitform.imagenetwork.visible := false;
  waitform.imagedisk.repaint;
  waitform.imagenetwork.repaint;
  waitform.repaint;
  //************************************************************

  PNCSForm.ShowExam;

  DeleteFile(PAnsiChar(TempDir + TempFileName + '.pnl'));

  QuickCopy(PNCSForm.localExam.Code.Script, PNCSForm.xMemoCode);
  WaitForm.Label1.Caption := 'Processing ...';
  WaitForm.Label1.Repaint;

  WaitForm.StaticText1.Caption := 'Repopulating objects...';
  Waitform.StaticText1.Repaint;
  QuickCopy(FmMemo_FormData, PNCSForm.xFormData);
  QuickCopy(FmMemo_TemplatesUtilized, PNCSForm.xFMTemplatesUtilized);
  PNCSForm.xDateTimeOfNote.Text := FmGets_CapriTemplateFile.GetField('4').FMDBExternal;
  PNCSForm.Caption := FmGets_CapriTemplateFile.GetField('9').FMDBExternal;
  PNCSForm.xFMPatientName.Caption := PatientName;
  PNCSForm.xFMSSN.Caption := PatientSSN;
  PNCSForm.xAuthorButton.Caption := FmGets_CapriTemplateFile.GetField('2').FMDBExternal;

  PNCSForm.xFMEdit2.Text := '`' + FmGets_CapriTemplateFile.GetField('.01').FMDBInternal;
  If FmGets_CapriTemplateFile.GetField('10').FMDBInternal <> '' Then
  Begin
    PNCSForm.xFMEdit4.Text := '`' + FmGets_CapriTemplateFile.GetField('10').FMDBInternal; //Transcriber
    If PNCSForm.xFMEdit4.Validate Then
    Begin
      PNCSForm.xFMEdit4.Text := PNCSForm.xFMEdit4.FMCtrlExternal;
    End;
  End
  Else
    PNCSForm.xFMEdit4.Text := '';

  PNCSForm.xFMEdit5.Text := '`' + FmGets_CapriTemplateFile.GetField('2').FMDBInternal;
  PNCSForm.xFMEdit6.Text := FmGets_CapriTemplateFile.GetField('3').FMDBExternal;
  PNCSForm.xFMEdit7.Text := FmGets_CapriTemplateFile.GetField('4').FMDBExternal;
  PNCSForm.xFMEdit8.Text := FmGets_CapriTemplateFile.GetField('5').FMDBExternal;
  PNCSForm.xFMEdit10.Text := FmGets_CapriTemplateFile.GetField('7').FMDBExternal;
  PNCSForm.xFMEdit11.Text := FmGets_CapriTemplateFile.GetField('9').FMDBExternal;
  PNCSForm.xFMEditReviewStatus.Text := FmGets_CapriTemplateFile.GetField('11').FMDBExternal;

  if pascalScript.Count > 0 then
  begin
    Quickcopy(pascalScript, PNCSForm.xMemoCode);
    PNCSForm.zzzzEditScriptStyle.text := 'PASCAL SCRIPT';
  end;

  pncsForm.SetupForm(Self);
  pncsForm.xTimerGo.Enabled := True;
  pncsForm.Hide;

  pascalScript.Free;
  Screen.Cursor := crDefault;
  WaitForm.Hide;
end;

end.
