// CodeCR696 JRL 4/8/15
// Unit added to mimic a Find Dialog for searching text on the Clinical Documents
// Tab with a right-click menu option.
unit SearchText;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls;

type
  TfrmSearchText = class(TForm)
    btnCancel: TButton;
    stFindWhat: TStaticText;
    edtFindText: TEdit;
    btnFindNext: TButton;
    chkMatchWholeWordOnly: TCheckBox;
    chkMatchCase: TCheckBox;
    procedure FormActivate(Sender: TObject);
    procedure btnFindNextClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmSearchText: TfrmSearchText;

implementation

uses
  Main;
{$R *.dfm}

//------------------------------------------------------------------------------
// Cancel Button Clicked                                    CodeCR696 JRL 4/8/15
//------------------------------------------------------------------------------
procedure TfrmSearchText.btnCancelClick(Sender: TObject);
begin
  Close;
end;

//------------------------------------------------------------------------------
// Find Next Button Clicked                                 CodeCR696 JRL 4/8/15
//------------------------------------------------------------------------------
procedure TfrmSearchText.btnFindNextClick(Sender: TObject);
begin
   frmMain.SearchText.FindText := edtFindText.Text;
   if chkMatchWholeWordOnly.Checked then
      frmMain.SearchText.Options := [stWholeWord]; // whole word search?
   if chkMatchCase.Checked then
      frmMain.SearchText.Options := [stMatchCase]; // case-sensitive search?
   frmMain.RunSearch(frmMain.SearchText.FindText);
end;

//------------------------------------------------------------------------------
// Form Activate                                            CodeCR696 JRL 4/8/15
//------------------------------------------------------------------------------
procedure TfrmSearchText.FormActivate(Sender: TObject);
begin
  if edtFindText.CanFocus then
     edtFindText.SetFocus;
end;

end.
