Unit checkremoteconnections;

Interface

Uses
  Windows,
  Classes,
  Controls,
  Dialogs,
  DialogsCAPRI,
  Forms,
  Gauges,
  Graphics,
  Main,
  Messages,
  ORCtrls,
  StdCtrls,
  SysUtils,
  TRPCB,
  CCOWRPCBrokerCAPRI, CCOWRPCBroker;

Type
  TfrmCheckRemoteConnections = Class(TForm)
    btnSelectAll: TButton;
    Button1     : TButton;
    Button2     : TButton;
    Gauge1      : TGauge;
    Label1      : TLabel;
    Label2      : TLabel;
    Label3      : TLabel;
    ORListBox1  : TORListBox;
    RPCBrokerRemote: TCCOWRPCBrokerCAPRI;
    lbFailure: TORListBox;
    lbSuccess: TORListBox;
    Procedure btnSelectAllClick(Sender: TObject);
    Procedure Button1Click(Sender: TObject);
    Procedure Button2Click(Sender: TObject);
    Procedure FormActivate(Sender: TObject);
    Procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  Private
    { Private declarations }
    function ConnectToHomeServer(): Boolean;  //rpm 6/29/09 - support addt'l broker
    function ConnectToRemoteServer(aServer: String; aPort: String): Boolean;  //rpm 6/29/09 - support addt'l broker
  Public
    { Public declarations }
    boDebug     : Boolean;
    sgDebugData : String;
  End;

Var
  frmCheckRemoteConnections: TfrmCheckRemoteConnections;
  stopcheck                : boolean;

Implementation

Uses
  caprisupport,
  essoselect;

{$R *.DFM}

Procedure TfrmCheckRemoteConnections.Button1Click(Sender: TObject);
Var
  boConnected: Boolean;
  count      : integer;
  x          : integer;

  Procedure stoprunning;
  Begin
    // Stop run here...
    RPCBrokerRemote.Connected := False;
    Gauge1.Visible := False;
    frmCheckRemoteConnections.height := 354;
    btnSelectAll.Enabled := True;
    Button2.Enabled := True;
    Button1.Enabled := True;
    Button1.Caption := '&Run Selected';
    StopCheck := True;
  End;
Begin
  If Button1.Caption <> '&Abort' Then
  Begin
    Count := 0;
    For x := 0 To ORListBox1.Items.Count - 1 Do
      If ORListBox1.Selected[x] = True Then
        inc(Count);
    If Count = 0 Then
    Begin
      // Stop run here...
      StopRunning;
      exit;
    End;

    If Gauge1.Visible = True Then
    Begin
      ShowMessageCAPRI('Previous connection in progress.  Please try again.');
      exit;
    End;
    btnSelectAll.Enabled := False;
    Button2.Enabled := False;
    Button1.Caption := '&Abort';
    Application.ProcessMessages();//rlm
    lbSuccess.Items.Clear; //CodeCR110 -MER 06/2010
    lbFailure.Items.Clear; //CodeCR110 -MER 06/2010
    If ORListBox1.Items.Count = 0 Then
      exit;
    Gauge1.Visible := True;
    frmCheckRemoteConnections.height := 376;
    //First count them up and set the gauge
    Gauge1.Progress := 0;
    Gauge1.MaxValue := Count;
    StopCheck := False;

    //rpm 6/29/09 - Home server connection required to obtain BSE tokens
    if ConnectToHomeServer then
    begin
      // Now run the list
      For x := 0 To ORListBox1.Items.Count - 1 Do
      Begin
        If ORListBox1.Selected[x] = True Then
        Begin
          Gauge1.Progress := Gauge1.Progress + 1;
          Application.ProcessMessages();//rlm
          If boDebug Then
          Begin
            Sleep(1000);
            boConnected:=True;
          End
          Else
          Begin
            Try
              //rpm 6/29/09 - remote connection using BSE token
              if ConnectToRemoteServer(frmMain.Piece(ORListBox1.Items[x], '^', 2),
                                       frmMain.Piece(ORListBox1.Items[x], '^', 3)) then
                boConnected := True
              else
                boConnected := False;
            Except
              boConnected:=False;
            End;
          End;
          If boConnected Then
          Begin
            lbSuccess.Items.Add(frmMain.Piece(ORListBox1.Items[x], '^', 1)); //CodeCR110 -MER 06/2010
          End
          Else
          Begin
            lbFailure.Items.Add(frmMain.Piece(ORListBox1.Items[x], '^', 1)); //CodeCR110 -MER 06/2010
          End;
          Application.ProcessMessages();//rlm
          If StopCheck = True Then
          Begin
            ShowMessageCapri('Aborting Connection Validation Process.');
            Break;
          End;
        End;
      End;
      frmMain.RPCBroker1.Connected := False;  //rpm 6/29/09 - addt'l broker support
    end;

    If StopCheck = False Then
    Begin
      Application.BringToFront;
      ShowMessageCapri('Completed Connection Validation Process.');
    End;
    StopRunning;
  End
  Else
  Begin
    // Stop run here...
    StopRunning;
  End;
End;

Procedure TfrmCheckRemoteConnections.Button2Click(Sender: TObject);
Begin
  modalresult := mrOK;
End;

Procedure TfrmCheckRemoteConnections.FormCreate(Sender: TObject);
Var
  x: integer;
Begin
  If (ESSOVersion = true) Then
  Begin
    If formESSOSelect.slUserSites.Count > 0 Then  //CodeCR77
      For x := 0 To formESSOSelect.slUserSites.Count - 1 Do
        ORListBox1.Items.Add(formESSOSelect.slUserSites[x]);
  End;
End;

Procedure TfrmCheckRemoteConnections.btnSelectAllClick(Sender: TObject);
Begin
  OrListBoxSelectAll(ORListBox1);
End;

Procedure TfrmCheckRemoteConnections.FormActivate(Sender: TObject);
Begin
  If Tag=0 Then
  Begin
    boDebug:= False;
    sgDebugData :=
      'ALBANY'+#13+#10+
      'ALBUQUERQUE'+#13+#10+
      'ALEXANDRIA'+#13+#10+
      'ALTOONA'+#13+#10+
      'AMARILLO HCS'+#13+#10+
      'ANCHORAGE VAMROC'+#13+#10+
      'ANN ARBOR'+#13+#10+
      'ARIZONA HCS'+#13+#10+
      'ASHEVILLE'+#13+#10+
      'ATLANTA'+#13+#10+
      'AUGUSTA'+#13+#10+
      'BALTIMORE'+#13+#10+
      'BATAVIA'+#13+#10+
      'BATH'+#13+#10+
      'BATTLE CREEK'+#13+#10+
      'BAY PINES VA HCS'+#13+#10+
      'BECKLEY'+#13+#10+
      'BEDFORD'+#13+#10+
      'BIG SPRING';
    If boDebug Then
    Begin
      ShowMessage('Warning! this dialog is in DEBUG mode.');
      ORListBox1.Items.SetText(PAnsiChar(sgDebugData));
    End;
    Gauge1.Visible := False;
    frmCheckRemoteConnections.height := 354;
    Tag:=1;
  End;
End;

procedure TfrmCheckRemoteConnections.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Tag:=0;
end;

{=================================================================
 ConnectToHomeServer
 rpm 6/29/09
 This function creates connection to home server to retrieve BSE tokens.
 Returns TRUE on successful connection; otherwise returns FALSE.
 =================================================================}
function TfrmCheckRemoteConnections.ConnectToHomeServer: Boolean;
begin
  Result := False;
  frmMain.RPCBroker1.Connected := False;
  if frmMain.RPCBroker1.Connect2HomeServer(frmMain.RPCBroker1.ANUAccessCodeHome,
                                      frmMain.RPCBroker1.ANUVerifyCodeHome,
                                      frmMain.RPCBroker1.ANUstrServerHome,
                                      frmMain.RPCBroker1.ANUstrPortHome,
                                      False) then
  begin
    frmMain.RPCBroker1.CreateContext('DVBA CAPRI GUI');
    Result := True;
  end;
end;

{=================================================================
 ConnectToRemoteServer
 rpm 6/29/09
 This function retrieves BSE token from home server connection and
 creates connection to remote server using BSE token.
 Returns TRUE on successful connection; otherwise returns FALSE.
 =================================================================}
function TfrmCheckRemoteConnections.ConnectToRemoteServer(aServer: String; aPort: String): Boolean;
begin
  Result := False;
  RPCBrokerRemote.Connected := False;
  try
    frmMain.RPCBroker1.RemoteProcedure := 'XUS SET VISITOR';
    frmMain.RPCBroker1.Call;
    if frmMain.RPCBroker1.Results.Count > 0 then
    begin
      RPCBrokerRemote.ANUBSEToken := frmMain.RPCBroker1.Results[0];
      RPCBrokerRemote.ANUTestMode := frmMain.RPCBroker1.ANUTestMode;
      if RPCBrokerRemote.Connect2RemoteServer(aServer, aPort, False, False) then
        Result := True;
    end;
  except
    RPCBrokerRemote.Connected := False;
    Result := False;
  end;
end;

End.
