Unit checktasks;

Interface

Uses
  Classes,
  Controls,
  Diaccess,
  Dialogs,
  DialogsCAPRI,
  Fmcmpnts,
  Fmcntrls,
  Forms,
  Gauges,
  Graphics,
  Main,
  Messages,
  ORCtrls,
  StdCtrls,
  SysUtils,
  TRPCB,
  Windows,
  CCOWRPCBrokerCAPRI;

Type
  TfrmCheckTasks = Class(TForm)
    btnSelectAll  : TButton;
    Button1       : TButton;
    Button2       : TButton;
    FMListBoxTasks: TFMListBox;
    FMListerTasks : TFMLister;
    Gauge1        : TGauge;
    Label1        : TLabel;
    Label2        : TLabel;
    Label3        : TLabel;
    Memo1         : TMemo;
    Memo2         : TMemo;
    ORListBox1    : TORListBox;
    Procedure btnSelectAllClick(Sender: TObject);
    Procedure Button1Click(Sender: TObject);
    Procedure Button2Click(Sender: TObject);
    Procedure FormActivate(Sender: TObject);
    Procedure FormCreate(Sender: TObject);
  Private
    { Private declarations }
  Public
    { Public declarations }
  End;

Var
  frmCheckTasks: TfrmCheckTasks;
  stopcheck    : boolean;

Implementation

Uses
  caprisupport,
  essoselect;

{$R *.DFM}

Procedure TfrmCheckTasks.Button1Click(Sender: TObject);
Var
  x, count: integer;

  Procedure stoprunning;
  Begin
    // Stop run here...
    Gauge1.Visible := False;
    frmCheckTasks.height := 354;
    btnSelectAll.Enabled := True;
    Button2.Enabled := True;
    Button1.Enabled := True;
    Button1.Caption := '&Run Selected';
    StopCheck := True;
  End;
Begin
  If Button1.Caption <> '&Abort' Then
  Begin
    Count := 0;
    For x := 0 To ORListBox1.Items.Count - 1 Do
      If ORListBox1.Selected[x] = True Then
        inc(Count);
    If Count = 0 Then
    Begin
      // Stop run here...
      StopRunning;
      exit;
    End;

    If Gauge1.Visible = True Then
    Begin
      ShowMessageCAPRI('Previous connection in progress.  Please try again.');
      exit;
    End;
    btnSelectAll.Enabled := False;
    Button2.Enabled := False;
    Button1.Caption := '&Abort';
    Button1.Enabled := False;
    Memo1.Lines.Clear;
    Memo2.Lines.Clear;
    If ORListBox1.Items.Count = 0 Then
      exit;
    Gauge1.Visible := True;
    frmCheckTasks.height := 376;
    //First count them up and set the gauge
    Gauge1.Progress := 0;
    Gauge1.MaxValue := Count;
    StopCheck := False;
    // Now run the list
    For x := 0 To ORListBox1.Items.Count - 1 Do
    Begin
      If ORListBox1.Selected[x] = True Then
      Begin
        Gauge1.Progress := Gauge1.Progress + 1;
        frmMain.RPCBroker1.Connected := False;
        frmMain.RPCBroker1.Server := frmMain.Piece(ORListBox1.Items[x], '^', 2);
        frmMain.RPCBroker1.ListenerPort := StrToInt(frmMain.Piece(ORListBox1.Items[x], '^', 3));
        frmMain.ConnectToServer('DVBA CAPRI GUI');
        If frmMain.RPCBroker1.Connected = True Then
        Begin
          //Memo2.Lines.Add(frmMain.Piece(ORListBox1.Items[x],'^',1));
          // Check tasks
          Repeat
            FMListBoxTasks.GetList;
            Application.ProcessMessages;
          Until FMListerTasks.More = False;

        End
        Else
        Begin
          Memo1.Lines.Add(frmMain.Piece(ORListBox1.Items[x], '^', 1));
        End;
        frmMain.RPCBroker1.Connected := False;
        If StopCheck = True Then
          exit;
      End;
    End;
    StopRunning;
  End
  Else
  Begin
    // Stop run here...
    StopRunning;
  End;
End;

Procedure TfrmCheckTasks.Button2Click(Sender: TObject);
Begin
  modalresult := mrOK;
End;

Procedure TfrmCheckTasks.FormCreate(Sender: TObject);
Var
  x: integer;
Begin
  If (ESSOVersion = true) Then
  Begin
    If formESSOSelect.slUserSites.Count > 0 Then  //CodeCR77
      For x := 0 To formESSOSelect.slUserSites.Count - 1 Do
        ORListBox1.Items.Add(formESSOSelect.slUserSites[x]);
  End;
End;

Procedure TfrmCheckTasks.btnSelectAllClick(Sender: TObject);
Begin
  OrListBoxSelectAll(ORListBox1);
End;

Procedure TfrmCheckTasks.FormActivate(Sender: TObject);
Begin
  Gauge1.Visible := False;
  frmCheckTasks.height := 354;
End;

End.
