unit fPatientProfileMAS;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, ComCtrls, CapriSupport;

type
  TfrmPatientProfileMAS = class(TForm)
    PanelPatientProfileMAS: TPanel;
    lblPatientProfileMAS: TLabel;
    btnOK: TButton;
    btnCancel: TButton;
    grpDateRange: TGroupBox;
    cbxDateRange: TCheckBox;
    rgpShowAppts: TRadioGroup;
    rgpShowEdits: TRadioGroup;
    rgpShowEnrollment: TRadioGroup;
    rgpShowDispositions: TRadioGroup;
    rgpShowTeam: TRadioGroup;
    rgpShowMeansTest: TRadioGroup;
    grpStartDate: TGroupBox;
    grpEndDate: TGroupBox;
    dtpStartDate: TDateTimePicker;
    dtpEndDate: TDateTimePicker;
    procedure cbxDateRangeClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    function GetDateRange: String;
    function IsShowAppts: Boolean;
    function IsShowEdits: Boolean;
    function IsShowEnrollment: Boolean;
    function IsShowDispositions: Boolean;
    function IsShowTeam: Boolean;
    function IsShowMeansTest: Boolean;
  end;

var
  frmPatientProfileMAS: TfrmPatientProfileMAS;

implementation

{$R *.dfm}

procedure TfrmPatientProfileMAS.btnCancelClick(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure TfrmPatientProfileMAS.btnOKClick(Sender: TObject);
begin
  ModalResult := mrOK;
end;

procedure TfrmPatientProfileMAS.cbxDateRangeClick(Sender: TObject);
begin
  If cbxDateRange.Checked = True Then
  Begin
    grpStartDate.Visible := False;
    grpEndDate.visible := False;
  End
  Else
  Begin
    grpStartDate.visible := True;
    grpEndDate.visible := True;
  End;
end;

procedure TfrmPatientProfileMAS.FormCreate(Sender: TObject);
begin
  dtpStartDate.Date := NOW;
  dtpEndDate.Date := NOW;
  grpStartDate.Visible := False;
  grpEndDate.Visible := False;
end;

function TfrmPatientProfileMAS.GetDateRange: String;
begin
  if cbxDateRange.Checked then
    Result := 'A' + '^^^1'
  else
  begin
    Result := 'R' + '^'
      + FMToDateConvert(FormatDateTime('mm/dd/yyyy', dtpStartDate.Date)) + '^'
      + FMToDateConvert(FormatDateTime('mm/dd/yyyy', dtpEndDate.Date)) + '^1';
  end;
end;

function TfrmPatientProfileMAS.IsShowAppts: Boolean;
begin
  if rgpShowAppts.ItemIndex = 0 then
    Result := True
  else
    Result := False;
end;

function TfrmPatientProfileMAS.IsShowDispositions: Boolean;
begin
  if rgpShowDispositions.ItemIndex = 0 then
    Result := True
  else
    Result := False;
end;

function TfrmPatientProfileMAS.IsShowEdits: Boolean;
begin
  if rgpShowEdits.ItemIndex = 0 then
    Result := True
  else
    Result := False;
end;

function TfrmPatientProfileMAS.IsShowEnrollment: Boolean;
begin
  if rgpShowEnrollment.ItemIndex = 0 then
    Result := True
  else
    Result := False;
end;

function TfrmPatientProfileMAS.IsShowMeansTest: Boolean;
begin
  if rgpShowMeansTest.ItemIndex = 0 then
    Result := True
  else
    Result := False;
end;

function TfrmPatientProfileMAS.IsShowTeam: Boolean;
begin
  if rgpShowTeam.ItemIndex = 0 then
    Result := True
  else
    Result := False;
end;

end.
