Unit findpatientanywhere;

Interface

Uses
  Windows,
  Messages,
  Classes,
  Controls,
  Diaccess,
  Dialogs,
  DialogsCAPRI,
  Fmcmpnts,
  Fmcntrls,
  Forms,
  Gauges,
  Graphics,
  Main,
  ORCtrls,
  StdCtrls,
  SysUtils,
  TRPCB,
  CCOWRPCBrokerCAPRI, CCOWRPCBroker;

Type
  TfrmFindPatientAnywhere = Class(TForm)
    ORListBox1: TORListBox;
    Button2: TButton;
    Button1: TButton;
    btnSelectAll: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Memo1: TMemo;
    Label3: TLabel;
    Memo2: TMemo;
    Gauge1: TGauge;
    Label4: TLabel;
    Edit1: TEdit;
    Button4: TButton;
    Label5: TLabel;
    FMCvrLister2Pt: TFMLister;  //rpm 6/30/09 - Changed RPCBroker property to RPCBrokerRemote
    FMCvrLister3Pt: TFMLister;  //rpm 6/30/09 - Changed RPCBroker property to RPCBrokerRemote
    FMCvrLister1Pt: TFMLister;  //rpm 6/30/09 - Changed RPCBroker property to RPCBrokerRemote
    FMCvrListBox1Pt: TFMListBox;
    FMCvrListBox2Pt: TFMListBox;
    FMCvrListBox3Pt: TFMListBox;
    RPCBrokerRemote: TCCOWRPCBrokerCAPRI;  //rpm 6/30/09 - addt'l broker to improve performance
    Procedure Button1Click(Sender: TObject);
    Procedure Button2Click(Sender: TObject);
    Procedure FormCreate(Sender: TObject);
    Procedure btnSelectAllClick(Sender: TObject);
    Procedure FormActivate(Sender: TObject);
    Procedure Button4Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  Private
    { Private declarations }
    function ConnectToHomeServer(): Boolean;  //rpm 6/30/09 - support addt'l broker
    function ConnectToRemoteServer(aServer: String; aPort: String): Boolean;  //rpm 6/30/09 - support addt'l broker
  Public
    { Public declarations }
    boDebug: Boolean;
    sgDebugData: String;
  End;

Var
  frmFindPatientAnywhere: TfrmFindPatientAnywhere;
  stopcheck: boolean;

Implementation

Uses
  caprisupport,
  essoselect;

{$R *.DFM}

Procedure TfrmFindPatientAnywhere.Button1Click(Sender: TObject);
Var
  boConnected: Boolean;
  count      : integer;
  tempstring : String;
  x          : integer;
  xx         : integer;

  Procedure stoprunning;
  Begin
    // Stop run here...
    RPCBrokerRemote.Connected := False;
    Gauge1.Visible := False;
    frmFindPatientAnywhere.height := 354;
    btnSelectAll.Enabled := True;
    Button2.Enabled := True;
    Button1.Enabled := True;
    Button1.Caption := '&Run Selected';
    StopCheck := True;
    Application.ProcessMessages();
  End;
Begin
  FMCvrLister1Pt.PartList.Clear;
  FMCvrLister1Pt.PartList.Add(uppercase(Edit1.Text));
  FMCvrLister2Pt.PartList.Clear;
  FMCvrLister2Pt.PartList.Add(uppercase(Edit1.Text));
  FMCvrLister3Pt.PartList.Clear;
  FMCvrLister3Pt.PartList.Add(uppercase(Edit1.Text));

  If Edit1.text = '' Then
  Begin
    ShowmessageCAPRI('Please enter a search string first.');
    exit;
  End;

  If Button1.Caption <> '&Abort' Then
  Begin
    Count := 0;
    For x := 0 To ORListBox1.Items.Count - 1 Do
      If ORListBox1.Selected[x] = True Then
        inc(Count);
    If Count = 0 Then
    Begin
      // Stop run here...
      StopRunning;
      exit;
    End;

    If Gauge1.Visible = True Then
    Begin
      ShowMessageCAPRI('Previous connection in progress.  Please try again.');
      exit;
    End;
    btnSelectAll.Enabled := False;
    Button2.Enabled := False;
    Button1.Caption := '&Abort';
    Application.ProcessMessages();
    Memo1.Lines.Clear;
    Memo2.Lines.Clear;
    If ORListBox1.Items.Count = 0 Then
      exit;
    Gauge1.Visible := True;
    frmFindPatientAnywhere.height := 380;
    //First count them up and set the gauge
    Gauge1.Progress := 0;
    Gauge1.MaxValue := Count;
    StopCheck := False;

    //rpm 6/30/09 - Home server connection required to obtain BSE tokens
    if ConnectToHomeServer then
    begin
      // Now run the list
      For x := 0 To ORListBox1.Items.Count - 1 Do
      Begin
        If ORListBox1.Selected[x] = True Then
        Begin
          Gauge1.Progress := Gauge1.Progress + 1;
          Application.ProcessMessages();
          If boDebug Then
          Begin
            Sleep(1000);
            boConnected:=True;
          End
          Else
          Begin
            Try
              //rpm 6/29/09 - remote connection using BSE token
              if ConnectToRemoteServer(frmMain.Piece(ORListBox1.Items[x], '^', 2),
                                       frmMain.Piece(ORListBox1.Items[x], '^', 3)) then
                boConnected := True
              else
                boConnected := False;
              If boConnected Then
              Begin
                FMCvrLister1Pt.GetList(FMCvrListBox1Pt.Items);
                FMCvrLister2Pt.GetList(FMCvrListBox2Pt.Items);
                FMCvrLister3Pt.GetList(FMCvrListBox3Pt.Items);
                If (FMCvrListBox1Pt.Items.Count = 0) And (FMCvrListBox2Pt.Items.Count = 0) And (FMCvrListBox3Pt.Items.Count = 0) Then
                Begin
                  Memo2.Lines.Add(frmMain.Piece(ORListBox1.Items[x], '^', 1) + ': NO MATCHES FOUND');
                  Memo2.Lines.Add('');
                  Memo2.Lines.Add('----------------------------------------------------------------------------------------------------');
                  Memo2.Lines.Add('');

                End
                Else
                Begin
                  Memo2.Lines.Add(frmMain.Piece(ORListBox1.Items[x], '^', 1));
                  Memo2.Lines.Add('');
                  tempString := '';
                  If FMCvrListBox1Pt.Items.Count > 0 Then
                  Begin
                    For xx := 0 To FMCvrListBox1Pt.Items.Count - 1 Do
                      tempString := tempstring + FMCvrListBox1Pt.Items[xx] + '    ';
                    Memo2.Lines.Add('NAME MATCH:  ' + TempString);
                    Memo2.Lines.Add('');
                  End;
                  tempString := '';
                  If FMCvrListBox2Pt.Items.Count > 0 Then
                  Begin
                    For xx := 0 To FMCvrListBox2Pt.Items.Count - 1 Do
                      tempString := tempstring + FMCvrListBox2Pt.Items[xx] + '    ';
                    Memo2.Lines.Add('SSN MATCH:  ' + TempString);
                    Memo2.Lines.Add('');
                  End;
                  tempString := '';
                  If FMCvrListBox3Pt.Items.Count > 0 Then
                  Begin
                    For xx := 0 To FMCvrListBox3Pt.Items.Count - 1 Do
                      tempString := tempstring + FMCvrListBox3Pt.Items[xx] + '    ';
                    Memo2.Lines.Add('LAST INITIAL + LAST 4 MATCH:  ' + TempString);
                    Memo2.Lines.Add('');
                  End;
                  Memo2.Lines.Add('----------------------------------------------------------------------------------------------------');
                  Memo2.Lines.Add('');
                End;
              End;
              //rpm 6/30/09 - frmMain.RPCBroker1.Connected := False;
            Except
              boConnected:=False;
            End;
          End;
          If Not boConnected Then Memo1.Lines.Add(frmMain.Piece(ORListBox1.Items[x], '^', 1));
          Application.ProcessMessages();
          If StopCheck = True Then
          Begin
            ShowMessageCapri('Aborting Process.');
            Break;
          End;
        End;
      End;
    end;
    frmMain.RPCBroker1.Connected := False;  //rpm 6/30/09 - addt'l broker support

    Memo1.Lines.Insert(0, '');
    Memo2.Lines.Insert(0, '');
    Memo1.Lines.Delete(0);
    Memo2.Lines.Delete(0);
    Application.ProcessMessages();
    If StopCheck = False Then
    Begin
      Application.BringToFront;
      ShowMessageCapri('Completed Process.');
    End;
    StopRunning;
  End
  Else
  Begin
    // Stop run here...
    StopRunning;
  End;
End;

Procedure TfrmFindPatientAnywhere.Button2Click(Sender: TObject);
Begin
  modalresult := mrOK;
End;

Procedure TfrmFindPatientAnywhere.FormCreate(Sender: TObject);
Var
  x: integer;
Begin
  If (ESSOVersion = true) Then
  Begin
    If formESSOSelect.slUserSites.Count > 0 Then   //CodeCR77
      For x := 0 To formESSOSelect.slUserSites.Count - 1 Do
        ORListBox1.Items.Add(formESSOSelect.slUserSites[x]);
  End;
End;

Procedure TfrmFindPatientAnywhere.btnSelectAllClick(Sender: TObject);
Begin
  OrListBoxSelectAll(ORListBox1);
End;

Procedure TfrmFindPatientAnywhere.FormActivate(Sender: TObject);
Begin
  If Tag=0 Then
  Begin
    boDebug:= False;
    sgDebugData :=
      'ALBANY'+#13+#10+
      'ALBUQUERQUE'+#13+#10+
      'ALEXANDRIA'+#13+#10+
      'ALTOONA'+#13+#10+
      'AMARILLO HCS'+#13+#10+
      'ANCHORAGE VAMROC'+#13+#10+
      'ANN ARBOR'+#13+#10+
      'ARIZONA HCS'+#13+#10+
      'ASHEVILLE'+#13+#10+
      'ATLANTA'+#13+#10+
      'AUGUSTA'+#13+#10+
      'BALTIMORE'+#13+#10+
      'BATAVIA'+#13+#10+
      'BATH'+#13+#10+
      'BATTLE CREEK'+#13+#10+
      'BAY PINES VA HCS'+#13+#10+
      'BECKLEY'+#13+#10+
      'BEDFORD'+#13+#10+
      'BIG SPRING';
    If boDebug Then
    Begin
      ShowMessage('Warning! this dialog is in DEBUG mode.');
      ORListBox1.Items.SetText(PAnsiChar(sgDebugData));
    End;
    If button1.enabled = true Then
    Begin
      frmFindPatientAnywhere.height := 358;
      Gauge1.Visible := False;
    End
    Else
    Begin
      Gauge1.Visible := True;
      frmFindPatientAnywhere.height := 380;
    End;
    Tag:=1;
  End;
End;

Procedure TfrmFindPatientAnywhere.Button4Click(Sender: TObject);
Begin
  ShowmessageCAPRI('Your search string should be the same text VistA or CAPRI would normally use for searching the ' +
    'patient file.' + char(13) + char(13) + 'Examples:' + char(13) +
    '  Enter an SSN without the dashes:  123456789 instead of 123-45-6789' + char(13) +
    '  Enter last name + comma + first name with no spaces:  "DOE,JOHN" instead of "DOE, JOHN"' + char(13) +
    '  Enter first letter of last name + last 4 digits of SSN:  A1234' + char(13) + char(13) +
    '* There is a limit of 50 items returned per search, per site.');

End;

procedure TfrmFindPatientAnywhere.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Tag:=0;
end;

{=================================================================
 ConnectToHomeServer
 rpm 6/30/09
 This function creates connection to home server to retrieve BSE tokens.
 Returns TRUE on successful connection; otherwise returns FALSE.
 =================================================================}
function TfrmFindPatientAnywhere.ConnectToHomeServer: Boolean;
begin
  Result := False;
  frmMain.RPCBroker1.Connected := False;
  if frmMain.RPCBroker1.Connect2HomeServer(frmMain.RPCBroker1.ANUAccessCodeHome,
                                      frmMain.RPCBroker1.ANUVerifyCodeHome,
                                      frmMain.RPCBroker1.ANUstrServerHome,
                                      frmMain.RPCBroker1.ANUstrPortHome,
                                      False) then
  begin
    frmMain.RPCBroker1.CreateContext('DVBA CAPRI GUI');
    Result := True;
  end;
end;

{=================================================================
 ConnectToRemoteServer
 rpm 6/30/09
 This function retrieves BSE token from home server connection and
 creates connection to remote server using BSE token.
 Returns TRUE on successful connection; otherwise returns FALSE.
 =================================================================}
function TfrmFindPatientAnywhere.ConnectToRemoteServer(aServer: String; aPort: String): Boolean;
begin
  Result := False;
  RPCBrokerRemote.Connected := False;
  try
    frmMain.RPCBroker1.RemoteProcedure := 'XUS SET VISITOR';
    frmMain.RPCBroker1.Call;
    if frmMain.RPCBroker1.Results.Count > 0 then
    begin
      RPCBrokerRemote.ANUBSEToken := frmMain.RPCBroker1.Results[0];
      RPCBrokerRemote.ANUTestMode := frmMain.RPCBroker1.ANUTestMode;
      if RPCBrokerRemote.Connect2RemoteServer(aServer, aPort, False, False) then
      begin
        RPCBrokerRemote.CreateContext('DVBA CAPRI GUI');
        Result := True;
      end;
    end;
  except
    RPCBrokerRemote.Connected := False;
    Result := False;
  end;
end;

End.
