unit frmContractedExamDeleteCO;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, frmContractedBase, Diaccess, Fmcmpnts, ExtCtrls, StdCtrls, CheckLst,
  Fmcntrls, untMiscMthds, dialogsCAPRI, CAPRISupport {Patch 193};

type
  TExntdCntrctdBaseFormDeleteCO = class(TCntrctdBaseForm)
    procedure FormShow(Sender: TObject);
    procedure chkdLstBxExamsClickCheck(Sender: TObject);
    procedure chkBxCntrctAllExamsClick(Sender: TObject);
    procedure btnCntrctdFrmCancelClick(Sender: TObject);
  protected
    { Protected declarations }
    procedure ExecuteBtnAction; override;
    procedure PopExamList(rqstIEN: String); override;
  private
    { Private declarations }
    function DelRqstInfo(): Boolean;
    procedure DeleteCheckOut;
  public
    { Public declarations }
  end;

var
  ExntdCntrctdBaseFormDeleteCO: TExntdCntrctdBaseFormDeleteCO;

implementation

{$R *.dfm}

procedure TExntdCntrctdBaseFormDeleteCO.FormShow(Sender: TObject);
begin
  inherited;
  GetContractors;  { Retrieve List of Contractors in File #396.45 }
  Caption := 'Delete Contracted Exam Check-Out(s) for ' + _PtntInfo.PatientName +
       ' (' + Copy(_PtntInfo.PatientSSN, Length(_PtntInfo.PatientSSN)-3, 4) + ')';
  { Inherited Contractor Lister NOT required for this form }
  btnRfrshRqstsClick(self); { Populate Requests }
end;

procedure TExntdCntrctdBaseFormDeleteCO.btnCntrctdFrmCancelClick(
  Sender: TObject);
begin
  inherited;
  { Dynamically setting button modal result is ignored when passed back
    to calling application, so set the Form's Modal Result so correct
    value is seen and lists can be refreshed. }
  if btnCntrctdFrmCancel.ModalResult = mrOk then
    ModalResult := mrOk;
end;

procedure TExntdCntrctdBaseFormDeleteCO.chkBxCntrctAllExamsClick(
  Sender: TObject);
var
  i : Integer;
begin
  for i := 0 to chkdLstBxExams.Items.Count - 1 do                               // Mark everything checked
    if (chkdLstBxExams.ItemEnabled[i]) then chkdLstBxExams.Checked[i] := true;  // JRL 8/1/13

  inherited;
  AllowAction;  { Enable/Disable Delete Action Button }
end;

procedure TExntdCntrctdBaseFormDeleteCO.chkdLstBxExamsClickCheck(
  Sender: TObject);
begin
  inherited;
  AllowAction;  { Enable/Disable Delete Action Button }
end;

procedure TExntdCntrctdBaseFormDeleteCO.ExecuteBtnAction;
begin
  ResetWndwTmr;
  { Delete Check-Out for selected exams. Reset Modal Result for Cancel
    button so that the Tree View is Refreshed on the MAIN form }
  DeleteCheckOut;
  fmCmbBx2507RqstsChange(self);  { Refresh Exam List for Request }
  btnCntrctdFrmCancel.ModalResult := mrOk;
end;

{ PRIVATE }

procedure TExntdCntrctdBaseFormDeleteCO.PopExamList(rqstIEN: string);
var
  i: Integer;
  IEN, exmSts, cntrctrIEN, cntrctrNme: String;
begin
  chkdLstBxExams.Items.BeginUpdate;
  { Add Exams for Request to list, enable only those entries that have been
    Checked-Out but NOT Checked-In from the Contractor }
  for i := 0 to _fmTmpLstrExams.Results.Count - 1 do
  begin
    IEN := _fmTmpLstrExams.Results[i];
    exmSts := _fmTmpLstrExams.GetRecord(IEN).GetField('.04').FMDBExternal;
    { Internal value requested in lister call, but value still returned in External }
    cntrctrIEN := _fmTmpLstrExams.GetRecord(IEN).GetField('100').FMDBExternal;
    cntrctrNme := '';
    if Not SameText(cntrctrIEN, '') then
      cntrctrNme := ' - ' + fmLstrCntrctrs.GetRecord(cntrctrIEN).GetField('.01').FMDBExternal;
    { Add Exam Info for Request to List }
    chkdLstBxExams.Items.AddObject(_fmTmpLstrExams.GetRecord(IEN).GetField
        ('.03').FMDBExternal + ' [' + exmSts + cntrctrNme  + ']', TObject(StrToInt(IEN)));
    { Show all Exams for request, but Disable Exam entries in list if the exam
      has been canceled (By MAS or RO), transferred out, completed or has been
      already Checked In from Contractor }
    if ((Not SameText(UpperCase(exmSts), 'OPEN')) or
        (SameText(_fmTmpLstrExams.GetRecord(IEN).GetField('101')
            .FMDBExternal, '')) or (Not SameText(_fmTmpLstrExams.GetRecord(IEN)
            .GetField('102').FMDBExternal, ''))) then
      chkdLstBxExams.ItemEnabled[(chkdLstBxExams.Items.Count - 1)] := False
    else
      chkBxCntrctAllExams.Enabled := True;  { If at least one exam is available }
  end; { End For Loop }
  chkdLstBxExams.Items.EndUpdate;
  chkdLstBxExams.Repaint;
  AllowAction;
end;

procedure TExntdCntrctdBaseFormDeleteCO.DeleteCheckOut;
var
  dlgType: TMsgDlgType;
  err, updtRqstInfo: Boolean;
  i: Integer;
  exmIEN, msg, rqstVal: String;
begin
  rqstVal := fmCmbBx2507Rqsts.Text;
  msg := 'All Contracted Check-Out information has been successfully removed from the Exam(s).';
  dlgType := mtConfirmation;
  i := -1;
  err := False;
  updtRqstInfo := DelRqstInfo;
  { At Least One Record had to be selected to get here }
  repeat
    inc(i);
    if chkdLstBxExams.ItemEnabled[i] then
      if chkdLstBxExams.Checked[i] or chkBxCntrctAllExams.Checked then
      begin
        exmIEN := IntToStr(Integer(chkdLstBxExams.Items.Objects[i]));
        if Not _2507Info.CheckOutExam(exmIEN, '@', '@')then
          err := True;
      end; { End If Item enabled and is checked or all items checkbox is checked }
  until (i = (chkdLstBxExams.Items.Count - 1));
  { Display Message to User }
  if err then
  begin
    msg := 'An error occurred while removing the Contracted Check-Out information ' +
         'from the selected exam entries.' + #13#10 + 'Reselect those available ' +
         'exams on the request and try and delete the check-out again.' + #13#10#13#10 +
         'If problems persist, please consult your local IRM for assistance.';
    dlgType := mtError;
  end  { End If Error Occurred Deleting Check-Out Information }
  else if updtRqstInfo then  { Update Request Info if applicable if no errors }
    begin
      // Patch 193 JRL 4/29/16
      // Changed Request Status field to pointer field.  Using IEN to populate
      // status here.
      If IsPatchInstalled('DVBA*2.7*193') then 
         _2507Info.UpdtRqstToSchld(fmCmbBx2507Rqsts.GetSelectedRecord.IEN, 'P', '@')
      else
         _2507Info.UpdtRqstToSchld(fmCmbBx2507Rqsts.GetSelectedRecord.IEN, '2', '@');
    end;

    
  MessageDlgCAPRI(msg, dlgType, [mbOK], 0);  { Display Appropriate Message to Screen }
  { If No errors and request info updated - refresh 2507 request info }
  if ((Not err) and UpdtRqstInfo) then
  begin
    btnRfrshRqstsClick(self); { Refresh Request Info }
    { Reselect current selection }
    fmCmbBx2507Rqsts.ItemIndex := fmCmbBx2507Rqsts.Items.IndexOf(rqstVal);
  end;
end;

function TExntdCntrctdBaseFormDeleteCO.DelRqstInfo(): Boolean;
begin
  Result := False;
  { Determine if Request has been Scheduling Completed - if it does prompt
    user to determine if they want to update the request. Prompt needed to
    allow them to NOT update if they re-scheduled in VistA prior to coming
    into demTRAN to delete the Check-Out from the exam. }
  if _2507Info.IsSchdlgCmpltd(fmCmbBx2507Rqsts.GetSelectedRecord.IEN) then
    Result := (MessageDlgCAPRI('Do you want to reset the following fields on the 2507 Request?' +
         #13#10#13#10 + '     - DATE SCHEDULING COMPLETED' + #13#10 +
         '     - REQUEST STATUS' + #13#10#13#10 + 'Note: These fields should NOT ' +
         'be reset if the appointment(s) have already been rescheduled in VistA.',
         mtConfirmation, [mbYes, mbNo], 0) = mrYes);
end;

end.
