unit mailman;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  DialogsCAPRI,
  Dialogs,
  Buttons,
  ComCtrls,
  Grids,
  StdCtrls,
  Fmcntrls,
  ExtCtrls,
  Fmcmpnts,
  Diaccess,
  wdwstate,
  caprisupport,
  main,
  Trpcb,
  DiTypLib,
  CCOWRPCBrokerCAPRI,
  GifImage;

type
  TfrmMailMan = class(TForm)
    btnRefresh: TBitBtn;
    Panel1: TPanel;
    Panel6: TPanel;
    Label23: TLabel;
    FMListBoxMailBaskets: TFMListBox;
    Splitter7: TSplitter;
    Label21: TLabel;
    FMListerMailBaskets: TFMLister;
    FMListerMailBoxMessages: TFMLister;
    FMGetsMailMessage: TFMGets;
    FMGetsMail: TFMGets;
    FMGetsNewPerson: TFMGets;
    BitBtn1: TBitBtn;
    PanelMailBoxMessages: TPanel;
    labelMailTitles: TLabel;
    FMListBoxMailboxMessages: TFMListBox;
    ListBoxMailBoxMessages: TListBox;
    Panel7: TPanel;
    HeaderControlMailBoxMessages: THeaderControl;
    ProgressBarMail: TProgressBar;
    ButtonOpenMessage: TButton;
    StringGridMailboxMessages: TStringGrid;
    ButtonNew: TButton;
    buttonDeleteMessage: TButton;
    procedure btnRefreshClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FMListBoxMailBasketsDrawItem(Control: TWinControl;
      Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure HeaderControlMailBoxMessagesSectionResize(
      HeaderControl: THeaderControl; Section: THeaderSection);
    procedure StringGridMailboxMessagesDrawCell(Sender: TObject; ACol,
      ARow: Integer; Rect: TRect; State: TGridDrawState);
    procedure ListBoxMailBoxMessagesDrawItem(Control: TWinControl;
      Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure FormResize(Sender: TObject);
    procedure StringGridMailboxMessagesSelectCell(Sender: TObject; ACol,
      ARow: Integer; var CanSelect: Boolean);
    procedure FMListBoxMailBasketsClick(Sender: TObject);
    procedure StringGridMailboxMessagesDblClick(Sender: TObject);
    procedure FMListBoxMailBasketsExit(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ButtonOpenMessageClick(Sender: TObject);
    procedure StringGridMailboxMessagesClick(Sender: TObject);
    procedure ButtonNewClick(Sender: TObject);
    procedure buttonDeleteMessageClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMailMan: TfrmMailMan;
  MailRowSelected: Integer;
  MailSender: string;
  MakingNew: Boolean;

implementation

uses mailmanmessage;

{$R *.DFM}

procedure TfrmMailMan.btnRefreshClick(Sender: TObject);
var
  x: integer;
  temptext: string;
  tempselect: integer;
begin
  tempSelect := FMListBoxMailBaskets.ItemIndex;
  newmail := false;
  //Load Mail Baskets
  FMListerMailBaskets.IENS := ',' + AuthorIEN + ',';
  FMListerMailBaskets.GetList(FMListBoxMailBaskets.Items);
  application.processmessages;
  if FMListBoxMailBaskets.Items.Count > 0 then
    for x := 0 to FMListBoxMailBaskets.Items.Count - 1 do
      if Uppercase(FMListBoxMailBaskets.Items[x]) = 'IN' then begin
        FMListBoxMailBaskets.ItemIndex := x;
        //FMListBoxMailBasketsClick(Application) // Force re-load of messages
      end;
  // Now reformat and tell how many are new
  if FMListBoxMailBaskets.Items.Count > 0 then
    for x := 0 to FMListBoxMailBaskets.Items.Count - 1 do begin
      temptext := FMListBoxMailBaskets.Items[x];
      FMListBoxMailBaskets.Items[x] := Copy(temptext, 1, pos('  ', temptext) - 1);
      temptext := copy(temptext, pos('  ', temptext) + 4, 999);

      //jcs - modified logic, removed try/except
      //if StrToInt(temptext) > 0 then begin
      if StrToIntDef(temptext, 0) > 0 then
      begin
        FMListBoxMailBaskets.Items[x] := '@' + FMListBoxMailBaskets.Items[x] + ' (' + temptext + ' new)';
        newmail := true;
      end;

      //      Try If StrToInt(temptext)>0 then ListboxMailBaskets.Items.Add('@'+FMListBoxMailBaskets.Items[x]+' ('+temptext+' new)') else
      //        ListboxMailBaskets.Items.Add(FMListBoxMailBaskets.Items[x]) except ListboxMailBaskets.Items.Add(FMListBoxMailBaskets.Items[x]) end;
    end;
  FMListBoxMailBaskets.ItemIndex := TempSelect;
end;

procedure TfrmMailMan.FormCreate(Sender: TObject);
begin
  MailRowSelected := -1;

  HeaderControlMailBoxMessagesSectionResize(HeaderControlMailBoxMessages, HeaderControlMailBoxMessages.Sections[3]);
end;

procedure TfrmMailMan.FMListBoxMailBasketsDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
  TempText: string;
begin
  with (Control as TListBox).Canvas do { draw on control canvas, not on the form } begin
    Font.Color := clWindowText; {Set to default color}
    TempText := (Control as TListBox).Items[Index];
    if Copy((Control as TListBox).Items[Index], 1, 1) = '@' then begin
      Font.Color := clRed; {Change color to show unsigned}
      TempText := Copy((Control as TListBox).Items[Index], 2, Length((Control as TListBox).Items[Index]) - 1)
    end;
    Brush.Color := clWindow;
    FillRect(Rect); { clear the rectangle }
    TextOut(Rect.Left, Rect.Top, TempText); { display the text }
  end;
end;

procedure TfrmMailMan.HeaderControlMailBoxMessagesSectionResize(
  HeaderControl: THeaderControl; Section: THeaderSection);
begin
  StringGridMailboxMessages.ColWidths[0] := HeaderControlMailBoxMessages.Sections[0].Width - 1;
  StringGridMailboxMessages.ColWidths[1] := HeaderControlMailBoxMessages.Sections[1].Width - 1;
  StringGridMailboxMessages.ColWidths[2] := HeaderControlMailBoxMessages.Sections[2].Width - 1;
  StringGridMailboxMessages.ColWidths[3] := StringGridMailBoxMessages.Width - HeaderControlMailBoxMessages.Sections[0].Width - HeaderControlMailBoxMessages.Sections[1].Width - HeaderControlMailBoxMessages.Sections[2].Width - 21;
end;

procedure TfrmMailMan.StringGridMailboxMessagesDrawCell(Sender: TObject;
  ACol, ARow: Integer; Rect: TRect; State: TGridDrawState);
var
  a: string;
begin
  exit;
  with Sender as TStringGrid do begin
    if StringGridMailboxMessages.Cells[10, ARow] = 'Y' then begin
      Canvas.Brush.Color := clBtnFace;
    end
    else begin
      Canvas.Brush.Color := clWhite;
    end;
    Font.Color := clBlack;
    Canvas.FillRect(Rect);
    //If (Pos('N',StringGridMailboxMessages.Cells[0,ARow])>0) and (ACol=0) then
      //Font.Style:=[fsbold] else Font.Style:=[];
    a := StringGridMailboxMessages.Cells[ACol, ARow];
    if a <> '' then
      if Canvas.textWidth(a) > Rect.Right - Rect.Left then
        repeat begin
            a := copy(a, 1, length(a) - 1);
        end until (length(a) = 1) or (Canvas.textWidth(a + '...') < Rect.Right - Rect.Left);
    if a <> StringGridMailboxMessages.Cells[ACol, ARow] then
      a := a + '...';
    Canvas.TextRect(Rect, Rect.Left, Rect.Top, a); { display the text }
    (*
            if gdFocused in State then begin;
              Canvas.DrawFocusRect(Rect);
            end;
    *)
  end;
end;

procedure TfrmMailMan.ListBoxMailBoxMessagesDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
  with (Control as TListBox).Canvas do { draw on control canvas, not on the form } begin
    FillRect(Rect);
    Font.Color := clWindowText; {Set to default color}
    (Control as TListBox).Items[Index];
    // The lists are in reverse order from each other
    if Copy(FMListBoxMailBoxMessages.Items[FMListBoxMailBoxMessages.Items.Count - 1 - Index], 1, 1) = '@' then begin
      Font.Color := clRed; {Change color to show unsigned}
    end;
    Brush.Color := clWindow;
    // Output title
    TextOut(Rect.Left, Rect.Top, (Control as TListbox).Items[index]); { display the text }
  end;

end;

procedure TfrmMailMan.FormResize(Sender: TObject);
begin
  HeaderControlMailBoxMessagesSectionResize(HeaderControlMailBoxMessages, HeaderControlMailBoxMessages.Sections[3]);
end;

procedure TfrmMailMan.StringGridMailboxMessagesSelectCell(Sender: TObject;
  ACol, ARow: Integer; var CanSelect: Boolean);
begin
  if StringGridMailboxMessages.Cells[10, ARow] <> 'Y' then
    StringGridMailboxMessages.Cells[10, ARow] := 'Y'
  else
    StringGridMailboxMessages.Cells[10, ARow] := '';
  StringGridMailboxMessages.Repaint;
end;

procedure TfrmMailMan.FMListBoxMailBasketsClick(Sender: TObject);
var
  x: integer;
  tempdate: string;
  tempsender: string;
  m, d, y: string;
begin
  ButtonOpenMessage.Enabled := False;
  ButtonDeleteMessage.Enabled := False;

  MailRowSelected := -1;
  MakingNew := False;
  StringGridMailBoxMessages.Repaint;

  ListBoxMailBoxMessages.Items.Clear;
  ButtonNew.Enabled := False;
  //Load Mail Messages
  FMListerMailBoxMessages.IENS := ',' + FMListBoxMailBaskets.GetSelectedRecord.IEN + ',' + AuthorIEN + ',';
  FMListerMailBoxMessages.GetList(FMListBoxMailBoxMessages.Items);
  if FMListerMailBoxMessages.More = True then
    repeat begin
        application.ProcessMessages;
        FMListBoxMailBoxMessages.GetMore;
    end until FMListerMailBoxMessages.More = False;

  //Convert 'NEW' to '@' to make it easier for customdraw procedure
  if FMListBoxMailBoxMessages.Items.Count > 0 then
    for x := 0 to FMListBoxMailBoxMessages.Items.Count - 1 do
      if Pos('NEW  ', FMListBoxMailBoxMessages.Items[x]) > 0 then begin
        ButtonNew.Enabled := True;
        FMListBoxMailBoxMessages.Items[x] := '@' + Copy(FMListBoxMailBoxMessages.Items[x], pos('  ', FMListBoxMailBoxMessages.Items[x]) + 4, 999);
      end
      else begin
        FMListBoxMailBoxMessages.Items[x] := '*' + Copy(FMListBoxMailBoxMessages.Items[x], pos('  ', FMListBoxMailBoxMessages.Items[x]) + 4, 999);
      end;

  ListBoxMailBoxMessages.Items.Clear;
  StringGridMailBoxMessages.RowCount := FMListBoxMailBoxMessages.Items.Count;
  StringGridMailBoxMessages.Cells[0, 0] := ''; // Clear these in case no messages are in the mailbox
  StringGridMailBoxMessages.Cells[1, 0] := '';
  StringGridMailBoxMessages.Cells[2, 0] := '';
  StringGridMailBoxMessages.Cells[3, 0] := '';
  StringGridMailBoxMessages.Cells[4, 0] := '';
  StringGridMailBoxMessages.Cells[5, 0] := ''; // Not used for now
  StringGridMailBoxMessages.Cells[6, 0] := '';
  try
  ProgressBarMail.Max := FMListBoxMailBoxMessages.Items.Count - 1 except
  end;
  ProgressBarmail.BringToFront;
  ProgressBarMail.Visible := True;
  if FMListBoxMailBoxMessages.Items.Count > 0 then
    for x := FMListBoxMailBoxMessages.Items.Count - 1 downto 0 do begin
      MailRowSelected := -1;
      ProgressBarMail.Position := FMListBoxMailBoxMessages.Items.Count - x;
      FMListBoxMailBoxMessages.ItemIndex := x;
      FMGetsMailMessage.IENS := FMListBoxMailBoxMessages.GetSelectedRecord.IEN;
      FMGetsMailMessage.GetData;
      // Get time
      try
      TempDate := FMGetsMailMessage.GetField('1.4').FMDBInternal except TempDate := 'UNKNOWN'
      end;
      try
      TempSender := FMGetsMailMessage.GetField('1').FMDBInternal except TempSender := 'UNKNOWN'
      end;
      if Pos('.', Piece(TempDate, ' ', 1)) = 0 then begin
        // External message
        //If comma is found, it means day of week,[space]+date is at beginning
        //Strip this off
        if Pos(',', tempdate) > 1 then begin
          TempDate := Piece(tempdate, ',', 2); // Space may remain at beginning
          if TempDate[1] = ' ' then
            TempDate := Copy(tempdate, 2, length(tempdate) - 1);
        end;
        TempDate := Uppercase(Piece(TempDate, ' ', 1) + ' ' + Piece(TempDate, ' ', 2) + ' ' + Piece(TempDate, ' ', 3));
      end
      else begin
        // Internal message
        TempDate := Piece(FMDateTimeConvert(TempDate), '@', 1); // Strip time
        //Reformat from JUL 1, 2001 to 01 JUL 2001
        m := Piece(TempDate, ' ', 1);
        d := Piece(TempDate, ' ', 2);
        d := Copy(d, 1, length(d) - 1); // Strip comma
        y := Piece(TempDate, ' ', 3);
        TempDate := d + ' ' + m + ' ' + y;
        FMGetsNewPerson.IENS := TempSender; //Convert internal format
        FMGetsNewPerson.GetData;
        try
        TempSender := FMGetsNewPerson.GetField('.01').FMDBExternal except TempSender := '<UNKNOWN>'
        end;
      end;
      // Format line
      ListBoxMailBoxMessages.Items.Add(tempdate + '  ' + tempsender + '  ' +
        Copy(FMListBoxMailBoxMessages.Items[x], 2, 999)); // Title
      application.processmessages;
      if Copy(FMListBoxMailBoxMessages.Items[x], 1, 1) = '@' then //New message
        StringGridMailBoxMessages.Cells[0, FMListBoxMailBoxMessages.Items.Count - x - 1] := 'N'
      else
        StringGridMailBoxMessages.Cells[0, FMListBoxMailBoxMessages.Items.Count - x - 1] := ' ';
      StringGridMailBoxMessages.Cells[1, FMListBoxMailBoxMessages.Items.Count - x - 1] := ' ' + tempdate;
      StringGridMailBoxMessages.Cells[2, FMListBoxMailBoxMessages.Items.Count - x - 1] := ' ' + tempsender;
      StringGridMailBoxMessages.Cells[3, FMListBoxMailBoxMessages.Items.Count - x - 1] := ' ' + Copy(FMListBoxMailBoxMessages.Items[x], 2, 999);
      StringGridMailboxMessages.RowHeights[FMListBoxMailBoxMessages.Items.Count - x - 1] := 15;
      StringGridMailBoxMessages.Cells[5, FMListBoxMailBoxMessages.Items.Count - x - 1] := inttostr(x); // Remember the index in the list
    end;
  ProgressBarMail.Visible := False;

  if FMListboxMailBoxMessages.Items.Count = 1 then
    LabelMailTitles.Caption := 'Messages:    (' + IntToStr(FMListboxMailBoxMessages.Items.Count) + ' message found)'
  else
    LabelMailTitles.Caption := 'Messages:    (' + IntToStr(FMListboxMailBoxMessages.Items.Count) + ' messages found)';

end;

procedure TfrmMailMan.StringGridMailboxMessagesDblClick(Sender: TObject);
var
  x, y: integer;
  msgCount: integer;
begin
  if frmMailMan.StringGridMailBoxMessages.Cells[3, StringGridMailBoxMessages.Row] = '** DELETED **' then
    exit;

  if ANURemoteProcedureCallInProgress = True then
    exit;
  //FrmMailmessage:=TFrmMailmessage.Create(frmMain);

//Clear fields;
  frmMailMessage.FMEditMailBasketMessageLastReadDateTime.Text := '';
  frmMailMessage.FMMemoMailMessage.Lines.Clear;
  frmMailMessage.MemoMessageText.Lines.Clear;
  frmMailMessage.LabelRow.Caption := IntToStr(StringGridMailBoxMessages.Row);

  if StringGridMailBoxMessages.Cells[5, StringGridMailBoxMessages.Row] = '' then
    exit;

  FMListBoxMailBoxMessages.ItemIndex := StrToInt(StringGridMailBoxMessages.Cells[5, StringGridMailBoxMessages.Row]);
  frmMailMessage.LabelIEN.Caption := FMListBoxMailBoxMessages.GetSelectedRecord.IEN;

  //Get Responses
  frmMailMessage.FMListerResponses.IENS := ',' + FMListBoxMailBoxMessages.GetSelectedRecord.IEN;
  frmMailMessage.FMListBoxResponses.GetList;

  //Get Recipients
  frmMailMessage.FMListerRecipients.IENS := ',' + FMListBoxMailBoxMessages.GetSelectedRecord.IEN;
  frmMailMessage.FMListBoxRecipients.GetList;
  if frmMailMessage.FMListBoxRecipients.Items.Count > 0 then
    for x := 0 to frmMailMessage.FMListBoxRecipients.Items.Count - 1 do
      if frmMailMessage.FMListBoxRecipients.Items[x] = AuthorIEN then begin
        frmMailMessage.FMListBoxRecipients.ItemIndex := x;
        frmMailMessage.FMGetsRecipientInfo.IENS := frmMailMessage.FMListBoxRecipients.GetSelectedRecord.IEN + ',' + FMListBoxMailBoxMessages.GetSelectedRecord.IEN;
        frmMailMessage.FMGetsRecipientInfo.GetAndFill;
        frmMailMessage.FMEditTerminationDate.IENS := frmMailMessage.FMGetsRecipientInfo.IENS;
      end;
  //Get message
  frmMailMessage.FMGetsMailMessage.IENS := FMListBoxMailBoxMessages.GetSelectedRecord.IEN;
  frmMailMessage.FMGetsMailMessage.GetAndFill;
  //Header
  mailsender := StringGridMailBoxMessages.Cells[2, StringGridMailBoxMessages.Row];
  if frmMailMessage.FMEditResponseNameSurrogate.Text <> '' then begin
    // Surrogate
    //ShowMessageCAPRI('*'+frmMailMessage.FMEditResponseNameSurrogate.Text+'*');
    frmMailMessage.FMGetsNewPerson.IENS := frmMailMessage.FMEditResponseNameSurrogate.Text;
    frmMailMessage.FMGetsNewPerson.GetAndFill;
    frmMailMessage.labelMessageHeader1.Caption := 'Mail Message From: ' + StringGridMailBoxMessages.Cells[2, StringGridMailBoxMessages.Row] + ' (Sender: ' + frmMailMessage.FMEditName.Text + ')  Dated: ' + StringGridMailBoxMessages.Cells[1, StringGridMailBoxMessages.Row];
  end
  else begin
    frmMailMessage.labelMessageHeader1.Caption := 'Mail Message From: ' + StringGridMailBoxMessages.Cells[2, StringGridMailBoxMessages.Row] + '  Dated: ' + StringGridMailBoxMessages.Cells[1, StringGridMailBoxMessages.Row];
  end;
  frmMailMessage.labelMessageHeader2.Caption := 'Subject: ' + StringGridMailBoxMessages.Cells[3, StringGridMailBoxMessages.Row];

  if frmMailMessage.FMEditMailBasketMessageMessageType.Text <> 'K' then begin
    //Get message
    frmMailMessage.FMGetsMailMessage2.IENS := FMListBoxMailBoxMessages.GetSelectedRecord.IEN;
    frmMailMessage.FMGetsMailMessage2.GetAndFill;
    if frmMailMessage.FMMemoMailMessage.Lines.Count > 0 then
      for x := 0 to frmMailMessage.FMMemoMailMessage.Lines.Count - 1 do
        frmMailMessage.MemoMessageText.Lines.Add(frmMailMessage.FMMemoMailMessage.Lines[x]);
  end
  else begin
    frmMailMessage.MemoMessageText.Lines.Add('KIDS builds not supported for display in the GUI.');
  end;
  //Add in responses
  if frmMailMessage.FMListBoxResponses.Items.Count > 0 then
    for y := 0 to frmMailMessage.FMListBoxResponses.Items.Count - 1 do begin
      //ShowMessageCAPRI(frmMailMessage.FMListBoxResponses.Items[y]);
      frmMailMessage.FMListBoxResponses.ItemIndex := y;
      frmMailMessage.FMGetsMailMessage2.IENS := frmMailMessage.FMListBoxResponses.Items[y] + ',';
      frmMailMessage.FMMemoMailMessage.Lines.Clear;
      frmMailMessage.FMGetsMailMessage2.GetAndFill;
      //If frmMailMessage.FMListBoxMessageLines.Items.Count>0 then begin;
      frmMailMessage.MemoMessageText.Lines.Add('');
      //ShowMessageCAPRI(frmMailMessage.FMListBoxResponses.Items[y]);
      frmMailMessage.FMGetsNewPerson.IENS := frmMailMessage.FMEditResponseFromName.Text;
      //ShowMessageCAPRI(frmMailMessage.FMGetsNewPerson.IENS);
      frmMailMessage.FMGetsNewPerson.GetAndFill;
      frmMailMessage.MemoMessageText.Lines.Add('--------------------------------------------------------------------------------');
      frmMailMessage.MemoMessageText.Lines.Add('Response ' + inttostr(y + 1) + ' of ' + inttostr(frmMailMessage.FMListBoxResponses.Items.Count) + ':  ' + frmMailMessage.FMEditName.Text + '  ' + frmMailMessage.FMEditResponseDateTime.Text);
      if frmMailMessage.FMEditResponseFromName.Text <> '' then begin
        frmMailMessage.FMGetsNewPerson.IENS := frmMailMessage.FMEditResponseFromNameSurrogate.text;
        if frmMailMessage.FMGetsNewPerson.IENS <> '' then begin
          frmMailMessage.FMGetsNewPerson.GetAndFill;
          frmMailMessage.MemoMessageText.Lines.Add('                  (Sender: ' + frmMailMessage.FMEditName.Text + ')');
        end;
      end;

      frmMailMessage.MemoMessageText.Lines.Add('');
      if frmMailMessage.FMEditMailBasketMessageMessageType.Text <> 'K' then begin
        for x := 0 to frmMailMessage.FMMemoMailMessage.Lines.Count - 1 do
          frmMailMessage.MemoMessageText.Lines.Add(frmMailMessage.FMMemoMailMessage.Lines[x]);
      end
      else begin
        frmMailMessage.MemoMessageText.Lines.Add('KIDS builds not supported for display in the GUI.');
      end;
      //end;
    end;

  // Set up message IEN in basket
  //ShowMessageCAPRI(FMListBoxMailBoxMessages.GetSelectedRecord.IEN+','+FMListBoxMailBaskets.GetSelectedRecord.IEN+FMListerMailBaskets.IENS);
  frmMailMessage.FMGetsMailBasketMessage.IENS := FMListBoxMailBoxMessages.GetSelectedRecord.IEN + ',' + FMListBoxMailBaskets.GetSelectedRecord.IEN + FMListerMailBaskets.IENS;
  frmMailMessage.FMEditMailBasketNewFlag.IENS := frmMailMessage.FMGetsMailBasketMessage.IENS;
  frmMailMessage.FMEditMailBasketMessageLastReadDateTime.IENS := frmMailMessage.FMGetsMailBasketMessage.IENS;
  frmMailMessage.FMListBoxResponses.IENS := frmMailMessage.FMGetsMailBasketMessage.IENS;

  frmMailMessage.FMGetsMailBaskets.IENS := FMListBoxMailBaskets.GetSelectedRecord.IEN + FMListerMailBaskets.IENS;
  frmMailMessage.FMEditNewMessagesInBasket.IENS := frmMailMessage.FMGetsMailBaskets.IENS;
  frmMailMessage.FMGetsMailBaskets.GetAndFill;
  frmMailMessage.FMGetsMailBox.IENS := Piece(FMListerMailBaskets.IENS, ',', 2);
  frmMailMessage.FMEditNewMessagesForUser.IENS := frmMailMessage.FMGetsMailBox.IENS;
  frmMailMessage.FMGetsMailBox.GetAndFill;
  frmMailMessage.FMGetsMailBasketMessage.GetAndFill;

  if FMListBoxMailBaskets.GetSelectedRecord.IEN = '.5' then begin
    //Waste Basket
    frmMailMessage.bitbtnMakeNew.enabled := False;
    frmMailMessage.bitbtnTerminate.Enabled := False;
    frmMailMessage.bitbtnDelete.Enabled := False;
    frmMailMessage.bitbtnInfoOnly.Enabled := False;
    frmMailMessage.bitbtnReply.Enabled := False;
    frmMailMessage.bitbtnForward.Enabled := False;
  end
  else begin
    frmMailMessage.bitbtnMakeNew.enabled := True;
    frmMailMessage.bitbtnTerminate.Enabled := True;
    frmMailMessage.bitbtnDelete.Enabled := True;
    frmMailMessage.bitbtnInfoOnly.Enabled := True;
    frmMailMessage.bitbtnReply.Enabled := True;
    frmMailMessage.bitbtnForward.Enabled := True;
  end;
  frmMailMessage.LabelMessageResponses.Caption := inttostr(frmMailMessage.fmListBoxResponses.Items.Count) + ' responses';
  if frmMailMessage.fmListBoxResponses.Items.Count = 1 then
    frmMailMessage.LabelMessageResponses.Caption := '1 response';
  if frmMailMessage.fmEditLastResponseRead.Text <> '' then
    frmMailMessage.LabelMessageResponsesRead.Caption := 'Last read response #' + frmMailMessage.fmEditLastResponseRead.Text
  else
    frmMailMessage.LabelMessageResponsesRead.Caption := '';
  frmMailMessage.labellastread.caption := 'Last read: ' + frmMailMessage.FMEditMailBasketMessageLastReadDateTime.Text;

  if frmMailMessage.FMEditTerminationDate.text <> '' then
    frmMailMessage.labelMessageTerminated.caption := 'Terminated on ' + frmMailMessage.FMEditTerminationDate.text
  else
    frmMailMessage.labelMessageTerminated.caption := '';
  if MakingNew <> True then begin
    if frmMailMessage.ShowModal = mrCancel then begin
      frmMailMan.StringGridMailBoxMessages.Cells[0, StrToInt(frmMailMessage.LabelRow.Caption)] := ''; // Clear these in case no messages are in the mailbox
      frmMailMan.StringGridMailBoxMessages.Cells[1, StrToInt(frmMailMessage.LabelRow.Caption)] := '';
      frmMailMan.StringGridMailBoxMessages.Cells[2, StrToInt(frmMailMessage.LabelRow.Caption)] := '';
      frmMailMan.StringGridMailBoxMessages.Cells[3, StrToInt(frmMailMessage.LabelRow.Caption)] := '** DELETED **';
      frmMailMan.StringGridMailBoxMessages.Cells[4, StrToInt(frmMailMessage.LabelRow.Caption)] := '';
      frmMailMan.StringGridMailBoxMessages.Cells[5, StrToInt(frmMailMessage.LabelRow.Caption)] := ''; // Not used for now
      frmMailMan.StringGridMailBoxMessages.Cells[6, StrToInt(frmMailMessage.LabelRow.Caption)] := '';

      msgCount := StrtoInt(Piece(Piece(LabelMailTitles.Caption, '(', 2), ' ', 1));
      msgCount := msgCount - 1;

      if msgCount <> 1 then
        LabelMailTitles.Caption := 'Messages:    (' + IntToStr(msgCount) + ' messages found)'
      else
        LabelMailTitles.Caption := 'Messages:    (' + IntToStr(msgCount) + ' message found)';

    end;
  end
  else begin
    if makingnew = true then begin
      frmMailMessage.btnCloseClick(Application);
    end;
  end;
  if frmMailMessage.FMEditMailBasketNewFlag.Text <> 'NEW' then
    frmMailMan.StringGridMailBoxMessages.Cells[0, frmMailMan.StringGridMailBoxMessages.Row] := ''
  else
    frmMailMan.StringGridMailBoxMessages.Cells[0, frmMailMan.StringGridMailBoxMessages.Row] := 'N';
  frmMailMan.btnRefreshClick(Application);
  frmMailMessage.Hide;
end;

procedure TfrmMailMan.FMListBoxMailBasketsExit(Sender: TObject);
begin
  if ANURemoteProcedureCallInProgress = True then
    exit;
end;

procedure TfrmMailMan.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if ANURemoteProcedureCallInProgress = True then
    exit;
  frmMain.RPCBroker1.RemoteProcedure := 'ORWU DT';
  frmMain.RPCBroker1.Param[1].Value := 'NOW';
  frmMain.RPCBroker1.Param[1].PType := literal;
  try
    frmMain.RPCBroker1.Call;
  except
    on EBrokerError do begin
      ANURemoteProcedureCallInProgress := False;

      //jcs - d2006
      //frmMain.GIFImageVistaYellow.Animate := False;
      TGifImage(frmMain.GifImageVistaYellow.picture.Graphic).Animate := False;
      frmMain.StatusBarLoadPt.Caption := 'RPC ORWU DT could not be accessed!';
      frmMain.StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('ORWU DT could not be accessed!');
    end;
  end;
  fmdatenow := frmMain.RPCBroker1.Results[0];
  //Last mailman access
  frmMain.FMFiler1.AddFDA('3.7', AuthorIEN, '3', fmdatetimeconvert(fmdatenow));
  //Last mailman access date
  frmMain.FMFiler1.AddFDA('3.7', AuthorIEN, '3.1', piece(fmdatenow, '.', 1));
  //Last user to access box
  frmMain.FMFiler1.AddFDA('3.7', AuthorIEN, '3.2', authorIEN);
  //Last new message notify date/time
  frmMain.FMFiler1.AddFDA('3.7', AuthorIEN, '1.12', authorIEN);
  FMFile;
end;

procedure TfrmMailMan.ButtonOpenMessageClick(Sender: TObject);
begin
  StringGridMailboxMessagesDblClick(Application);
end;

procedure TfrmMailMan.StringGridMailboxMessagesClick(Sender: TObject);
begin
  ButtonOpenMessage.Enabled := True;
  if frmMailMan.StringGridMailBoxMessages.Cells[2, StringGridMailBoxMessages.Row] <> '' then begin
    ButtonDeleteMessage.Enabled := True;
  end
  else begin
    ButtonOpenMessage.Enabled := False;
    ButtonDeleteMessage.Enabled := False;
    ButtonNew.Enabled := False;
  end;
  if FMListBoxMailBaskets.GetselectedRecord.IEN = '.5' then begin
    ButtonDeleteMessage.Enabled := False;
    ButtonNew.Enabled := False;
  end;
end;

procedure TfrmMailMan.ButtonNewClick(Sender: TObject);
var
  x: integer;
  msgCount: integer;
begin
  msgCount := 0;
  if Application.MessageBox('This will remove the NEW flag from all messages in this mailbox so that they appear read.  Are you sure you want to do this?', 'Mark NEW Messages as Read', 4) = 6 then begin
    // Count new messages for progress bar
    for x := 0 to StringGridMailboxMessages.RowCount - 1 do
      if Pos('N', frmMailMan.StringGridMailBoxMessages.Cells[0, x]) > 0 then
        inc(msgCount);
    ProgressBarMail.Visible := True;
    ProgressBarMail.BringToFront;
    ProgressBarMail.Max := msgCount;
    ProgressBarMail.Position := 0;
    // Now unmark each one
    MakingNew := True;
    for x := 0 to StringGridMailboxMessages.RowCount - 1 do
      if Pos('N', frmMailMan.StringGridMailBoxMessages.Cells[0, x]) > 0 then begin
        ProgressBarMail.Position := x + 1;
        StringGridMailBoxMessages.Row := x;
        ButtonOpenMessageClick(Application);
      end;
    ProgressBarMail.Visible := False;
  end;
  makingnew := false;
  buttondeletemessage.enabled := false;
  buttonopenmessage.enabled := false;
  buttonnew.enabled := false;
end;

procedure TfrmMailMan.buttonDeleteMessageClick(Sender: TObject);
var
  wasteIEN: string;
  msgcount: integer;
begin
  if ANURemoteProcedureCallInProgress = True then
    exit;
  //FrmMailmessage:=TFrmMailmessage.Create(frmMain);

  if Application.MessageBox('Delete the selected message?', 'Delete?', 4) = 6 then begin
    //Clear fields;
    frmMailMessage.FMEditMailBasketMessageLastReadDateTime.Text := '';
    frmMailMessage.FMMemoMailMessage.Lines.Clear;
    frmMailMessage.MemoMessageText.Lines.Clear;
    frmMailMessage.LabelRow.Caption := IntToStr(StringGridMailBoxMessages.Row);
    if StringGridMailBoxMessages.Cells[5, StringGridMailBoxMessages.Row] = '' then
      exit;

    FMListBoxMailBoxMessages.ItemIndex := StrToInt(StringGridMailBoxMessages.Cells[5, StringGridMailBoxMessages.Row]);
    frmMailMessage.LabelIEN.Caption := FMListBoxMailBoxMessages.GetSelectedRecord.IEN;

    frmMailMessage.FMGetsMailBasketMessage.IENS := FMListBoxMailBoxMessages.GetSelectedRecord.IEN + ',' + FMListBoxMailBaskets.GetSelectedRecord.IEN + FMListerMailBaskets.IENS;
    frmMailMessage.FMEditMailBasketNewFlag.IENS := frmMailMessage.FMGetsMailBasketMessage.IENS;
    frmMailMessage.FMEditMailBasketMessageLastReadDateTime.IENS := frmMailMessage.FMGetsMailBasketMessage.IENS;
    frmMailMessage.FMListBoxResponses.IENS := frmMailMessage.FMGetsMailBasketMessage.IENS;

    frmMailMessage.FMGetsMailBaskets.IENS := FMListBoxMailBaskets.GetSelectedRecord.IEN + FMListerMailBaskets.IENS;
    frmMailMessage.FMEditNewMessagesInBasket.IENS := frmMailMessage.FMGetsMailBaskets.IENS;
    frmMailMessage.FMGetsMailBaskets.GetAndFill;
    frmMailMessage.FMGetsMailBox.IENS := Piece(FMListerMailBaskets.IENS, ',', 2);
    frmMailMessage.FMEditNewMessagesForUser.IENS := frmMailMessage.FMGetsMailBox.IENS;
    frmMailMessage.FMGetsMailBox.GetAndFill;
    frmMailMessage.FMGetsMailBasketMessage.GetAndFill;

    // Delete Function
    wasteien := '.5';
    //frmMain.FMValidator1.Setup('3.702','+1,'+wasteien+','+AuthorIEN+',','.01','`'+labelIEN.Caption);
    //If not frmmain.FMValidator1.Validate then frmmain.FMValidator1.DisplayErrors
    //else application.terminate;
    tempIEN := '+' + frmMailMessage.labelIEN.Caption + ',' + wasteien + ',' + AuthorIEN + ',';
    frmMain.FMFiler1.AddFDA('3.702', tempien, '.01', frmMailMessage.labelIEN.Caption);
    frmMain.FMFiler1.AddFDA('3.702', tempien, '4', Piece(frmMailMessage.FMGetsMailBasketMessage.GetField('4').FMDBInternal, '.', 1)); // Just date, not time
    //frmMain.FMFiler1.AddFDA('3.702',tempien,'5',FMGetsMailBasketMessage.GetField('5').FMDBInternal);
    //frmMain.FMFiler1.AddFDA('3.702',tempien,'6',FMGetsMailBasketMessage.GetField('6').FMDBInternal);
    //frmMain.FMFiler1.AddFDA('3.702',tempien,'7',FMGetsMailBasketMessage.GetField('7').FMDBInternal);
    FMFile;

    tempIEN := Piece(frmMain.FMFiler1.NewIENs[0], '^', 2);
    // Reset New message Count if message is new
    if frmMailMessage.FMEditMailBasketNewFlag.Text = 'NEW' then begin
      frmMailMessage.FMEditMailBasketNewFlag.Text := '@';
      FMEditFilePrepare(frmMailMessage.FMEditMailBasketNewFlag);
      frmMain.FMFiler1.AddFDA('3.701', frmMailMessage.FMEditNewMessagesInBasket.IENS, '2', IntToStr(StrToInt(frmMailMessage.FMEditNewMessagesInBasket.Text) - 1));
      frmMain.FMFiler1.AddFDA('3.7', frmMailMessage.FMEditNewMessagesForUser.IENS, '1.1', IntToStr(StrToInt(frmMailMessage.FMEditNewMessagesForUser.Text) - 1));
      FMFile;
    end;
    DeleteRecord(frmMain.RPCBroker1, '3.702', frmMailMessage.FMGetsMailBasketMessage.IENS);

    //frmMailMan.FMListBoxMailBasketsClick(Application);
    //FrmMailMessage.Release;

    // Need to fix the global because Delphi creates a default global
    // It needs to be set a specific way

    frmMain.RPCBroker1.Results.Clear;
    frmMain.RPCBroker1.RemoteProcedure := 'DVBAB MAIL FIX MOVED MESSAGE';
    frmMain.RPCBroker1.Param[0].Value := tempIEN;
    frmMain.RPCBroker1.Param[0].PType := literal;
    frmMain.RPCBroker1.Param[1].Value := '.5';
    frmMain.RPCBroker1.Param[1].PType := literal;
    frmMain.RPCBrokerCall;
    frmMain.RPCBroker1.Call;
    (*
          except
        On EBrokerError do begin;  ANURemoteProcedureCallInProgress:=False;
          frmMain.GIFImageVistaYellow.Animate:=False;
          frmMain.StatusBarLoadPt.Caption:='RPC DVBA FIX MOVED MESSAGE could not be accessed!'; frmMain.StatusBarLoadPt.Repaint; Application.Processmessages;
          ShowMessageCAPRI('DVBAB DVBA FIX MOVED MESSAGE could not be accessed!');
        end; end;
      *)
    frmMailMan.StringGridMailBoxMessages.Cells[0, StrToInt(frmMailMessage.LabelRow.Caption)] := ''; // Clear these in case no messages are in the mailbox
    frmMailMan.StringGridMailBoxMessages.Cells[1, StrToInt(frmMailMessage.LabelRow.Caption)] := '';
    frmMailMan.StringGridMailBoxMessages.Cells[2, StrToInt(frmMailMessage.LabelRow.Caption)] := '';
    frmMailMan.StringGridMailBoxMessages.Cells[3, StrToInt(frmMailMessage.LabelRow.Caption)] := '** DELETED **';
    frmMailMan.StringGridMailBoxMessages.Cells[4, StrToInt(frmMailMessage.LabelRow.Caption)] := '';
    frmMailMan.StringGridMailBoxMessages.Cells[5, StrToInt(frmMailMessage.LabelRow.Caption)] := ''; // Not used for now
    frmMailMan.StringGridMailBoxMessages.Cells[6, StrToInt(frmMailMessage.LabelRow.Caption)] := '';

    msgCount := StrtoInt(Piece(Piece(LabelMailTitles.Caption, '(', 2), ' ', 1));
    msgCount := msgCount - 1;

    if msgCount <> 1 then
      LabelMailTitles.Caption := 'Messages:    (' + IntToStr(msgCount) + ' messages found)'
    else
      LabelMailTitles.Caption := 'Messages:    (' + IntToStr(msgCount) + ' message found)';

    buttondeletemessage.enabled := false;
    buttonopenmessage.enabled := false;
    buttonnew.enabled := false;
    frmMailMan.btnRefreshClick(Application);
  end;
end;

end.
