unit managetemplatedefs;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  ComCtrls,
  ExtCtrls,
  StdCtrls,
  Diaccess,
  Fmcmpnts,
  Fmcntrls,
  Trpcb,
  CCOWRPCBroker,
  CCOWRPCBrokerCAPRI,
  DialogsCAPRI,
  ORCtrls,
  CAPRISupport,
  ORFn;

type
  TfrmManageTemplateDefinitions = class(TForm)
    GroupBox2: TGroupBox;
    FMListBoxReleasedTemplates: TFMListBox;
    FMListerReleasedTemplates: TFMLister;
    RPCBrokerDevAccount: TCCOWRPCBrokerCAPRI;
    FMListerReleasedTemplatesLocal: TFMLister;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    GroupBox3: TGroupBox;
    FMListBoxReleasedTemplatesLocal: TFMListBox;
    GroupBox1: TGroupBox;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Shape1: TShape;
    ORListBoxUpdate: TORListBox;
    ORListBoxNew: TORListBox;
    ButtonImportOnly: TButton;
    ButtonImportAll: TButton;
    ORListBoxTestVersions: TORListBox;
    ButtonImportOnlyTest: TButton;
    ButtonImportAllTest: TButton;
    ButtonReloadList: TButton;
    FMEdit1: TFMEdit;
    FMEdit2: TFMEdit;
    FMEdit3: TFMEdit;
    FMEdit4: TFMEdit;
    FMEdit5: TFMEdit;
    FMEdit6: TFMEdit;
    FMCommentsMemo: TFMMemo;
    Button1: TButton;
    FMGetsTemplateInfo: TFMGets;
    RichEditFormDef: TRichEdit;
    procedure ButtonReloadListClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FMListBoxReleasedTemplatesLocalClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FMEdit1Change(Sender: TObject);
    procedure ORListBoxTestVersionsClick(Sender: TObject);
    procedure ORListBoxNewClick(Sender: TObject);
    procedure ButtonImportAllClick(Sender: TObject);
    procedure ButtonImportOnlyClick(Sender: TObject);
    procedure ButtonImportAllTestClick(Sender: TObject);
    procedure ButtonImportOnlyTestClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmManageTemplateDefinitions: TfrmManageTemplateDefinitions;

implementation

uses main;

var
  xUpdating: boolean;
  maxLines: integer;

{$R *.DFM}

procedure TfrmManageTemplateDefinitions.ButtonReloadListClick(Sender: TObject);
var
  x, y: integer;
  foundflag: boolean;
  foundupdate: boolean;
  foundupdateIEN: string;
  tempstring, tempstringlocal: string;
begin
  xUpdating := True;
  fmGetsTemplateInfo.RPCBroker := frmMain.RPCBroker1;
  ButtonImportAll.Enabled := False;
  ButtonImportOnly.Enabled := False;
  ButtonImportAllTest.Enabled := False;
  ButtonImportOnlyTest.Enabled := False;
  FMEdit1.Color := clWhite;
  FMEdit2.Color := clWhite;
  FMEdit3.Color := clWhite;
  FMEdit4.Color := clWhite;
  FMEdit5.Color := clWhite;
  FMEdit6.Color := clWhite;
  FMCommentsMemo.Color := clWhite;
  Button1.Enabled := False;
  FMEdit1.Text := '';
  FMEdit2.Text := '';
  FMEdit3.Text := '';
  FMEdit4.Text := '';
  FMEdit5.Text := '';
  FMEdit6.Text := '';
  FMCommentsMemo.Lines.Clear;

  screen.cursor := crHourglass;
  ORListBoxNew.Items.Clear;
  ORListBoxUpdate.Items.Clear;
  ORListBoxTestVersions.Items.Clear;
  RPCBrokerDevAccount.Connected := False;
  RPCBrokerDevAccount.RPCTimeLimit := 28800;
  RPCBrokerDevAccount.Server := 'cor.DNS       .URL       ';
  RPCBrokerDevAccount.ListenerPort := PORT;
  RPCBrokerDevAccount.ANUUserSpecs :=
    AuthorSSN + '^' +
    AuthorName + '^' +
    UserDivision + '^' + // Site
  UserDivisionNumber + '^' + // Site num
  AuthorIEN;
  try
  RPCBrokerDevAccount.Connected := True except begin
      frmMain.AnimateLogo(False);
      RPCBrokerDevAccount.Connected := False;
      ShowMessageCAPRI('Development account server cannot be accessed!');
      application.terminate;
      exit;
    end
  end;
  if not RPCBrokerDevAccount.CreateContext('DVBA CAPRI GUI') then begin
    ShowMessageCAPRI('Could not use option "DVBA CAPRI GUI!"');
    application.terminate;
  end;
  FMListBoxReleasedTemplates.GetList;
  screen.cursor := crHourglass;
  RPCBrokerDevAccount.Connected := False;
  screen.cursor := crHourglass;
  FMListBoxReleasedTemplatesLocal.GetList;
  screen.cursor := crHourglass;
  FMListBoxReleasedTemplatesLocal.visible := false;
  for x := 0 to FMListBoxReleasedTemplates.Items.Count - 1 do begin
    FMListBoxReleasedTemplates.ItemIndex := x;
    FoundFlag := false;
    FoundUpdate := False;
    FoundUpdateIEN := '';
    tempstring := FMListBoxReleasedTemplates.Items[x];
    for y := 0 to FMListBoxReleasedTemplatesLocal.Items.Count - 1 do begin
      FMListBoxReleasedTemplatesLocal.ItemIndex := y;
      tempstringlocal := FMListBoxReleasedTemplatesLocal.Items[y];
      if frmMain.Piece(tempString, '^', 1) = frmMain.Piece(tempStringlocal, '^', 1) then
        if frmMain.Piece(tempString, '^', 2) <> frmMain.Piece(tempStringLocal, '^', 2) then begin
          FoundUpdate := True;
          FoundUpdateIEN := FMListBoxReleasedTemplatesLocal.GetSelectedRecord.IEN;
        end;
      if tempstring = tempstringlocal then
        foundflag := true;
    end;
    if foundflag <> true then
      if foundUpdate = true then begin
        // Add to update section
        ORListBoxUpdate.Items.Add(FoundUpdateIEN + '^' + FMListBoxReleasedTemplates.GetselectedRecord.IEN + '^' + tempstring);
      end
      else begin
        // Add to new section
        if Pos('T', frmMain.Piece(frmMain.Piece(tempstring, '^', 1), '~', 2)) > 0 then begin
          ORListBoxTestVersions.Items.Add(FMListBoxReleasedTemplates.GetselectedRecord.IEN + '^' + tempstring);
        end
        else begin
          ORListBoxNew.Items.Add(FMListBoxReleasedTemplates.GetselectedRecord.IEN + '^' + tempstring);
        end;
      end;
  end;

  // Remove activation date from display to user
  if FMListBoxReleasedTemplatesLocal.Items.Count > 0 then
    for x := FMListBoxReleasedTemplatesLocal.Items.Count - 1 downto 0 do
      FMListBoxReleasedTemplatesLocal.Items[x] := frmMain.Piece(FMListBoxReleasedTemplatesLocal.Items[x], '^', 1);

  FMListBoxReleasedTemplatesLocal.visible := True;
  screen.cursor := crDefault;

  if FMListBoxReleasedTemplatesLocal.Items.Count > 0 then begin
    FMListBoxReleasedTemplatesLocal.ItemIndex := 0;
    FMListBoxReleasedTemplatesLocalClick(Application);
  end;

  if (ORListBoxUpdate.Items.Count > 0) or (ORListBoxNew.Items.Count > 0) then
    ButtonImportAll.Enabled := True;
  if ORListBoxTestVersions.Items.Count > 0 then
    ButtonImportAllTest.Enabled := True;
  xUpdating := False;
end;

procedure TfrmManageTemplateDefinitions.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  // Prevent exit if broker call is running.
  if ANURemoteProcedureCallInProgress = True then
    CanClose := False;
  if FMEdit1.Color = clYellow then
    if Application.MessageBox('Save your changes on the "Edit Local" tab before closing?  If you answer "no," your changes will be lost.', 'Save?', 4) = 6 then begin
      Button1Click(Application);
    end;
end;

procedure TfrmManageTemplateDefinitions.FMListBoxReleasedTemplatesLocalClick(
  Sender: TObject);
begin
  if FMEdit1.Color = clYellow then
    if Application.MessageBox('Save your changes?  If you don''t save, changes will be lost.', 'Save?', 4) = 6 then begin
      Button1Click(Application);
      exit;
    end;
  xUpdating := true;
  FMGetsTemplateInfo.IENS := FMListBoxReleasedTemplatesLocal.GetSelectedRecord.IEN;
  FMGetsTemplateInfo.GetAndFill;
  FMEdit1.Color := clWhite;
  FMEdit2.Color := clWhite;
  FMEdit3.Color := clWhite;
  FMEdit4.Color := clWhite;
  FMEdit5.Color := clWhite;
  FMEdit6.Color := clWhite;
  FMCommentsMemo.Color := clWhite;
  Button1.Enabled := False;
  xUpdating := False;
end;

procedure TfrmManageTemplateDefinitions.Button1Click(Sender: TObject);
begin
  if FMEdit1.FMModified then
    if FMEdit1.Validate then begin
      frmMain.fmfiler1.AddChgdControl(FMEdit1);
      FMEdit1.Text := FMEdit1.FMCtrlExternal;
    end
    else begin
      frmMain.FMValidator1.DisplayErrors;
      FMEdit1.Text := FMEdit1.FMTag;
    end;
  if FMEdit2.FMModified then
    if FMEdit2.Validate then begin
      frmMain.fmfiler1.AddChgdControl(FMEdit2);
      FMEdit2.Text := FMEdit2.FMCtrlExternal;
    end
    else begin
      frmMain.FMValidator1.DisplayErrors;
      FMEdit2.Text := FMEdit2.FMTag;
    end;
  if FMEdit3.FMModified then
    if FMEdit3.Validate then begin
      frmMain.fmfiler1.AddChgdControl(FMEdit3);
      FMEdit3.Text := FMEdit3.FMCtrlExternal;
    end
    else begin
      frmMain.FMValidator1.DisplayErrors;
      FMEdit3.Text := FMEdit3.FMTag;
    end;
  if FMEdit4.FMModified then
    if FMEdit4.Validate then begin
      frmMain.fmfiler1.AddChgdControl(FMEdit4);
      FMEdit4.Text := FMEdit4.FMCtrlExternal;
    end
    else begin
      frmMain.FMValidator1.DisplayErrors;
      FMEdit4.Text := FMEdit4.FMTag;
    end;
  if FMEdit5.FMModified then
    if FMEdit5.Validate then begin
      frmMain.fmfiler1.AddChgdControl(FMEdit5);
      FMEdit5.Text := FMEdit5.FMCtrlExternal;
    end
    else begin
      frmMain.FMValidator1.DisplayErrors;
      FMEdit5.Text := FMEdit5.FMTag;
    end;
  if FMEdit6.FMModified then
    if FMEdit6.Validate then begin
      frmMain.fmfiler1.AddChgdControl(FMEdit6);
      FMEdit6.Text := FMEdit6.FMCtrlExternal;
    end
    else begin
      frmMain.FMValidator1.DisplayErrors;
      FMEdit6.Text := FMEdit6.FMTag;
    end;
  frmMain.fmfiler1.AddChgdControl(FMCommentsMemo);
  if frmMain.FMFiler1.AnythingToFile then
    if frmMain.FMFiler1.Update then begin
    end
    else begin
      ShowmessageCAPRI('All data wasn''t saved.  Please double-check the entries and try again.');
    end;

  FMEdit1.Color := clWhite;
  FMEdit2.Color := clWhite;
  FMEdit3.Color := clWhite;
  FMEdit4.Color := clWhite;
  FMEdit5.Color := clWhite;
  FMEdit6.Color := clWhite;
  FMCommentsMemo.Color := clWhite;
  Button1.Enabled := False;
  if xUpdating <> true then
    buttonReloadListClick(application);
end;

procedure TfrmManageTemplateDefinitions.FMEdit1Change(Sender: TObject);
begin
  if xupdating = False then begin
    FMEdit1.Color := clYellow;
    FMEdit2.Color := clYellow;
    FMEdit3.Color := clYellow;
    FMEdit4.Color := clYellow;
    FMEdit5.Color := clYellow;
    FMEdit6.Color := clYellow;
    FMCommentsMemo.Color := clYellow;
    Button1.Enabled := True;
  end;
end;

procedure TfrmManageTemplateDefinitions.ORListBoxTestVersionsClick(
  Sender: TObject);
var
  x: integer;
  foundflag: boolean;
begin
  foundflag := false;
  if ORListBoxTestVersions.Items.Count > 0 then
    for x := 0 to ORListBoxTestVersions.Items.Count - 1 do
      if ORListBoxTestVersions.Selected[x] = true then
        foundflag := true;
  if FoundFlag = true then
    ButtonImportOnlyTest.Enabled := True
  else
    ButtonImportOnlyTest.Enabled := False;
end;

procedure TfrmManageTemplateDefinitions.ORListBoxNewClick(Sender: TObject);
var
  x: integer;
  foundflag: boolean;
begin
  foundflag := false;
  if ORListBoxUpdate.Items.Count > 0 then
    for x := 0 to ORListBoxUpdate.Items.Count - 1 do
      if ORListBoxUpdate.Selected[x] = true then
        foundflag := true;
  if ORListBoxNew.Items.Count > 0 then
    for x := 0 to ORListBoxNew.Items.Count - 1 do
      if ORListBoxNew.Selected[x] = true then
        foundflag := true;
  if FoundFlag = true then
    ButtonImportOnly.Enabled := True
  else
    ButtonImportOnly.Enabled := False;
end;

procedure TfrmManageTemplateDefinitions.ButtonImportAllClick(
  Sender: TObject);
var
  x: integer;
begin
  if Application.MessageBox('Are you sure you want to update your template definitions?', 'Update Templates?', 4) <> 6 then
    exit;

  if ORListBoxUpdate.Items.Count > 0 then
    for x := 0 to ORListBoxUpdate.Items.Count - 1 do
      ORListBoxUpdate.Selected[x] := true;
  if ORListBoxNew.Items.Count > 0 then
    for x := 0 to ORListBoxNew.Items.Count - 1 do
      ORListBoxNew.Selected[x] := true;
  ButtonImportOnlyClick(Application);

end;

procedure TfrmManageTemplateDefinitions.ButtonImportOnlyClick(
  Sender: TObject);
var
  x, y, xx: integer;
  fmDateNow: string;
  tempIEN: string;
begin
  if Application.MessageBox('Are you sure you want to update your template definitions?', 'Update Templates?', 4) <> 6 then
    exit;

  xUpdating := True;
  frmMain.RPCBroker1.RemoteProcedure := 'ORWU DT';
  frmMain.RPCBroker1.Param[1].Value := 'NOW';
  frmMain.RPCBroker1.Param[1].PType := literal;
  frmMain.RPCBroker1.Call;
  fmdatenow := frmMain.RPCBroker1.Results[0];
  fmdatenow := copy(fmdatenow, 1, pos('.', fmdatenow) - 1);
  // Connect to Server
  frmMain.RPCBroker1.ANUUserSpecs :=
    AuthorSSN + '^' +
    AuthorName + '^' +
    UserDivision + '^' + // Site
  UserDivisionNumber + '^' + // Site num
  AuthorIEN;
  try
  RPCBrokerDevAccount.Connected := True except begin
      frmMain.AnimateLogo(False);
      RPCBrokerDevAccount.Connected := False;
      ShowMessageCAPRI('Development account server cannot be accessed!');
      application.terminate;
      exit;
    end
  end;
  if not RPCBrokerDevAccount.CreateContext('DVBA CAPRI GUI') then begin
    ShowMessageCAPRI('Could not use option "DVBA CAPRI GUI!"');
    application.terminate;
  end;

  // Now get forms
  fmGetsTemplateInfo.RPCBroker := RPCBrokerDevAccount;
  for x := 0 to ORListBoxNew.Items.Count - 1 do
    if ORListBoxNew.Selected[x] = True then begin
      fmGetsTemplateInfo.RPCBroker := RPCBrokerDevAccount;
      fmGetsTemplateInfo.IENS := piece(ORListBoxNew.Items[x], '^', 1);
      fmGetsTemplateInfo.GetAndFill;
      // Now get form definition
      RPCBrokerDevAccount.RemoteProcedure := 'DVBAB TEMPLATE DEFINITION';
      RPCBrokerDevAccount.Param[0].Value := Piece(fmGetsTemplateInfo.IENS, ',', 1);
      RPCBrokerDevAccount.Param[0].PType := literal;
      RPCBrokerDevAccount.Param[1].Value := '1';
      RPCBrokerDevAccount.Param[1].PType := literal;
      //frmMain.RPCBrokerCall; RPCBrokerDevAccount.Call;
      try
        RPCBrokerDevAccount.Call;
      except
        on EBrokerError do begin
          ANURemoteProcedureCallInProgress := False;
          ShowMessageCAPRI('DVBAB TEMPLATE DEFINITION could not be accessed!');
        end;
      end;
      QuickCopy(RPCBrokerDevAccount.Results, RichEditFormDef);
      // Got everything.  These are new forms, not updates, so need so save them into a new record.

      FMEdit1.IENS := '+1,';
      FMEdit2.IENS := '+1,';
      FMEdit3.IENS := '+1,';
      FMEdit4.IENS := '+1,';
      FMEdit5.IENS := '+1,';
      FMEdit6.IENS := '+1,';
      FMCommentsMemo.IENS := '+1,';
      Button1Click(Application);
      xx := 0;
      MaxLines := 200;
      tempIEN := frmMain.FMFiler1.FindIen('+1,');
      if Pos('^396.184', RichEditFormDef.Lines[0]) = 0 then
        RichEditFormDef.Lines.Insert(0, '^396.184^' + inttostr(RichEditFormDef.Lines.Count) + '^' + inttostr(RichEditFormDef.Lines.Count) + '^' + fmdatenow + '^^^^');
      repeat begin
          frmMain.RPCBroker1.RemoteProcedure := 'DVBAB TEMPLATE DEFINITION UPDT';
          frmMain.RPCBroker1.Param[0].Value := tempIEN;
          frmMain.RPCBroker1.Param[0].PType := literal;
          frmMain.RPCBroker1.Param[1].Value := '1';
          frmMain.RPCBroker1.Param[1].PType := literal;
          y := 0;
          repeat begin
              frmMain.RPCBroker1.Param[2].Mult[inttostr(y + 1)] := richEditFormDef.lines[xx + y];
              frmMain.RPCBroker1.Param[2].PType := list;
              inc(y);
          end until ((y + xx > RichEditFormDef.Lines.Count - 1) or (y = maxlines));
          frmMain.RPCBroker1.Param[3].Value := inttostr(y);
          frmMain.RPCBroker1.Param[3].PType := literal;
          frmMain.RPCBroker1.Param[4].Value := inttostr(xx);
          frmMain.RPCBroker1.Param[4].PType := literal;
          frmMain.RPCBroker1.Call;
          xx := xx + y;
      end until (xx > richEditFormDef.Lines.Count - 1);
    end;

  // Now get forms
  fmGetsTemplateInfo.RPCBroker := RPCBrokerDevAccount;
  for x := 0 to ORListBoxUpdate.Items.Count - 1 do
    if ORListBoxUpdate.Selected[x] = True then begin
      fmGetsTemplateInfo.RPCBroker := RPCBrokerDevAccount;
      fmGetsTemplateInfo.IENS := piece(ORListBoxUpdate.Items[x], '^', 2);
      fmGetsTemplateInfo.GetAndFill;
      // Now get form definition
      RPCBrokerDevAccount.RemoteProcedure := 'DVBAB TEMPLATE DEFINITION';
      RPCBrokerDevAccount.Param[0].Value := Piece(fmGetsTemplateInfo.IENS, ',', 1);
      RPCBrokerDevAccount.Param[0].PType := literal;
      RPCBrokerDevAccount.Param[1].Value := '1';
      RPCBrokerDevAccount.Param[1].PType := literal;
      //frmMain.RPCBrokerCall; RPCBrokerDevAccount.Call;
      try
        RPCBrokerDevAccount.Call;
      except
        on EBrokerError do begin
          ANURemoteProcedureCallInProgress := False;
          ShowMessageCAPRI('DVBAB TEMPLATE DEFINITION could not be accessed!');
        end;
      end;
      QuickCopy(RPCBrokerDevAccount.Results, RichEditFormDef);
      // Got everything.  These are new forms, not updates, so need so save them into a new record.

      FMEdit1.IENS := Piece(ORListBoxUpdate.Items[x], '^', 1);
      FMEdit2.IENS := FMEdit1.IENS;
      FMEdit3.IENS := FMEdit1.IENS;
      FMEdit4.IENS := FMEdit1.IENS;
      FMEdit5.IENS := FMEdit1.IENS;
      FMEdit6.IENS := FMEdit1.IENS;
      FMCommentsMemo.IENS := FMEdit1.IENS;
      Button1Click(Application);
      xx := 0;
      MaxLines := 200;
      tempIEN := FMEdit1.IENS;
      if Pos('^396.184', RichEditFormDef.Lines[0]) = 0 then
        RichEditFormDef.Lines.Insert(0, '^396.184^' + inttostr(RichEditFormDef.Lines.Count) + '^' + inttostr(RichEditFormDef.Lines.Count) + '^' + fmdatenow + '^^^^');
      repeat begin
          frmMain.RPCBroker1.RemoteProcedure := 'DVBAB TEMPLATE DEFINITION UPDT';
          frmMain.RPCBroker1.Param[0].Value := tempIEN;
          frmMain.RPCBroker1.Param[0].PType := literal;
          frmMain.RPCBroker1.Param[1].Value := '1';
          frmMain.RPCBroker1.Param[1].PType := literal;
          y := 0;
          repeat begin
              frmMain.RPCBroker1.Param[2].Mult[inttostr(y + 1)] := richEditFormDef.lines[xx + y];
              frmMain.RPCBroker1.Param[2].PType := list;
              inc(y);
          end until ((y + xx > RichEditFormDef.Lines.Count - 1) or (y = maxlines));
          frmMain.RPCBroker1.Param[3].Value := inttostr(y);
          frmMain.RPCBroker1.Param[3].PType := literal;
          frmMain.RPCBroker1.Param[4].Value := inttostr(xx);
          frmMain.RPCBroker1.Param[4].PType := literal;
          frmMain.RPCBroker1.Call;
          xx := xx + y;
      end until (xx > richEditFormDef.Lines.Count - 1);
    end;

  RPCBrokerDevAccount.Connected := False;
  buttonReloadListClick(Application);
  xUpdating := False;
end;

procedure TfrmManageTemplateDefinitions.ButtonImportAllTestClick(
  Sender: TObject);
var
  x: integer;
begin
  if Application.MessageBox('Are you sure you want to update your template definitions?', 'Update Templates?', 4) <> 6 then
    exit;

  if ORListBoxTestVersions.Items.Count > 0 then
    for x := 0 to ORListBoxTestVersions.Items.Count - 1 do
      ORListBoxTestVersions.Selected[x] := true;
  ButtonImportOnlyTestClick(Application);
end;

procedure TfrmManageTemplateDefinitions.ButtonImportOnlyTestClick(
  Sender: TObject);
var
  x, y, xx: integer;
  fmDateNow: string;
  tempIEN: string;
begin
  if Application.MessageBox('Are you sure you want to update your template definitions?', 'Update Templates?', 4) <> 6 then
    exit;

  xUpdating := True;
  frmMain.RPCBroker1.RemoteProcedure := 'ORWU DT';
  frmMain.RPCBroker1.Param[1].Value := 'NOW';
  frmMain.RPCBroker1.Param[1].PType := literal;
  frmMain.RPCBroker1.Call;
  fmdatenow := frmMain.RPCBroker1.Results[0];
  fmdatenow := copy(fmdatenow, 1, pos('.', fmdatenow) - 1);
  // Connect to Server
  frmMain.RPCBroker1.ANUUserSpecs :=
    AuthorSSN + '^' +
    AuthorName + '^' +
    UserDivision + '^' + // Site
  UserDivisionNumber + '^' + // Site num
  AuthorIEN;
  try
  RPCBrokerDevAccount.Connected := True except begin
      frmMain.AnimateLogo(False);
      RPCBrokerDevAccount.Connected := False;
      ShowMessageCAPRI('Development account server cannot be accessed!');
      application.terminate;
      exit;
    end
  end;
  if not RPCBrokerDevAccount.CreateContext('DVBA CAPRI GUI') then begin
    ShowMessageCAPRI('Could not use option "DVBA CAPRI GUI!"');
    application.terminate;
  end;

  // Now get forms
  fmGetsTemplateInfo.RPCBroker := RPCBrokerDevAccount;
  for x := 0 to ORListBoxTestVersions.Items.Count - 1 do
    if ORListBoxTestVersions.Selected[x] = True then begin
      fmGetsTemplateInfo.RPCBroker := RPCBrokerDevAccount;
      fmGetsTemplateInfo.IENS := piece(ORListBoxTestVersions.Items[x], '^', 1);
      fmGetsTemplateInfo.GetAndFill;
      // Now get form definition
      RPCBrokerDevAccount.RemoteProcedure := 'DVBAB TEMPLATE DEFINITION';
      RPCBrokerDevAccount.Param[0].Value := Piece(fmGetsTemplateInfo.IENS, ',', 1);
      RPCBrokerDevAccount.Param[0].PType := literal;
      RPCBrokerDevAccount.Param[1].Value := '1';
      RPCBrokerDevAccount.Param[1].PType := literal;
      //frmMain.RPCBrokerCall; RPCBrokerDevAccount.Call;
      try
        RPCBrokerDevAccount.Call;
      except
        on EBrokerError do begin
          ANURemoteProcedureCallInProgress := False;
          ShowMessageCAPRI('DVBAB TEMPLATE DEFINITION could not be accessed!');
        end;
      end;
      QuickCopy(RPCBrokerDevAccount.Results, RichEditFormDef);
      // Got everything.  These are new forms, not updates, so need so save them into a new record.

      FMEdit1.IENS := '+1,';
      FMEdit2.IENS := '+1,';
      FMEdit3.IENS := '+1,';
      FMEdit4.IENS := '+1,';
      FMEdit5.IENS := '+1,';
      FMEdit6.IENS := '+1,';
      FMCommentsMemo.IENS := '+1,';
      Button1Click(Application);
      xx := 0;
      MaxLines := 200;
      tempIEN := frmMain.FMFiler1.FindIen('+1,');
      if Pos('^396.184', RichEditFormDef.Lines[0]) = 0 then
        RichEditFormDef.Lines.Insert(0, '^396.184^' + inttostr(RichEditFormDef.Lines.Count) + '^' + inttostr(RichEditFormDef.Lines.Count) + '^' + fmdatenow + '^^^^');
      repeat begin
          frmMain.RPCBroker1.RemoteProcedure := 'DVBAB TEMPLATE DEFINITION UPDT';
          frmMain.RPCBroker1.Param[0].Value := tempIEN;
          frmMain.RPCBroker1.Param[0].PType := literal;
          frmMain.RPCBroker1.Param[1].Value := '1';
          frmMain.RPCBroker1.Param[1].PType := literal;
          y := 0;
          repeat begin
              frmMain.RPCBroker1.Param[2].Mult[inttostr(y + 1)] := richEditFormDef.lines[xx + y];
              frmMain.RPCBroker1.Param[2].PType := list;
              inc(y);
          end until ((y + xx > RichEditFormDef.Lines.Count - 1) or (y = maxlines));
          frmMain.RPCBroker1.Param[3].Value := inttostr(y);
          frmMain.RPCBroker1.Param[3].PType := literal;
          frmMain.RPCBroker1.Param[4].Value := inttostr(xx);
          frmMain.RPCBroker1.Param[4].PType := literal;
          frmMain.RPCBroker1.Call;
          xx := xx + y;
      end until (xx > richEditFormDef.Lines.Count - 1);
    end;
  RPCBrokerDevAccount.Connected := False;
  buttonReloadListClick(Application);
  xUpdating := False;
end;

end.
