unit printtemplate;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  Fmcntrls,
  Fmcmpnts,
  Diaccess,
  ORCtrls,
  Trpcb,
  CAPRISupport,
  DialogsCAPRI,
  UUCode,
  ZipMcpt,
  ComCtrls,
  PNCSRunReport,
  ExtCtrls,
  clipbrd,
  CCOWRPCBrokerCAPRI;

type
  TfrmGenerateBlankTemplate = class(TForm)
    FMListBoxAllTemplates: TFMListBox;
    FMListBoxTemplates: TFMListBox;
    ListBoxTemplates: TORListBox;
    FMListerTemplates: TFMLister;
    FMGetsTemplateInfo: TFMGets;
    FMCommentsMemo: TFMMemo;
    Label1: TLabel;
    Label2: TLabel;
    Label4: TLabel;
    ButtonGenerateTemplate: TButton;
    ButtonCancel: TButton;
    MiniZip1: TMiniZip;
    FMMemoReportDefinition: TRichEdit;
    FMMemoScriptDefinition: TRichEdit;
    FMMemoFormDefinition: TRichEdit;
    xSampleReportOutput: TRichEdit;
    xpanelBaseControl: TPanel;
    xMemoReportErrors: TMemo;
    ButtonClipboardTemplate: TButton;
    procedure ButtonCancelClick(Sender: TObject);
    procedure ButtonGenerateTemplateClick(Sender: TObject);
    procedure ListBoxTemplatesClick(Sender: TObject);
    procedure ButtonClipboardTemplateClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmGenerateBlankTemplate: TfrmGenerateBlankTemplate;

implementation

uses wait,
  main;

{$R *.DFM}

procedure TfrmGenerateBlankTemplate.ButtonCancelClick(Sender: TObject);
begin
  modalresult := mrcancel;
end;

procedure TfrmGenerateBlankTemplate.ButtonGenerateTemplateClick(
  Sender: TObject);
var
  x: integer;

  formfilenamehandle: integer;
  formToMergeIEN: string;
  formfilename: string;
  tempMemoryStream: TMemoryStream;
begin
  xSampleReportOutput.Lines.Clear;

  if ANURemoteProcedureCallInProgress = True then
    exit;

  x := ListBoxTemplates.itemindex;

  FMGetsTemplateInfo.IENS := Piece(ListBoxTemplates.Items[x], '^', 2);
  FMGetsTemplateInfo.GetAndFill;

  WaitForm.BringToFront;
  WaitForm.Label1.Caption := 'Loading ' + Piece(ListBoxTemplates.Items[x], '^', 1);
  WaitForm.Repaint;
  formtomergeIEN := Piece(ListBoxTemplates.Items[x], '^', 2);

  FMGetsTemplateInfo.IENS := formToMergeIEN;
  FMGetsTemplateInfo.GetData;

  formfilename := TempDir;
  formfilename := formfilename + FMGetsTemplateInfo.GetField('.01').FMDBExternal + '^';
  formfilename := formfilename + FMGetsTemplateInfo.GetField('5').FMDBInternal + '.zip';


  if fileexists(formfilename) = false then begin
    waitform.imagenetwork.visible := True;
    waitform.imagenetwork.repaint;
    waitform.repaint;

    frmMain.RPCBroker1.RemoteProcedure := 'DVBAB TEMPLATE DEFINITION';
    frmMain.RPCBroker1.Param[0].Value := formToMergeIEN;
    frmMain.RPCBroker1.Param[0].PType := literal;
    frmMain.RPCBroker1.Param[1].Value := '1';
    frmMain.RPCBroker1.Param[1].PType := literal;
    //frmMain.RPCBrokerCall; frmMain.RPCBroker1.Call;
    WaitForm.StaticText1.Caption := 'Loading definition...';
    Waitform.StaticText1.Repaint;
    frmMain.RPCBrokerCall;
    try
      frmMain.RPCBroker1.Call;
    except
      on EBrokerError do begin
        ANURemoteProcedureCallInProgress := False;
        frmMain.AnimateLogo(False);
        frmMain.StatusBarLoadPt.Caption := 'DVBAB TEMPLATE DEFINITION could not be accessed!';
        frmMain.StatusBarLoadPt.Repaint;
        Application.Processmessages;
        ShowMessageCAPRI('DVBAB TEMPLATE DEFINITION could not be accessed!');
      end;
    end;
    //frmMain.FMMemoFormDefinitionChange(FMMemoFormDefinition);

    if frmMain.RPCBroker1.Results.Count = 0 then begin
      ShowmessageCAPRI('The template definition needed for ' + Piece(ListBoxTemplates.Items[x], '^', 2) + '^' + Piece(ListBoxTemplates.Items[x], '^', 1) + ' (IEN #' + formToMergeIEN + ') is no longer available in the file.');
      exit;
    end;

    WaitForm.StaticText1.Caption := 'Decoding...';
    Waitform.StaticText1.Repaint;
    TempFileName := Copy(frmMain.RPCBroker1.Results[0], 11, 999);
    if TempFileName = '' then begin
      ShowMessageCAPRI('There was a problem with the definition file.  Exiting CAPRI.');
      application.terminate;
      exit;
    end;

    if FileExists(TempDir + TempFileName + '.uue') then begin
      try
      DeleteFile(TempDir + TempFileName + '.uue')except begin
          ShowMessageCAPRI('You have an outdated definition that cannot be deleted.  Exiting CAPRI.');
          application.terminate;
        end;
      end;
    end;

    if FileExists(TempDir + TempFileName) then begin
      try
      DeleteFile(TempDir + TempFileName)except begin
          ShowMessageCAPRI('You have an outdated definition that cannot be deleted.  Exiting CAPRI.');
          application.terminate;
        end;
      end;
    end;
    frmMain.RPCBroker1.Results.SaveToFile(TempDir + TempFileName + '.uue');
    UUDecode(TempDir + TempFileName + '.uue');
    DeleteFile(TempDir + TempFileName + '.uue');
    renamefile(TempDir + TempFileName, formfilename);
    MiniZip1.UnZipFile := formfilename;
    MiniZip1.UnzipAllTo(TempDir);
    MiniZip1.UnZipFile := '';
    TempFileName := Piece(TempFilename, '.', 1);

    RenameFile(TempDir + TempFileName + '.pnl.frm', formfilename + '.pnl.frm');
    RenameFile(TempDir + TempFileName + '.pnl.cde', formfilename + '.pnl.cde');
    RenameFile(TempDir + TempFileName + '.pnl.rep', formfilename + '.pnl.rep');

    if FileExists(TempDir + TempFileName + '.pnl.map') then
    begin
      RenameFile(TempDir + TempFileName + '.pnl.map', formfilename + '.pnl.map');
    end;

  end;
  // Touch form date/time
  formFileNameHandle := FileOpen(formFileName, fmOpenReadWrite);
  if formfileNamehandle > -1 then
    FileSetDate(formfilenamehandle, DateTimeToFileDate(now));
  FileClose(formFileNameHandle);

  FMMemoFormDefinition.Lines.LoadFromFile(formfilename + '.pnl.frm');
  FMMemoScriptDefinition.Lines.LoadFromFile(formfilename + '.pnl.cde');
  FMMemoReportDefinition.Lines.LoadFromFile(formfilename + '.pnl.rep');
  { TBD CKU - do we need to load the XML definition as well? }

  if ANURemoteProcedureCallInProgress = True then
    repeat application.processmessages until
    ANURemoteProcedureCallInProgress = False;

  tempMemoryStream := tMemoryStream.Create;
  PNCSReportRunBlankTemplate(FMMemoReportDefinition, xSampleReportOutput, xPanelBaseControl, xmemoReportErrors, tempMemoryStream);
  tempMemoryStream.Position := 0;
  xSampleReportOutput.Lines.LoadFromStream(tempMemoryStream);
  tempMemoryStream.Free;

  waitform.hide;

  if sender = ButtonClipboardTemplate then begin
    clipboard.AsText := xSampleReportOutput.Text;
    ShowmessageCAPRI('The report has been copied to the clipboard.');
  end
  else begin
    frmMain.actFilePrintExecute(frmGenerateBlankTemplate);
  end;
end;

procedure TfrmGenerateBlankTemplate.ListBoxTemplatesClick(Sender: TObject);
begin
  FMGetsTemplateInfo.IENS := Piece(ListBoxTemplates.Items[ListBoxTemplates.ItemIndex], '^', 2);
  FMGetsTemplateInfo.GetAndFill;
  ButtonGenerateTemplate.Enabled := True;
  ButtonClipboardTemplate.Enabled := True;
end;

procedure TfrmGenerateBlankTemplate.ButtonClipboardTemplateClick(Sender: TObject);
begin
  ButtonGenerateTemplateClick(ButtonClipboardTemplate);
end;

end.
