Unit REPORTS;
{
REPORTS.PAS road map
 1. Pending C&P Exams -
  a. Panel: PanelReportChoice3
  b. OKButton:  Button1Click
  c. RPC: 'DVBAB PENDING C&P REPORT'
 2. Insufficient Exam Report -
  a. Panel : PanelInsufficientExamReport
  b. OkButton : Button5Click
  c. RPC:  Report 5, 'DVBAB REPORTS'
 3. Pending 7131 Requests
  a. Panel: PanelReportChoice2
  b. OKButton: Button9Click
  c. RPC:  (DVBAB REPORT PENDING7131)
 4. Request Status By Date Range
  a. Panel: PanelReportChoice2
  b. OKButton: Button9Click
  c. Routine:  GetRequestStatusReport(IsDelimited, IsIgnoreDate)
  d. RPC:  Report 14, DVBAB REPORTS
 5. Exam Request By Date Range
  a. Panel:  PanelReportChoice2
  b. OKButton: Button9Click
  c. RPC: (DVBAB EXAMS BY DATE)
 6. Admission Report for SC Veterans
  a. Panel: PanelReportChoice2
  b. OKButton: Button9Click
  c. RPC/Routine:  GetHospAdjReport('DVBAB REPORT ADMISSIONS','AdmissionSCVeteransReport', IsDelimited)
 7. Admission Inquiry By Date
  a. Panel: PanelReportChoice2
  b. OKButton: Button9Click
  c. Routine: GetAdmissionInquiryByDate
  d. RPC:  'DVBAB REPORT ADMINQ'
 8. Special Report for A&A/Pension
  a. Reports.pas control:  ORReportsAvailable
  b. Form:  SpecialReport.pas
  c. RPC: 'DVBAB REPORT SPECIAL'
 9. Discharge Report
  a. Panel: PanelReportChoice2
  b. OKButton: Button9Click
  c. RPC/Routine: GetHospAdjReport('DVBAB REPORT DISCHARGE', 'DischargeReport', IsDelimited)
 10. CNH Report of Admissions/Discharges
  a. Panel: PanelReportChoice2
  b. OKButton:  Button9Click
  c. Routine:  GetFeeBasisReport('CNH Report of Admissions/Discharges', IsDelimited)
  d. RPC:  Report 12, DVBAB REPORTS
 11. Re-Admission Report
  a. Panel: PanelReportChoice2
  b. OKButton: Button9Click
  c. RPC/Routine: GetHospAdjReport('DVBAB REPORT READMIT', 'ReAdmissionReport', IsDelimited)
 12. CNH Stays in Excess of 90 Days
  a. Panel: PanelReportChoice2
  b. OKButton: Button9Click
  c. Routine:  GetFeeBasisReport('CNH Stays in Excess of 90 Days', IsDelimited)
  d. RPC:  Report 13, DVBAB REPORTS
 13. CNH Roster Print
  a. Panel: PanelReportChoice2
  b. OKButton: Button9Click
  c. Routine: GetFeeBasisReport('CNH Roster Print', IsDelimited)
  d. RPC:  Report 11, DVBAB REPORTS
 14. Incompetent Veteran Report
  a. Panel: PanelReportChoice2
  b. OKButton: Button9Click
  c. RPC/Routine: GetHospAdjReport('DVBAB REPORT INCOMPVET', 'IncompVetReport', IsDelimited)
 15. Template Activity
  a. Panel: PanelReportDateRange
  b. OKButton: Button8Click
  c. RPC: 'DVBAB TEMPLATE REPORT FULL'
 16. Amis290
  a. Panel: PanelReportChoice2
  b. OKButton: Button9Click
  c. Routine: GetAMIS290Report(False)
 17. Amis290 By Division
  a. Panel: PanelReportChoice2
  b. OKButton: Button9Click
  c. Routine: GetAMIS290Report(True)
}

Interface

Uses
  Windows,
  Classes,
  clipbrd,
  ComCtrls,
  Controls,
  Diaccess,
  Dialogs,
  DialogsCAPRI,
  ExtCtrls,
  Fmcmpnts,
  Fmcntrls,
  Forms,
  GIFImage,
  Graphics,
  Menus,
  Messages,
  ORCtrls,
  ORDtTm,
  ORFn,
  printers,
  PrintSupport,
  Qrctrls,
  QrPrntr,
  QuickRpt,
  RpcConf1,
  StdCtrls,
  StrUtils,
  SysUtils,
  ShlObj,
  Trpcb,
  CCOWRPCBrokerCAPRI, ActnPopup, ToolWin, ActnMan, ActnCtrls, ActnMenus,
  ActnList, XPStyleActnCtrls,
  Contnrs,                                                                      // CODECR_129 whh
  RpDefine, RpBase, RpSystem, VA508AccessibilityManager;                        //CodeCR199 - rpm 10/19/2011

{
00 -- C&P EXAMS --
01 AMIS 290
02 AMIS 290 by Division
03 Insufficient Exam Report
04 Pending C&P Exams
05 C&P Exams Checklist
06 Re-Print C&P Final Report
07 Exam Requests by Date
08 Request Status by Date
09
10 -- HOSPITAL ADJUSTMENT --
11 Admission Report for SC Veteran
12 Admission Inquiry by Date
13 Special Report fo A&A and Pension
14 Re-Admission Report
15 Discharge Report
16 Incompetent Veterans Report
17 CNH Display Episode of Care
18 CNH Roster Print
19 CNH Report of Admissions/Discharges
20 CNH Stays in Excess of 90 Days
21
22 -- REQUEST FOR INFO --
23 Pending Form 7131 Requests
24 21 Day Certificate Printing
25 Reprint a 21 Day Certificate
26 Reprint a Notice of Discharge
27
28 -- VHA REPORTS --
29 Template Activity
30
31 -- VR & E REPORTS
32 VR&E Status
}

CONST
  // CodeCR347 - JRL 7/13/12
  // Added the following Constants to make changes to the report list
  // easier to edit.  Did not replace all instances of report names at
  // this time, just indexes.
  CnP_EXAMS_IDX = 0;
  CnP_EXAMS = '-- C&P EXAMS ----';
  AMIS_290_IDX = 1;
  AMIS_290 = 'AMIS 290';
  AMIS_290_BY_DIVISION_IDX = 2;
  AMIS_290_BY_DIVISION = 'AMIS 290 by Division';
  INSUFFICIENT_EXAM_REPORT_IDX = 3;
  INSUFFICIENT_EXAM_REPORT = 'Insufficient Exam Report';
  PENDING_CnP_EXAMS_IDX = 4;
  PENDING_CnP_EXAMS = 'Pending C&P Exams';
  CnP_EXAMS_CHECKLIST_IDX = 5;
  CnP_EXAMS_CHECKLIST = 'C&P Exams Checklist';
  REPRINT_CnP_FINAL_REPORT_IDX = 6;
  REPRINT_CnP_FINAL_REPORT = 'Re-Print C&P Final Report(s)';
  EXAM_REQUESTS_BY_DATE_RANGE_IDX = 7;
  EXAM_REQUESTS_BY_DATE_RANGE = 'Exam Requests by Date Range';
  REQUEST_STATUS_BY_DATE_RANGE_IDX = 8;
  REQUEST_STATUS_BY_DATE_RANGE = 'Request Status by Date Range';
  BLANK_LINE1_IDX = 9;
  BLANK_LINE1 = '';
  HOSPITAL_ADJUSTMENT_IDX = 10;
  HOSPITAL_ADJUSTMENT = '-- HOSPITAL ADJUSTMENT ----';
  ADMISSION_REPORT_FOR_SC_VETERANS_IDX = 11;
  ADMISSION_REPORT_FOR_SC_VETERANS = 'Admission Report for SC Veterans';
  ADMISSION_INQUIRY_BY_DATE_IDX = 12;
  ADMISSION_INQUIRY_BY_DATE = 'Admission Inquiry by Date';
  SPECIAL_REPORT_FOR_AnA_PENSION_IDX = 13;
  SPECIAL_REPORT_FOR_AnA_PENSION = 'Special Report for A&A/Pension';
  READMISSION_REPORT_IDX = 14;
  READMISSION_REPORT = 'Re-Admission Report';
  DISCHARGE_REPORT_IDX = 15;
  DISCHARGE_REPORT = 'Discharge Report';
  INCOMPETENT_VETERANS_REPORT_IDX = 16;
  INCOMPETENT_VETERANS_REPORT = 'Incompetent Veterans Report';
  CHN_DISPLAY_EPISODE_OF_CARE_IDX = 17;
  CHN_DISPLAY_EPISODE_OF_CARE = 'CNH Display Episode of Care';
  CHN_ROSTER_PRINT_IDX = 18;
  CHN_ROSTER_PRINT = 'CNH Roster Print';
  CNH_REPORT_OF_ADMISSIONS_DISCHARGES_IDX = 19;
  CNH_REPORT_OF_ADMISSIONS_DISCHARGES = 'CNH Report of Admissions/Discharges';
  CNH_STAYS_IN_EXCESS_OF_90_DAYS_IDX = 20;
  CNH_STAYS_IN_EXCESS_OF_90_DAYS = 'CNH Stays in Excess of 90 Days';
  BLANK_LINE2_IDX = 21;
  BLANK_LINE2 = '';
  REQUEST_FOR_INFO_IDX = 22;
  REQUEST_FOR_INFO = '-- REQUEST FOR INFO ----';
  PENDING_FORM_7131_REQUESTS_IDX = 23;
  PENDING_FORM_7131_REQUESTS = 'Pending Form 7131 Requests';
  TWENTYONE_DAY_CERTIFICATE_PRINTING_IDX = 24;
  TWENTYONE_DAY_CERTIFICATE_PRINTING = '21 Day Certificate Printing';
  REPRINT_A_21_DAY_CERTIFICATE_IDX = 25;
  REPRINT_A_21_DAY_CERTIFICATE = 'Reprint a 21 Day Certificate';
  REPRINT_A_NOTICE_OF_DISCHARGE_IDX = 26;
  REPRINT_A_NOTICE_OF_DISCHARGE = 'Reprint a Notice of Discharge';
  BLANK_LINE3_IDX = 27;
  BLANK_LINE3 = '';
  VHA_REPORTS_IDX = 28;
  VHA_REPORTS = '-- VHA REPORTS ----';
  TEMPLATE_ACTIVITY_IDX = 29;
  TEMPLATE_ACTIVITY = 'Template Activity';
  BLANK_LINE4_IDX = 30;
  BLANK_LINE4 = '';
  VRnE_REPORTS_IDX = 31;
  VRnE_REPORTS = '-- VR & E REPORTS ----';
  VRnE_STATUS_IDX = 32;
  VRnE_STATUS = 'VR&E Status';


Type
  Tfrmreports = Class(TForm)

    Button1: TButton;
    Button13: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    CheckBoxMailman: TCheckBox;
    DateTimePicker1: TDateTimePicker;
    DateTimePicker2: TDateTimePicker;
    DateTimePicker3: TDateTimePicker;
    DateTimePicker4: TDateTimePicker;
    Edit1: TEdit;
    Edit2: TEdit;
    EditInstructions: TEdit;
    FMListerInsufficientReason: TFMLister;
    FMRegionalOfficeNumberFake: TFMEdit;
    FMRegionalOfficeNumeralFake: TFMEdit;
    FMRoutingLocation: TORComboBox;
    FMRoutingLocation2: TORComboBox;
    FMRoutingLocationFake: TFMEdit;
    FMRoutingLocationFake2: TFMEdit;
    GroupBox1: TGroupBox;
    GroupBox1_1ROMAS: TRadioGroup;
    GroupBox1_1RunBy: TGroupBox;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    GroupBox4: TGroupBox;
    GroupBox5: TGroupBox;
    GroupBox6: TGroupBox;
    GroupBox7: TGroupBox;
    GroupBox8: TGroupBox;
    GroupBoxDivision: TGroupBox;
    GroupBoxInfo: TGroupBox;
    Label1: TLabel;
    Label1_1: TLabel;
    Label1_3: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label16: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    LabelDatePanel: TLabel;
    LabelReportChoice2: TLabel;
    ListBoxSort: TListBox;
    Memo1: TMemo;
    MemoInfo: TMemo;
    ORListBoxData1: TORListBox;
    ORReportsAvailable: TORListBox;
    ORReportsAvailable2: TORListBox;
    Panel1: TPanel;
    Panel2: TPanel;
    PanelBuildingReport: TPanel;
    PanelInstructions: TPanel;
    PanelInsufficientExamReport: TPanel;
    PanelProgress: TPanel;
    PanelReportChoice1: TPanel;
    panelReportChoice2: TPanel;
    panelReportChoice3: TPanel;
    PanelReportDateRange: TPanel;
    ProgressBar1: TProgressBar;
    QRCompositeReport1: TQRCompositeReport;
    RadioButton1_1: TRadioButton;
    RadioButton1_2: TRadioButton;
    RadioGroup1: TRadioGroup;
    RadioGroup2: TRadioGroup;
    RadioGroup3: TRadioGroup;
    RadioGroupDoYouWant: TRadioGroup;
    RadioGroupHospDom: TRadioGroup;
    RadioGroupInsuffDetailedSummary: TRadioGroup;
    RadioGroupSortByDivision: TRadioGroup;
    RadioGroupSortCriteria: TRadioGroup;
    RadioGroupStatus: TRadioGroup;
    ReportMemo: TRichEdit;
    Splitter3: TSplitter;
    aniBusy: TAnimate;
    ActionManReports: TActionManager;
    actFilePrint: TAction;
    actFilePrintOne: TAction;
    actFilePrintPreview: TAction;
    actFilePageSetup: TAction;
    actEditCopy: TAction;
    actEditSelectAll: TAction;
    actMenuBarReports: TActionMainMenuBar;
    actPopUpReports: TPopupActionBar;
    mnuPopUpCopy: TMenuItem;
    mnuPopUpSelectAll: TMenuItem;
    gbSelectReportDate1: TGroupBox;                                             //CodeCR85 - replace ORDateCombo w/DateTimePicker
    dtpReportDate1: TDateTimePicker;                                            //CodeCR85
    dtpInsuffStart: TDateTimePicker;                                            //CodeCR85
    dtpInsuffEnd: TDateTimePicker;                                              //CodeCR85
    SaveDialog: TSaveDialog;
    rgReportFormat: TRadioGroup;                                                //CodeCR129
    rgPriorityOfExamFilter: TRadioGroup;                                        //CodeCR123 - rpm 11/2/10
    RaveSystem: TRvSystem;                                                      //CodeCR199 - rpm 10/19/2011
    pnlRequestStatusFilter: TPanel;                                             //CodeCR266 - rpm 4/4/12
    cbxRequestStatus: TComboBox;                                                //CodeCR266 - rpm 4/4/12
    rgIgnoreDate: TRadioGroup;                                                  //CodeCR266 - rpm 4/4/12
    lblSelectStatus: TLabel;
    FMRegionalOfficeNumber: TFMComboBox;
    rgInsufficientRptFmt: TRadioGroup;
    rgPendingCnPRptFmt: TRadioGroup;
    rgExportFormat: TRadioGroup;
    GroupBoxInsufficientReason: TGroupBox;
    FMComboBoxInsuffReason: TFMComboBox;
    rgInsuffPriorityOfExamFilter: TRadioGroup;                                  //CodeCR266 - rpm 4/4/12
    VA508AccessibilityManager1: TVA508AccessibilityManager;
    Procedure Button13Click(Sender: TObject);
    Procedure Button1Click(Sender: TObject);
    Procedure Button2Click(Sender: TObject);
    Procedure Button3Click(Sender: TObject);
    Procedure Button4Click(Sender: TObject);
    Procedure Button5Click(Sender: TObject);
    Procedure Button6Click(Sender: TObject);
    Procedure Button7Click(Sender: TObject);
    Procedure Button8Click(Sender: TObject);
    Procedure Button9Click(Sender: TObject);
    Procedure Edit1Exit(Sender: TObject);
    Procedure Edit2Exit(Sender: TObject);
    Procedure FMComboBoxInsuffReasonExit(Sender: TObject);
    Procedure FMRegionalOfficeNumberEnter(Sender: TObject);
    Procedure FMRoutingLocation2Exit(Sender: TObject);
    Procedure FMRoutingLocationExit(Sender: TObject);
    Procedure FormActivate(Sender: TObject);
    Procedure FormCloseQuery(Sender: TObject; Var CanClose: Boolean);
    Procedure FormCreate(Sender: TObject);
    Procedure FormResize(Sender: TObject);
    Procedure FormShow(Sender: TObject);
    Procedure ORReportsAvailable2Click(Sender: TObject);
    Procedure ORReportsAvailableClick(Sender: TObject);
    Procedure PanelReportChoice1Click(Sender: TObject);
    Procedure QRCompositeReport1AddReports(Sender: TObject);
    Procedure RadioButton1_1Click(Sender: TObject);
    Procedure RadioGroup1Click(Sender: TObject);
    Procedure RadioGroupInsuffDetailedSummaryClick(Sender: TObject);
    Procedure RadioGroupSortByDivisionClick(Sender: TObject);
    Procedure ReportMemoChange(Sender: TObject);
    procedure actFilePrintUpdate(Sender: TObject);
    procedure actFilePrintOneUpdate(Sender: TObject);
    procedure actFilePrintPreviewUpdate(Sender: TObject);
    procedure actFilePageSetupUpdate(Sender: TObject);
    procedure actFilePrintExecute(Sender: TObject);
    procedure actFilePrintOneExecute(Sender: TObject);
    procedure actFilePrintPreviewExecute(Sender: TObject);
    procedure actFilePageSetupExecute(Sender: TObject);
    procedure actEditCopyExecute(Sender: TObject);
    procedure actEditSelectAllExecute(Sender: TObject);
    procedure actEditCopyUpdate(Sender: TObject);
    procedure PatientSelectClick(Sender: TObject);                              //CodeCR124 - rpm 7/15/10
    procedure PatientSelectDblClick(Sender: TObject);                           //CodeCR124 - rpm 7/15/10
    procedure OneItemPerPagePrint(Sender: TObject);                             //CodeCR199 - rpm 10/19/2011
    procedure OneItemPerPagePrintFooter(Sender: TObject);                       //CodeCR199 - rpm 10/19/2011
    procedure OneItemPerPagePrintHeader(Sender: TObject);                       //CodeCR199 - rpm 10/19/2011
    procedure NormalPrint(Sender: TObject);                                     //CodeCR212 - rpm 10/19/2011
    procedure NormalPrintFooter(Sender: TObject);                               //CodeCR212 - rpm 10/19/2011
    procedure NormalPrintHeader(Sender: TObject);                               //CodeCR212 - rpm 10/19/2011
    procedure NormalBeforePrint(Sender: TObject);                               //CodeCR212 - rpm 10/19/2011
    procedure cbxRequestStatusChange(Sender: TObject);                          //CodeCR266 - rpm 4/4/12
    procedure rgIgnoreDateClick(Sender: TObject);
    procedure panelReportChoice2Click(Sender: TObject);
    procedure rgExportFormatClick(Sender: TObject);                             //CodeCR266 - rpm 4/4/12
    procedure rgInsufficientRptFmtClick(Sender: TObject);
    procedure rgInsufficientRptFmtEnter(Sender: TObject);
    procedure RadioGroupInsuffDetailedSummaryEnter(Sender: TObject);
  Private
    FDtTm: String;                                                              //CodeCR199 - rpm 10/19/2011
    FDivision: String;                                                          //CodeCR199 - rpm 10/19/2011
    FFootdescrip: String;                                                       //CodeCR199 - rpm 10/19/2011
    FFooterLineHeight: Double;                                                  //CodeCR212 - rpm 11/2/2011
    FROStationNumber: String;                                                   //CodeCR171 - rpm 4/28/11
    FSpecRepDateRangeHdr: String;                                               //CodeCR127 - rpm 8/10/2010
    FeeBasisPatientIEN: String;                                                 //CodeCR124 - rpm 7/13/10
    FPatch179Installed: Boolean;                                                //CodeCR266 - rpm 1/24/12
    procedure WMMenuChar(var Message: TWMMenuChar); message WM_MENUCHAR;
    function GetPatient(var aPatientDFN: String): Boolean;                      //CodeCR124 - rpm 7/15/10
    procedure GetEpisodeOfCare(aPatientDFN: String);                            //CodeCR124 - rpm 7/15/10
    procedure GetAdmissionInquiryByDate(IsDelimited: Boolean);                  //CodeCR129 - rpm 10/13/10
    procedure GetHospAdjReportByDay(RPCName: String; AbbrevReportName: String; IsDelimited: Boolean); //CodeCR129 - rpm 10/19/10
    procedure GetFeeBasisReport(ReportName: String; IsDelimited: Boolean);      //CodeCR124 - rpm 10/19/10
    procedure GetAMIS290Report(IsByDivision: Boolean);                          //CodeCR123 - rpm 11/2/10
    function GetDelimitedParam(IsDelimited: Boolean): String;                   //CodeCR129 - rpm 10/12/10
    function ReplaceTabs(LineWithTabs: String; tabSize: Integer): String;       //CodeCR212 - rpm 11/2/11
    procedure PrintLine(ReportComponent: TBaseReport; ReportLine: String);      //CodeCR212 - rpm 11/2/11
    function IsNextPageNewPatient(currentIndex: Integer): Boolean;              //CodeCR212 - rpm 11/3/11
    procedure PrintIntentionalBlank(ReportComponent: TBaseReport);              //CodeCR212 - rpm 11/3/11
    procedure GetRequestStatusReport(IsDelimited: Boolean; IsIgnoreDate: Boolean); //CodeCR266 - rpm 1/24/12
    procedure GetHospAdjReport(RPCName: String; AbbrevReportName: String; IsDelimited: Boolean); //CodeCR269 - rpm 2/2/12
  Public
    { Public declarations }
    Property SpecialReportDtRangeHdr: String Read FSPecRepDateRangeHdr
      Write FSpecRepDateRangeHdr;                                               //CodeCR127 - rpm 8/10/2010
    Procedure DisplayBusyAnimation(Display: Boolean);
    function SaveDelimitedReport(DelimitedLines: TStringList; ReportName: String): String; //CodeCR129 - rpm 10/12/10
    function SaveDelimitedReportCSV(DelimitedLines: TStringList; ReportName: String): String; //CodeCR470 JRL 4/3/13
    property IsPatch179Installed: Boolean Read FPatch179Installed
      Write FPatch179Installed;                                                 //CodeCR266 - rpm 1/24/12
  End;


Var
  frmreports: Tfrmreports;
  formPrintVirtual: Array Of tformPrint;
  formPrintVirtualCounter: integer;

Implementation

Uses
  CAPRISupport,
  fEpisodeOfCare,                                                               //CodeCR124 - rpm 7/13/10
  main,
  patientlist,                                                                  //CodeCR124 - rpm 7/13/10
  rofinder,
  specialreport,
  VA508AccessibilityRouter,                                                     // rpk 7/14/2015
  VocRehabReportSetup,                                                          //CodeCR347 - jrl 5/21/12
  VocRehabClass,                                                                //CodeCR347 - jrl 6/14/12
  wait;

{$R *.DFM}
var
  frmPatientSelector: TfrmPatientList;                                          //CodeCR124 - rpm 7/13/10

Procedure Tfrmreports.ORReportsAvailableClick(Sender: TObject);
Var
  x: integer;
  aDFN: String;
Begin
  ReportMemo.Lines.Clear;

  If (ORReportsAvailable.ItemIndex = CnP_EXAMS_IDX) Or (ORReportsAvailable.ItemIndex = BLANK_LINE1_IDX) Or //CodeCR266 - rpm 1/24/12 // CodeCR347 - jrl 7/13/12
    (ORReportsAvailable.ItemIndex = HOSPITAL_ADJUSTMENT_IDX) Or (ORReportsAvailable.ItemIndex = BLANK_LINE2_IDX) Or //CodeCR266 - rpm 1/24/12 // CodeCR347 - jrl 7/13/12
    (ORReportsAvailable.ItemIndex = REQUEST_FOR_INFO_IDX) Then                  //CodeCR124 - rpm 7/13/10  //CodeCR266 - rpm 1/24/12 // CodeCR347 - jrl 7/13/12
  Begin
    ORReportsAvailable.ItemIndex := -1;
    exit;
  End;
  GroupBox5.Caption := 'Start Date (Oldest):';                                  //CodeCR124 - rpm 7/20/10
  ORReportsAvailable2.ItemIndex := -1;
  GroupBoxInfo.Visible := False;
  RadioButton1_1.Caption := 'For patient ' + PatientName;
  GroupBox3.Visible := False;
  PanelInsufficientExamReport.Visible := False;
  PanelReportChoice1.Visible := False;
  PanelReportChoice2.Visible := False;
  PanelReportChoice3.Visible := False;
  PanelReportDateRange.Visible := False;
  rgReportFormat.Visible := False;                                              //CodeCR129 - rpm 10/12/10
  rgReportFormat.ItemIndex := 0;                                                //CodeCR129 - rpm 10/12/10
  rgPriorityOfExamFilter.Visible := False;                                      //CodeCR123 - rpm 11/2/10
  rgPriorityOfExamFilter.ItemIndex := 3;                                        //CodeCR123 - rpm 11/2/10
  if not IsPatchInstalled('DVBA*2.7*192') then                                  //CodeCR709 JRL 6/16/15 P192 Removes Priority of Exam filter
  begin                                                                         //CodeCR709 JRL 6/16/15 P192 Removes Priority of Exam filter
    rgInsuffPriorityOfExamFilter.Visible := False;                              //CodeCR123 - rpm 11/2/10
    rgInsuffPriorityOfExamFilter.ItemIndex := 3;                                //CodeCR123 - rpm 11/2/10
  end;                                                                          //CodeCR709 JRL 6/16/15 P192 Removes Priority of Exam filter
  pnlRequestStatusFilter.Visible := False;                                      //CodeCR266 - rpm 1/24/12
  rgIgnoreDate.Enabled := False;                                                //CodeCR266 - rpm 4/4/12
  //Turn off print one item per page option
  actFilePrintOne.Enabled := False;
  If ORReportsAvailable.ItemIndex = ADMISSION_REPORT_FOR_SC_VETERANS_IDX Then   //CodeCR266 - rpm 1/24/12 // CodeCR347 - jrl 7/13/12
    actFilePrintOne.Enabled := True;
  If ORReportsAvailable.ItemIndex = PENDING_CnP_EXAMS_IDX Then                  // CodeCR347 - jrl 7/13/12
    actFilePrintOne.Enabled := True;
  If ORReportsAvailable.ItemIndex = INCOMPETENT_VETERANS_REPORT_IDX Then        //CodeCR266 - rpm 1/24/12 // CodeCR347 - jrl 7/13/12
    actFilePrintOne.Enabled := True;
  If ORReportsAvailable.ItemIndex = DISCHARGE_REPORT_IDX Then                   //CodeCR266 - rpm 1/24/12  // CodeCR347 - jrl 7/13/12
    actFilePrintOne.Enabled := True;
  If ORReportsAvailable.ItemIndex = SPECIAL_REPORT_FOR_AnA_PENSION_IDX Then     //CodeCR266 - rpm 1/24/12  // CodeCR347 - jrl 7/13/12
    actFilePrintOne.Enabled := True;
  If ORReportsAvailable.ItemIndex = READMISSION_REPORT_IDX Then                 //CodeCR266 - rpm 1/24/12  // CodeCR347 - jrl 7/13/12
    actFilePrintOne.Enabled := True;
  If ORReportsAvailable.ItemIndex = PENDING_FORM_7131_REQUESTS_IDX Then         //CodeCR124 - rpm 7/13/10  //CodeCR266 - rpm 1/24/12 // CodeCR347 - jrl 7/13/12
    actFilePrintOne.Enabled := True;
  If ORReportsAvailable.ItemIndex = TWENTYONE_DAY_CERTIFICATE_PRINTING_IDX Then //CodeCR124 - rpm 7/13/10  //CodeCR266 - rpm 1/24/12  // CodeCR347 - jrl 7/13/12
    actFilePrintOne.Enabled := False;
  //6=Reprint final C&P report
  actFilePrintPreview.Enabled := True;
  If ORReportsAvailable.ItemIndex = REPRINT_CnP_FINAL_REPORT_IDX Then           // CodeCR347 - jrl 7/13/12
    actFilePrintPreview.Enabled := False;

  ReportMemo.Lines.Clear;
  panelReportChoice2.Visible := False;
  panelReportChoice3.Visible := False;
  PanelReportDateRange.Visible := False;
  panelReportChoice1.Visible := False;
  PanelInsufficientExamReport.Visible := False;
  fmRegionalOfficeNumber.Visible := False;
  label16.Visible := False;
  checkboxMailman.Visible := False;
  If ORReportsAvailable.ItemIndex = AMIS_290_IDX Then                           // CodeCR347 - jrl 7/13/12
  Begin
    if frmMain.AMIS290URL = '' then                                             // CodeCR440 JRL 11/16/12
    begin                                                                       // if the URL is '', then run the original AMIS290 report
      fmRegionalOfficeNumber.Text := '';                                        //CodeCR123 - rpm 11/3/10
      fmRegionalOfficeNumberFake.Text := '';                                    //CodeCR123 - rpm 11/3/10
      fmRegionalOfficeNumber.Visible := true;
      GroupBoxDivision.Visible := False;
      DateTimePicker1.Visible := True;
      DateTimePicker2.Visible := True;
      Groupbox5.Visible := True;
      Groupbox6.Visible := True;
      RadioGroupSortByDivision.Visible := False;
      label16.Visible := true;
      checkboxMailman.Visible := true;
      LabelReportChoice2.Caption := 'AMIS 290';
      RadioGroupDoYouWant.Visible := False;
      RadioGroupHospDom.Visible := False;
      rgPriorityOfExamFilter.Visible := True;                                   //CodeCR296 - rpm 2/2/12 - replaced FPatch149Installed check
      PanelReportChoice2.Visible := True;
      GroupBox5.SetFocus;
      DateTimePicker1.SetFocus;
      PanelReportDateRange.Visible := False;
    end                                                                         // CodeCR440 JRL 11/16/12
    else                                                                        // if the URL is defined, display the URL in a message to indicate new location for this report.  // CodeCR440 JRL 11/16/12
    begin                                                                       // CodeCR440 JRL 11/16/12
      ShowMessageCAPRI('AMIS 290 Report is no longer available here.  Please go to:  ' + frmMain.AMIS290URL); // CodeCR440 JRL 11/16/12
    end;                                                                        // CodeCR440 JRL 11/16/12
  End;
  If ORReportsAvailable.ItemIndex = EXAM_REQUESTS_BY_DATE_RANGE_IDX Then        // CodeCR347 - jrl 7/13/12
  Begin
    fmRegionalOfficeNumber.Visible := false;
    GroupBoxDivision.Visible := False;
    DateTimePicker1.Visible := True;
    DateTimePicker2.Visible := True;
    GroupBox5.Visible := True;
    GroupBox6.Visible := True;
    RadioGroupSortByDivision.Visible := False;
    label16.Visible := false;
    checkboxMailman.Visible := false;
    LabelReportChoice2.Caption := 'Exam Requests by Date Range';
    RadioGroupDoYouWant.Visible := False;
    RadioGroupHospDom.Visible := False;
    PanelReportChoice2.Visible := True;
    rgReportFormat.Items.Clear;                                                 // CodeCR470 JRL 4/9/13
    rgReportFormat.Items.Add('Plain Text');                                     // CodeCR470 JRL 4/9/13
    rgReportFormat.Items.Add('CSV Comma Delimited Export');                     // CodeCR470 JRL 4/9/13
    rgReportFormat.ItemIndex := 0;                                              // CodeCR470 JRL 4/10/13
    rgReportFormat.Visible := True;                                             // CodeCR470 JRL 4/8/13
    GroupBox5.SetFocus;
    DateTimePicker1.Setfocus;
    PanelReportDateRange.Visible := False;
  End;
  If ORReportsAvailable.ItemIndex = ADMISSION_REPORT_FOR_SC_VETERANS_IDX Then   //CodeCR266 - rpm 1/24/12 // CodeCR347 - jrl 7/13/12
  Begin
    fmRegionalOfficeNumber.Visible := false;
    GroupBoxDivision.Visible := False;
    DateTimePicker1.Visible := True;
    DateTimePicker2.Visible := True;
    GroupBox5.Visible := True;
    GroupBox6.Visible := True;
    RadioGroupSortByDivision.Visible := False;
    label16.Visible := false;
    checkboxMailman.Visible := false;
    LabelReportChoice2.Caption := 'Admission Report for SC Veterans';
    rgReportFormat.Items.Clear;                                                 // CodeCR470 JRL 4/9/13
    rgReportFormat.Items.Add('Plain Text');                                     // CodeCR470 JRL 4/9/13
    rgReportFormat.Items.Add('CSV Comma Delimited Export');                     // CodeCR470 JRL 4/24/13
    rgReportFormat.ItemIndex := 0;                                              // CodeCR470 JRL 4/10/13
    rgReportFormat.Visible := True;                                             //CodeCR296 - rpm 2/2/12 - replaced FPatch149Installed check
    RadioGroupDoYouWant.Visible := False;
    RadioGroupHospDom.Visible := False;
    PanelReportChoice2.Visible := True;
    GroupBox5.SetFocus;
    DateTimePicker1.SetFocus;
    PanelReportDateRange.Visible := False;
  End;
  If ORReportsAvailable.ItemIndex = PENDING_CnP_EXAMS_IDX Then                  // Pending C&P EXAMS   // CodeCR347 - jrl 7/13/12
  Begin
    PanelReportChoice3.Visible := True;
    PanelReportChoice3.Top := (frmReports.Height - PanelReportChoice3.Height) Div 2;
    PanelReportChoice3.Left := (frmReports.Width - PanelReportChoice3.Width) Div 2;
    PanelReportChoice3.BringToFront;
    RadioGroup1.Visible := True;
    RadioGroup2.Visible := (RadioGroup1.ItemIndex = 1);
    GroupBox1.Visible := (RadioGroup1.ItemIndex = 0);
    GroupBox2.Visible := (RadioGroup1.ItemIndex = 3);
    label1_3.Caption := 'Pending C&&P Exams';
    RadioGroup1.SetFocus;
  End;
  If ORReportsAvailable.ItemIndex = CnP_EXAMS_CHECKLIST_IDX Then                // C&P EXAM CHECKLIST // CodeCR347 - jrl 7/13/12
  Begin
    // Report Checklist
    frmMain.RPCBroker1.Results.Clear;
    frmMain.RPCBroker1.RemoteProcedure := 'DVBAB REPORT EXAM CHKLIST';
    DisplayBusyAnimation(True);
    frmMain.RPCBrokerCall;
    Try
      frmMain.RPCBroker1.Call;
    Except
      On EBrokerError Do
        ShowMessageCAPRI('RPC DVBAB REPORT EXAM CHKLIST could not be accessed!');
    End;
    //CAPRI_CodeCR101 - jcs - 05/02/2010
    CapriQuickCopy(frmMain.RPCBroker1.Results, ReportMemo);
    If ReportMemo.Lines.count = 0 Then
      ReportMemo.Lines.Add('No data found for requested report criteria.');
    ReportMemo.SelStart := 0;
    ReportMemo.SelLength := 0;
    ReportMemo.Setfocus;
  End;
  If ORReportsAvailable.ItemIndex = INCOMPETENT_VETERANS_REPORT_IDX Then        //CodeCR266 - rpm 1/24/12  // Incompetent Veteran Report // CodeCR347 - jrl 7/13/12
  Begin
    //Incompetent Veterans Report
    fmRegionalOfficeNumber.Visible := false;
    GroupBoxDivision.Visible := False;
    DateTimePicker1.Visible := True;
    DateTimePicker2.Visible := True;
    GroupBox5.Visible := True;
    GroupBox6.Visible := True;
    RadioGroupSortByDivision.Visible := False;
    label16.Visible := false;
    checkboxMailman.Visible := false;
    LabelReportChoice2.Caption := 'Incompetent Veterans Report';
    rgReportFormat.Items.Clear;                                                 // CodeCR470 JRL 4/9/13
    rgReportFormat.Items.Add('Plain Text');                                     // CodeCR470 JRL 4/9/13
    rgReportFormat.Items.Add('CSV Comma Delimited Export');                     // CodeCR470 JRL 4/24/13
    rgReportFormat.ItemIndex := 0;                                              // CodeCR470 JRL 4/10/13
    rgReportFormat.Visible := True;                                             //CodeCR296 - rpm 2/2/12 - replaced FPatch149Installed check
    RadioGroupDoYouWant.Visible := False;
    RadioGroupHospDom.Visible := False;
    PanelReportChoice2.Visible := True;
    GroupBox5.SetFocus;
    DateTimePicker1.SetFocus;
    PanelReportDateRange.Visible := False;
    PanelReportChoice2.BringToFront;
  End;
  If ORReportsAvailable.ItemIndex = DISCHARGE_REPORT_IDX Then                   //CodeCR266 - rpm 1/24/12   // Discharge Report  // CodeCR347 - jrl 7/13/12
  Begin
    //Discharge Report
    fmRegionalOfficeNumber.Visible := false;
    GroupBoxDivision.Visible := False;
    DateTimePicker1.Visible := True;
    DateTimePicker2.Visible := True;
    GroupBox5.Visible := True;
    GroupBox6.Visible := True;
    RadioGroupSortByDivision.Visible := False;
    label16.Visible := false;
    checkboxMailman.Visible := false;
    LabelReportChoice2.Caption := 'Discharge Report';
    rgReportFormat.Items.Clear;                                                 // CodeCR470 JRL 4/9/13
    rgReportFormat.Items.Add('Plain Text');                                     // CodeCR470 JRL 4/9/13
    rgReportFormat.Items.Add('CSV Comma Delimited Export');                     // CodeCR470 JRL 4/24/13
    rgReportFormat.ItemIndex := 0;                                              // CodeCR470 JRL 4/10/13
    rgReportFormat.Visible := True;                                             //CodeCR296 - rpm 2/2/12 - replaced FPatch149Installed check
    RadioGroupDoYouWant.Visible := True;
    RadioGroupHospDom.Visible := False;
    PanelReportChoice2.Visible := True;
    PanelReportDateRange.Visible := False;
    PanelReportChoice2.BringToFront;
    GroupBox5.SetFocus;
    DateTimePicker1.SetFocus;
  End;
  If ORReportsAvailable.ItemIndex = READMISSION_REPORT_IDX Then                 //CodeCR266 - rpm 1/24/12  // Re-admission Report // CodeCR347 - JRL 7/13/12
  Begin
    //Discharge Report
    fmRegionalOfficeNumber.Visible := false;
    GroupBoxDivision.Visible := False;
    DateTimePicker1.Visible := True;
    DateTimePicker2.Visible := True;
    GroupBox5.Visible := True;
    GroupBox6.Visible := True;
    RadioGroupSortByDivision.Visible := False;
    label16.Visible := false;
    checkboxMailman.Visible := false;
    LabelReportChoice2.Caption := 'Re-Admission Report';
    rgReportFormat.Items.Clear;                                                 // CodeCR470 JRL 4/9/13
    rgReportFormat.Items.Add('Plain Text');                                     // CodeCR470 JRL 4/9/13
    rgReportFormat.Items.Add('CSV Comma Delimited Export');                     // CodeCR470 JRL 4/24/13
    rgReportFormat.ItemIndex := 0;                                              // CodeCR470 JRL 4/10/13
    rgReportFormat.Visible := True;                                             //CodeCR296 - rpm 2/2/12 - replaced FPatch149Installed check
    RadioGroupDoYouWant.Visible := False;
    RadioGroupHospDom.Visible := True;
    PanelReportChoice2.Visible := True;
    GroupBox5.SetFocus;
    DateTimePicker1.SetFocus;
    PanelReportDateRange.Visible := False;
  End;
  If ORReportsAvailable.ItemIndex = PENDING_FORM_7131_REQUESTS_IDX Then         //CodeCR124 - rpm 7/13/10  //CodeCR266 - rpm 1/24/12  // CodeCR347 - jrl 7/13/12
  Begin
    //Pending Form 7131 Requests
    fmRegionalOfficeNumber.Visible := false;
    GroupBoxDivision.Visible := True;
    DateTimePicker1.Visible := False;
    DateTimePicker2.Visible := False;
    GroupBox5.Visible := False;
    GroupBox6.Visible := False;
    RadioGroupSortByDivision.Visible := True;
    RadioGroupSortByDivision.ItemIndex := -1;
    RadioGroupSortByDivision.ItemIndex := 1;
    label16.Visible := false;
    checkboxMailman.Visible := false;
    LabelReportChoice2.Caption := 'Pending Form 7131 Requests';
    RadioGroupDoYouWant.Visible := False;
    RadioGroupHospDom.Visible := False;
    PanelReportChoice2.Visible := True;
    rgReportFormat.Items.Clear;                                                 // CodeCR470 JRL 4/9/13
    rgReportFormat.Items.Add('Plain Text');                                     // CodeCR470 JRL 4/9/13
    rgReportFormat.Items.Add('CSV Comma Delimited Export');                     // CodeCR470 JRL 4/9/13
    rgReportFormat.ItemIndex := 0;                                              // CodeCR470 JRL 4/10/13
    rgReportFormat.Visible := True;                                             // CodeCR470 JRL 4/8/13
    RadioGroupSortByDivision.SetFocus;
    PanelReportDateRange.Visible := False;
  End;
  If ORReportsAvailable.ItemIndex = TWENTYONE_DAY_CERTIFICATE_PRINTING_IDX Then //CodeCR124 - rpm 7/13/10  //CodeCR266 - rpm 1/24/12 // CodeCR347 - jrl 7/13/12
  Begin
    frmMain.RPCBroker1.Results.Clear;
    frmMain.RPCBroker1.RemoteProcedure := 'DVBAB REPORTS';
    frmMain.RPCBroker1.Param[1].Value := '1';                                   // 21 Day Cert Print
    frmMain.RPCBroker1.Param[1].PType := literal;
    frmMain.RPCBroker1.Param[2].Value := '';
    frmMain.RPCBroker1.Param[2].PType := literal;
    DisplayBusyAnimation(True);

    frmMain.RPCBrokerCall;
    Try
      frmMain.RPCBroker1.Call;
    Except
      On EBrokerError Do
        ShowMessageCAPRI('RPC DVBAB REPORTS could not be accessed!');
    End;
    //CAPRI_CodeCR101 - jcs - 05/02/2010
    CapriQuickCopy(frmMain.RPCBroker1.Results, ReportMemo);
    If ReportMemo.Lines.count = 0 Then
      ReportMemo.Lines.Add('No data found for requested report criteria.');
    ReportMemo.SelStart := 0;
    ReportMemo.SelLength := 0;
    ReportMemo.setfocus;
  End;
  If ORReportsAvailable.ItemIndex = REPRINT_A_NOTICE_OF_DISCHARGE_IDX Then      //CodeCR124 - rpm 7/13/10  //CodeCR266 - rpm 1/24/12 // CodeCR347 - jrl 7/13/12
  Begin
    GroupBox1_1RunBy.Visible := True;
    RadioButton1_1.Visible := TRUE;
    PanelReportChoice1.Visible := True;
    PanelReportChoice1.BringToFront;
    RadioButton1_1.Caption := 'For patient ' + patientname;
    PanelReportChoice1.Top := (frmReports.Height - PanelReportChoice1.Height) Div 2;
    PanelReportChoice1.Left := (frmReports.Width - PanelReportChoice1.Width) Div 2;
    label1_1.Caption := 'Reprint a Notice of Discharge';
    If PatientIEN = '' Then
      RadioButton1_1.Visible := False;
    GroupBox1_1RunBy.SetFocus;
    RadioButton1_2.Setfocus;
    If RadioButton1_1.visible = true Then
      RadioButton1_1.Setfocus;
  End;
  If ORReportsAvailable.ItemIndex = REPRINT_A_21_DAY_CERTIFICATE_IDX Then       //CodeCR124 - rpm 7/13/10  //CodeCR266 - rpm 1/24/12  //CodeCR347 - jrl 7/13/12
  Begin
    GroupBox1_1RunBy.Visible := True;
    RadioButton1_1.Visible := True;
    RadioButton1_2.Checked := True;
    PanelReportChoice1.Visible := True;
    PanelReportChoice1.BringToFront;
    PanelReportChoice1.Top := (frmReports.Height - PanelReportChoice1.Height) Div 2;
    PanelReportChoice1.Left := (frmReports.Width - PanelReportChoice1.Width) Div 2;
    label1_1.Caption := 'Reprint a 21 Day Certificate';
    If PatientIEN = '' Then
      RadioButton1_1.Visible := False;
    GroupBox1_1RunBy.SetFocus;
    RadioButton1_2.Setfocus;
    If RadioButton1_1.visible = true Then
      RadioButton1_1.Setfocus;
  End;
  If ORReportsAvailable.ItemIndex = REPRINT_CnP_FINAL_REPORT_IDX Then           // Reprint Final C&P Report // CodeCR347 - jrl 7/13/12
  Begin
    GroupBox1_1RunBy.Visible := True;
    RadioButton1_1.Visible := False;
    PanelReportChoice1.Visible := True;
    PanelReportChoice1.BringToFront;
    RadioButton1_1.Caption := 'For patient ' + patientname;
    RadioButton1_2.Checked := True;
    PanelReportChoice1.Top := (frmReports.Height - PanelReportChoice1.Height) Div 2;
    PanelReportChoice1.Left := (frmReports.Width - PanelReportChoice1.Width) Div 2;
    label1_1.Caption := 'Re-print C&&P Final Report(s)';
    If PatientIEN = '' Then
      RadioButton1_1.Visible := False;
    GroupBox1_1RunBy.SetFocus;
    RadioButton1_2.Setfocus;
    If RadioButton1_1.visible = true Then
      RadioButton1_1.Setfocus;
  End;
  If ORReportsAvailable.ItemIndex = ADMISSION_INQUIRY_BY_DATE_IDX Then          //CodeCR266 - rpm 1/24/12  // Admission Inquiry By Date // CodeCR347 - jrl 7/13/12
  Begin
    GroupBoxInfo.Visible := True;
    MemoInfo.Lines.Clear;
    frmMain.RPCBroker1.RemoteProcedure := 'DVBAB REPORT ADMISSION INQUIRY';
    frmMain.RPCBrokerCall;
    Try
      frmMain.RPCBroker1.Call;
    Except
      On EBrokerError Do
        ShowMessageCAPRI('RPC DVBAB REPORT ADMISSION INQUIRY could not be accessed!');
    End;
    If frmMain.RPCBroker1.Results.Count > 0 Then
      For x := 0 To frmMain.RPCBroker1.Results.Count - 1 Do
        MemoInfo.Lines.Add(frmMain.RPCBroker1.Results[x]);
    MemoInfo.Lines.Insert(0, '');
    MemoInfo.Lines.Insert(0, 'NOTE:  Regional Office is optional.  If a Regional Office is selected, the report will be sorted by that RO.');
    fmRegionalOfficeNumber.Visible := true;
    GroupBoxDivision.Visible := true;
    DateTimePicker1.Visible := True;
    DateTimePicker2.Visible := True;
    GroupBox5.Visible := true;
    GroupBox6.Visible := true;
    RadioGroupSortByDivision.Visible := FALSE;
    label16.Visible := true;
    checkboxMailman.Visible := false;
    FMRegionalOfficeNumeralFake.Text := '';
    FMRegionalOfficeNumber.Text := '';
    FMRegionalOfficeNumberFake.Text := '';
    LabelReportChoice2.Caption := 'Admission Inquiry By Date';
    rgReportFormat.Items.Clear;                                                 // CodeCR470 JRL 4/9/13
    rgReportFormat.Items.Add('Plain Text');                                     // CodeCR470 JRL 4/9/13
    rgReportFormat.Items.Add('CSV Comma Delimited Export');                     // CodeCR470 JRL 4/24/13
    rgReportFormat.ItemIndex := 0;                                              // CodeCR470 JRL 4/10/13
    rgReportFormat.Visible := True;                                             //CodeCR296 - rpm 2/2/12 - replaced FPatch149Installed check
    RadioGroupDoYouWant.Visible := False;
    RadioGroupHospDom.Visible := False;
    PanelReportChoice2.Visible := True;
    PanelReportDateRange.Visible := False;
    GroupBox5.SetFocus;
    DateTimePicker1.SetFocus;
  End;
  If ORReportsAvailable.ItemIndex = INSUFFICIENT_EXAM_REPORT_IDX Then           // CodeCR347 - jrl 7/13/12
  Begin
    // Insufficient Exam Report
    PanelInsufficientExamReport.Visible := True;
    PanelInsufficientExamReport.BringToFront;
    if not IsPatchInstalled('DVBA*2.7*192') then                                //CodeCR709 JRL 6/16/15 P192 Removes Priority of Exam filter
    begin                                                                       //CodeCR709 JRL 6/16/15 P192 Removes Priority of Exam filter
      FMListerInsufficientReason.GetList(FMComboBoxInsuffReason.Items);
      FMComboBoxInsuffReason.Text := '';
      rgInsuffPriorityOfExamFilter.Visible := True;                             //CodeCR296 - rpm 2/2/12 - replaced FPatch149Installed check
      //CodeCR147 - rpm 11/1/10
      GroupBoxInsufficientReason.Visible := (RadioGroupInsuffDetailedSummary.ItemIndex = 0);
      RadioGroupInsuffDetailedSummary.Visible := TRUE;                          //CodeCR709 JRL 7/23/15 P192 Removes POE filter and summary rpt
    end;                                                                        //CodeCR709 JRL 6/16/15 P192 Removes Priority of Exam filter
    Groupbox7.SetFocus;
    dtpInsuffStart.Setfocus;
  End;
  If ORReportsAvailable.ItemIndex = AMIS_290_BY_DIVISION_IDX Then               // AMIS 290 by Division // CodeCR347 - JRL 7/13/12
  Begin
    if frmMain.AMIS290URL = '' then                                             // If the URL is '' then run the original AMIS 290 by Division report
    begin
      fmRegionalOfficeNumber.Text := '';                                        //CodeCR123 - rpm 11/3/10
      fmRegionalOfficeNumberFake.Text := '';                                    //CodeCR123 - rpm 11/3/10
      fmRegionalOfficeNumber.Visible := true;
      GroupBoxDivision.Visible := True;
      DateTimePicker1.Visible := True;
      DateTimePicker2.Visible := True;
      GroupBox5.Visible := True;
      GroupBox6.Visible := True;
      RadioGroupSortByDivision.Visible := False;
      label16.Visible := true;
      checkboxMailman.Visible := true;
      LabelReportChoice2.Caption := 'AMIS 290 by Division';
      RadioGroupDoYouWant.Visible := False;
      RadioGroupHospDom.Visible := False;
      rgPriorityOfExamFilter.Visible := True;                                   //CodeCR296 - rpm 2/2/12 - replaced FPatch149Installed check
      PanelReportChoice2.Visible := True;
      PanelReportDateRange.Visible := False;
      GroupBox5.SetFocus;
      DateTimePicker1.SetFocus;
    end
    else                                                                        // if the URL is defined, display the URL in a message to indicate new location for this report.
    begin
      ShowMessageCAPRI('AMIS 290 By Division Report is no longer available here.  Please go to:  ' + frmMain.AMIS290URL);
    end;
  End;
  If ORReportsAvailable.ItemIndex = SPECIAL_REPORT_FOR_AnA_PENSION_IDX Then     //CodeCR266 - rpm 1/24/12  // CodeCR347 - jrl 7/13/12 // Special Report for A&A/Pension // JRL
  Begin
    // A&A/Pension Report
    frmSpecialReport := TfrmSpecialreport.Create(frmReports);
    Try
      frmSpecialReport.ShowModal;
    Finally
      FreeAndNil(frmSpecialReport);
    End;
  End;
  If ORReportsAvailable.ItemIndex = TEMPLATE_ACTIVITY_IDX Then                  //CodeCR124 - rpm 7/13/10  //CodeCR266 - rpm 1/24/12  //CodeCR347 - jrl 7/13/12 //  Template Activity // JRL
  Begin
    // Template Activity
    labelDatePanel.Caption := 'Template Activity';
    DateTimePicker4.Date := Now;
    rgExportFormat.Visible := TRUE;                                             //CodeCR470 - JRL 4/18/13
    PanelReportDateRange.Visible := True;
    PanelReportDateRange.BringToFront;
    DateTimePicker3.SetFocus;
  End;
  If ORReportsAvailable.ItemIndex = VRnE_STATUS_IDX Then                        //CodeCR347 - JRL 5/18/12
  Begin                                                                         //CodeCR347 - JRL 5/18/12
    if not IsPatchInstalled('DVBA*2.7*181') then                                //CodeCR347 - JRL 5/18/12
    begin                                                                       //CodeCR347 - JRL 5/18/12
      ShowmessageCAPRI('Patch DVBA*2.7*181 must be installed');                 //CodeCR347 - JRL 5/18/12
      Exit;                                                                     //CodeCR347 - JRL 5/18/12
    end;                                                                        //CodeCR347 - JRL 5/18/12
    frmVREReportSetup := TfrmVREReportSetup.Create(frmReports);                 //CodeCR347 - JRL 5/18/12
    Try                                                                         //CodeCR347 - JRL 5/18/12
      x := frmVREReportSetup.ShowModal;                                         //CodeCR347 - JRL 7/16/12
    Finally                                                                     //CodeCR347 - JRL 5/18/12
      FreeAndNil(frmVREReportSetup);                                            //CodeCR347 - JRL 5/18/12
    End;                                                                        //CodeCR347 - JRL 5/18/12
    if x = mrOK then                                                            //CodeCR347 - JRL 7/16/12
      frmMain.VocRehab.RunForm8861StatusReport;                                 //CodeCR347 - JRL 5/18/12
  End;                                                                          //CodeCR347 - JRL 5/18/12

  DisplayBusyAnimation(False);
  {======================================================================
   Added four Fee Basis Nursing home options
   CodeCR124 - rpm 7/14/10
   ======================================================================}
  if ORReportsAvailable.ItemIndex = CHN_DISPLAY_EPISODE_OF_CARE_IDX then        //CNH Display Episode of Care  //CodeCR266 - rpm 1/24/12  // CodeCR347 - JRL 7/13/12
  begin
    //CodeCR296 - rpm 2/2/12 - removed FPatch149Installed check
    aDFN := '';
    if GetPatient(aDFN) then                                                    //display patient selector
    begin
      GetEpisodeOfCare(aDFN);                                                   //populate and display patient's episode of care
    end
    else
      Exit;
  end;

  if ORReportsAvailable.ItemIndex = CHN_ROSTER_PRINT_IDX then                   //CNH Roster Print  //CodeCR266 - rpm 1/24/12 // CodeCR347 - jrl 7/13/12
  begin
    //CodeCR296 - rpm 2/2/12 - removed FPatch149Installed check
    fmRegionalOfficeNumber.Visible := false;
    GroupBoxDivision.Visible := False;
    DateTimePicker1.Visible := False;
    DateTimePicker2.Visible := False;
    GroupBox5.Visible := False;
    GroupBox6.Visible := False;
    RadioGroupSortByDivision.Visible := False;
    label16.Visible := false;
    checkboxMailman.Visible := false;
    LabelReportChoice2.Caption := 'CNH Roster Print';
    rgReportFormat.Items.Clear;                                                 // CodeCR470 JRL 4/9/13
    rgReportFormat.Items.Add('Plain Text');                                     // CodeCR470 JRL 4/9/13
    rgReportFormat.Items.Add('CSV Comma Delimited Export');                     // CodeCR470 JRL 4/15/13
    rgReportFormat.ItemIndex := 0;                                              // CodeCR470 JRL 4/10/13
    rgReportFormat.Visible := True;                                             //CodeCR129 - rpm 10/12/10
    RadioGroupDoYouWant.Visible := False;
    RadioGroupHospDom.Visible := False;
    PanelReportChoice2.Visible := True;
    PanelReportDateRange.Visible := False;
    PanelReportChoice2.BringToFront;
    (rgReportFormat.Controls[rgReportFormat.ItemIndex] as TRadioButton).SetFocus;
  end;

  if ORReportsAvailable.ItemIndex = CNH_REPORT_OF_ADMISSIONS_DISCHARGES_IDX then //CNH Report of Admissions/Discharges  //CodeCR266 - rpm 1/24/12 // CodeCR347 - jrl 7/13/12
  begin
    //CodeCR296 - rpm 2/2/12 - removed FPatch149Installed check
    fmRegionalOfficeNumber.Visible := false;
    GroupBoxDivision.Visible := False;
    DateTimePicker1.Visible := True;
    DateTimePicker2.Visible := True;
    GroupBox5.Visible := True;
    GroupBox6.Visible := True;
    RadioGroupSortByDivision.Visible := False;
    label16.Visible := false;
    checkboxMailman.Visible := false;
    LabelReportChoice2.Caption := 'CNH Report of Admissions/Discharges';
    rgReportFormat.Items.Clear;                                                 // CodeCR470 JRL 4/9/13
    rgReportFormat.Items.Add('Plain Text');                                     // CodeCR470 JRL 4/9/13
    rgReportFormat.Items.Add('CSV Comma Delimited Export');                     // CodeCR470 JRL 4/15/13
    rgReportFormat.ItemIndex := 0;                                              // CodeCR470 JRL 4/10/13
    rgReportFormat.Visible := True;                                             //CodeCR129 - rpm 10/12/10
    RadioGroupDoYouWant.Visible := False;
    RadioGroupHospDom.Visible := False;
    PanelReportChoice2.Visible := True;
    PanelReportDateRange.Visible := False;
    PanelReportChoice2.BringToFront;
    GroupBox5.SetFocus;
    DateTimePicker1.SetFocus;
  end;

  if ORReportsAvailable.ItemIndex = CNH_STAYS_IN_EXCESS_OF_90_DAYS_IDX then     //CNH Stays in Excess of 90 days  //CodeCR266 - rpm 1/24/12 // CodeCR347 - jrl 7/13/12
  begin
    //CodeCR296 - rpm 2/2/12 - removed FPatch149Installed check
    fmRegionalOfficeNumber.Visible := false;
    GroupBoxDivision.Visible := False;
    DateTimePicker1.Visible := True;
    DateTimePicker2.Visible := False;
    GroupBox5.Caption := 'Effective Date';
    GroupBox5.Visible := True;
    GroupBox6.Visible := False;
    RadioGroupSortByDivision.Visible := False;
    label16.Visible := false;
    checkboxMailman.Visible := false;
    LabelReportChoice2.Caption := 'CNH Stays in Excess of 90 Days';
    rgReportFormat.Items.Clear;                                                 // CodeCR470 JRL 4/9/13
    rgReportFormat.Items.Add('Plain Text');                                     // CodeCR470 JRL 4/9/13
    rgReportFormat.Items.Add('CSV Comma Delimited Export');                     // CodeCR470 JRL 4/15/13
    rgReportFormat.ItemIndex := 0;                                              // CodeCR470 JRL 4/10/13
    rgReportFormat.Visible := True;                                             //CodeCR129 - rpm 10/12/10
    RadioGroupDoYouWant.Visible := False;
    RadioGroupHospDom.Visible := False;
    PanelReportChoice2.Visible := True;
    PanelReportDateRange.Visible := False;
    PanelReportChoice2.BringToFront;
    GroupBox5.SetFocus;
    DateTimePicker1.SetFocus;
  end;

  if ORReportsAvailable.ItemIndex = REQUEST_STATUS_BY_DATE_RANGE_IDX then       //Request Status by Date Range   //CodeCR266 - rpm 1/24/12 // CodeCR347 - jrl 7/13/12
  begin
    //CodeCR470 - JRL 4/15/13 - removed FPatch179Installed check
    fmRegionalOfficeNumber.Visible := false;
    GroupBoxDivision.Visible := False;
    DateTimePicker1.Visible := True;
    DateTimePicker2.Visible := True;
    GroupBox5.Visible := True;
    GroupBox6.Visible := True;
    RadioGroupSortByDivision.Visible := False;
    label16.Visible := false;
    checkboxMailman.Visible := false;
    LabelReportChoice2.Caption := 'Request Status by Date Range';
    RadioGroupDoYouWant.Visible := False;
    RadioGroupHospDom.Visible := False;
    rgReportFormat.Items.Clear;                                                 // CodeCR470 JRL 4/9/13
    rgReportFormat.Items.Add('Plain Text');                                     // CodeCR470 JRL 4/9/13
    rgReportFormat.Items.Add('CSV Comma Delimited Export');                     // CodeCR470 JRL 4/9/13
    rgReportFormat.ItemIndex := 0;                                              // CodeCR470 JRL 4/10/13
    rgReportFormat.Visible := True;
    pnlRequestStatusFilter.Visible := True;                                     //CodeCR266 - rpm 4/5/12
    cbxRequestStatus.ItemIndex := 0;                                            //default:All Statuses  //CodeCR266 - rpm 4/5/12
    rgIgnoreDate.ItemIndex := 0;                                                //default:NO  //CodeCR266 - rpm 4/5/12
    PanelReportChoice2.Visible := True;
    GroupBox5.SetFocus;
    DateTimePicker1.Setfocus;
    PanelReportDateRange.Visible := False;
  end
End;

Procedure Tfrmreports.Button9Click(Sender: TObject);
Var
  y: integer;
  IsDelimited: Boolean;                                                         //CodeCR129 - rpm 10/13/10
  IsIgnoreDate: Boolean;                                                        //CodeCR266 - rpm 4/4/12
  Filename: String;                                                             // CodeCR470 JRL 4/10/13
  DelimitedLines: TStringList;                                                  // CodeCR470 JRL 4/10/13
  AbbrevReportName: String;                                                     // CodeCR470 JRL 4/10/13
Begin
  If (DateTimePicker1.Visible) and (DateTimePicker2.Visible) then
  Begin
    // -mer 12/10 Patch 149 - Added trunc for compare of float values.  The
    // comparison without truncing was sometimes causing the evaluation to be
    // true when the dates selected were equal.
    If Trunc(DateTimePicker1.Date) > Trunc(DateTimePicker2.Date) Then
    Begin
      ShowMessageCAPRI('Start date cannot be greater than stop date.');
      exit;
    End;
  End;

  if (rgReportFormat.ItemIndex = 1) then                                        //CodeCR129 - rpm 10/13/10
    IsDelimited := True
  else
    IsDelimited := False;

  //CodeCR266 - rpm 4/4/12
  if (rgIgnoreDate.Enabled = True) and (rgIgnoreDate.ItemIndex = 1) then
    IsIgnoreDate := True
  else
    IsIgnoreDate := False;

  frmReports.Color := clWindow;
  PanelReportChoice2.Visible := False;
  If LabelReportChoice2.Caption = 'Exam Requests by Date Range' Then            // CodeCR347 - jrl 7/13/12
  Begin
    frmMain.RPCBroker1.Results.Clear;
    frmMain.RPCBroker1.RemoteProcedure := 'DVBAB EXAMS BY DATE';
    frmMain.RPCBroker1.Param[0].Value := FMToDateConvert(FormatDateTime('mm/dd/yyyy', DateTimePicker1.DateTime));
    frmMain.RPCBroker1.Param[0].PType := literal;
    frmMain.RPCBroker1.Param[1].Value := FMToDateConvert(FormatDateTime('mm/dd/yyyy', DateTimePicker2.DateTime));
    frmMain.RPCBroker1.Param[1].PType := literal;
    if rgReportFormat.ItemIndex = 0 then                                        // CodeCR470 JRL 4/10/13
    begin                                                                       // CodeCR470 JRL 4/10/13
      frmMain.RPCBroker1.Param[2].Value := '0';                                 // CodeCR470 JRL 4/10/13
      frmMain.RPCBroker1.Param[2].PType := literal;                             // CodeCR470 JRL 4/10/13
    end                                                                         // CodeCR470 JRL 4/10/13
    else                                                                        // CodeCR470 JRL 4/10/13
    begin                                                                       // CodeCR470 JRL 4/10/13
      frmMain.RPCBroker1.Param[2].Value := '1';                                 // CodeCR470 JRL 4/10/13
      frmMain.RPCBroker1.Param[2].PType := literal;                             // CodeCR470 JRL 4/10/13
    end;                                                                        // CodeCR470 JRL 4/10/13
    DisplayBusyAnimation(True);
    frmMain.RPCBroker1.Call;

    panelReportChoice2.Visible := False;
    ReportMemo.Visible := False;

    if IsDelimited then                                                         // delimited report                                     // CodeCR470 JRL 4/10/13
    begin
      If frmMain.RPCBroker1.Results.count < 2 Then                              // 0 shouldn't happen, a header should always be returned so 1 is no data
      Begin
        ReportMemo.Lines.Add('');
        ReportMemo.Lines.Add('No data found between ' + FormatDateTime('mm/dd/yyyy', DateTimePicker1.DateTime) + ' and ' + FormatDateTime('mm/dd/yyyy', DateTimePicker2.DateTime));
      End;
      if frmMain.RPCBroker1.Results.Count > 1 then
      begin
        AbbrevReportName := 'ExamReqByDate';                                    // CodeCR470 JRL 4/3/13
        DelimitedLines := TStringList.Create;                                   // CodeCR470 JRL 4/3/13
        try                                                                     // CodeCR470 JRL 4/10/13

          CAPRIQuickCopy(frmMain.RPCBroker1.Results, DelimitedLines);           // CodeCR470 JRL 4/10/13
          FileName := SaveDelimitedReportCSV(DelimitedLines, AbbrevReportName   // CodeCR470 JRL 7/18/13
            + '_'
            + FormatDateTime('YYYYMMDD', DateTimePicker1.Date)
            + '_'
            + FormatDateTime('YYYYMMDD', DateTimePicker2.Date));
          ReportMemo.Lines.Insert(0, '');                                       // CodeCR470 JRL 4/10/13
          if (FileName <> '') then                                              // CodeCR470 JRL 4/10/13
            ReportMemo.Lines.Insert(0, IntToStr(DelimitedLines.Count)           // CodeCR470 JRL 4/10/13
              + ' Extract lines saved to: ' + #13#10
              + FileName)
          else                                                                  // CodeCR470 JRL 4/10/13
            ReportMemo.Lines.Insert(0, 'No delimited text lines were saved!');  // CodeCR470 JRL 4/10/13
        finally                                                                 // CodeCR470 JRL 4/10/13
          FreeAndNil(DelimitedLines);                                           // CodeCR470 JRL 4/10/13
        end;                                                                    // CodeCR470 JRL 4/10/13
      end
    end                                                                         // if IsDelimited
    else
    begin                                                                       // plain text report
      If frmMain.RPCBroker1.Results.count = 0 Then
      Begin
        ReportMemo.Lines.Add('');
        ReportMemo.Lines.Add('No data found between ' + FormatDateTime('mm/dd/yyyy', DateTimePicker1.DateTime) + ' and ' + FormatDateTime('mm/dd/yyyy', DateTimePicker2.DateTime));
      End;
      If frmMain.RPCBroker1.Results.Count > 0 Then                              // CodeCR470 JRL 8/2/13
      begin
//      ReportMemo.Lines.Add('SSN        PATIENT NAME          REQUEST DT    DT RELEASED   DT PRINTED    STATUS');
//      ReportMemo.Lines.Add('------------------------------------------------------------------------------------------------------');
        ReportMemo.Lines.Add('SSN        PATIENT NAME          REQUEST DT    DT RELEASED   DT PRINTED    STATUS                         CLAIM TYPE     SPECIAL CONSIDERATIONS'); // CodeCR709 JRL 7/1/15
        ReportMemo.Lines.Add('---------------------------------------------------------------------------------------------------------------------------------------------------------------'); // CodeCR709 JRL 7/1/15
        For y := 0 To frmMain.RPCBroker1.Results.Count - 1 Do                   // CodeCR470 JRL 8/2/13
          ReportMemo.Lines.Add(
            copy(frmMain.piece(frmMain.RPCBroker1.Results[y], '^', 6) + '                              ', 1, 9) + '  ' +
            copy(frmMain.piece(frmMain.RPCBroker1.Results[y], '^', 1) + '                              ', 1, 20) + '  ' +
            Copy(Piece(FMDateTimeConvert(Piece(frmMain.RPCBroker1.Results[y], '^', 2)), '@', 1) + '                              ', 1, 12) + '  ' +
            Copy(Piece(FMDateTimeConvert(Piece(frmMain.RPCBroker1.Results[y], '^', 3)), '@', 1) + '                              ', 1, 12) + '  ' +
            Copy(Piece(FMDateTimeConvert(Piece(frmMain.RPCBroker1.Results[y], '^', 4)), '@', 1) + '                              ', 1, 12) + '  ' +
//          Piece(frmMain.RPCBroker1.Results[y], '^', 5)
            copy(frmMain.piece(frmMain.RPCBroker1.Results[y], '^', 5) + '                             ', 1, 29) + '  ' + // CodeCR709 JRL 7/1/15
            copy(frmMain.piece(frmMain.RPCBroker1.Results[y], '^', 7) + '                             ', 1, 13) + '  ' + // CodeCR709 JRL 7/1/15
            copy(frmMain.piece(frmMain.RPCBroker1.Results[y], '^', 8) + '                             ', 1, 38) // CodeCR709 JRL 7/1/15
            );
      end;                                                                      // if Results.Count > 0
    end;                                                                        // plain text report
    ReportMemo.Visible := True;
  End                                                                           {'Exam Requests by Date Range'}
  else if LabelReportChoice2.Caption = 'Pending Form 7131 Requests' Then
  Begin
    if (RadioGroupSortByDivision.ItemIndex = 0) and
      (FMRoutingLocationFake2.Text = '') Then
    begin
      PanelReportChoice2.Visible := True;
      ShowMessageCAPRI('Please select a division.');
      FMRoutingLocation2.SetFocus;
    end
    else
    begin
      frmMain.RPCBroker1.Results.Clear;
      frmMain.RPCBroker1.RemoteProcedure := 'DVBAB REPORT PENDING7131';
      frmMain.RPCBroker1.Param[0].Value := '';
      frmMain.RPCBroker1.Param[0].PType := literal;
      If RadioGroupSortByDivision.Items[RadioGroupSortByDivision.ItemIndex] = 'Yes' Then
        frmMain.RPCBroker1.Param[0].Value := 'Y';
      If RadioGroupSortByDivision.Items[RadioGroupSortByDivision.ItemIndex] = 'No' Then
        frmMain.RPCBroker1.Param[0].Value := 'N';
      frmMain.RPCBroker1.Param[1].Value := FMRoutingLocationFake2.Text;
      frmMain.RPCBroker1.Param[1].PType := literal;
      if rgReportFormat.ItemIndex = 0 then                                      // CodeCR470 JRL 4/8/13
      begin                                                                     // CodeCR470 JRL 4/8/13
        frmMain.RPCBroker1.Param[2].Value := '0';                               // CodeCR470 JRL 4/8/13
        frmMain.RPCBroker1.Param[2].PType := literal;                           // CodeCR470 JRL 4/8/13
      end                                                                       // CodeCR470 JRL 4/8/13
      else                                                                      // CodeCR470 JRL 4/8/13
      begin                                                                     // CodeCR470 JRL 4/8/13
        frmMain.RPCBroker1.Param[2].Value := '1';                               // CodeCR470 JRL 4/8/13
        frmMain.RPCBroker1.Param[2].PType := literal;                           // CodeCR470 JRL 4/8/13
      end;                                                                      // CodeCR470 JRL 4/8/13
      DisplayBusyAnimation(True);
      frmMain.RPCBroker1.Call;
      panelReportChoice2.Visible := False;
      ReportMemo.Visible := False;
      If frmMain.RPCBroker1.Results.Count > 0 Then
      Begin
        Screen.Cursor := crHourglass;
        if rgReportFormat.ItemIndex = 0 then                                    // plain text                      // CodeCR470 JRL 4/25/13
        begin
          Repeat
            Begin
              If Pos('^', frmMain.RPCBroker1.Results[0]) > 0 Then
              Begin
                ReportMemo.Lines.Add(Copy(frmMain.RPCBroker1.Results[0], 1, Pos('^', frmMain.RPCBroker1.Results[0]) - 1));
                frmMain.RPCBroker1.Results[0] := Copy(frmMain.RPCBroker1.Results[0], Pos('^', frmMain.RPCBroker1.Results[0]) + 1, Length(frmMain.RPCBroker1.Results[0]));
              End
              Else
              Begin
                ReportMemo.Lines.Add(frmMain.RPCBroker1.Results[0]);
                frmMain.RPCBroker1.Results[0] := '';
              End;
          End Until frmMain.RPCBroker1.Results[0] = '';
        end
        else                                                                    // delimited CSV data                                                //CodeCR470 JRL 4/25/13
        begin
          AbbrevReportName := 'Pending7131Rpt';                                 // CodeCR470 JRL 4/25/13
          DelimitedLines := TStringList.Create;                                 // CodeCR470 JRL 4/25/13
          try                                                                   // CodeCR470 JRL 4/25/13
            CAPRIQuickCopy(frmMain.RPCBroker1.Results, DelimitedLines);         // CodeCR470 JRL 4/25/13
            FileName := SaveDelimitedReportCSV(DelimitedLines, AbbrevReportName // CodeCR470 JRL 7/18/13
              + '_'
              + FormatDateTime('YYYYMMDD', Now));
            ReportMemo.Lines.Insert(0, '');                                     // CodeCR470 JRL 4/25/13
            if (FileName <> '') then                                            // CodeCR470 JRL 4/25/13
              ReportMemo.Lines.Insert(0, IntToStr(DelimitedLines.Count)         // CodeCR470 JRL 4/25/13
                + ' Extract lines saved to: ' + #13#10
                + FileName)
            else                                                                // CodeCR470 JRL 4/25/13
              ReportMemo.Lines.Insert(0, 'No delimited text lines were saved!'); // CodeCR470 JRL 4/25/13
          finally                                                               // CodeCR470 JRL 4/25/13
            FreeAndNil(DelimitedLines);                                         // CodeCR470 JRL 4/25/13
          end;                                                                  // CodeCR470 JRL 4/25/13
        end;
        Screen.Cursor := crDefault;
      End;
      If ReportMemo.Lines.count = 0 Then
        ReportMemo.Lines.Add('No data found for requested report criteria.');
      ReportMemo.Visible := True;
      ReportMemo.SelStart := 0;
      ReportMemo.SelLength := 0;
    end;
  End                                                                           {'Pending Form 7131 Requests'}
  else if LabelReportChoice2.Caption = 'Admission Report for SC Veterans' Then
  begin
    if FPatch179Installed then                                                  //CodeCR269 - call new design report
      GetHospAdjReport('DVBAB REPORT ADMISSIONS',
        'AdmissionSCVeteransReport', IsDelimited)
    else
      GetHospAdjReportByDay('DVBAB REPORT ADMISSIONS',
        'AdmissionSCVeteransReport', IsDelimited);                              //CodeCR129 - rpm 10/19/10
  end                                                                           {'Admission Report for SC Veterans'}
  else if LabelReportChoice2.Caption = 'Admission Inquiry By Date' Then
  begin
    GetAdmissionInquiryByDate(IsDelimited);                                     //CodeCR129 - rpm 10/13/10
  end                                                                           {'Admission Inquiry By Date'}
  else if LabelReportChoice2.Caption = 'Re-Admission Report' Then
  begin
    if FPatch179Installed then                                                  //CodeCR269 - call new design report
      GetHospAdjReport('DVBAB REPORT READMIT', 'ReAdmissionReport',
        IsDelimited)
    else
      GetHospAdjReportByDay('DVBAB REPORT READMIT', 'ReAdmissionReport',
        IsDelimited);                                                           //CodeCR129 - rpm 10/19/10
  end                                                                           {'Re-Admission Report'}
  else if LabelReportChoice2.Caption = 'Discharge Report' Then
  begin
    if FPatch179Installed then                                                  //CodeCR269 - call new design report
      GetHospAdjReport('DVBAB REPORT DISCHARGE', 'DischargeReport',
        IsDelimited)
    else
      GetHospAdjReportByDay('DVBAB REPORT DISCHARGE', 'DischargeReport',
        IsDelimited);                                                           //CodeCR129 - rpm 10/19/10
  end                                                                           {'Discharge Report'}
  else if LabelReportChoice2.Caption = 'Incompetent Veterans Report' Then
  begin
    if FPatch179Installed then                                                  //CodeCR269 - call new design report
      GetHospAdjReport('DVBAB REPORT INCOMPVET', 'IncompVetReport',
        IsDelimited)
    else
      GetHospAdjReportByDay('DVBAB REPORT INCOMPVET', 'IncompVetReport',
        IsDelimited);                                                           //CodeCR129 - rpm 10/19/10
  end                                                                           {'Incompetent Veterans Report'}
  else if LabelReportChoice2.Caption = AMIS_290 Then
  begin
    {ensure that 'Fake' text is consistent with visible text}
    if (FMRegionalOfficeNumber.Text = '') then
      FMRegionalOfficeNumberFake.Text := '';

    {CodeCR123 - rpm 11/2/10 - removed Regional Office validation to allow '',
                               which is interpreted on server as 'ALL'.
                               Defensive code checks for patch 149 to prevent
                               incompatibility error}
    //CodeCR296 - rpm 2/2/12 - removed FPatch149Installed check
    GetAMIS290Report(False);                                                    //CodeCR123 - rpm 11/2/10
  end                                                                           {'AMIS 290'}
  else if LabelReportChoice2.Caption = AMIS_290_BY_DIVISION Then                // CodeCR347 - JRL 7/13/12
  begin
    {Ensure that 'Fake' component text is consistent with visible text}
    if (FMRegionalOfficeNumber.Text = '') then
      FMRegionalOfficeNumberFake.Text := '';
    if (FMRoutingLocation2.Text = '') then
      FMRoutingLocationFake2.Text := '';

    {CodeCR123 - rpm 11/2/10 - removed Regional Office validation to allow '',
                               which is interpreted on server as 'ALL'.
                               Defensive code checks for patch 149 to prevent
                               incompatibility error}
    //CodeCR296 - rpm 2/2/12 - removed FPatch149Installed check
    if (FMRoutingLocationFake2.Text = '') then
    begin
      PanelReportChoice2.Visible := True;
      ShowMessageCAPRI('Please select a division.');
      FMRoutingLocation2.SetFocus;
    end
    else
      GetAMIS290Report(True);                                                   //CodeCR123 - rpm 11/2/10
  end                                                                           {'AMIS 290 BY DIVISION'}
  {============================================================================
   Add CNH Roster Print, CNH Report of Admissions/Discharges, and CNH Stays in
   Excess of 90 Days.
   CodeCR124 - rpm 7/20/10
   ============================================================================}
  else if (LabelReportChoice2.Caption = 'CNH Roster Print') then
    GetFeeBasisReport(LabelReportChoice2.Caption, IsDelimited)
  else if (LabelReportChoice2.Caption = 'CNH Report of Admissions/Discharges') then
    GetFeeBasisReport(LabelReportChoice2.Caption, IsDelimited)
  else if (LabelReportChoice2.Caption = 'CNH Stays in Excess of 90 Days') then
    GetFeeBasisReport(LabelReportChoice2.Caption, IsDelimited)
  else if (LabelReportChoice2.Caption = 'Request Status by Date Range') then    //CodeCR266
    GetRequestStatusReport(IsDelimited, IsIgnoreDate);
  frmReports.Color := clBtnFace;
End;

//CodeCR266 - rpm 4/5/12 - add new handler

procedure Tfrmreports.cbxRequestStatusChange(Sender: TObject);
var
  RequestStatus: String;
begin
  RequestStatus := UpperCase(cbxRequestStatus.Items[cbxRequestStatus.ItemIndex]);
  if (RequestStatus = 'NEW') or
    (RequestStatus = 'PENDING, REPORTED') or
    (RequestStatus = 'RELEASED TO RO, NOT PRINTED') or
    (RequestStatus = 'NEW, RE-ROUTED') or
    (RequestStatus = 'RE-ROUTED, PENDING ACCEPTANCE') or
    (RequestStatus = 'RE-ROUTED, ACCEPTED') or
    (RequestStatus = 'RE-ROUTED, REJECTED') then
  begin
    rgIgnoreDate.Enabled := True;
  end
  else
  begin
    rgIgnoreDate.Enabled := False;
  end;

  rgIgnoreDate.ItemIndex := 0;                                                  //always default to NO
end;

procedure Tfrmreports.actEditCopyExecute(Sender: TObject);
begin
  FEditCtrl := TRichEdit(Screen.ActiveControl);
  FEditCtrl.CopyToClipboard;
end;

procedure Tfrmreports.actEditCopyUpdate(Sender: TObject);
begin
  FEditCtrl := Nil;
  actEditCopy.Enabled := False;
  actEditSelectAll.Enabled := False;

  If screen.activecontrol.name = 'ReportMemo' Then
  Begin
    FEditCtrl := TRichEdit(Screen.ActiveControl);
    actEditCopy.Enabled := True;
    actEditSelectAll.Enabled := True;
  End;

end;

procedure Tfrmreports.actEditSelectAllExecute(Sender: TObject);
begin
  FEditCtrl := TRichEdit(Screen.ActiveControl);
  FEditCtrl.SelectAll;
end;

procedure Tfrmreports.actFilePageSetupExecute(Sender: TObject);
begin
  formPrint.ButtonPrinterSetupClick(application);
end;

procedure Tfrmreports.actFilePageSetupUpdate(Sender: TObject);
begin
  If noprinting = true Then
    actFilePageSetup.Enabled := False;
end;

{=====================================================================
 actFilePrintExecute
 This event procedure supports the File/Print menu option
 and is also called by actFilePrintPreview.

 CodeCR103 - rpm 4/21/10 - refactored; added formPrintVirtual cleanup
 =====================================================================}

procedure Tfrmreports.actFilePrintExecute(Sender: TObject);
begin
  //CAUTION - short-circuit when nothing selected or Broker is busy
  if ((ORReportsAvailable.ItemIndex = -1) and
    (ORReportsAvailable2.ItemIndex = -1)) or
    (ANURemoteProcedureCallInProgress = True) then
    exit;

  RaveSystem.OnPrint := NormalPrint;
  RaveSystem.OnPrintHeader := NormalPrintHeader;
  RaveSystem.OnPrintFooter := NormalPrintFooter;
  RaveSystem.OnBeforePrint := NormalBeforePrint;
  RaveSystem.SystemSetups := RaveSystem.SystemSetups - [ssAllowDestPreview, ssAllowDestFile];
  RaveSystem.DefaultDest := rdPrinter;
  RaveSystem.Execute;
  RaveSystem.SystemSetups := RaveSystem.SystemSetups + [ssAllowDestPreview, ssAllowDestFile];
end;

{========================================================================
 OneItemPerPagePrint
 This event procedure assigned to the Rave reports OnPrint event parses
 reports to print records on separate pages based on a defined record
 delimiter.

 CodeCR199  rpm - 10/19/2011
 ========================================================================}

procedure Tfrmreports.OneItemPerPagePrint(Sender: TObject);
var
  I: integer;
  startLine: integer;
  recordSeparator: String;
begin
  with Sender as TBaseReport do begin
    FDtTm := '';
    FDivision := '';
    FFootdescrip := '';

    {Get Date}
    frmMain.RPCBroker1.RemoteProcedure := 'DVBAB DATETIME';
    try
      frmMain.RPCBroker1.Call;
      if (frmMain.RPCBroker1.Results.Count > 0) then
        FDtTm := frmMain.RPCBroker1.Results[0];                                 //CodeCR199 - rpm 10/19/2011
    except
      on EBrokerError do
      begin
        ANURemoteProcedureCallInProgress := False;
        //jcs - d2006
        //frmMain.GIFImageVistaYellow.Animate := False;
        TGifImage(frmMain.GifImageVistaYellow.picture.Graphic).Animate := False;
        frmMain.StatusBarLoadPt.Caption := 'RPC DVBAB DATETIME could not be accessed!';
        frmMain.StatusBarLoadPt.Repaint;
        Application.Processmessages;
        ShowMessageCAPRI('DVBAB DATETIME could not be accessed!');
      end;
    end;

    {Get Division}
    frmMain.RPCBroker1.RemoteProcedure := 'XWB GET VARIABLE VALUE';
    frmMain.RPCBroker1.Param[0].Value := 'DUZ("2")';
    frmMain.RPCBroker1.Param[0].PType := reference;
    try
      frmMain.RPCBroker1.Call;
      if (frmMain.RPCBroker1.Results.Count > 0) then
        FDivision := frmMain.RPCBroker1.Results[0];
    except
      on EBrokerError do
      begin
        ANURemoteProcedureCallInProgress := False;
        //jcs - d2006
        //frmMain.GIFImageVistaYellow.Animate := False;
        TGifImage(frmMain.GifImageVistaYellow.picture.Graphic).Animate := False;
        frmMain.StatusBarLoadPt.Caption := 'RPC XWB GET VARIABLE VALUE could not be accessed!';
        frmMain.StatusBarLoadPt.Repaint;
        Application.Processmessages;
        ShowMessageCAPRI('XWB GET VARIABLE VALUE could not be accessed!');
      end;
    end;

    SetFont('Courier New', 10);

    FFootdescrip := 'REPORT: ' + ORReportsAvailable.Items[OrReportsAvailable.ItemIndex]; //CodeCR199 - rpm 10/19/2011

    Screen.Cursor := crHourGlass;
    frmmain.AnimateLogo(True);
    frmMain.StatusBarLoadPt.Caption := 'Printing...';
    frmMain.StatusBarLoadPt.Repaint;
    Application.Processmessages;

    case OrReportsAvailable.ItemIndex of
      PENDING_CnP_EXAMS_IDX:                                                    // CodeCR347 - JRL 7/13/12
        begin                                                                   //Pending C&P Exams
          startLine := 6;
          recordSeparator := 'Division:';
        end;
      ADMISSION_REPORT_FOR_SC_VETERANS_IDX:                                     // CodeCR347 - JRL 7/13/12
        begin                                                                   //Admission Report for SC Veterans  //CodeCR266 - rpm 1/24/12
          startLine := 4;
          recordSeparator := 'Patient Name:';
        end;
      SPECIAL_REPORT_FOR_AnA_PENSION_IDX:                                       // CodeCR347 - JRL 7/13/12
        begin                                                                   //Special Report for A&A/Pension  //CodeCR266 - rpm 1/24/12
          startLine := 6;
          recordSeparator := '----------------------------------------------------------------------';
        end;
      READMISSION_REPORT_IDX:                                                   // CodeCR347 - JRL 7/13/12
        begin                                                                   //Re-Admission Report  //CodeCR266 - rpm 1/24/12
          startLine := 3;
          recordSeparator := 'Patient:';
        end;
      DISCHARGE_REPORT_IDX:                                                     // CodeCR347 - JRL 7/13/12
        begin                                                                   //Discharge Report  //CodeCR266 - rpm 1/24/12
          startLine := 3;
          recordSeparator := 'Patient Name:';
        end;
      INCOMPETENT_VETERANS_REPORT_IDX:                                          // CodeCR347 - JRL 7/13/12
        begin                                                                   //Incompetent Veterans Report  //CodeCR266 - rpm 1/24/12
          startLine := 2;
          recordSeparator := 'Patient Name:';
        end;
      PENDING_FORM_7131_REQUESTS_IDX:                                           // CodeCR347 - JRL 7/13/12
        begin                                                                   //Pending Form 7131 Requests  //CodeCR124 - rpm 7/15/10  //CodeCR266 - rpm 1/24/12
          startLine := 6;
          recordSeparator := 'Original Division:';
        end;
    else                                                                        //default
      begin
        startLine := 0;
        recordSeparator := '';
      end;
    end;

    for I := startLine To ReportMemo.Lines.Count - 1 do
    begin
      PrintLine(TBaseReport(Sender), ReportMemo.Lines[I]);
      if (LinesLeft < 5) then                                                   //need 4 lines for footer
      begin
        NewPage
      end
      else if (recordSeparator <> '') then
      begin
        if (I + 1) <= (ReportMemo.Lines.Count - 1) then
          if (Pos(recordSeparator, ReportMemo.Lines[I + 1]) > 0) then
            NewPage;
      end;
    end;

    Screen.Cursor := crDefault;
    frmMain.AnimateLogo(False);
    frmMain.StatusBarLoadPt.Caption := 'Ready.';
    frmMain.StatusBarLoadPt.Repaint;
  end;
end;

{======================================================================
 actFilePrintOneExecute
 This event procedure supports the File/Print One Item per Page
 menu option.  The procedure sets the Rave reports OnPrint, OnPrintHeader
 , and OnPrintFooter handlers and executes Rave reports.

 CodeCR103 - rpm 4/28/10 - refactored; added formPrintVirtual cleanup
 CodeCR199 - rpm 10/19/2011 - converted to Rave reports
 ======================================================================}

procedure Tfrmreports.actFilePrintOneExecute(Sender: TObject);
begin
  //CAUTION - short-circuit when nothing selected or Broker is busy
  if ((ORReportsAvailable.ItemIndex = -1) and
    (ORReportsAvailable2.ItemIndex = -1)) or
    (ANURemoteProcedureCallInProgress = True) then
    exit;

  // Don't do this print routine for the 2nd report list.
  if ORReportsAvailable2.ItemIndex > -1 then
  begin
    exit;
  end;

  RaveSystem.OnPrint := OneItemPerPagePrint;
  RaveSystem.OnPrintHeader := OneItemPerPagePrintHeader;
  RaveSystem.OnPrintFooter := OneItemPerPagePrintFooter;
  RaveSystem.SystemSetups := RaveSystem.SystemSetups - [ssAllowDestPreview, ssAllowDestFile];
  RaveSystem.DefaultDest := rdPrinter;
  RaveSystem.Execute;
  RaveSystem.SystemSetups := RaveSystem.SystemSetups + [ssAllowDestPreview, ssAllowDestFile];
end;

procedure Tfrmreports.actFilePrintOneUpdate(Sender: TObject);
begin
  If noprinting = true Then
    actFilePrintOne.Enabled := False;
end;

procedure Tfrmreports.actFilePrintPreviewExecute(Sender: TObject);
begin
  If ANURemoteProcedureCallInProgress = True Then
    exit;

  If ((ORReportsAvailable.ItemIndex = -1) And (ORReportsAvailable2.ItemIndex = -1)) Then
    exit;
  If ((ORReportsAvailable.ItemIndex = -1) And (ORReportsAvailable2.ItemIndex > -1)) Then
  Begin
    ShowMessageCAPRI('Print preview is not allowed for this report type.');
    exit;
  End;

  RaveSystem.OnPrint := NormalPrint;
  RaveSystem.OnPrintHeader := NormalPrintHeader;
  RaveSystem.OnPrintFooter := NormalPrintFooter;
  RaveSystem.OnBeforePrint := NormalBeforePrint;
  RaveSystem.SystemSetups := RaveSystem.SystemSetups - [ssAllowDestPrinter, ssAllowDestFile];
  RaveSystem.DefaultDest := rdPreview;
  RaveSystem.Execute;
  RaveSystem.SystemSetups := RaveSystem.SystemSetups + [ssAllowDestPrinter, ssAllowDestFile];
end;

procedure Tfrmreports.actFilePrintPreviewUpdate(Sender: TObject);
begin
  If noprinting = true Then
    actFilePrintPreview.Enabled := False;
end;

procedure Tfrmreports.actFilePrintUpdate(Sender: TObject);
begin
  If noprinting = true Then
    actFilePrint.Enabled := False;
end;

Procedure Tfrmreports.Button13Click(Sender: TObject);
Begin
  PanelReportChoice2.Visible := False;
  PanelProgress.Visible := False;
  ORReportsAvailable.SetFocus;
End;

Procedure Tfrmreports.Button2Click(Sender: TObject);
Begin
  PanelReportChoice3.Visible := False;
  ORReportsAvailable.SetFocus;
End;

//------------------------------------------------------------------------------
// Pending C&P Exams Report
//------------------------------------------------------------------------------
// RPC:  DVBAB PENDING C&P REPORT
// Input Parameters:
//   0 : Sort By
//       'A  Age, 'S  Status, 'V  Veteran Name, 'R  Routing Location
//   1 : If Sort By = 'S' (Status)
//       'N  New, 'P  Pending, Reported, 'T  Transcribed, 'NR  New, Re-Routed
//       'RP  Re-Routed, Pending Acceptance, 'RA  Re-Routed, Accepted,
//       'RR  Re-Routed, Rejected, 'A  All Statuses 
//   2 : if Sort By = 'A' (Age)
//       Earliest Days (edit1.text)
//   3 : if Sort By = 'A' (Age)
//       Oldest Days (edit2.text)
//   4 : if Sort By = 'R' (Routing Location)
//       FMRoutingLocation selected
//   5 : Report By (always set, not dependent upon Sorting)
//       'C' - Calendar Days, 'W' - Work Days
//   6 : Report Format
//       '0' - Plain Text, '1' - Delimited
//   7 : Report Mode ** Always '0' from this location
//       '0' - Local Mode
//       '1' - Remote Consolidate Reports mode (frmRemoteReports.PendingCnP) 
//------------------------------------------------------------------------------
Procedure Tfrmreports.Button1Click(Sender: TObject);
var
  ADelimiter: String;                                                           // CodeCR470 JRL 4/2/13
  Filename: String;                                                             // CodeCR470 JRL 4/3/13
  DelimitedLines: TStringList;                                                  // CodeCR470 JRL 4/3/13
  AbbrevReportName: String;                                                     // CodeCR470 JRL 4/3/13
  StatusSelection : String;    // Patch 193 JRL 7/25/16
Begin
  If RadioGroup1.ItemIndex = -1 Then
  Begin
    ShowMessageCAPRI('Please select a type of sort for this report.');
    exit;
  End;
  If Radiogroup1.Items[RadioGroup1.ItemIndex] = 'Age' Then
  Begin
    If StrToInt(Edit1.Text) > StrToInt(Edit2.Text) Then
    Begin
      ShowMessageCAPRI('Earliest age must be less than oldest age.');
      exit;
    End;
  End;
  If Radiogroup1.Items[RadioGroup1.ItemIndex] = 'Routing Location' Then
  Begin
    If FMRoutingLocationFake.Text = '' Then
    Begin
      ShowMessageCAPRI('Please select a routing location.');
      exit;
    End;
  End;
  If label1_3.caption = 'Pending C&&P Exams' Then
  Begin
    frmMain.RPCBroker1.Results.Clear;
    frmMain.RPCBroker1.RemoteProcedure := 'DVBAB PENDING C&P REPORT';
    // Always set sort by
    frmMain.RPCBroker1.Param[0].Value := RadioGroup1.Items[RadioGroup1.ItemIndex];
    frmMain.RPCBroker1.Param[0].Value := frmMain.RPCBroker1.Param[0].Value[1];  // Just get 1st char
    frmMain.RPCBroker1.Param[0].PType := literal;
    // Status
    frmMain.RPCBroker1.Param[1].Value := '';
    frmMain.RPCBroker1.Param[1].PType := literal;
    If frmMain.RPCBroker1.Param[0].Value = 'S' Then // Status
    Begin
       // Patch 193 JRL 7/25/16.  Added in new statuses.  Changed code (which
       // originally chose the first character of the status) to choose the 
       // status code below.
      case RadioGroup2.ItemIndex of
        0: StatusSelection := 'N';  // New
        1: StatusSelection := 'P';  // Pending
        2: StatusSelection := 'T';  // Transcribed
        3: StatusSelection := 'NR'; // New, Re-Routed
        4: StatusSelection := 'RP'; // Re-Routed, Pending Acceptance
        5: StatusSelection := 'A';  // All
      end; // case
      frmMain.RPCBroker1.Param[1].Value := RadioGroup2.Items[RadioGroup2.ItemIndex];
      frmMain.RPCBroker1.Param[1].Value := StatusSelection; // Patch 193 JRL 7/25/16
//    frmMain.RPCBroker1.Param[1].Value := frmMain.RPCBroker1.Param[1].Value[1]; // Just get 1st char
    End;
    frmMain.RPCBroker1.Param[2].Value := '';
    frmMain.RPCBroker1.Param[2].PType := literal;
    frmMain.RPCBroker1.Param[3].Value := '';
    frmMain.RPCBroker1.Param[3].PType := literal;
    If frmMain.RPCBroker1.Param[0].Value = 'A' Then
    Begin
      frmMain.RPCBroker1.Param[2].Value := Edit1.Text;
      frmMain.RPCBroker1.Param[3].Value := Edit2.Text;
    End;
    frmMain.RPCBroker1.Param[4].Value := '';
    frmMain.RPCBroker1.Param[4].PType := literal;
    If frmMain.RPCBroker1.Param[0].Value = 'R' Then
    Begin
      frmMain.RPCBroker1.Param[4].Value := FMRoutingLocationFake.Text;
    End;
    // Always set (c)alendar or (w)ork days            
    frmMain.RPCBroker1.Param[5].Value := '';
    frmMain.RPCBroker1.Param[5].PType := literal;
    frmMain.RPCBroker1.Param[5].Value := RadioGroup3.Items[RadioGroup3.ItemIndex];
    frmMain.RPCBroker1.Param[5].Value := frmMain.RPCBroker1.Param[5].Value[1];  // Just get 1st char
    // Delimited or not
    case rgPendingCnPRptFmt.ItemIndex of                                        // CodeCR470 JRL 4/5/13
      0: ADelimiter := '0';                                                     // CodeCR470 JRL 4/5/13
      1: ADelimiter := '1';                                                     // CodeCR470 JRL 4/5/13
    end;                                                                        // CodeCR470 JRL 4/5/13
    frmMain.RPCBroker1.Param[6].Value := ADelimiter;                            // CodeCR470 JRL 4/5/13
    frmMain.RPCBroker1.Param[6].PType := literal;                               // CodeCR470 JRL 4/5/13
    frmMain.RPCBroker1.Param[7].Value := '0';                                   // Local mode vs.            // CodeCR470 JRL 5/22/13
    frmMain.RPCBroker1.Param[7].PType := literal;                               // Consolidated remote rpts  // CodeCR470 JRL 5/22/13
    try
      DisplayBusyAnimation(True);
      frmMain.RPCBroker1.Call;
    except on E: Exception do
      begin
        ShowMessageCAPRI('DVBAB PENDING C&P REPORT returned an error!' + #13#10 + E.Message);
        Screen.Cursor := crDefault;
        exit;
      end;
    end;
    panelReportChoice3.Visible := False;
    ReportMemo.Visible := False;
    If frmMain.RPCBroker1.Results.Count > 0 Then
    Begin
      if ADelimiter = '0' then                                                  // normal report                                 // CodeCR470 JRL 4/5/13
      begin
        Repeat
          Begin
            Screen.Cursor := crHourglass;
            If Pos('^', frmMain.RPCBroker1.Results[0]) > 0 Then
            Begin
              ReportMemo.Lines.Add(Copy(frmMain.RPCBroker1.Results[0], 1, Pos('^', frmMain.RPCBroker1.Results[0]) - 1));
              frmMain.RPCBroker1.Results[0] := Copy(frmMain.RPCBroker1.Results[0], Pos('^', frmMain.RPCBroker1.Results[0]) + 1, Length(frmMain.RPCBroker1.Results[0]));
            End
            Else
            Begin
              ReportMemo.Lines.Add(frmMain.RPCBroker1.Results[0]);
              frmMain.RPCBroker1.Results[0] := '';
            End;
          End
        Until frmMain.RPCBroker1.Results[0] = '';
      end
      else                                                                      // delimited report CodeCR470 JRL 4/5/13
      begin
        AbbrevReportName := 'PendingCPExam';                                    // CodeCR470 JRL 4/3/13
        DelimitedLines := TStringList.Create;                                   // CodeCR470 JRL 4/3/13
        try
          CAPRIQuickCopy(frmMain.RPCBroker1.Results, DelimitedLines);
          FileName := SaveDelimitedReportCSV(DelimitedLines, AbbrevReportName
            + '_'
            + FormatDateTime('YYYYMMDD', dtpInsuffStart.Date)
            + '_'
            + FormatDateTime('YYYYMMDD', dtpInsuffEnd.Date));
          ReportMemo.Lines.Insert(0, '');
          if (FileName <> '') then
            ReportMemo.Lines.Insert(0, IntToStr(DelimitedLines.Count)
              + ' Extract lines saved to: ' + #13#10
              + FileName)
          else
            ReportMemo.Lines.Insert(0, 'No delimited text lines were saved!');
        finally
          FreeAndNil(DelimitedLines);
        end;
      end;
      Screen.Cursor := crDefault;
    End;
    If ReportMemo.Lines.count = 0 Then
      ReportMemo.Lines.Add('No data found for requested report criteria.');
    ReportMemo.Visible := True;
    ReportMemo.SelStart := 0;
    ReportMemo.SelLength := 0;
    ReportMemo.SetFocus;
  End;
  panelReportChoice3.Visible := False;
End;

Procedure Tfrmreports.RadioGroup1Click(Sender: TObject);
Begin
  If Radiogroup1.Items[RadioGroup1.ItemIndex] = 'Age' Then
  Begin
    GroupBox1.Visible := True;
    RadioGroup2.Visible := False;
    GroupBox2.Visible := False;
  End;
  If Radiogroup1.Items[RadioGroup1.ItemIndex] = 'Status' Then
  Begin
    GroupBox1.Visible := False;
    RadioGroup2.Visible := True;
    GroupBox2.Visible := False;
  End;
  If Radiogroup1.Items[RadioGroup1.ItemIndex] = 'Veteran Name' Then
  Begin
    GroupBox1.Visible := False;
    RadioGroup2.Visible := False;
    GroupBox2.Visible := False;
  End;
  If Radiogroup1.Items[RadioGroup1.ItemIndex] = 'Routing Location' Then
  Begin
    GroupBox1.Visible := False;
    RadioGroup2.Visible := False;
    GroupBox2.Visible := True;
  End;
End;

Procedure Tfrmreports.Edit1Exit(Sender: TObject);
Begin
  Edit1.Text := IntToStr(StrToInt(Edit1.Text));
  If Edit1.Text = '0' Then
    Edit1.Text := '1';
End;

Procedure Tfrmreports.Edit2Exit(Sender: TObject);
Begin
  Edit2.Text := IntToStr(StrToInt(Edit2.Text));
  If Edit2.Text = '0' Then
    Edit2.Text := '1';
End;

Procedure Tfrmreports.FMRoutingLocationExit(Sender: TObject);
Var
  x: integer;
Begin
  If FMRoutingLocation.Text = '' Then
    exit;
  For x := 0 To FMRoutingLocation.Items.Count - 1 Do
    If Pos(uppercase(FMRoutingLocation.Text), uppercase(FMRoutingLocation.Items[x])) = 1 Then
    Begin
      FMRoutingLocation.ItemIndex := x;
    End;
  If FMRoutingLocation.ItemIndex = -1 Then
  Begin
    ShowMessageCAPRI('The Routing Location response is not valid.');
    FMRoutingLocation.Text := '';
    FMRoutingLocation.SetFocus;
    exit;
  End;
  FMRoutingLocationFake.Text := Copy(Piece(FMRoutingLocation.Text, '^', 1), Pos('  ', Piece(FMRoutingLocation.Text, '^', 1)) + 4, 255);
End;

Procedure Tfrmreports.FMRoutingLocation2Exit(Sender: TObject);
Var
  x: integer;
Begin
  If FMRoutingLocation2.Text = '' Then
    exit;
  For x := 0 To FMRoutingLocation2.Items.Count - 1 Do
    If Pos(uppercase(FMRoutingLocation2.Text), uppercase(FMRoutingLocation2.Items[x])) = 1 Then
    Begin
      FMRoutingLocation2.ItemIndex := x;
    End;
  If FMRoutingLocation2.ItemIndex = -1 Then
  Begin
    ShowMessageCAPRI('The Routing Location response is not valid.');
    FMRoutingLocation2.Text := '';
    FMRoutingLocation2.SetFocus;
    exit;
  End;
  FMRoutingLocationFake2.Text := Copy(Piece(FMRoutingLocation2.Text, '^', 1), Pos('  ', Piece(FMRoutingLocation2.Text, '^', 1)) + 4, 255);
End;

Procedure Tfrmreports.RadioGroupSortByDivisionClick(Sender: TObject);
Begin
  If RadioGroupSortByDivision.ItemIndex = 1 Then
  Begin
    GroupBoxDivision.Visible := False;
    FMRoutingLocationFake2.Text := ''
  End
  Else
  Begin
    GroupBoxDivision.Visible := True;
    FMRoutingLocation2.ItemIndex := -1;
    FMRoutingLocationFake2.Text := '';
  End;
End;

{=========================================================================
 OneItemPerPagePrintFooter
 This procedure is the OnPrintFooter event handler for the One Item Per Page
 print option.

 CodeCR199 - rpm 10/19/2011
 =========================================================================}

procedure Tfrmreports.OneItemPerPagePrintFooter(Sender: TObject);
var
  X, Y: double;
  SavedPen, LinePen: TPen;
begin
  with Sender as TBaseReport do begin
    SaveFont(1);
    SetFont('Arial', 10);
    SectionBottom := SectionBottom - (3 * LineHeight);
    GoToFooter;

    //Draw separator line
    SavedPen := Canvas.Pen;
    LinePen := CreatePen(clBlack, psSolid, 10, pmBlack);
    try
      Canvas.Pen := LinePen;
      X := XD2I(CursorXPos);
      Y := YD2I(CursorYPos);
      MoveTo(X, Y);
      LineTo(SectionRight, Y);
    finally
      Canvas.Pen := SavedPen;
      FreeAndNil(LinePen);
    end;

    //footer line 1
    SectionBottom := SectionBottom + LineHeight;
    PrintFooter(FFootDescrip, pjLeft);
    PrintFooter('Page: ' + IntToStr(CurrentPage), pjRight);

    //footer line 2
    SectionBottom := SectionBottom + LineHeight;
    PrintFooter('Printed on: ' + FDtTm, pjRight);

    //footer line 3
    SectionBottom := SectionBottom + LineHeight;
    PrintFooter('System: ' + Uppercase(frmMain.RPCBroker1.ANUStrServer), pjLeft);
    PrintFooter('Division: ' + FDivision, pjRight);

    RestoreFont(1);
  end;
end;

{=========================================================================
 OneItemPerPagePrintHeader
 This procedure is the OnPrintHeader event handler for OneItemPerPage
 option.

 CodeCR199 - rpm 10/19/2011
 =========================================================================}

procedure Tfrmreports.OneItemPerPagePrintHeader(Sender: TObject);
begin
  with Sender as TBaseReport do
  begin
    if (FSpecRepDateRangeHdr <> '') then
    begin
      SaveFont(1);
      SetFont('Courier New', 10);
      Bold := True;
      PrintCenter(FSpecRepDateRangeHdr, (SectionLeft + SectionRight) / 2.0);
      Bold := False;
      NewLine;
      NewLine;
      RestoreFont(1);
    end;
  end;
end;

Procedure Tfrmreports.FormResize(Sender: TObject);
Begin
  PanelReportDateRange.Left := (frmReports.Width Div 2) - (PanelReportDateRange.width Div 2);
  PanelReportDateRange.Top := (frmReports.Height Div 2) - (PanelReportDateRange.height Div 2) - 30;

  PanelReportChoice2.Left := (frmReports.Width Div 2) - (PanelReportChoice2.width Div 2);
  PanelReportChoice2.Top := (frmReports.Height Div 2) - (PanelReportChoice2.height Div 2) - 30;

  PanelReportChoice3.Left := (frmReports.Width Div 2) - (PanelReportChoice3.width Div 2);
  PanelReportChoice3.Top := (frmReports.Height Div 2) - (PanelReportChoice3.height Div 2) - 30;

  PanelReportChoice1.Left := (frmReports.Width Div 2) - (PanelReportChoice1.width Div 2);
  PanelReportChoice1.Top := (frmReports.Height Div 2) - (PanelReportChoice1.height Div 2) - 30;

  PanelInsufficientExamReport.Left := (frmReports.Width Div 2) - (PanelInsufficientExamReport.width Div 2);
  PanelInsufficientExamReport.Top := (frmReports.Height Div 2) - (PanelInsufficientExamReport.height Div 2) - 30;

  PanelProgress.Left := (frmReports.Width Div 2) - (PanelProgress.width Div 2);
  PanelProgress.Top := (frmReports.Height Div 2) - (PanelProgress.height Div 2) - 30;

  PanelBuildingReport.Top := +35;
  PanelBuildingReport.Left := frmReports.Width - PanelBuildingReport.Width - 20;
End;

Procedure Tfrmreports.FormCreate(Sender: TObject);
Begin
  FFooterLineHeight := 0.20;
  ORReportsAvailable.Items.Clear;
  ReportMemo.SendToBack;
  ReportMemo.Lines.Clear;
  // CodeCR347 - JRL 7/13/12 Changed all 33 lines below: ORReportsAvailable.Items.Add(InsertedConstantNameHere) text to use a constant
  ORReportsAvailable.Items.Add(CnP_EXAMS);
  ORReportsAvailable.Items.Add(AMIS_290);
  ORReportsAvailable.Items.Add(AMIS_290_BY_DIVISION);
  ORReportsAvailable.Items.Add(INSUFFICIENT_EXAM_REPORT);
  ORReportsAvailable.Items.Add(PENDING_CnP_EXAMS);
  ORReportsAvailable.Items.Add(CnP_EXAMS_CHECKLIST);
  ORReportsAvailable.Items.Add(REPRINT_CnP_FINAL_REPORT);
  ORReportsAvailable.Items.Add(EXAM_REQUESTS_BY_DATE_RANGE);
  ORReportsAvailable.Items.Add(REQUEST_STATUS_BY_DATE_RANGE);                   //CodeCR266 - rpm 1/24/12
  ORReportsAvailable.Items.Add(BLANK_LINE1);
  ORReportsAvailable.Items.Add(HOSPITAL_ADJUSTMENT);
  ORReportsAvailable.Items.Add(ADMISSION_REPORT_FOR_SC_VETERANS);
  ORReportsAvailable.Items.Add(ADMISSION_INQUIRY_BY_DATE);
  ORReportsAvailable.Items.Add(SPECIAL_REPORT_FOR_AnA_PENSION);
  ORReportsAvailable.Items.Add(READMISSION_REPORT);
  ORReportsAvailable.Items.Add(DISCHARGE_REPORT);
  ORReportsAvailable.Items.Add(INCOMPETENT_VETERANS_REPORT);
  ORReportsAvailable.Items.Add(CHN_DISPLAY_EPISODE_OF_CARE);
  ORReportsAvailable.Items.Add(CHN_ROSTER_PRINT);
  ORReportsAvailable.Items.Add(CNH_REPORT_OF_ADMISSIONS_DISCHARGES);            //CodeCR124 - rpm 7/13/10
  ORReportsAvailable.Items.Add(CNH_STAYS_IN_EXCESS_OF_90_DAYS);                 //CodeCR124 - rpm 7/13/10
  ORReportsAvailable.Items.Add(BLANK_LINE2);
  ORReportsAvailable.Items.Add(REQUEST_FOR_INFO);
  ORReportsAvailable.Items.Add(PENDING_FORM_7131_REQUESTS);
  ORReportsAvailable.Items.Add(TWENTYONE_DAY_CERTIFICATE_PRINTING);
  ORReportsAvailable.Items.Add(REPRINT_A_21_DAY_CERTIFICATE);
  ORReportsAvailable.Items.Add(REPRINT_A_NOTICE_OF_DISCHARGE);
  ORReportsAvailable.Items.Add(BLANK_LINE3);
  ORReportsAvailable.Items.Add(VHA_REPORTS);
  ORReportsAvailable.Items.Add(TEMPLATE_ACTIVITY);
  ORReportsAvailable.Items.Add(BLANK_LINE4);                                    // CodeCR347 - jrl 5/18/12
  ORReportsAvailable.Items.Add(VRnE_REPORTS);                                   // CodeCR347 - jrl 5/18/12
  ORReportsAvailable.Items.Add(VRnE_STATUS);                                    // CodeCR347 - jrl 5/18/12
  ORReportsAvailable.ItemIndex := 0;
  // Second listbox entries
  ORReportsAvailable2.Items.Add('Print C&P Final Report (Manual)');
  ORReportsAvailable2.Items.Add('Print New Notices of Discharge');
  DateTimePicker1.Date := Now;
  DateTimePicker2.Date := Now;
  dtpReportDate1.Date := Now;                                                   //CodeCR85 - rpm 4/12/10
  dtpInsuffStart.Date := Now;                                                   //CodeCR85 - rpm 4/12/10
  dtpInsuffEnd.Date := Now;                                                     //CodeCR85 - rpm 4/12/10
  //jcs - d2006
//  TGifImage(GifImageWait.picture.Graphic).AnimationSpeed := 1500;
End;

{==========================================================================
 ReplaceTabs
 This function replaces all tab characters in a given string with spaces
 based on the given tab size.

 CodeCR212 - rpm 11/2/11
 ==========================================================================}

function Tfrmreports.ReplaceTabs(LineWithTabs: String; tabSize: Integer): String;
var
  I, padLength: Integer;
  LineWithSpaces: String;
begin
  LineWithSpaces := '';
  for I := 1 to Length(LineWithTabs) do
  begin
    if LineWithTabs[i] = #9 then
    begin
      padLength := tabSize - (Length(LineWithSpaces) MOD tabSize);
      LineWithSpaces := LineWithSpaces + StringOfChar(' ', padLength);
    end
    else
      LineWithSpaces := LineWithSpaces + LineWithTabs[i];
  end;
  Result := LineWithSpaces;
end;

Procedure Tfrmreports.ReportMemoChange(Sender: TObject);
Begin
  Try
    DisplayBusyAnimation(False);
  Except
  End;
End;

//CodeCR266 - rpm 4/5/12 - add new event handler

procedure Tfrmreports.rgIgnoreDateClick(Sender: TObject);
begin
  if (rgIgnoreDate.Items[rgIgnoreDate.ItemIndex] = 'Yes') then
  begin
    GroupBox5.Visible := False;
    GroupBox6.Visible := False;
  end
  else
  begin
    GroupBox5.Visible := True;
    GroupBox6.Visible := True;
  end;
end;

procedure Tfrmreports.rgInsufficientRptFmtClick(Sender: TObject);
begin
  case rgInsufficientRptFmt.ItemIndex of
    0:
      GetScreenReader.Speak('Plain Text');                                      // rpk 7/14/2015
    1:
      GetScreenReader.Speak('CSV Comma Delimited Export');                      // rpk 7/14/2015
  end;

end;

procedure Tfrmreports.rgInsufficientRptFmtEnter(Sender: TObject);               // rpk 7/14/2015
begin
  rgInsufficientRptFmtClick(Sender);
end;

Procedure Tfrmreports.Button4Click(Sender: TObject);
Begin
  PanelReportChoice1.Visible := False;
  GroupBox3.Visible := False;
  ORReportsAvailable.SetFocus;
End;

Procedure Tfrmreports.RadioButton1_1Click(Sender: TObject);
Var
  x: integer;
Begin
  //run report by date
  If RadioButton1_2.Checked = True Then
  Begin
    gbSelectReportDate1.Visible := True;                                        //CodeCR85
    If (ORListBoxData1.Items.Count > 0) and (Piece(ORListBoxData1.Items[0], '^', 2) = '< No data found for patient. >') then
      ORListBoxData1.Items.Clear;
  End
  Else                                                                          //otherwise, run report by patient
  Begin
    //clear 'Which One?' selection list
    ORListBoxData1.Items.Clear;

    //exit if not the reprint a 21 day certificate report
    If Label1_1.caption <> 'Reprint a 21 Day Certificate' Then
      Exit;
    //otherwise get get list of certs to reprint
    gbSelectReportDate1.Visible := False;                                       //CodeCR85
    frmMain.RPCBroker1.RemoteProcedure := 'DVBAB ORIGINAL PROCESSING DATE';
    frmMain.RPCBroker1.Param[1].Value := PatientIEN;
    frmMain.RPCBroker1.Param[1].PType := literal;
    frmMain.RPCBrokerCall;
    Try
      frmMain.RPCBroker1.Call;
    Except
      On EBrokerError Do
      Begin
        ANURemoteProcedureCallinProgress := False;
        ShowMessageCAPRI('RPC DVBAB ORIGINAL PROCESSING DATE could not be accessed!');
        PanelReportChoice1.Visible := False;
      End;
    End;

    //populate 'Which One?' selection list with rpc results
    If frmMain.RPCBroker1.Results.Count > 0 Then
    begin
      For x := 0 To frmMain.RPCBroker1.Results.Count - 1 Do
        ORListBoxData1.Items.Add(frmMain.piece(frmMain.RPCBroker1.Results[x], '^', 1) + '^' + fmDateTimeConvert(frmMain.Piece(frmMain.RPCBroker1.Results[x], '^', 2)));
    End
    Else                                                                        //otherwise no data found for populating selection list - kcl 2/26/09
    Begin
      ORListBoxData1.Items.Add('' + '^' + '< No data found for patient. >');
      Repaint;
    End;
    GroupBox3.Visible := True;
  End;
End;

Procedure Tfrmreports.Button3Click(Sender: TObject);
Var
  yesno, origdate, capdfn: String;
  brkcall: String;
  ROMAS: String;
  Remote: String;                                                               // CodeCR711 JRL 6/8/15
Begin
  If RadioButton1_1.Checked = False Then
    If RadioButton1_2.Checked = False Then
    Begin
      ShowMessageCAPRI('Please select criteria first.');
      exit;
    End;
  If label1_1.Caption = 'Re-print C&&P Final Report(s)' Then
  Begin
    brkCall := 'DVBAB REPORTS';
    If RadioButton1_2.Checked = True Then
    Begin
      ROMAS := 'R';
      If FloatToStr(dtpReportDate1.DateTime) = '0' Then                         //CodeCR85
      Begin
        ShowMessageCAPRI('Pick a date first.');
        exit;
      End;
    End;
    If ESSOVersion then                                                         // CodeCR711 JRL 6/8/15
      Remote := '1'                                                             // CodeCR711 JRL 6/8/15
    else                                                                        // CodeCR711 JRL 6/8/15
      Remote := '0';                                                            // CodeCR711 JRL 6/8/15
    frmMain.RPCBroker1.RemoteProcedure := brkCall;
    frmMain.RPCBroker1.Param[1].Value := '4';
    frmMain.RPCBroker1.Param[1].PType := literal;
//  frmMain.RPCBroker1.Param[2].Value := 'D^' + FMToDateConvert(FormatDateTime('mm/dd/yyyy', dtpReportDate1.DateTime)) + '^' + ROMAS + '^0^^^';  //CodeCR85
    frmMain.RPCBroker1.Param[2].Value := 'D^' + FMToDateConvert(FormatDateTime('mm/dd/yyyy', dtpReportDate1.DateTime)) + '^' + ROMAS + '^0^^^^' + Remote; // CodeCR711 JRL 6/8/15
    frmMain.RPCBroker1.Param[2].PType := literal;
  End;
  If label1_1.Caption = 'Reprint a Notice of Discharge' Then
  Begin
    brkCall := 'DVBAB REPORTS';                                                 //REPRINT NOTICE DC
    If RadioButton1_1.Checked = True Then
    Begin
      yesno := '1';
      Origdate := '';
      CapDFN := PatientIEN;
    End
    Else
    Begin
      If FloatToStr(dtpReportDate1.DateTime) = '0' Then                         //CodeCR85
      Begin
        ShowMessageCAPRI('Pick a date first.');
        exit;
      End;
      yesno := '0';
      OrigDate := FMToDateConvert(FormatDateTime('mm/dd/yyyy', dtpReportDate1.DateTime)); //CodeCR85
      CapDFN := '';
    End;
    frmMain.RPCBroker1.RemoteProcedure := brkCall;
    frmMain.RPCBroker1.Param[1].Value := '6';
    frmMain.RPCBroker1.Param[1].PType := literal;

    frmMain.RPCBroker1.Param[2].Value := yesno + '^' + origdate + '^' + capdfn;
    frmMain.RPCBroker1.Param[2].PType := literal;
  End;
  If label1_1.Caption = 'Reprint a 21 Day Certificate' Then
  Begin
    If ((RadioButton1_2.Checked = true) And (dtpReportDate1.DateTime = 0)) And
      ((RadioButton1_1.Checked = false)) Then                                   //CodeCR85
    Begin
      ShowMessageCAPRI('Please select which one you would like to print.');
      exit;
    End;
    brkCall := 'DVBAB REPORTS';
    If RadioButton1_1.Checked = True Then
    Begin
      yesno := 'N';
      Origdate := '';
      CapDFN := PatientIEN;
    End
    Else
    Begin
      If FloatToStr(dtpReportDate1.DateTime) = '0' Then                         //CodeCR85
      Begin
        ShowMessageCAPRI('Pick a date first.');
        exit;
      End;
      yesno := 'D';
      OrigDate := FMToDateConvert(FormatDateTime('mm/dd/yyyy', dtpReportDate1.DateTime)); //CodeCR85
      CapDFN := '';
    End;

    frmMain.RPCBroker1.RemoteProcedure := brkCall;
    frmMain.RPCBroker1.Param[1].Value := '2';                                   // RE-PRINT 21 DAY CERTIFICATE
    frmMain.RPCBroker1.Param[1].PType := literal;
    frmMain.RPCBroker1.Param[2].Value := yesno + '^' + origdate + '^' + capdfn;
    frmMain.RPCBroker1.Param[2].PType := literal;

    If YesNo = 'N' Then
    Begin
      //exit if user has not selected an item to print - kcl 2/26/09
      If ORListBoxData1.ItemIndex = -1 then
      Begin
        ShowMessageCAPRI('Please select which one you would like to print.');
        Exit;
      End;
      frmMain.RPCBroker1.Param[2].Value := yesno + '^' + origdate + '^' + frmMain.Piece(ORListBoxData1.Items[ORListBoxData1.ItemIndex], '^', 1);
    End;
  End;

  DisplayBusyAnimation(True);
  panelreportchoice1.visible := False;
  frmMain.RPCBrokerCall;
  Try
    frmMain.RPCBroker1.Call;
  Except
    On EBrokerError Do
    Begin
      ANURemoteProcedureCallinProgress := False;
      ShowMessageCAPRI('RPC ' + brkCall + ' could not be accessed!');
      PanelReportChoice1.Visible := False;
    End;
  End;

  //CAPRI_CodeCR101 - jcs - 05/02/2010
  CapriQuickCopy(frmMain.RPCBroker1.Results, ReportMemo);
  If ReportMemo.Lines.count = 0 Then
    ReportMemo.Lines.Add('No data found for requested report criteria.');
  ReportMemo.SelStart := 0;
  ReportMemo.SelLength := 0;
  PanelReportChoice1.Visible := False;
  GroupBox3.Visible := False;
End;

Procedure Tfrmreports.Button6Click(Sender: TObject);
Begin
  PanelInsufficientExamReport.Visible := False;
  ORReportsAvailable.SetFocus;
End;


{
Note:  The insufficient report will be for historical purposes only after
patch 189 is installed. The report in the CAPRI GUI is filtered by
Priority of Exam and in patch 189 the Priority of Exam field was removed,
so there is no need to put in the Insufficient reason (report) field.
If the business decides to modify the insufficient exam report in the future,
we will need to capture the insufficient reason (.03 INSUFFICIENT REASON (REPORT).
}

Procedure Tfrmreports.Button5Click(Sender: TObject);
var
  InsuffReasonIEN: String;                                                      //CodeCR147 - rpm 11/1/10
  PriorityFilter: String;                                                       //CodeCR123 - rpm 11/2/10
  ADelimiter: String;                                                           // CodeCR470 JRL 4/2/13
  Filename: String;                                                             // CodeCR470 JRL 4/3/13
  DelimitedLines: TStringList;                                                  // CodeCR470 JRL 4/3/13
  AbbrevReportName: String;                                                     // CodeCR470 JRL 4/3/13
  ParameterList: String;                                                        // CodeCR709 JRL 6/17/15
Begin
  If dtpInsuffStart.DateTime = 0 Then                                           //CodeCR85
  Begin
    ShowMessageCAPRI('Please select a start date.');
    exit;
  End;
  If dtpInsuffEnd.DateTime = 0 Then                                             //CodeCR85
  Begin
    ShowMessageCAPRI('Please select an end date.');
    exit;
  End;

  if not IsPatchInstalled('DVBA*2.7*192') then                                  //CodeCR709 JRL 6/16/15 P192 Removes Priority of Exam filter and Insufficient Reason
  begin                                                                         //CodeCR709 JRL 6/16/15 P192 Removes Priority of Exam filter and Insufficient Reason
    if (FMComboboxInsuffReason.ItemIndex > -1) then                             //CodeCR147 - rpm 11/1/10
      InsuffReasonIEN := FMComboboxInsuffReason.GetSelectedRecord.IEN
    else
      InsuffReasonIEN := '';                                                    //defaults to ALL
    case rgInsuffPriorityOfExamFilter.ItemIndex of
      0: PriorityFilter := 'AO';
      1: PriorityFilter := 'BDD';
      2: PriorityFilter := 'IDES';                                              //CodeCR331 - LMS 12/18/2012
    else
      PriorityFilter := 'ALL';
    end;
  end;                                                                          //CodeCR709 JRL 6/16/15 P192 Removes Priority of Exam filter and Insufficient Reason

  case rgInsufficientRptFmt.ItemIndex of                                        // CodeCR470 JRL 4/2/13
    0: ADelimiter := '0';                                                       // No delimiter                // CodeCR470 JRL 4/2/13
    1: ADelimiter := '1';                                                       // Comma delimiter             // CodeCR470 JRL 4/2/13
  end;                                                                          // CodeCR470 JRL 4/2/13

  DisplayBusyAnimation(True);
  //CodeCR85, CodeCR147 - rpm 11/1/10, CodeCR123 - rpm 11/2/10

  AbbrevReportName := 'InsuffExam';                                             // CodeCR470 JRL 4/3/13
  DelimitedLines := TStringList.Create;                                         // CodeCR470 JRL 4/3/13
  try
    if IsPatchInstalled('DVBA*2.7*192') then                                    //CodeCR709 JRL 6/16/15 P192 Removes Priority of Exam filter
    begin
      ParameterList :=
//      Uppercase(Copy(RadioGroupInsuffDetailedSummary.Items[RadioGroupInsuffDetailedSummary.ItemIndex], 1, 1))
        'D'                                                                     // CodeCR709 - Always run detailed
        + '^'                                                                   // JRL 7/23/15 rpt after Patch 192
        + FMToDateConvert(FormatDateTime('mm/dd/yyyy', dtpInsuffStart.DateTime))
        + '^'
        + FMToDateConvert(FormatDateTime('mm/dd/yyyy', dtpInsuffEnd.DateTime))
        + '^'                                                                   // Remove optional Insufficient Reason IEN CodeCR709 JRL 6/19/15
        + '^'                                                                   // Remove Priority of Exam filter CodeCR709 JRL 6/19/15
        + '^'                                                                   // CodeCR470 JRL 4/2/13   Added delimiter for this report
        + ADelimiter;
    end
    else                                                                        // Patch 190 or earlier
    begin
      ParameterList :=
        Uppercase(Copy(RadioGroupInsuffDetailedSummary.Items[RadioGroupInsuffDetailedSummary.ItemIndex], 1, 1))
        + '^'
        + FMToDateConvert(FormatDateTime('mm/dd/yyyy', dtpInsuffStart.DateTime))
        + '^'
        + FMToDateConvert(FormatDateTime('mm/dd/yyyy', dtpInsuffEnd.DateTime))
        + '^'
        + InsuffReasonIEN
        + '^'
        + PriorityFilter
        + '^'                                                                   // CodeCR470 JRL 4/2/13   Added delimiter for this report
        + ADelimiter;
    end;
    if CallRPC(frmMain.RPCBroker1, 'DVBAB REPORTS',
      ['5', ParameterList], nil, False) then                                    // CodeCR470 JRL 4/2/13  // CodeCR709 JRL 6/16/15
    begin
      if (frmMain.RPCBroker1.Results.Count > 0) then
      begin
        if ADelimiter = '0' then                                                // Normal display report
        begin
          CapriQuickCopy(frmMain.RPCBroker1.Results, ReportMemo);               //CodeCR101 - jcs 5/2/10
        end
        else                                                                    // Delimited Report
        begin
          CAPRIQuickCopy(frmMain.RPCBroker1.Results, DelimitedLines);
          FileName := SaveDelimitedReportCSV(DelimitedLines, AbbrevReportName
            + '_'
            + FormatDateTime('YYYYMMDD', dtpInsuffStart.Date)
            + '_'
            + FormatDateTime('YYYYMMDD', dtpInsuffEnd.Date));
          ReportMemo.Lines.Insert(0, '');
          if (FileName <> '') then
            ReportMemo.Lines.Insert(0, IntToStr(DelimitedLines.Count)
              + ' Extract lines saved to: ' + #13#10
              + FileName)
          else
            ReportMemo.Lines.Insert(0, 'No delimited text lines were saved!');
        end;
      end;
    end;
    DisplayBusyAnimation(False);

    if ReportMemo.Lines.count = 0 then
      ReportMemo.Lines.Add('No data found for requested report criteria.');
    ReportMemo.SelStart := 0;
    ReportMemo.SelLength := 0;
    PanelInsufficientExamReport.Visible := False;
  finally
    FreeAndNil(DelimitedLines);
  end;
End;

Procedure Tfrmreports.FMComboBoxInsuffReasonExit(Sender: TObject);
Var
  x: integer;
Begin
  If FMComboBoxInsuffReason.Text = '' Then
    exit;
  For x := 0 To FMComboBoxInsuffReason.Items.Count - 1 Do
    If Pos(uppercase(FMComboBoxInsuffReason.Text), uppercase(FMComboBoxInsuffReason.Items[x])) = 1 Then
    Begin
      FMComboBoxInsuffReason.ItemIndex := x;
    End;
  If FMComboBoxInsuffReason.ItemIndex = -1 Then
  Begin
    ShowMessageCAPRI('The insufficient reason response is not valid.');
    FMComboBoxInsuffReason.Text := '';
    FMComboBoxInsuffReason.Setfocus;
    exit;
  End;
End;

Procedure Tfrmreports.RadioGroupInsuffDetailedSummaryClick(
  Sender: TObject);
Begin
  If RadioGroupInsuffDetailedSummary.ItemIndex = 1 Then
  Begin
    if not IsPatchInstalled('DVBA*2.7*192') then                                //CodeCR709 JRL 6/16/15 P192 Removes Priority of Exam filter
    begin
      GroupBoxInsufficientReason.Visible := False;
      FMComboBoxInsuffReason.Text := '';
    end;
    rgInsufficientRptFmt.Buttons[1].Enabled := False;                           // CodeCR471 JRL 08/09/13 Disable CSV save option in Summary Report
    GetScreenReader.Speak('Summary');                                           // rpk 7/14/2015
  End
  Else
  Begin
    if not IsPatchInstalled('DVBA*2.7*192') then                                //CodeCR709 JRL 6/16/15 P192 Removes Priority of Exam filter
      GroupBoxInsufficientReason.Visible := true;
    rgInsufficientRptFmt.Buttons[1].Enabled := True;                            // CodeCR471 JRL 08/09/13 Enable CSV save option in Detailed Report
    GetScreenReader.Speak('Detailed');                                          // rpk 7/14/2015
  End;
End;

procedure Tfrmreports.RadioGroupInsuffDetailedSummaryEnter(Sender: TObject);  // rpk 7/14/2015
begin
  RadioGroupInsuffDetailedSummaryClick(Sender);
end;

Procedure Tfrmreports.FMRegionalOfficeNumberEnter(Sender: TObject);
Var
  tempstring: String;
Begin
  If ANUReportsClosing = True Then
    exit;
  If frmROFinder.ShowModal = mrOK Then
  Begin
    FMRegionalOfficeNumeralFake.Text := frmMain.Piece(frmROFinder.ORListBoxSites.Items[frmROFinder.ORListBoxSites.ItemIndex], '^', 2);
    //CodeCR171 - rpm 4/28/11 - populate station number value to pass to RPC
    FROStationNumber := frmMain.Piece(frmMain.Piece(frmROFinder.ORListBoxSites.Items[frmROFinder.ORListBoxSites.ItemIndex], '^', 1), ' ', 1);
    tempString := frmROFinder.GetCurrentROName;                                 //CodeCR170 - rpm 3/10/11
    FMRegionalOfficeNumber.Text := tempstring;
    FMRegionalOfficeNumberFake.Text := tempstring;
  End;
  // -MER Patch149 11/2010
  // note: since this combo box is being used in a non-conventional way, it is
  // necessary for focus to pass to the next control to behave as the users are
  // accustomed
  if (ActiveControl = FMRegionalOfficeNumber) then
    SelectNext(ActiveControl as TWinControl, TRUE, TRUE);
End;

Procedure Tfrmreports.FormCloseQuery(Sender: TObject;
  Var CanClose: Boolean);
Begin
  ANUReportsClosing := True;
  // -MER 11/2010 In testing of Patch 149, a bug was discovered.  When this form
  // is closed, the text for FMRoutingLocation2 stays set, but the item index
  // gets set to -1.  This created a problem if the reports form was shown
  // again.  In order to prevent disagreement between the item index and the
  // displayed element, we now explicitly set both.
  FMRoutingLocation2.Text := '';
  FMRoutingLocation2.ItemIndex := -1;
End;

Procedure Tfrmreports.FormShow(Sender: TObject);
Begin
  ANUReportsClosing := False;
  //CodeCR296 - rpm 2/2/12 - removed FPatch149Installed check
  FPatch179Installed := IsPatchInstalled('DVBA*2.7*179');                       //CodeCR266 - rpm 1/24/12
End;

{==========================================================================
 GetPatient
 This function calls the CAPRI patient selector with a filter that screens
 for patients in the FEE BASIS PATIENT (#161) file and returns the selected
 patient's DFN.  Performing the lookup on the PATIENT (#2) file is successful,
 because both file #161 and #2 using the same record number (IEN) for a given
 patient.

 Input: none
 Output: patient DFN and True on success; otherwise returns '' and False
        on failure.
 CodeCR124 - rpm 7/15/10
 ==========================================================================}

function Tfrmreports.GetPatient(var aPatientDFN: String): Boolean;
begin
  Result := False;
  FeeBasisPatientIEN := '';
  frmPatientSelector := TfrmPatientList.Create(nil);
  try
    frmPatientSelector.btnCvrSelectPt.OnClick := PatientSelectClick;
    frmPatientSelector.FMCvrListBox1Pt.OnDblClick := PatientSelectDblClick;
    frmPatientSelector.PatientFilterType := pfFeeBasis;
    // -mer 12/10 Patch 149 - A bug was found in testing of 149: when the
    // demographics were viewed from the patient selector, the z order was
    // not correct and the modal message would appear behind the reports form.
    // This made the message box where it could not be viewed or closed.
    // In order to correct this, here we set the z order of the reports form
    // to the behind all forms with the topmost flag, but in front of all other
    // forms.
    SetWindowPos(Handle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE + SWP_NOSIZE);
    frmPatientSelector.ShowModal;
    if (FeeBasisPatientIEN <> '') then
    begin
      aPatientDFN := FeeBasisPatientIEN;
      Result := True;
    end;
  finally
    FreeAndNil(frmPatientSelector);
  end;
end;

{============================================================================
 IsNextPageNewPatient
 This function is used to determine the start of a new patient report for
 C&P Final Report formats.  It is hard-coded to search for 'Page: 1' at the
 end of the line of a report start and return TRUE whe 'Page: 1' is found;
 otherwise returns FALSE.

 CodeCR212 - rpm 11/3/11
 ============================================================================}

function Tfrmreports.IsNextPageNewPatient(currentIndex: Integer): Boolean;
var
  Page1Pos: Integer;
  Page1Text, TrimLine: String;
begin
  Result := False;
  if (currentIndex + 2 <= ReportMemo.Lines.Count - 1) then                      //prevent access past end of report
  begin
    Page1Text := 'Page: 1';
    TrimLine := TrimRight(ReportMemo.Lines[currentIndex + 2]);
    Page1Pos := Pos(Page1Text, TrimLine);
    if (Page1Pos > 0) and
      (Length(TrimLine) - Page1Pos = Length(Page1Text) - 1) then
      Result := True;                                                           {a Page 1 found at end of line}
  end;
end;

{========================================================================
 NormalBeforePrint
 This event procedure assigned to the Rave reports OnBeforePrint event
 provides custom setup.

 CodeCR212  rpm - 10/24/2011
 ========================================================================}

procedure Tfrmreports.NormalBeforePrint(Sender: TObject);
begin
  with Sender as TBaseReport do
  begin
    LineHeight := 0.147;                                                        //just to match existing QuickReports spacing
    if ORReportsAvailable.ItemIndex > -1 then
    begin
      if ORReportsAvailable.Items[ORReportsAvailable.ItemIndex] = 'Exam Requests by Date Range' then
        LineHeight := 0.1
    end;
  end;
end;

{========================================================================
 NormalPrint
 This event procedure assigned to the Rave reports OnPrint event.

 CodeCR212  rpm - 10/24/2011
 ========================================================================}

procedure Tfrmreports.NormalPrint(Sender: TObject);
var
  I, startLine: Integer;
  reportName: String;
  IsComposite: Boolean;
  currentLineHeight: Double;
begin
  with Sender as TBaseReport do
  begin
    startline := 0;
    FDtTm := '';                                                                //CodeCR199 - rpm 10/19/2011
    FDivision := '';                                                            //CodeCR199 - rpm 10/19/2011
    FFootDescrip := '';                                                         //CodeCR199 - rpm 10/19/2011
    reportName := '';
    IsComposite := False;

    {Get Date}
    frmMain.RPCBroker1.RemoteProcedure := 'DVBAB DATETIME';
    try
      frmMain.RPCBroker1.Call;
      if (frmMain.RPCBroker1.Results.Count > 0) then
        FDtTm := frmMain.RPCBroker1.Results[0];                                 //CodeCR199 - rpm 10/19/2011
    except
      on EBrokerError do
      begin
        ANURemoteProcedureCallInProgress := False;
      //jcs - d2006
      //frmMain.GIFImageVistaYellow.Animate := False;
        TGifImage(frmMain.GifImageVistaYellow.picture.Graphic).Animate := False;
        frmMain.StatusBarLoadPt.Caption := 'RPC DVBAB DATETIME could not be accessed!';
        frmMain.StatusBarLoadPt.Repaint;
        Application.Processmessages;
        ShowMessageCAPRI('DVBAB DATETIME could not be accessed!');
      end;
    end;

    {Get Division}
    frmMain.RPCBroker1.RemoteProcedure := 'XWB GET VARIABLE VALUE';
    frmMain.RPCBroker1.Param[0].Value := 'DUZ("2")';
    frmMain.RPCBroker1.Param[0].PType := reference;
    try
      frmMain.RPCBroker1.Call;
      if (frmMain.RPCBroker1.Results.Count > 0) then
        FDivision := frmMain.RPCBroker1.Results[0];                             //CodeCR199 - rpm 10/19/2011
    except
      on EBrokerError Do
      begin
        ANURemoteProcedureCallInProgress := False;
        //jcs - d2006
        //frmMain.GIFImageVistaYellow.Animate := False;
        TGifImage(frmMain.GifImageVistaYellow.picture.Graphic).Animate := False;
        frmMain.StatusBarLoadPt.Caption := 'RPC XWB GET VARIABLE VALUE could not be accessed!';
        frmMain.StatusBarLoadPt.Repaint;
        Application.Processmessages;
        ShowMessageCAPRI('XWB GET VARIABLE VALUE could not be accessed!');
      end;
    end;

    SetFont('Courier New', 10);                                                 //set default font

    Screen.Cursor := crHourGlass;
    frmmain.AnimateLogo(True);
    frmMain.StatusBarLoadPt.Caption := 'Printing...';
    frmMain.StatusBarLoadPt.Repaint;
    Application.Processmessages;

    if ORReportsAvailable.ItemIndex > -1 Then
    begin
      reportName := ORReportsAvailable.Items[ORReportsAvailable.ItemIndex];
      Ffootdescrip := 'REPORT: ' + reportName;                                  //CodeCR199 - rpm 10/19/2011

      //132-column reports
      if (reportName = 'C&P Exams Checklist') or
        (reportName = 'Exam Requests by Date Range') or
        (reportName = 'Request Status by Date Range') or                        //CodeCR266 - rpm 1/24/12
        (reportName = 'VR&E Status') then                                       //CodeCR347 - jrl 7/2/12
      begin
        SetFont('Courier New', 7);
      end
      else if (reportName = 'Re-Print C&P Final Report(s)') then
      begin
        SetFont('Courier New', 10);
      end
      else
        SetFont('Courier New', 11);

      if (reportName = 'Request Status by Date Range') then                     //CodeCR266 - rpm 1/24/12
        startLine := 5;                                                         //offset past report header

      //composite reports
      if (reportName = '21 Day Certificate Printing') or
        (reportName = 'Reprint a Notice of Discharge') or
        (reportName = 'Reprint a 21 Day Certificate') or
        (reportName = 'Re-Print C&P Final Report(s)') or
        (reportName = 'Insufficient Exam Report') then
      begin
        IsComposite := True;
      end;
    end;

    if ORReportsAvailable2.ItemIndex > -1 Then
    begin
      reportName := ORReportsAvailable2.Items[ORReportsAvailable2.ItemIndex];
      Ffootdescrip := 'REPORT: ' + reportName;                                  //CodeCR199 - rpm 10/19/2011

      //composite reports
      if (reportName = 'Print C&P Final Report (Manual)') or
        (reportName = 'Print New Notices of Discharge') then
      begin
        IsComposite := True;
      end;
    end;

    //Composite reports contain embedded Form Feeds
    if IsComposite = True then
    begin
      for I := startline To ReportMemo.Lines.Count - 1 do
      begin
        if ReportMemo.Lines[I] <> #$C Then
        begin
          PrintLine(TBaseReport(Sender), ReportMemo.Lines[I]);
          currentLineHeight := LineHeight;
          LineHeight := FFooterLineHeight;
          if (LinesLeft < 5) then
            if (I + 1 <= ReportMemo.Lines.Count - 1) and
              (ReportMemo.Lines[I + 1] <> #$C) then                             //prevent excess blank page
              NewPage;
          LineHeight := currentLineHeight;
        end
        else begin                                                              //received FormFeed (#$C) so start new page
          // -MER 12/10 if it is a Final report, add another page to ensure that
          // no physical page printed duplex will contain more than one patient
          if (reportName = 'Print C&P Final Report (Manual)') or
            (reportName = 'Re-Print C&P Final Report(s)') then
          begin
            if IsNextPageNewPatient(I) then
              PrintIntentionalBlank(TBaseReport(Sender));
          end;
          NewPage;
        end;
      end;
    end
    else                                                                        //NOT Composite report
    begin
      for I := startLine To ReportMemo.Lines.Count - 1 do                       //CodeCR266 - rpm 1/24/12
      begin
        PrintLine(TBaseReport(Sender), ReportMemo.Lines[I]);
        currentLineHeight := LineHeight;
        LineHeight := FFooterLineHeight;
        if (LinesLeft < 5) then                                                 //need 4 lines for footer
          NewPage;
        LineHeight := currentLineHeight;
      end;
    end;

    Screen.Cursor := crDefault;
    frmMain.AnimateLogo(False);
    frmMain.StatusBarLoadPt.Caption := 'Ready.';
    frmMain.StatusBarLoadPt.Repaint;
  end;
end;

{=========================================================================
 NormalPrintFooter
 This procedure is the OnPrintFooter event handler for normal reporting.

 CodeCR212 - rpm 10/24/2011
 =========================================================================}

procedure Tfrmreports.NormalPrintFooter(Sender: TObject);
var
  X, Y, currentLineHeight: double;
  SavedPen, LinePen: TPen;
begin
  with Sender as TBaseReport do begin
    currentLineHeight := LineHeight;
    LineHeight := FFooterLineHeight;
    SaveFont(1);
    SetFont('Arial', 10);
    SectionBottom := SectionBottom - (3 * LineHeight);
    GoToFooter;

    //Draw separator line
    SavedPen := Canvas.Pen;
    LinePen := CreatePen(clBlack, psSolid, 10, pmBlack);
    try
      Canvas.Pen := LinePen;
      X := XD2I(CursorXPos);
      Y := YD2I(CursorYPos);
      MoveTo(X, Y);
      LineTo(SectionRight, Y);
    finally
      Canvas.Pen := SavedPen;
      FreeAndNil(LinePen);
    end;

    //footer line 1
    SectionBottom := SectionBottom + LineHeight;
    PrintFooter(FFootDescrip, pjLeft);
    PrintFooter('Page: ' + IntToStr(CurrentPage), pjRight);

    //footer line 2
    SectionBottom := SectionBottom + LineHeight;
    PrintFooter('Printed on: ' + FDtTm, pjRight);

    //footer line 3
    SectionBottom := SectionBottom + LineHeight;
    PrintFooter('System: ' + Uppercase(frmMain.RPCBroker1.ANUStrServer), pjLeft);
    PrintFooter('Division: ' + FDivision, pjRight);
    LineHeight := currentLineHeight;
    RestoreFont(1);
  end;
end;

{=========================================================================
 NormalPrintHeader
 This procedure is the OnPrintHeader event handler for normal reports.

 CodeCR212 - rpm 10/24/2011
 =========================================================================}

procedure Tfrmreports.NormalPrintHeader(Sender: TObject);
begin
  with Sender as TBaseReport do
  begin
    if (FSpecRepDateRangeHdr <> '') then
    begin
      SaveFont(1);
      SetFont('Courier New', 10);
      Bold := True;
      PrintCenter(FSpecRepDateRangeHdr, (SectionLeft + SectionRight) / 2.0);
      Bold := False;
      NewLine;
      NewLine;
      RestoreFont(1);
    end;

    //CodeCR266 - rpm 1/24/12 - add date range and request status to header
    if (ORReportsAvailable.ItemIndex > -1) then
    begin
      if (ORReportsAvailable.Items[ORReportsAvailable.ItemIndex] = 'Request Status by Date Range')
        and (ReportMemo.Lines.Count > 4) then
      begin
        SaveFont(1);
        SetFont('Courier New', 10);
        Bold := True;
        PrintCenter(ReportMemo.Lines[0], (SectionLeft + SectionRight) / 2.0);   //date range
        NewLine;
        PrintCenter(ReportMemo.Lines[1], (SectionLeft + SectionRight) / 2.0);   //request status
        Bold := False;
        NewLine;
        NewLine;
        SetFont('Courier New', 7);
        PrintLn(ReportMemo.Lines[3]);                                           //column labels from server
        PrintLn(ReportMemo.Lines[4]);                                           //line separator from server
        RestoreFont(1);
      end;
    end;
  end;
end;

{=========================================================================
 GetHospAdjReportByDay
 Input:
   RPCName: String;
   AbbrevReportName: String;
   IsDelimited: Boolean

   This procedure was refactored out of the Button9Click event procedure
   in an attempt to consolidate duplicate functionality.
   The procedure generates a Hospital Adjustment report based on the
   remote procedure name associated with the report and supports delimited
   report results.
   NOTE: The data is collected one day at a time to prevent exceeding the
         partition size in VistA due to the use of local arrays.

  //CodeCR129 - rpm 10/19/10
 =========================================================================}

procedure Tfrmreports.GetHospAdjReportByDay(RPCName: String; AbbrevReportName: String; IsDelimited: Boolean);
var
  counter, y: Integer;
  DelimitedLines: TStringList;
  FileName, HospDom, DoYouWant: String;
  RPCSuccess: Boolean;
begin
  frmMain.RPCBroker1.Results.Clear;
  counter := StrToInt(Copy(FloatToStr(DateTimePicker1.Date), 1, Pos('.', FloatToStr(DateTimePicker1.Date)) - 1));
  PanelProgress.Visible := True;
  PanelProgress.Top := (frmReports.Height - PanelProgress.Height) Div 2;
  PanelProgress.Left := (frmReports.Width - PanelProgress.Width) Div 2;
  PanelProgress.Repaint;
  ProgressBar1.Min := 0;
  ProgressBar1.Max := StrToInt(Copy(FloatToStr(DateTimePicker2.Date), 1, Pos('.', FloatToStr(DateTimePicker2.Date)) - 1)) - Counter;
  ProgressBar1.Position := 0;
  RPCSuccess := False;
  FileName := '';
  DelimitedLines := TStringList.Create;
  case RadioGroupHospDom.ItemIndex of
    0: HospDom := 'H';
  else HospDom := 'D';
  end;
  case RadioGroupDoYouWant.ItemIndex of
    0: DoYouWant := 'A';
    1: DoYouWant := 'P';
    2: DoYouWant := 'S';
  else DoYouWant := 'L';
  end;

  try
    while Counter <= StrToInt(Copy(FloatToStr(DateTimePicker2.Date), 1, Pos('.', FloatToStr(DateTimePicker2.Date)) - 1)) Do
    begin
      DisplayBusyAnimation(True);
      frmMain.RPCBroker1.Results.Clear;
      if (RPCName = 'DVBAB REPORT ADMISSIONS') or
        (RPCName = 'DVBAB REPORT INCOMPVET') then
      begin
        //CodeCR296 - rpm 2/2/12 - removed FPatch149Installed check
        RPCSuccess := CallRPC(frmMain.RPCBroker1, RPCName,
          [FMToDateConvert(FormatDateTime('mm/dd/yyyy', counter)),
          FMToDateConvert(FormatDateTime('mm/dd/yyyy', counter)) + '.9999',
            GetDelimitedParam(IsDelimited)],
            nil, False)
      end
      else if (RPCName = 'DVBAB REPORT READMIT') then
      begin
        //CodeCR296 - rpm 2/2/12 - removed FPatch149Installed check
        RPCSuccess := CallRPC(frmMain.RPCBroker1, RPCName,
          [FMToDateConvert(FormatDateTime('mm/dd/yyyy', counter)),
          FMToDateConvert(FormatDateTime('mm/dd/yyyy', counter)) + '.9999',
            HospDom,
            GetDelimitedParam(IsDelimited)],
            nil, False)
      end
      else if (RPCName = 'DVBAB REPORT DISCHARGE') then
      begin
        //CodeCR296 - rpm 2/2/12 - removed FPatch149Installed check
        RPCSuccess := CallRPC(frmMain.RPCBroker1, RPCName,
          [FMToDateConvert(FormatDateTime('mm/dd/yyyy', counter)),
          FMToDateConvert(FormatDateTime('mm/dd/yyyy', counter)) + '.9999',
            DoYouWant,
            GetDelimitedParam(IsDelimited)],
            nil, False)
      end;

      if RPCSuccess then
      begin
        ReportMemo.Visible := False;
        If (frmMain.RPCBroker1.Results.Count > 0) Then
        begin
          if NOT AnsiStartsText('NO DATA FOUND', frmMain.RPCBroker1.Results[0]) Then
            For y := 0 To frmMain.RPCBroker1.Results.Count - 1 Do
            begin
              if IsDelimited then
                DelimitedLines.Add(frmMain.RPCBroker1.Results[y])
              else
                ReportMemo.Lines.Add(frmMain.RPCBroker1.Results[y]);
            end;
        end;
        ReportMemo.Visible := True;
        counter := counter + 1;
        ProgressBar1.Position := ProgressBar1.Position + 1;
        Application.ProcessMessages;
      end;
    end;

    DisplayBusyAnimation(False);
    PanelProgress.Visible := False;

    if (DelimitedLines.Count > 0) then
    begin
      FileName := SaveDelimitedReport(DelimitedLines, AbbrevReportName
        + '_'
        + FormatDateTime('YYYYMMDD', DateTimePicker1.Date)
        + '_'
        + FormatDateTime('YYYYMMDD', DateTimePicker2.Date));
      ReportMemo.Lines.Insert(0, '');
      if (FileName <> '') then
      begin
        ReportMemo.Lines.Insert(0, IntToStr(DelimitedLines.Count)
          + ' Extract lines saved to: ' + #13#10
          + FileName);
      end
      else
        ReportMemo.Lines.Insert(0, 'No delimited text lines were saved!');
    end;

    if (ReportMemo.Lines.Count = 0) and (DelimitedLines.Count = 0) then
      ReportMemo.Lines.Add('No data found for parameters entered.');
    ReportMemo.Visible := True;
    ReportMemo.Lines.Insert(0, '');
    if not IsDelimited then                                                     //CodeCR470 JRL 7/18/13
      ReportMemo.Lines.Insert(0, 'DATE RANGE:  ' + FormatDateTime('mm/dd/yyyy', DateTimePicker1.Date) + ' TO ' + FormatDateTime('mm/dd/yyyy', DateTimePicker2.Date));
    ReportMemo.SelStart := 0;
    ReportMemo.SelLength := 0;
  finally
    FreeAndNil(DelimitedLines);
  end;
end;

{=========================================================================
 GetFeeBasisReport
 Input:
   ReportName: String;
   IsDelimited: Boolean

   This procedure generates a Fee Basis report based on the Report Name
   contained in the LabelReportChoice2.Caption and supports delimited
   report results.  The supported Fee Basis reports are: CNH Roster Print,
   CNH Report of Admissions/Discharges, and CNH Stays in Excess of 90 Days.

  //CodeCR124 - rpm 10/19/10
 =========================================================================}

procedure Tfrmreports.GetFeeBasisReport(ReportName: String; IsDelimited: Boolean);
var
  DelimitedLines: TStringList;
  AbbrevReportName, FileName, FilePath: String;
  NoDataResults, InfoHdr, DelimitedParam: String;
  RPCSuccess: Boolean;
begin
  Reportmemo.Lines.Clear;
  FileName := '';
  FilePath := '';
  NoDataResults := '';
  InfoHdr := '';
  DelimitedLines := TStringList.Create;
  RPCSuccess := False;
  if IsDelimited then
    DelimitedParam := '1'
  else
    DelimitedParam := '0';

  try
    DisplayBusyAnimation(True);
    if (ReportName = 'CNH Roster Print') then
    begin
      RPCSuccess := CallRPC(frmMain.RPCBroker1, 'DVBAB REPORTS',
        ['11', DelimitedParam], nil, False);
      if not IsDelimited then                                                   //CodeCR470 JRL 7/18/13
        InfoHdr := 'Date Run: ' + FormatDateTime('mm/dd/yyyy', Now);
      AbbrevReportName := 'CNHRosterPrint';
      FileName := AbbrevReportName + '_'
        + FormatDateTime('YYYYMMDD', Now);
    end
    else if (ReportName = 'CNH Report of Admissions/Discharges') then
    begin
      RPCSuccess := CallRPC(frmMain.RPCBroker1, 'DVBAB REPORTS',
        ['12',
        FMToDateConvert(FormatDateTime('mm/dd/yyyy', DateTimePicker1.Date))
          + '^'
          + FMToDateConvert(FormatDateTime('mm/dd/yyyy', DateTimePicker2.Date))
          + '^'
          + DelimitedParam], nil, False);
      if not IsDelimited then                                                   //CodeCR470 JRL 7/18/13
        InfoHdr := 'Date Range: ' + FormatDateTime('mm/dd/yyyy', DateTimePicker1.Date) + ' TO ' + FormatDateTime('mm/dd/yyyy', DateTimePicker2.Date);
      AbbrevReportName := 'CNHAdmissionDischarge';
      FileName := AbbrevReportName + '_'
        + FormatDateTime('YYYYMMDD', DateTimePicker1.Date)
        + '_'
        + FormatDateTime('YYYYMMDD', DateTimePicker2.Date);
    end
    else if (ReportName = 'CNH Stays in Excess of 90 Days') then
    begin
      RPCSuccess := CallRPC(frmMain.RPCBroker1, 'DVBAB REPORTS',
        ['13',
        FMToDateConvert(FormatDateTime('mm/dd/yyyy', DateTimePicker1.Date))
          + '^'
          + DelimitedParam], nil, False);
      if not IsDelimited then                                                   //CodeCR470 JRL 7/18/13
        InfoHdr := 'Effective Date: ' + FormatDateTime('mm/dd/yyyy', DateTimePicker1.Date);
      AbbrevReportName := 'CNHStaysExcess90Days';
      FileName := AbbrevReportName + '_'
        + FormatDateTime('YYYYMMDD', DateTimePicker1.Date);
    end;

    if RPCSuccess then
      if (frmMain.RPCBroker1.Results.Count > 0) then
        if NOT AnsiStartsText('NO DATA FOUND', frmMain.RPCBroker1.Results[0]) then
        begin                                                                   {Start reportable data found}
          if IsDelimited then                                                   {Start delimited text report processing}
          begin
            CAPRIQuickCopy(frmMain.RPCBroker1.Results, DelimitedLines);
            if (DelimitedLines.Count > 0) then
//            FilePath := SaveDelimitedReport(DelimitedLines, FileName);
              FilePath := SaveDelimitedReportCSV(DelimitedLines, FileName);     // CodeCR470 JRL 4/15/13
          end                                                                   {End delimited text report processing}
          else                                                                  {Plain text report processing}
            CAPRIQuickCopy(frmMain.RPCBroker1.Results, Reportmemo);
        end                                                                     {End reportable data found}
        else                                                                    //No reportable data found
          NoDataResults := frmMain.RPCBroker1.Results[0];

    DisplayBusyAnimation(False);

    if IsDelimited then                                                         {Display delimited processing results}
    begin
      ReportMemo.Lines.Add(InfoHdr);
      ReportMemo.Lines.Add('');
      if (DelimitedLines.Count > 0) then                                        //Saveable result returned
      begin
        if (FilePath <> '') then                                                //Successful save
        begin
          ReportMemo.Lines.Add(IntToStr(DelimitedLines.Count) + ' Extract lines saved to: ');
          ReportMemo.Lines.Add(FilePath);
        end
        else                                                                    //Aborted save
          ReportMemo.Lines.Add('No delimited text lines were saved!');
      end
      else                                                                      //No saveable results returned
        ReportMemo.Lines.Add(NoDataResults);
    end;

    ReportMemo.Visible := True;
    ReportMemo.SelStart := 0;
    ReportMemo.SelLength := 0;
  finally
    FreeAndNil(DelimitedLines);
  end;
end;

{=========================================================================
 GetAdmissionInquiryByDate
 Input: IsDelimited: Boolean

 This procedure was refactored out of the Button9Click event procedure to
 encapsulate the Admission Inquiry by Date report.  The procedure supports
 both plain text and delimited format.

  //CodeCR129 - rpm 10/13/10
 =========================================================================}

procedure Tfrmreports.GetAdmissionInquiryByDate(IsDelimited: Boolean);
var
  DelimitedLines: TStringList;
  AbbrevReportName, FileName, FilePath: String;
  RegOfcNum, RegOfcYesNo: String;
  RPCSuccess: Boolean;
begin
  frmMain.RPCBroker1.Results.Clear;
  DelimitedLines := TStringList.Create;
  AbbrevReportName := 'AdmissionInquiryByDateReport';
  FileName := AbbrevReportName + '_'
    + FormatDateTime('YYYYMMDD', DateTimePicker1.Date)
    + '_'
    + FormatDateTime('YYYYMMDD', DateTimePicker2.Date);
  if (FMRegionalOfficeNumeralFake.Text = '') then
  begin
    RegOfcYesNo := 'N';
    RegOfcNum := '0';
  end
  else
  begin
    RegOfcYesNo := 'Y';
    RegOfcNum := FROStationNumber;                                              //CodeCR171 - rpm 4/28/11

  end;
  try
    DisplayBusyAnimation(True);
    //CodeCR296 - rpm 2/2/12 - removed FPatch149Installed check
    RPCSuccess := CallRPC(frmMain.RPCBroker1, 'DVBAB REPORT ADMINQ',
      [FMToDateConvert(FormatDateTime('mm/dd/yyyy', DateTimePicker1.DateTime)),
      FMToDateConvert(FormatDateTime('mm/dd/yyyy', DateTimePicker2.DateTime + 1)),
        RegOfcYesNo,
        RegOfcNum,
        GetDelimitedParam(IsDelimited)], nil, False);

    if RPCSuccess then
    begin
      ReportMemo.Visible := False;
      if frmMain.RPCBroker1.Results.Count > 0 then
        if NOT AnsiStartsText('NO DATA FOUND', frmMain.RPCBroker1.Results[0]) then
          if IsDelimited then
            CAPRIQuickCopy(frmMain.RPCBroker1.Results, DelimitedLines)
          else
            CAPRIQuickCopy(frmMain.RPCBroker1.Results, Reportmemo);
    end;

    DisplayBusyAnimation(False);

    if (DelimitedLines.Count > 0) then
    begin
//      FilePath := SaveDelimitedReport(DelimitedLines, FileName);
      FilePath := SaveDelimitedReportCSV(DelimitedLines, FileName);             // CodeCR470 JRL 4/15/13
      ReportMemo.Lines.Insert(0, '');
      if (FilePath <> '') then
        ReportMemo.Lines.Insert(0, IntToStr(DelimitedLines.Count)
          + ' Extract lines saved to: ' + #13#10
          + FilePath)
      else
        ReportMemo.Lines.Insert(0, 'No delimited text lines were saved!');
    end;

    If (ReportMemo.Lines.Count = 0) and (DelimitedLines.Count = 0) Then
      ReportMemo.Lines.Add('No data found for parameters entered.');
    if IsDelimited then
      ReportMemo.Lines.Insert(0, '')                                            //only insert space when delimited to maintain existing text format
    else
      ReportMemo.Lines.Insert(0, 'DATE RANGE:  ' + FormatDateTime('mm/dd/yyyy', DateTimePicker1.Date) + ' TO ' + FormatDateTime('mm/dd/yyyy', DateTimePicker2.Date)); // don't display on delimited reports
    ReportMemo.Visible := True;
    ReportMemo.SelStart := 0;
    ReportMemo.SelLength := 0;
  finally
    FreeAndNil(DelimitedLines);
  end;
end;

{==========================================================================
 GetAMIS290Report
 Input:  IsByDivision : Boolean

 This procedure was refactored out of the Button9Click event procedure to
 encapsulate the AMIS 290 and AMIS 290 by Division reports.  The procedure
 generates an AMIS 290 or AMIS 290 by Division based on the IsByDivision
 input parameter.

 CodeCR123 - rpm 11/2/10
 ==========================================================================}

procedure Tfrmreports.GetAMIS290Report(IsByDivision: Boolean);
var
  SendToMailMan: String;
  PriorityFilter: String;
  RegionOffice: String;
  RPCSuccess: Boolean;
begin
  if IsByDivision then
    RegionOffice := FMRegionalOfficeNumberFake.Text
      + '^'
      + Piece(FMRoutingLocation2.Items[FMRoutingLocation2.ItemIndex], '^', 2)
  else
    RegionOffice := FMRegionalOfficeNumberFake.Text;

  if CheckboxMailMan.Checked then
    SendToMailMan := 'Y'
  else
    SendToMailMan := 'N';

  case rgPriorityOfExamFilter.ItemIndex of
    0: PriorityFilter := 'AO';
    1: PriorityFilter := 'BDD';
    2: PriorityFilter := 'IDES';                                                //CodeCR331 - LMS 12/18/2012
  else
    PriorityFilter := 'ALL';
  end;

  frmMain.RPCBroker1.Results.Clear;
  DisplayBusyAnimation(True);
  //CodeCR296 - rpm 2/2/12 - removed FPatch149Installed check
  RPCSuccess := CallRPC(frmMain.RPCBroker1, 'DVBAB AMIS REPORT',
    [FMToDateConvert(FormatDateTime('mm/dd/yyyy', DateTimePicker1.Date)),
    FMToDateConvert(FormatDateTime('mm/dd/yyyy', DateTimePicker2.Date)),
      RegionOffice,
      SendToMailMan,
      AuthorIEN,
      PriorityFilter], nil, False);

  if RPCSuccess then
    if (frmMain.RPCBroker1.Results.Count > 0) then
    begin
      CapriQuickCopy(frmMain.RPCBroker1.Results, ReportMemo);                   //CodeCR101 - jcs 5/2/10
      if IsByDivision then
        Reportmemo.Lines.Insert(0, 'Division: ' + Piece(FMRoutingLocation2.Items[FMRoutingLocation2.ItemIndex], '^', 1));
    end;
  DisplayBusyAnimation(False);
  if ReportMemo.Lines.count = 0 then
    ReportMemo.Lines.Add('No data found for requested report criteria.');
end;

{==========================================================================
 GetEpisodeOfCare
 Input: aPatientDFN - PATIENT (#2) file record #
 Output: none

 This procedure prompts the user to select an Episode Of Care for a given
 patient, retrieves the display text from the server and populates the
 report memo.

 CodeCR124 - rpm 7/15/10
 ==========================================================================}

procedure Tfrmreports.GetEpisodeOfCare(aPatientDFN: String);
var
  frmEpisodeOfCare: TfrmEpisodeOfCare;
begin
  if (aPatientDFN <> '') then
  begin
    frmEpisodeOfCare := TfrmEpisodeOfCare.Create(nil);
    frmEpisodeOfCare.FMListAdmitDtTm.Screen := 'I $P(^(0),U,3)="A"&($P(^(0),U,2)=' + aPatientDFN + ')';
    try
      if (frmEpisodeOfCare.ShowModal = mrOK) then
      begin
        Reportmemo.Lines.Clear;
        if CallRPC(frmMain.RPCBroker1, 'DVBAB REPORTS', ['10', (aPatientDFN + '^' + frmEpisodeOfCare.EpisodeOfCareIFN)], nil, False) then
          if (frmMain.RPCBroker1.Results.Count > 0) then
            Reportmemo.Lines := frmMain.RPCBroker1.Results
          else
            Reportmemo.Lines.Add('No results returned');
      end;
    finally
      FreeAndNil(frmEpisodeOfCare);
    end;
  end;
end;

Procedure Tfrmreports.ORReportsAvailable2Click(Sender: TObject);
Begin
  ORReportsAvailable.ItemIndex := -1;
  GroupBoxInfo.Visible := False;
  RadioButton1_1.Caption := 'For patient ' + PatientName;
  GroupBox3.Visible := False;
  PanelInsufficientExamReport.Visible := False;
  PanelReportChoice1.Visible := False;
  PanelReportChoice2.Visible := False;
  PanelReportChoice3.Visible := False;

  actFilePrintOne.Enabled := False;

  If ORReportsAvailable2.ItemIndex = 0 Then
  Begin
    frmMain.RPCBroker1.Results.Clear;
    If ReadOnlyMode = True Then
    Begin
      ShowMessageCAPRI('You cannot run this report due to the DVBA CAPRI READ ONLY security key that you''ve been assigned.');
      exit;
    End;
    If
      MessageDlgCAPRI('WARNING:  This report will extract all unprinted exams, record your name as the person who printed, and will change the status to "PRINTED BY RO" so that they cannot again be printed automatically.  Are you sure you want to continue?',
      mtConfirmation, [mbYes, mbNo], 0) <> mrYes Then
    Begin
      exit;
    End;
    frmMain.RPCBroker1.RemoteProcedure := 'DVBAB REPORTS';
    frmMain.RPCBroker1.Param[1].Value := '3';                                   // C&P FINAL (MANUAL)
    frmMain.RPCBroker1.Param[1].PType := literal;
    frmMain.RPCBroker1.Param[2].Value := '';                                    //
    frmMain.RPCBroker1.Param[2].PType := literal;
    DisplayBusyAnimation(True);
    frmMain.RPCBrokerCall;
    Try
      frmMain.RPCBroker1.Call;
    Except
      On EBrokerError Do
      Begin
        ShowMessageCAPRI('RPC DVBAB REPORTS could not be accessed!');
      End
    End;
    //CAPRI_CodeCR101 - jcs - 05/02/2010
    CapriQuickCopy(frmMain.RPCBroker1.Results, ReportMemo);
    If ReportMemo.Lines.count = 0 Then
      ReportMemo.Lines.Add('No data found for requested report criteria.');
    ReportMemo.SelStart := 0;
    ReportMemo.SelLength := 0;
    ReportMemo.Setfocus;
  End;
  If ORReportsAvailable2.ItemIndex = 1 Then
  Begin
    frmMain.RPCBroker1.Results.Clear;
    If ReadOnlyMode = True Then
    Begin
      ShowMessageCAPRI('You cannot run this report due to the DVBA CAPRI READ ONLY security key that you''ve been assigned.');
      exit;
    End;
    If
      MessageDlgCAPRI('WARNING:  This report will print new deaths, d/c''s to nursing homes, and 7131 d/c notifications.  Once run, they will be set as printed and the re-print must be used to re-run specific notifications.',
      mtConfirmation, [mbYes, mbNo], 0) <> mrYes Then
    Begin
      exit;
    End;
    frmMain.RPCBroker1.RemoteProcedure := 'DVBAB REPORT NEW NOTICES DC';
    DisplayBusyAnimation(True);
    frmMain.RPCBrokerCall;
    Try
      frmMain.RPCBroker1.Call;
    Except
      On EBrokerError Do
      Begin
        ShowMessageCAPRI('RPC DVBAB REPORT NEW NOTICES DC could not be accessed!');
      End
    End;
    //CAPRI_CodeCR101 - jcs - 05/02/2010
    CapriQuickCopy(frmMain.RPCBroker1.Results, ReportMemo);
    If ReportMemo.Lines.count = 0 Then
      ReportMemo.Lines.Add('No data found for requested report criteria.');
    ReportMemo.SelStart := 0;
    ReportMemo.SelLength := 0;
    ReportMemo.Setfocus;
  End;

  DisplayBusyAnimation(False);
End;

Procedure Tfrmreports.QRCompositeReport1AddReports(Sender: TObject);
Var
  x: integer;
  tempQuickRep: TQuickRep;
Begin
  With QRCompositeReport1 Do
  Begin
    If formPrintVirtualCounter > 0 Then
      For x := 1 To formPrintVirtualCounter Do
      Begin
        tempQuickRep := formPrintVirtual[x].findComponent('QuickRep1') As TQuickRep;
        reports.add(tempQuickRep);
      End;
  End;
End;

Procedure Tfrmreports.Button8Click(Sender: TObject);
Var
  x, y: integer;
  temptext, temptext2: String;
  include: boolean;
  ADelimiter: string;
  Filename: String;                                                             // CodeCR470 JRL 4/10/13
  DelimitedLines: TStringList;                                                  // CodeCR470 JRL 4/10/13
  AbbrevReportName: String;                                                     // CodeCR470 JRL 4/10/13
Begin
  If labelDatePanel.Caption = 'Template Activity' Then
  Begin
    If DateTimePicker3.Date > DateTimePicker4.Date Then
    Begin
      ShowMessageCAPRI('Start date cannot be greater than stop date.');
      exit;
    End;
    case rgExportFormat.ItemIndex of                                            //CodeCR470 - JRL 4/18/13
      0: ADelimiter := '0';                                                     //CodeCR470 - JRL 4/18/13
      1: ADelimiter := '1';                                                     //CodeCR470 - JRL 4/18/13
    end;                                                                        //CodeCR470 - JRL 4/18/13

    DisplayBusyAnimation(True);
    rgExportFormat.Visible := False;                                            //CodeCR470 - JRL 4/18/13 (this control is new to this form)
    PanelReportDateRange.Visible := False;
    frmMain.RPCBroker1.Results.Clear;
    frmMain.RPCBroker1.RemoteProcedure := 'DVBAB TEMPLATE REPORT FULL';
    frmMain.RPCBroker1.Param[1].Value := FMToDateConvert(FormatDateTime('mm/dd/yyyy', DateTimePicker3.DateTime));
    frmMain.RPCBroker1.Param[1].PType := literal;
    frmMain.RPCBroker1.Param[2].Value := FMToDateConvert(FormatDateTime('mm/dd/yyyy', DateTimePicker4.DateTime));
    frmMain.RPCBroker1.Param[2].PType := literal;
    frmMain.RPCBroker1.Param[3].Value := ADelimiter;
    frmMain.RPCBroker1.Param[3].PType := literal;
    frmMain.RPCBroker1.Call;

    ListBoxSort.Items.Clear;
    ListBoxSort.Sorted := False;

    If frmMain.RPCBroker1.Results.Count > 0 Then
    begin
      if ADelimiter = '1' then                                                  // delimited report                              // CodeCR470 JRL 4/18/13
      begin                                                                     // CodeCR470 JRL 4/18/13
        AbbrevReportName := 'TemplateActivity';                                 // CodeCR470 JRL 4/18/13
        DelimitedLines := TStringList.Create;                                   // CodeCR470 JRL 4/18/13
        try                                                                     // CodeCR470 JRL 4/18/13
          CAPRIQuickCopy(frmMain.RPCBroker1.Results, DelimitedLines);           // CodeCR470 JRL 4/18/13
          FileName := SaveDelimitedReportCSV(DelimitedLines, AbbrevReportName   // CodeCR470 JRL 4/18/13
            + '_'
            + FormatDateTime('YYYYMMDD', DateTimePicker3.Date)
            + '_'
            + FormatDateTime('YYYYMMDD', DateTimePicker4.Date));
          ReportMemo.Lines.Insert(0, '');                                       // CodeCR470 JRL 4/18/13
          ReportMemo.Visible := True;                                           // CodeCR470 JRL 4/18/13
          if (FileName <> '') then                                              // CodeCR470 JRL 4/18/13
            ReportMemo.Lines.Insert(0, IntToStr(DelimitedLines.Count)           // CodeCR470 JRL 4/18/13
              + ' Extract lines saved to: ' + #13#10
              + FileName)
          else                                                                  // CodeCR470 JRL 4/18/13
            ReportMemo.Lines.Insert(0, 'No delimited text lines were saved!');  // CodeCR470 JRL 4/18/13
        finally                                                                 // CodeCR470 JRL 4/18/13
          FreeAndNil(DelimitedLines);                                           // CodeCR470 JRL 4/18/13
        end;                                                                    // try                                                            // CodeCR470 JRL 4/18/13
      end                                                                       // ADelimiter = '1'                                                  // CodeCR470 JRL 4/18/13
      else                                                                      // regular report
      begin
      // First, set up a sort in a hidden listbox
        For x := 0 To frmMain.RPCBroker1.Results.Count - 1 Do
        Begin
          If RadioGroupSortCriteria.ItemIndex = 0 Then                          // Date Created
            ListBoxSort.Items.Add('^' + inttostr(x));
          If RadioGroupSortCriteria.ItemIndex = 1 Then                          // Date Created
            ListBoxSort.Items.Add(Piece(frmMain.RPCBroker1.Results[x], '^', 1) + '^' + inttostr(x));
          If RadioGroupSortCriteria.ItemIndex = 2 Then                          // Author
            ListBoxSort.Items.Add(Piece(frmMain.RPCBroker1.Results[x], '^', 2) + '^' + inttostr(x));
          If RadioGroupSortCriteria.ItemIndex = 3 Then                          // Date Created
            ListBoxSort.Items.Add(Piece(frmMain.RPCBroker1.Results[x], '^', 5) + '^' + inttostr(x));
        End;                                                                    // for
        ListBoxSort.Sorted := True;

        // Now that it's sorted, go pull the records from the broker results
        // and build the report
        ReportMemo.Visible := False;
        If ListBoxSort.Items.Count > 0 Then
          For x := 0 To ListBoxSort.Items.Count - 1 Do
          Begin
            temptext := frmMain.RPCBroker1.Results[strtoint(piece(ListBoxSort.Items[x], '^', 2))];
            include := true;
            If RadioGroupStatus.ItemIndex = 1 Then
              If piece(TempText, '^', 5) = 'COMPLETE' Then
                include := false;
            If RadioGroupStatus.ItemIndex = 2 Then
              If piece(TempText, '^', 5) <> 'COMPLETE' Then
                include := false;
            If Include = True Then
            Begin
              ReportMemo.Lines.Add(
                Copy('Pt: ' + Piece(TempText, '^', 1) + '                              ', 1, 30) + ' ' +
                Copy('Author: ' + Piece(TempText, '^', 2) + '                              ', 1, 26) + ' ' +
                Copy('Status: ' + Piece(TempText, '^', 5) + '                              ', 1, 26));
              temptext2 := Piece(TempText, '^', 4);                             // Date Signed
              If temptext2 = 'JAN 1,1980' Then
                temptext2 := 'UNSIGNED';
              ReportMemo.Lines.Add('    ' +
                Copy('Created: ' + Piece(TempText, '^', 3) + '                              ', 1, 30) +
                Copy('Signed: ' + TempText2 + '                              ', 1, 30));
              y := 2;                                                           // First piece should always be blank
              TempText2 := Piece(TempText, '^', 6);                             // Form Names
              If Piece(TempText2, '|', y) <> '' Then
                Repeat
                  ReportMemo.Lines.Add('    ' + Piece(TempText2, '|', y));
                  inc(y);
                Until Piece(TempText2, '|', y) = '';
            End;                                                                // if Include
          End;                                                                  // For
        ReportMemo.Visible := True;
        // Get ReportMemo to top
        ReportMemo.Lines.Insert(0, '');
        ReportMemo.Lines.Insert(0, 'DATE RANGE: ' + DateToStr(DateTimePicker3.Date) + ' to ' + DateToStr(DateTimePicker4.Date));
      end;                                                                      // else regular report
    end;                                                                        // if Results.Count > 1

    If ReportMemo.Lines.count = 0 Then
      ReportMemo.Lines.Add('No data found for requested report criteria.');
    ReportMemo.SelStart := 0;
    ReportMemo.SelLength := 0;
  End;                                                                          // If Caption = Template Activity
End;

Procedure Tfrmreports.Button7Click(Sender: TObject);
Begin
  PanelReportDateRange.Visible := False;
  ORReportsAvailable.SetFocus;
End;

Procedure Tfrmreports.FormActivate(Sender: TObject);
Begin
  If not IsPatchInstalled('DVBA*2.7*192') then
  begin
    rgInsuffPriorityOfExamFilter.Visible := TRUE;
  end;


  frmMain.labeldivision.caption := '';
  If ESSOVersion = True Then
  Begin
    frmMain.labeldivision.visible := true;
    frmMain.RPCBroker1.RemoteProcedure := 'DVBAB SET DIVISION';
    frmMain.RPCBroker1.Param[1].Value := RemoteUserDivisionNumber;
    frmMain.RPCBroker1.Param[1].PType := literal;

    Try
      frmMain.RPCBroker1.Call;
    Except
      On EBrokerError Do
      Begin
        ANURemoteProcedureCallInProgress := False;
        frmMain.AnimateLogo(False);
        frmMain.StatusBarLoadPt.Caption := 'RPC DVBAB SET DIVISION could not be accessed!';
        frmMain.StatusBarLoadPt.Repaint;
        Application.Processmessages;
        ShowMessageCAPRI('DVBAB SET DIVISION could not be accessed!');
      End;
    End;
    Try
      If piece(frmMain.RPCBroker1.results[0], '^', 1) = '0' Then
      Begin
        frmMain.LabelDivision.Caption := 'Division: Set division failed!';
        ShowmessageCAPRI('WARNING:  There was a problem setting the user''s division.  Some reports may not function correctly.  ' + piece(frmMain.RPCBroker1.results[0], '^', 2));
      End
      Else
      Begin
        // User's division IEN is in piece 1, but we don't need it right now.
        frmMain.LabelDivision.caption := 'Division: ' + piece(frmMain.RPCBroker1.results[0], '^', 2);
      End;
    Except
      Begin
      End;
    End;
  End
  Else
  Begin
    // Non-remote mode
    frmMain.labelDivision.Caption := 'Division: ' + UserDivision;
  End;
  frmMain.PanelDivision.Width := frmMain.labelDivision.Width + 8;

  If frmMain.labelDivision.Caption = '' Then
  Begin
    ShowmessageCAPRI('WARNING:  There was a problem setting the user''s division.  Please check the host system and log in again.  If the problem continues, notify your IT support service.');
    frmMain.timerhalt.enabled := true;
  End;
  EditInstructions.Setfocus;
End;

Procedure Tfrmreports.PanelReportChoice1Click(Sender: TObject);
Begin
  ORReportsAvailable.SetFocus;
End;

procedure Tfrmreports.panelReportChoice2Click(Sender: TObject);
begin

end;

{=============================================================================
 PatientSelectClick
 This event procedure wraps the TfrmPatientList.btnCvrSelectPtClick event
 procedure defined in patientlist.pas to prevent modifying PatientIEN and
 PatientIENDOD global variables when selecting a patient for FBCNH Display
 Episode of Care option.

 CodeCR124 - rpm 7/13/10
 =============================================================================}

procedure Tfrmreports.PatientSelectClick(Sender: TObject);
var
  SavePatientIEN, SavePatientIENDOD: String;
begin
  SavePatientIEN := PatientIEN;
  SavePatientIENDoD := PatientIENDoD;
  PatientIEN := '';
  PatientIENDoD := '';
  FeeBasisPatientIEN := '';
  try
    frmPatientSelector.btnCvrSelectPtClick(Sender);
    FeeBasisPatientIEN := PatientIEN;
  finally
    PatientIEN := SavePatientIEN;
    PatientIENDoD := SavePatientIENDoD;
  end;
end;

{=============================================================================
 PatientSelectDblClick
 This event procedure wraps the intercepts the
 TfrmPatientList.FMCvrListBox1PtDblClick event procedure defined in
 patientlist.pas to prevent modifying PatientIEN and PatientIENDOD global
 variables when selecting a patient for FBCNH Display Episode of Care option.

 CodeCR124 - rpm 7/15/10
 =============================================================================}

procedure Tfrmreports.PatientSelectDblClick(Sender: TObject);
var
  SavePatientIEN, SavePatientIENDOD: String;
begin
  SavePatientIEN := PatientIEN;
  SavePatientIENDoD := PatientIENDoD;
  PatientIEN := '';
  PatientIENDoD := '';
  FeeBasisPatientIEN := '';
  try
    frmPatientSelector.btnCvrSelectPtClick(Sender);
    FeeBasisPatientIEN := PatientIEN;
  finally
    PatientIEN := SavePatientIEN;
    PatientIENDoD := SavePatientIENDoD;
  end;
end;

{===========================================================================
 PrintIntentionalBlank
 This procedure prints a new page containing the text 'This page is
 intentionally blank'.

 CodeCR212 - rpm 11/3/11
 ===========================================================================}

procedure Tfrmreports.PrintIntentionalBlank(ReportComponent: TBaseReport);
begin
  with ReportComponent do
  begin
    NewPage;
    SaveFont(1);
    SetFont('Courier New', 10);
    Bold := True;
    NewLine;
    NewLine;
    PrintCenter('This page is intentionally blank', (SectionLeft + SectionRight) / 2.0);
    Bold := False;
    RestoreFont(1);
  end
end;

{============================================================================
 PrintLine
 This procedure provides a wrapper around the TBaseReport PrintLn procedure
 to prevent Tab (#9) characters from crashing the report writer.

 CodeCR212 - rpm 11/2/11
 ============================================================================}

procedure Tfrmreports.PrintLine(ReportComponent: TBaseReport;
  ReportLine: String);
var
  cleanLine, trimmedLine: String;
  printWidth: Double;
  maxChars: Integer;
begin
  if Pos(#9, ReportLine) > 0 then
    cleanLine := ReplaceTabs(ReportLine, 6)
  else
    cleanLine := ReportLine;

  {Some reports erroneously return long strings of periods '.' that
   are intended as a keepalive for interactive terminal sessions.
   These strings cause errors when they are longer than 255 characters.
   The following code attempts to prevent lines of periods from printing and
   also wraps the remaining valid text that is longer than the available
   page print width.

   CodeCR217 - rpm 11/17/11}
  printWidth := ReportComponent.PageWidth - ReportComponent.MarginLeft - ReportComponent.MarginRight;
  if ReportComponent.TextWidth(cleanLine) > printWidth then
  begin
    maxChars := Round(Length(cleanLine) / ReportComponent.TextWidth(cleanLine) * printWidth);
    while (Length(cleanLine) > maxChars) do
    begin
      trimmedLine := Copy(cleanLine, 0, maxChars);
      if trimmedLine <> StringOfChar('.', Length(trimmedLine)) then             //only print if not periods
        ReportComponent.PrintLn(trimmedLine);

      cleanLine := Copy(cleanLine, maxChars + 1, Length(cleanLine));
      if cleanLine = StringOfChar('.', Length(cleanLine)) then                  //clear "periods only" line
        cleanLine := '';
    end;
  end;

  ReportComponent.Println(cleanLine);

end;

Procedure TfrmReports.DisplayBusyAnimation(Display: Boolean);
begin
  if Display then
  begin
    PanelBuildingReport.Visible := True;
    aniBusy.Active := True;
    ORReportsAvailable.Enabled := False;
    ORReportsAvailable2.Enabled := False;
    frmReports.Repaint;
  end
  else
  begin
    aniBusy.Active := False;
    PanelBuildingReport.Visible := False;
    ORReportsAvailable.Enabled := True;
    ORReportsAvailable2.Enabled := True;
  end;
end;

//CCAPRI_CodeCR96 - jcs - 03/16/10

procedure TfrmReports.WMMenuChar(var Message: TWMMenuChar);
begin
  If Not ActivateMenu(self, Message) then
    Inherited;
end;

{===========================================================================
 SaveDelimitedReport
 This procedure displays the save dialog and saves the passed delimited data
 to the selected filename.  Returns filepath on success; otherwise returns ''

 //CodeCR129 - rpm - 10/12/10
 ===========================================================================}

function Tfrmreports.SaveDelimitedReport(DelimitedLines: TStringList; ReportName: String): String;
var
  IsExistingFile: Boolean;
  ExistsDlgMsg: String;
begin
  Result := '';
  if (DelimitedLines.Count > 0) then
  begin
    SaveDialog.FileName := ReportName;
    if (SaveDialog.InitialDir = '') then
      SaveDialog.InitialDir := GetSystemPath(CSIDL_DESKTOP);
    SaveDialog.DefaultExt := 'txt';
    SaveDialog.Filter := 'Text file (*.txt)|*.txt';
    if SaveDialog.Execute then
    begin
      IsExistingFile := FileExists(SaveDialog.FileName);
      if IsExistingFile then
        ExistsDlgMsg := SaveDialog.FileName + ' already exists.' + #13#10 +
          'Do you want to replace it?';

      if NOT IsExistingFile or
        (IsExistingFile and
        (MessageBox(0, PAnsiChar(ExistsDlgMsg), 'Save As', +mb_YesNo + mb_ICONWARNING + mb_DEFBUTTON2) = IDYES)) then
      begin
        DelimitedLines.SaveToFile(SaveDialog.FileName);
        SaveDialog.InitialDir := ExtractFileDir(SaveDialog.FileName);
        Result := SaveDialog.FileName;
      end;
    end;
  end;
end;

{===========================================================================
 SaveDelimitedReportCSV
 This procedure displays the save dialog and saves the passed delimited data
 to the selected filename.  Returns filepath on success; otherwise returns ''
 This routine saves the data to a CSV extension instead of a TXT extension
 for easier integration into Excel.

 //CodeCR470 - JRL - 4/3/13
 ===========================================================================}

function Tfrmreports.SaveDelimitedReportCSV(DelimitedLines: TStringList;
  ReportName: String): String;
var
  IsExistingFile: Boolean;
  ExistsDlgMsg: String;
begin
  Result := '';
  if (DelimitedLines.Count > 0) then
  begin
    SaveDialog.FileName := ReportName;
    if (SaveDialog.InitialDir = '') then
      SaveDialog.InitialDir := GetSystemPath(CSIDL_DESKTOP);
    SaveDialog.DefaultExt := 'csv';
    SaveDialog.Filter := 'CSV file (*.csv)|*.csv';
    if SaveDialog.Execute then
    begin
      IsExistingFile := FileExists(SaveDialog.FileName);
      if IsExistingFile then
        ExistsDlgMsg := SaveDialog.FileName + ' already exists.' + #13#10 +
          'Do you want to replace it?';

      if NOT IsExistingFile or
        (IsExistingFile and
        (MessageBox(0, PAnsiChar(ExistsDlgMsg), 'Save As', +mb_YesNo + mb_ICONWARNING + mb_DEFBUTTON2) = IDYES)) then
      begin
        DelimitedLines.SaveToFile(SaveDialog.FileName);
        SaveDialog.InitialDir := ExtractFileDir(SaveDialog.FileName);
        Result := SaveDialog.FileName;
      end;
    end;
  end;
end;

{===========================================================================
 GetDelimitedParam
 Input: IsDelimited

 This function retrieves the delimited report parameter.
 //CodeCR129 - rpm 10/12/10
 ===========================================================================}

function Tfrmreports.GetDelimitedParam(IsDelimited: Boolean): String;
begin
  if IsDelimited then                                                           //delimited
    Result := FMToDateConvert(FormatDateTime('mm/dd/yyyy', DateTimePicker2.Date))
  else
    Result := '';                                                               //plain text
end;

{==========================================================================
 GetRequestStatusReport
 Input: IsDelimited
        IsIgnoreDate - ignore date range for NEW, PENDING, and RELEASED

 This procedure retrieves the Request Status by Date report data.
 //CodeCR266 - rpm 1/24/12

 Added new statuses for re-routing - Patch 193 JRL 7/25/16
 ==========================================================================}

procedure Tfrmreports.GetRequestStatusReport(IsDelimited: Boolean; IsIgnoreDate: Boolean);
var
  DelimitedLines: TStringList;
  StatusFilter, DelimitedParam, IgnoreDateParam, FileName, AbbrevReportName: String;
  RPCSuccess: Boolean;
begin
  FileName := '';
  AbbrevReportName := 'RequestStatusByDateReport';
  case cbxRequestStatus.ItemIndex of
    1: StatusFilter := 'N';                                                     //NEW
    2: StatusFilter := 'P';                                                     //PENDING, REPORTED
    3: StatusFilter := 'X';                                                     //CANCELED BY MAS
    4: StatusFilter := 'RX';                                                    //CANCELED BY RO
    5: StatusFilter := 'R';                                                     //RELEASED TO RO, NOT PRINTED
    6: StatusFilter := 'C';                                                     //COMPLETED, PRINTED BY RO
    7: StatusFilter := 'NR';   // Patch 193 JRL 4/27/16                         // NEW, RE-ROUTED                //
    8: StatusFilter := 'RP';   // Patch 193 JRL 7/25/16                         // RE-ROUTED, PENDING ACCEPTANCE //
    9: StatusFilter := 'RA';   // Patch 193 JRL 7/26/16                         // RE-ROUTED, ACCEPTED           //
   10: StatusFilter := 'RR';   // Patch 193 JRL 7/26/16                         // RE-ROUTED, REJECTED           //
  else
    StatusFilter := 'A';                                                        //return all status values
  end;

  if IsIgnoreDate then
    IgnoreDateParam := '1'
  else
    IgnoreDateParam := '0';

  if IsDelimited then
    DelimitedParam := '1'
  else
    DelimitedParam := '0';

  DisplayBusyAnimation(TRUE);

  RPCSuccess := CallRPC(frmMain.RPCBroker1, 'DVBAB REPORTS',
    ['14',
    FMToDateConvert(FormatDateTime('mm/dd/yyyy', DateTimePicker1.DateTime))
      + '^'
      + FMToDateConvert(FormatDateTime('mm/dd/yyyy', DateTimePicker2.DateTime))
      + '^'
      + StatusFilter
      + '^'
      + DelimitedParam
      + '^'
      + IgnoreDateParam], nil, False);

  DisplayBusyAnimation(FALSE);

  if RPCSuccess and (frmMain.RPCBroker1.Results.Count > 0) then
  begin
    if NOT AnsiStartsText('NO DATA FOUND', frmMain.RPCBroker1.Results[0]) then
    begin
      if IsDelimited then
      begin
        DelimitedLines := TStringList.Create;
        try
          CapriQuickCopy(frmMain.RPCBroker1.Results, DelimitedLines);
          if (DelimitedLines.Count > 0) then
          begin
            FileName := SaveDelimitedReportCSV(DelimitedLines, AbbrevReportName // CodeCR470 JRL 4/9/13
              + '_'                                                             // Replaced TXT save with CSV save
              + FormatDateTime('YYYYMMDD', DateTimePicker1.Date)
              + '_'
              + FormatDateTime('YYYYMMDD', DateTimePicker2.Date));
            ReportMemo.Lines.Insert(0, '');
          end;
          if (FileName <> '') then
          begin
            ReportMemo.Lines.Insert(0, IntToStr(DelimitedLines.Count)
              + ' Extract lines saved to: ' + #13#10
              + FileName);
          end
          else
            ReportMemo.Lines.Insert(0, 'No delimited text lines were saved!');
        finally
          FreeAndNil(DelimitedLines);
        end;
      end
      else                                                                      //regular report - not delimited
        CapriQuickCopy(frmMain.RPCBroker1.Results, ReportMemo);
    end
    else                                                                        //NO DATA FOUND
      ReportMemo.Lines.Add('No data found for requested report criteria.');
  end;
end;

{=============================================================================
 GetHospAdjReport
  Input:
   RPCName: String;
   AbbrevReportName: String;
   IsDelimited: Boolean

   The procedure generates a Hospital Adjustment report based on the
   remote procedure name associated with the report and supports delimited
   report results.
   The procedure replaces the original loop and counter design of the
   GetHospAdjReportByDay and calls the RPCBroker with the complete selected
   date range.

 //CodeCR269 - rpm 2/2/12
 =============================================================================}

procedure Tfrmreports.GetHospAdjReport(RPCName, AbbrevReportName: String;
  IsDelimited: Boolean);
var
  y: Integer;
  DelimitedLines: TStringList;
  FileName, HospDom, DoYouWant: String;
  RPCSuccess: Boolean;
begin
  frmMain.RPCBroker1.Results.Clear;
  RPCSuccess := False;
  FileName := '';
  DelimitedLines := TStringList.Create;
  case RadioGroupHospDom.ItemIndex of
    0: HospDom := 'H';
  else HospDom := 'D';
  end;
  case RadioGroupDoYouWant.ItemIndex of
    0: DoYouWant := 'A';
    1: DoYouWant := 'P';
    2: DoYouWant := 'S';
  else DoYouWant := 'L';
  end;

  try
    DisplayBusyAnimation(True);
    frmMain.RPCBroker1.Results.Clear;
    if (RPCName = 'DVBAB REPORT ADMISSIONS') or
      (RPCName = 'DVBAB REPORT INCOMPVET') then
    begin
      RPCSuccess := CallRPC(frmMain.RPCBroker1, RPCName,
        [FMToDateConvert(FormatDateTime('mm/dd/yyyy', DateTimePicker1.DateTime)),
        FMToDateConvert(FormatDateTime('mm/dd/yyyy', DateTimePicker2.DateTime)) + '.9999',
          GetDelimitedParam(IsDelimited)],
          nil, False)
    end
    else if (RPCName = 'DVBAB REPORT READMIT') then
    begin
      RPCSuccess := CallRPC(frmMain.RPCBroker1, RPCName,
        [FMToDateConvert(FormatDateTime('mm/dd/yyyy', DateTimePicker1.DateTime)),
        FMToDateConvert(FormatDateTime('mm/dd/yyyy', DateTimePicker2.DateTime)) + '.9999',
          HospDom,
          GetDelimitedParam(IsDelimited)],
          nil, False)
    end
    else if (RPCName = 'DVBAB REPORT DISCHARGE') then
    begin
      RPCSuccess := CallRPC(frmMain.RPCBroker1, RPCName,
        [FMToDateConvert(FormatDateTime('mm/dd/yyyy', DateTimePicker1.DateTime)),
        FMToDateConvert(FormatDateTime('mm/dd/yyyy', DateTimePicker2.DateTime)) + '.9999',
          DoYouWant,
          GetDelimitedParam(IsDelimited)],
          nil, False)
    end;

    if RPCSuccess then
    begin
      ReportMemo.Visible := False;
      If (frmMain.RPCBroker1.Results.Count > 0) Then
      begin
        if NOT AnsiStartsText('NO DATA FOUND', frmMain.RPCBroker1.Results[0]) Then
          For y := 0 To frmMain.RPCBroker1.Results.Count - 1 Do
          begin
            if IsDelimited then
              DelimitedLines.Add(frmMain.RPCBroker1.Results[y])
            else
              ReportMemo.Lines.Add(frmMain.RPCBroker1.Results[y]);
          end;
      end;
      ReportMemo.Visible := True;
      Application.ProcessMessages;
    end;

    DisplayBusyAnimation(False);
    PanelProgress.Visible := False;

    if (DelimitedLines.Count > 0) then
    begin
      FileName := SaveDelimitedReportCSV(DelimitedLines,                        // CodeCR470 JRL 4/15/13
        AbbrevReportName
        + '_'
        + FormatDateTime('YYYYMMDD', DateTimePicker1.Date)
        + '_'
        + FormatDateTime('YYYYMMDD', DateTimePicker2.Date));
      ReportMemo.Lines.Insert(0, '');
      if (FileName <> '') then
      begin
        ReportMemo.Lines.Insert(0, IntToStr(DelimitedLines.Count)
          + ' Extract lines saved to: ' + #13#10
          + FileName);
      end
      else
        ReportMemo.Lines.Insert(0, 'No delimited text lines were saved!');
    end;

    if (ReportMemo.Lines.Count = 0) and (DelimitedLines.Count = 0) then
      ReportMemo.Lines.Add('No data found for parameters entered.');
    ReportMemo.Visible := True;
    ReportMemo.Lines.Insert(0, '');
    if not IsDelimited then                                                     // CodeCR470 JRL 7/18/13
      ReportMemo.Lines.Insert(0, 'DATE RANGE:  ' + FormatDateTime('mm/dd/yyyy', DateTimePicker1.Date) + ' TO ' + FormatDateTime('mm/dd/yyyy', DateTimePicker2.Date));
    ReportMemo.SelStart := 0;
    ReportMemo.SelLength := 0;
  finally
    FreeAndNil(DelimitedLines);
  end;
end;


// CodeCR470 JRL 08/09/13
// If the user selects a Delimited report, hide the "Sort By" and "Show" options.
// These functions can be easily done in Excel and the sorting and deleting of
// columns should be done there.

procedure Tfrmreports.rgExportFormatClick(Sender: TObject);
begin
  if rgExportFormat.ItemIndex = 0 then                                          // plain text, show all options
  begin
    RadioGroupSortCriteria.Visible := TRUE;
    RadioGroupStatus.Visible := TRUE;
  end
  else                                                                          // Delimited, hide 'sort' and 'show' options
  begin
    RadioGroupSortCriteria.Visible := FALSE;
    RadioGroupStatus.Visible := FALSE;
  end;


end;





End.

