unit tiusign;

interface

uses
  Windows,
  Messages,
  CAPRISupport,
  Classes,
  ComCtrls,
  Controls,
  CPWMObjects,
  Diaccess,
  Dialogs,
  DialogsCAPRI,
  DiTypLib,
  ExtCtrls,
  Fmcmpnts,
  Fmcntrls,
  Forms,
  Gauges,
  Graphics,
  Hash,
  ORDtTm,
  ORFn,
  pncscoderun,
  PNCSMain,
  StdCtrls,
  SysUtils,
  Tabnotbk,
  TRPCB,
  XmlEngine, XMLIntf, XMLDoc, VlerDasClient, VlerDasClaim, Patient, ZipMcpt,
  UUCode, VA508AccessibilityManager, PNCSPanelLoader, VlerDasClientThread
  , untBrkrMthds                                                                // CodeCR540 JRL 12/11/13
  , idCookieManager                                                             // CodeCR540 JRL 12/12/13
  , idCookie                                                                    // CodeCR540 JRL 12/12/13
  , clsPatientInfo
  ;

type
  TTIUSignForm = class(TForm)
    Button3: TButton;
    ButtonGetAppts: TButton;
    ButtonOK2: TButton;
    ButtonTemplatesUtilized: TButton;
    ComboBox1: TComboBox;
    ComboBoxExamLocation: TComboBox;
    ComboBoxReleaseReport: TComboBox;
    CosignerButton: TButton;
    Edit3: TEdit;
    FMEdit1: TFMEdit;
    FMEdit10: TFMEdit;
    FMEdit11: TFMEdit;
    FMEdit12: TFMEdit;
    FMEdit13: TFMEdit;
    FMEdit14: TFMEdit;
    FMEdit15: TFMEdit;
    FMEdit16: TFMEdit;
    FMEdit17: TFMEdit;
    FMEdit18: TFMEdit;
    FMEdit19: TFMEdit;
    FMEdit2: TFMEdit;
    FMEdit20: TFMEdit;
    FMEdit21: TFMEdit;
    FMEdit22: TFMEdit;
    FMEdit23: TFMEdit;
    FMEdit24: TFMEdit;
    FMEdit25: TFMEdit;
    FMEdit26: TFMEdit;
    FMEdit27: TFMEdit;
    FMEdit28: TFMEdit;
    FMEdit29: TFMEdit;
    FMEdit3: TFMEdit;
    FMEdit30: TFMEdit;
    FMEdit31: TFMEdit;
    FMEdit32: TFMEdit;
    FMEdit33: TFMEdit;
    FMEdit4: TFMEdit;
    FMEdit5: TFMEdit;
    FMEdit6: TFMEdit;
    FMEdit7: TFMEdit;
    FMEdit8: TFMEdit;
    FMEdit9: TFMEdit;
    FMExamRequestListbox: TFMListBox;
    FMExamRequestLister1: TFMLister;
    FMExProvider: TFMEdit;
    FMFiler1: TFMFiler;
    FMFind1UncosgndTmplt: TFMFindOne;
    FMGets2: TFMGets;
    FMGets3: TFMGets;
    FMGets4: TFMGets;
    FMGetsExamInfo: TFMGets;
    FMGetsExamRequestInfo: TFMGets;
    FMGetsHospitalLocation: TFMGets;
    FMGetsSavedTemplateInfo: TFMGets;
    FMListBoxApptExternal: TFMListBox;
    FMLister1: TFMLister;
    FMListerAppt: TFMLister;
    FMListerExamsRequested: TFMLister;
    FMMemoAMIEResults: TFMMemo;
    FMMemoAMIEResultsRTF: TFMMemo;
    FMReportText: TFMMemo;
    FMVisitLocation: TFMEdit;
    Gauge1: TGauge;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    LabelCosigner: TLabel;
    ListBox2: TListBox;
    ListBox3: TListBox;
    ListBox5: TListBox;
    lstExamsRequested: TListBox;
    lstExamsRequestedHidden: TListBox;
    Panel1: TPanel;
    Panel2: TPanel;
    PNTitles: TComboBox;
    ptIENHidden: TLabel;
    Timer1: TTimer;
    xEditFormNum: TEdit;
    xFMTemplatesUtilized: TFMMemo;
    FMGetsVVAPatientInfo: TFMGets;
    GroupBox2: TGroupBox;
    Label2: TLabel;
    TabbedNotebook1: TTabbedNotebook;
    ListBox1: TListBox;
    ButtonAllPreviousAppointments: TButton;
    ListBox4: TListBox;
    ListBoxApptMatches: TListBox;
    FMListboxApptInternal: TFMListBox;
    CheckBoxOpinion: TCheckBox;
    cmbxCPRqst: TComboBox;
    sttxtCnPExamQuestion: TStaticText;
    VA508AccessibilityManager1: TVA508AccessibilityManager;
    pnlNotACnPExam: TPanel;
    Memo1: TMemo;
    MiniZip1: TMiniZip;
    function FindMatchingApptData: string;
    procedure Button3Click(Sender: TObject);
    procedure ButtonAllPreviousAppointmentsClick(Sender: TObject);
    procedure ButtonGetApptsClick(Sender: TObject);
    procedure ButtonOK2Click(Sender: TObject);
    procedure ButtonTemplatesUtilizedClick(Sender: TObject);
    procedure CheckBoxOpinionClick(Sender: TObject);
    procedure CosignerButtonClick(Sender: TObject);
    procedure FMExamRequestListboxClick(Sender: TObject);
    procedure FMExProviderExit(Sender: TObject);
    procedure FMExProviderKeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure InitParams(NoteIEN: Int64; Suppress: Integer);
    procedure ListBox1Click(Sender: TObject);
    procedure ListBox4Click(Sender: TObject);
    procedure PNTitlesChange(Sender: TObject);
    procedure SetText(var ErrMsg: string; NoteText: TStrings; NoteIEN: Int64; Suppress: Integer);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure cmbxCPRqstChange(Sender: TObject);
  private
    { Private declarations}
    titleLst: TStringList;                                                      //CodeCR459 JRL 5/21/13
    parentExamIen: string;
    ExamSent: array[1..25] of Boolean;                                          //CodeCR562 JRL 7/17/14
    CoSigMode: Boolean;                                                         // moved from Button2Click routine                     //CodeCR565 JRL 7/20/14
    function IsUserInputValid(aCoSignMode: Boolean): Boolean;
    function GetSelectedExamCount: Integer;
    function IsSelectedCountValid(anExamCount: Integer): Boolean;
    function IsSignatureValid(var aSigErr: string): Boolean;
    function GetTIUTitleIEN: string;
    function CreateTIURecord(aVisitIDIEN: string; aTitleIEN: string): string;
    function GetTIUText(aTIUNoteIEN: string; aTIUText: TStringList): Boolean;
    function GetLineCount(aTIUText: TStringList): Integer;
    function IsTIUTextValid(aTIUNoteIEN: string): Boolean;
    function SignTIURecord(aTIUNoteIEN: string; aSignature: string): Boolean;
    function DeleteTIURecord(aTIUNoteIEN: string; aSignature: string): Boolean;
    procedure SetExamInTemplate(aCosignMode: Boolean);
    function GetApptPointer(aTIUNoteIEN: string): string;
    procedure SetAMIEResults(aTIUNoteIEN, aVisitIDIEN, anAppointment: string);
    function IsExamOKtoRelease: Boolean;
    procedure ReleaseExamToRO;
    procedure SetMatchingTemplateComplete(aTIUNoteIEN: string);
    procedure PopTitleList(forCPRqst: Boolean);                                 //CodeCR459 JRL 5/21/13
    procedure SendDbqsToVlerAndVista(selectedPatient: TPatient; ReTransmit: Boolean); // CodeCR562 7/17/14
    procedure SendDbqsToVista(anExamIEN, fileName: string);
    procedure LoadDBQForRendering(TiuDocumentIen: string);
    procedure UnloadDBQForRendering;
    function CheckErrorsForRetransmitOption(vlerDasClientResult: TStringList): Boolean;
    function ReleaseVendorExamResultsToVLER(selectedRequestID: string): Boolean;
//    function ReleaseVendorExamResultsToVLER(selectedRequestID: String; _PtntInfo: TPatientInfo): Boolean;
  public
    { Public declarations }
    TIUtoVVAProgressNotes: TStringList;
    ParentExamTitle: string;
    FinalReport: TMemoryStream;
  end;

var
  AlertAddedIEN: string;
  AlertRecipientIEN: string;
  anuApptPointer: string;
  anudivision: string;
  anuinstitution: string;
  CoSigTIUNoteIEN: string;
  TimerCount: Integer;
  TIUNoteIEN: string;
  TIUSignForm: TTIUSignForm;
  VisitIDIEN: string;
  PdfMemoryStream: TMemoryStream;

implementation

uses
  listunit,
  main,
  templatesincluded,
  tiucosignature,
  uncosignedutility
  , untMiscMthds                                                                // CodeCR496 - LMS - 2014-07-14 consolidate/refactor all GetTempDir into one location, so all can benefit from Win 7 specific handling.
  , CCOWRPCBrokerCAPRI
  , SplitExamInfo
  , untConstVals
  , demTranMain
  , managereportsCCR
  ;

{$R *.DFM}

procedure TTIUSignForm.FormCreate(Sender: TObject);
begin
  titleLst := TStringList.Create;                                               //CodeCR459 JRL 5/21/13
  TimerCount := 0;
  TIUNoteIEN := '';
  if self.owner = frmTIUCosign then
    TabbedNotebook1.Visible := False;
end;

procedure TTIUSignForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  titleLst.Clear;
  titleLst.Free;
end;

procedure TTIUSignForm.InitParams(NoteIEN: Int64; Suppress: Integer);
begin
  with frmMain.RPCBroker1 do
  begin
    ClearParameters := True;
    RemoteProcedure := 'TIU SET DOCUMENT TEXT';
    Param[0].PType := literal;
    Param[0].Value := IntToStr(NoteIEN);
    Param[1].PType := list;
    Param[2].PType := literal;
    Param[2].Value := IntToStr(Suppress);
  end;
end;

procedure TTIUSignForm.SetText(var ErrMsg: string; NoteText: TStrings; NoteIEN: Int64; Suppress: Integer);
const
  DOCUMENT_PAGE_SIZE = 300;
var
  i, j, page, pages: Integer;
  x: integer;
begin
  // Compute pages, initialize Params
  // Prevent the notetext from being exactly divisable by document_page_size.
  // Without this code, notes sometimes come across blank
  if NoteText.count / document_page_size = trunc(NoteText.count / document_page_size) then
    NoteText.Add('');
  pages := (NoteText.Count div DOCUMENT_PAGE_SIZE) + 1;
  page := 1;
  InitParams(NoteIEN, Suppress);
  // Loop through NoteRec.Lines
  for i := 0 to NoteText.Count - 1 do
  begin
    j := i + 1;
    // Can't send a string over 999 chars.
    if length(notetext[i]) > 999 then
    begin
      x := length(notetext[i]);
      if Copy(notetext[i], x, 1) = ' ' then
        repeat
          notetext[i] := Copy(notetext[i], 1, x - 1);
          dec(x);
        until (x = 0) or (copy(notetext[i], x, 1) <> ' ');
      //showmessage('*'+notetext[i]+'*');
    end;
    //Add each successive line to Param[1].Mult...
    frmMain.RPCBroker1.Param[1].Mult['"TEXT",' + IntToStr(j) + ',0'] := NoteText[i];
    // When current page is filled, call broker, increment page, itialize params,
    // and continue...
    if (j mod DOCUMENT_PAGE_SIZE) = 0 then
    begin
      frmMain.RPCBroker1.Param[1].Mult['"HDR"'] := IntToStr(page) + U + IntToStr(pages);
      frmmain.RPCBrokerCall;
      try
        frmMain.RPCBroker1.Call;
      except
        on EBrokerError do
          ShowMessageCAPRI('RPC TIU SET DOCUMENT TEXT could not be accessed!');
      end;
      ErrMsg := Piece(frmMain.RPCBroker1.Results[0], U, 4);
      if ErrMsg <> '' then
        Exit;
      page := page + 1;
      InitParams(NoteIEN, Suppress);
    end;                                                                        // if
  end;                                                                          // for
  // finally, file any remaining partial page
  if (NoteText.Count mod DOCUMENT_PAGE_SIZE) <> 0 then
  begin
    frmMain.RPCBroker1.Param[1].Mult['"HDR"'] := IntToStr(page) + U + IntToStr(pages);
    frmmain.RPCBrokerCall;
    try
      frmMain.RPCBroker1.Call;
    except
      on EBrokerError do
        ShowMessageCAPRI('RPC TIU SET DOCUMENT TEXT could not be accessed!');
    end;
    ErrMsg := Piece(frmMain.RPCBroker1.Results[0], U, 4);
  end;
end;                                                                            // SetText

procedure TTIUSignForm.Button3Click(Sender: TObject);
begin
  ComboBox1.ItemIndex := -1;
  PNTitles.Text := '';
  CosignerButton.Caption := '';
  AlertRecipientIEN := '';
  Edit3.Text := '';
  ModalResult := mrCancel;
end;

procedure TTIUSignForm.CosignerButtonClick(Sender: TObject);
var
  termDate: string;
begin
  ListForm := TListForm.Create(PNCSForm);
  ListForm.Caption := 'Select a cosigner by last name...';
  ListForm.FMLister1.DisplayFields.Clear;
  ListForm.FMLister1.DisplayFields.Add('.01');
  ListForm.FMLister1.FieldNumbers.Clear;
  ListForm.FMLister1.FieldNumbers.Add('.01');
  ListForm.FMLister1.FileNumber := '200';
  ListForm.Button2.Enabled := True;
  ListForm.ShowModal;
  AlertRecipientIEN := '';
  if ReturnString = pncsForm.xAuthorButton.Caption then
  begin
    ReturnIEN := '';
    ShowMessageCAPRI('Author and co-signer can''t be the same!');
  end;
  if ReturnIEN <> '' then
  begin
    // Be sure selected person is not terminated
    ListForm.FMGets1.FieldNumbers.Clear;
    ListForm.FMGets1.FieldNumbers.Add('.01');
    ListForm.FMGets1.FieldNumbers.Add('9.2');
    ListForm.FMGets1.FileNumber := '200';
    ListForm.FMGets1.IENS := ReturnIEN;
    ListForm.FMGets1.GetData;
    termDate := ListForm.FMGets1.GetField('9.2').FMDBInternal;
    if termDate <> '' then
    begin
      ShowMessageCAPRI('That user has been terminated.  Please select a different co-signer.');
      CosignerButton.Caption := '';
      FMEdit16.Text := '';
      CosignerButtonClick(Application);
      exit;
    end
    else
    begin
      ListForm.FMGets1.FieldNumbers.Clear;
      ListForm.FMGets1.FieldNumbers.Add('.01');
      ListForm.FMGets1.FieldNumbers.Add('8');
      ListForm.FMGets1.FieldNumbers.Add('29');
      ListForm.FMGets1.FileNumber := '200';
      ListForm.FMGets1.IENS := ReturnIEN;
      ListForm.FMGets1.GetData;
      if Application.MessageBox(Pchar('Select user ' + ListForm.FMGets1.GetField('.01').FMDBExternal + ': ' + ListForm.FMGets1.GetField('8').FMDBExternal + ', ' +
        ListForm.FMGets1.GetField('29').FMDBExternal + ' as expected co-signer?'), 'Confirm Co-Signer', 4) = 6 then
      begin
        CosignerButton.Caption := ReturnString;
        FMEdit16.Text := ReturnIEN;
      end;
    end;
  end
  else
  begin
    CosignerButton.Caption := '';
    FMEdit16.Text := '';                                                        // where CAPRI stores the ien of the person co-signing
  end;
end;

procedure TTIUSignForm.ListBox1Click(Sender: TObject);
begin
  if ListBox1.ItemIndex = -1 then
    exit;

  Listbox4.ItemIndex := -1;
  GroupBox1.Visible := SameText(UpperCase(TIUSignForm.cmbxCPRqst.Text), 'YES'); //CodeCR459 JRL 5/21/13
  Panel1.Visible := True;
end;

procedure TTIUSignForm.ListBox4Click(Sender: TObject);
begin
  if ListBox4.ItemIndex = -1 then
    exit;

  Listbox1.ItemIndex := -1;
  GroupBox1.Visible := SameText(UpperCase(TIUSignForm.cmbxCPRqst.Text), 'YES'); //CodeCR459 JRL 5/21/13
  Panel1.Visible := True;
end;

procedure TTIUSignForm.FMExamRequestListboxClick(Sender: TObject);
var
  x: integer;
begin
  if FMExamRequestListBox.ItemIndex = -1 then
    exit;

  Gauge1.Progress := 0;
  Panel2.Visible := True;

  // Find Exams
  frmMain.RPCBroker1.Results.Clear;
  frmMain.RPCBroker1.RemoteProcedure := 'DVBAB FIND EXAMS';
  frmMain.RPCBroker1.Param[0].Value := FMExamRequestListbox.GetSelectedRecord.IEN;
  frmMain.RPCBroker1.Param[0].PType := literal;
  frmmain.RPCBrokerCall;
  try
    frmMain.RPCBroker1.Call;
  except
    on EBrokerError do
      ShowMessageCAPRI('RPC DVBAB FIND EXAMS could not be accessed!');
  end;
  lstExamsRequestedHidden.Items := frmMain.RPCBroker1.Results;
  lstExamsRequested.Items.Clear;
  Gauge1.MaxValue := lstExamsRequestedHidden.Items.Count;
  if lstExamsRequestedHidden.Items.Count > 0 then
    for x := 0 to lstExamsRequestedHidden.Items.Count - 1 do
    begin
      lstExamsRequested.Items.Add(Copy(lstExamsRequestedHidden.Items[x], Pos('^', lstExamsRequestedHidden.Items[x]) + 1, 254) +
        '                                                                                                           ^' + Piece(lstExamsRequestedHidden.Items[x], '^', 1));
    end;
  if lstExamsRequested.Items.Count > 0 then
    for x := lstExamsRequested.Items.Count - 1 downto 0 do
    begin
      // Check for text already stored and remove as a choice if text
      // is there due to transcription
      Gauge1.Progress := Gauge1.MaxValue - x + 1;
      FMMemoAMIEResults.Lines.Clear;
      FMGetsExamInfo.IENS := Piece(lstExamsRequested.Items[x], '^', 2);
      FMGetsExamInfo.GetAndFill;
      if ((pos('[OPEN]', lstExamsRequested.Items[x]) = 0) or
        (FMMemoAMIEResults.Lines.Count > 1)) then
      begin
        lstExamsRequested.Items.Delete(x);
      end
      else
        // Sometimes a blank line is returned as the only item in a memo.
        // This should be considered a null, not valid user data.
        if FMMemoAMIEResults.Lines.Count = 1 then
          if FMMemoAMIEResults.Lines[0] <> '' then
            lstExamsRequested.Items.Delete(x);
    end;

  Gauge1.Progress := Gauge1.MaxValue;                                           // Force it to 100%
  Panel2.Visible := false;

end;

function findLastPiece(s: string): string;
var
  x: integer;
begin
  result := '';
  x := length(s) - 1;
  if x > 0 then
    repeat
      begin
        if s[x] = ' ' then
          result := copy(s, x + 1, length(s));
        dec(x);
    end until (result <> '') or (x = 0);
end;


//------------------------------------------------------------------------------
// OK Button - Sign the exam
//------------------------------------------------------------------------------
// YES/NO - this is a C&P Exam notes
//
//  If the user chooses NO to "is this a C&P exam" and there is a cosignature,
//  handle the same way as "NO" without a cosignature, i.e. mark the exam as
//  complete. In addition, validate the cosigner data, and then delete it.  This
//  avoids alerts being sent to the cosigner (desired) for non-C&P exams.
//
//  If the user chooses NO to "is this a C&P exam", do not send that note to VVA
//  or VLER/DAS web service.  Only C&P exams are sent to any webservices now.
//
//  Check to see if the question "Is this a C&P exam" is begin displayed.
//  If so, handle normally.  If it is not being displayed, then the user is
//  coming from an alert/cosignature screen.  Treat the exam as a C&P exam.
//------------------------------------------------------------------------------

procedure TTIUSignForm.ButtonOK2Click(Sender: TObject);
var
  Appointment: string;
  TitleIEN: string;
  ErrMsg: string;
  CheckTIUNotes: Boolean;
  SendExamToVVA: Boolean;                                                       // CodeCR423 JRL 3/8/13
  PopulatingNameSSN: Boolean;                                                   // CodeCR423 JRL 3/8/13
  I: Integer;                                                                   // CodeCR471 JRL 4/30/13
  ExamIENs: TStrings;                                                           // CodeCR471 JRL 4/30/13
  RequestIEN: string;                                                           // CodeCR471 JRL 5/08/13
  buffer: string;                                                               // CodeCR471 JRL 5/08/13
  SelectedPatientName, SavePatientName: string;                                 // JRL 5/3/13
  SelectedPatientSSN, SavePatientSSN: string;                                   // JRL 5/3/13
  CosignYes_CnPExamNO: Boolean;                                                 // CodeCR459 JRL 7/18/13
  CnPExam: Boolean;                                                             // CodeCR459 JRL 7/22/13
  selectedPatient: TPatient;
//  PatientInfo: TPatientInfo;
  PatientInfoBucket, SavePatientInfoBucket: TPatientInfoBucket;
//  DFN: String;

  {cosignature variables needed for vler das #186}
  isCosignatureRequired: Boolean;
  cosigTiuDocumentIEN: string;
//  cosigCapriTemplateIEN: string;
  TrasmissionErrors: Boolean;                                                   //CodeCR562 JRL 7/17/14
  tbool: Boolean;
begin
  PatientInfoBucket := nil;
  SavePatientInfoBucket := nil;
  { is a cosignature required? }
  isCosignatureRequired := Trim(FMEdit16.Text) <> '';

  if Self.Owner is TfrmTIUCosign then
    cosigTiuDocumentIEN := (Self.Owner as TfrmTIUCosign).TiuDocumentIEN;

  { identify which exam will be the parent exam ien, addresses an edge case bug }
  for i := 0 to lstExamsRequested.Items.Count - 1 do
  begin
    if lstExamsRequested.Selected[i] = true then
    begin
      parentExamIen := Piece(lstExamsRequested.Items[i], '^', 2);
      ParentExamTitle := TrimRight(Piece(lstExamsRequested.Items[i], '^', 1));  // JRL 09/27/13 C&P Exam Title
      break;
    end;
  end;

  // Is the question "Is this a C&P exam" being displayed?
  if cmbxCPRqst.Visible then                                                    //CodeCR459 JRL 7/22/13
    CnPExam := SameText(UpperCase(cmbxCPRqst.Text), 'YES')                      //CodeCR459 JRL 5/21/13
  else                                                                          //CodeCR459 JRL 7/22/13
    CnPExam := TRUE;                                                            //CodeCR459 JRL 7/22/13

//  If the user chooses NO to "is this a C&P exam" and there is a cosignature,
//  handle the same way as "NO" without a cosignature, i.e. mark the exam as
//  complete.
  if (CnPExam = FALSE) and                                                      //CodeCR459 JRL 7/22/13
    (cosignerButton.Caption <> '') then                                         //CodeCR459 JRL 7/18/13
    CosignYes_CnPExamNO := TRUE                                                 //CodeCR459 JRL 7/18/13
  else                                                                          //CodeCR459 JRL 7/18/13
    CosignYes_CnPExamNO := FALSE;                                               //CodeCR459 JRL 7/18/13

  ComboBoxExamLocation.ItemIndex := 0;

  // Set to release report in AMIE by default.
  ComboBoxReleaseReport.ItemIndex := 0;

  CosigMode := False;
  if CoSigTIUNoteIEN <> '' then
  begin
    TIUNoteIEN := CoSigTIUNoteIEN;
    CosigMode := True;
  end;

  //Validate user input fields - Short-circuit on failure
  if not IsUserInputValid(CosigMode) then
    Exit;

  // wait until validation is done.  Then check if the condition of a Non-C&P
  // Exam is being signed that requires a cosignature.  If so, delete the
  // cosignature information and send the TIU note only.  Removing the cosignature
  // information keeps the cosigner from getting an "alert" when they login to
  // CAPRI.  The cosignature process is handled outside of CAPRI for non-C&P
  // exams so we don't care who the cosigner was supposed to be.  Bottom line is
  // sacrificing storing this data to avoid the alert.
  if CosignYes_CnPExamNO = TRUE then                                            //CodeCR459 JRL 7/25/13
  begin                                                                         //CodeCR459 JRL 7/25/13
    cosignerButton.Caption := '';                                               //CodeCR459 JRL 7/25/13
    FMEdit16.Text := '';                                                        // Clear out saved IEN                                 //CodeCR459 JRL 7/25/13
  end;                                                                          //CodeCR459 JRL 7/25/13

  //Are any exams pending - Short-circuit if NO
  if CnPExam then                                                               //CodeCR459 JRL 5/21/13
  begin
    if FMExamRequestListbox.Items.Count = 0 then
    begin
      ShowMessageCAPRI('There are no AMIE exam requests needing results.  This document must be linked to an open request before it can be uploaded.');
      ModalResult := mrCancel;
      Exit;
    end;
  end;                                                                          { End If Template was for C&P Request }

  if CosigMode = False then
  begin                                                                         {Start NOT CosigMode}
    {=========== Swap date and clinic location ======================}
    VisitIDIEN := '';                                                           // clear any previous visit IENS                          //CodeCR499 JRL 6/27/13
    if Listbox4.ItemIndex > -1 then
      VisitIDIEN := Piece(Listbox5.Items[Listbox4.ItemIndex], ';', 2) + ';'
        + Piece(Listbox5.Items[Listbox4.ItemIndex], ';', 1) + ';H'
    else if Listbox1.ItemIndex > -1 then
    begin
      Appointment := FindMatchingApptData;
      VisitIDIEN := Piece(Appointment, '^', 2) + ';'
        + Piece(Appointment, '^', 1) + ';A';
    end;

    {============ Create and Populate TIU Record ====================}
    if TIUNoteIEN = '' then
    begin
      TitleIEN := GetTIUTitleIEN;
      TIUNoteIEN := CreateTIURecord(VisitIDIEN, TitleIEN);

      if Piece(TIUNoteIEN, '^', 1) = '0' then
      begin
        ShowMessageCAPRI('Could not create TIU Record. Cannot Continue.  ' + Piece(TIUNoteIEN, '^', 2));
        ModalResult := mrCancel;
        Exit;
      end;

      // Populate TIU record text
      ErrMsg := '';
      if PNCSForm.xSampleReportOutput.Lines.Count > 0 then
        SetText(ErrMsg, PNCSForm.xSampleReportOutput.Lines, StrToInt(TIUNoteIEN), 0);

      if ErrMsg <> '' then
        ShowMessageCAPRI(ErrMsg);
    end;

    PNCSform.xPanelSave.Visible := False;
    PNCSform.xGauge1.Progress := 0;
    TIUSignForm.Visible := True;

    {================ Validate TIU Text transfer  =======================}
    if not IsTIUTextValid(TIUNoteIEN) then
    begin
      ModalResult := mrCancel;
      Exit;
    end;

    {==== Sign TIU Record and if failed, then try to delete TIU ===}
    if SignTIURecord(TIUNoteIEN, Edit3.Text) then
    begin
      //Update status and TIU Document # in CAPRI and AMIE files
      PNCSForm.XFMEdit10.Text := TIUNoteIEN;                                    // Set TIU Document number in CAPRI template file
      // Set Review Status
      if cosignerButton.Caption <> '' then
        pncsForm.xFMEditReviewStatus.Text := 'U'
      else
        pncsForm.xFMEditReviewStatus.Text := 'C';
      if CosignYes_CnPExamNO then                                               // CodeCR459 JRL 7/22/13    If cosigning a non-c&p exam, then set
        pncsForm.xFMEditReviewStatus.Text := 'C';                               // CodeCR459 JRL 7/22/13    the status to complete.
      pncsForm.xFMEdit8.Text := 'NOW';                                          {Set date/time of sig to lock note in IPR file}
    end
    else
    begin
      DeleteTIURecord(TIUNoteIEN, '');
      ModalResult := mrCancel;
      Exit;
    end;
  end                                                                           {End NOT CosignMode}
  else
  begin                                                                         {Start CosignMode}
    if SignTIURecord(TIUNoteIEN, Edit3.Text) then
    begin
      if frmTIUCosign.addendumText.Lines.Count > 0 then
        frmTIUCosign.SaveAddendum;
    end
    else
      Exit;
  end;                                                                          {End CosigMode}

  // Get Episode Date/Time
  anuApptPointer := '';                                                         //CodeCR499 JRL 6/27/13
  if not CheckBoxOpinion.Checked then                                           //CodeCR499 JRL 6/27/13
    anuApptPointer := GetApptPointer(TIUNoteIEN);

  if CnPExam then                                                               //CodeCR459 JRL 7/22/13
  begin                                                                         //Added if statement and encapsulated
                                                                                //existing code
    // Set AMIE with TIU text
    if labelCosigner.enabled = false then
      SetAMIEResults(TIUNoteIEN, VisitIDIEN, anuApptPointer);

    //Store linked AMIE exams in CAPRI Template file
    SetExamInTemplate(coSigMode);

    if labelCosigner.enabled = false then
    begin
      // Send out email for completed exam(s)                                   // Added email send routine
      try                                                                       // from try/finally inclusive
        ExamIENs := TStringList.Create;                                         // CodeCR471 JRL 5/1/13
        ExamIENs.Clear;                                                         // Relocated code JRL 6/25/13
        for I := 0 to lstExamsRequested.Items.Count - 1 do                      //
        begin                                                                   //
          if lstExamsRequested.Selected[I] = true then                          // Get selected exam IEN
          begin                                                                 // and add to exam list
            buffer := Piece(lstExamsRequested.Items[I], '^', 2);                //
            ExamIENS.Add(buffer);                                               //
          end;                                                                  //
        end;                                                                    //
        RequestIEN := FMExamRequestListbox.GetSelectedRecord.IEN;               //
        if not SendNotificationTwo(ExamIENs,                                    //
          AuthorIEN,                                                            //
          RequestIEN) then                                                      //
          ShowMessageCAPRI('There was a problem sending a completion email notification.  Please notify IRM!');
      finally                                                                   //
        FreeAndNil(ExamIENs);                                                   //
      end;                                                                      //

      FMExamRequestListboxClick(Application);
      // Be sure that nothing is still open
      if IsExamOKtoRelease then begin
//        ReleaseVendorExamResultsToVLER(RequestIEN);
//        ReleaseExamToRO; // Release the results to the RO
        if CosigMode then begin
          FMGetsVVAPatientInfo.FieldNumbers.Clear;                              // If a patient is selected from an
          FMGetsVVAPatientInfo.FieldNumbers.Add('.09');                         // ssn template screen from the tools
          FMGetsVVAPatientInfo.FileNumber := '2';                               // menu, the patient exam being signed
          FMGetsVVAPatientInfo.IENS := ptIENHidden.Caption;                     // may be different from the patient
          FMGetsVVAPatientInfo.GetData;                                         // selected from normal CAPRI use.
          if FMGetsVVAPatientInfo.Results.Count > 0 then                        //
          begin                                                                 // Get Selected patient info from
            SavePatientName := PatientName;                                     // Save the current selected patient
            SavePatientSSN := PatientSSN;                                       // in CAPRI to restore later
            SelectedPatientSSN := FMGetsVVAPatientInfo.GetField('.09').FMDBExternal;
            SavePatientInfoBucket := frmmain.PatientInfo;
//            PatientInfoBucket := TPatientInfoBucket.Create(SelectedPatientSSN);

            // get PatientInfoBucket for selected patient.
            try
              tbool := TPatientInfoBucket.CreatePatientInfoBucket(SelectedPatientSSN, PatientInfoBucket); // CodeCR701 rpk 2/9/2015
            except                                                              // CodeCR701 rpk 2/9/2015
              PatientInfoBucket := nil;                                         // CodeCR701 rpk 2/9/2015
            end;                                                                // CodeCR701 rpk 2/9/2015

            try
              if (PatientInfoBucket <> nil) and (PatientInfoBucket.SSN > '') then begin
                // Since SSN is different than current PatientSSN,
                // PatientInfoBucket must be assigned to frmMain.PatientInfo before
                // PatientInfo is read by TfrmCntrctdExmMain.GetPatientInfo
                // as part of setup of frmCntrctdExmMain and frmManageReportsCCR
                // in ReleaseVendorExamResultsToVLER.
                frmMain.PatientInfo := PatientInfoBucket;
                ReleaseVendorExamResultsToVLER(RequestIEN);
                ReleaseExamToRO;                                                // Release the results to the RO
              end;
            finally
              frmMain.PatientInfo := SavePatientInfoBucket;
              PatientName := SavePatientName;                                   // them now to avoid any other issues
              PatientSSN := SavePatientSSN;
              FreeAndNil(PatientInfoBucket);
            end;
          end;                                                                  // count > 0
        end                                                                     // if CosigMode
        else begin                                                              // else not CosigMode
          ReleaseVendorExamResultsToVLER(RequestIEN);
          ReleaseExamToRO;                                                      // Release the results to the RO
        end;                                                                    // not CosigMode
      end;                                                                      // IsExamOKtoRelease
    end; { if labelCosigner.enabled = false; End If Template was for C&P Request } //CodeCR459 JRL 5/21/13

    TIUSignForm.Visible := False;

    if CosigMode = True then
    // Find template that matches this document in CAPRI and change
    // status to complete.
      SetMatchingTemplateComplete(TIUNoteIEN)
    else if isCosignatureRequired = True then
    begin
      frmMain.RPCBroker1.Results.Clear;
      frmMain.RPCBroker1.Param.Clear;
      frmMain.RPCBroker1.RemoteProcedure := 'DVBA CAPRI EXAM LINK TIU';
      frmMain.RPCBroker1.Param[0].Value := Piece(PNCSForm.xFMEdit2.IENS, ',', 1);
      frmMain.RPCBroker1.Param[0].PType := literal;
      frmMain.RPCBroker1.Param[1].Value := TIUNoteIEN;
      frmMain.RPCBroker1.Param[1].PType := literal;
      frmMain.RPCBrokerCall;
      frmMain.RPCBroker1.Call;
      if frmMain.RPCBroker1.Results.Count > 0 then
        if frmMain.RPCBroker1.Results[0] <> '1' then
          MessageDlgCAPRI('Error: Unable to link exam to progress note.', mtError, [mbOK], 0);
    end;

   // CodeCR729 JRL 5/29/15
   // The following code deletes the saved and 'in progress' versions of the
   // template form data.  This code existed prior to Patch 186 and is being
   // added back in now.
    if CosigMode = FALSE then                                                   // CodeCR729 JRL 5/29/15
    begin                                                                       //
      frmMain.RPCBroker1.Results.Clear;                                         //
      frmMain.RPCBroker1.Param.Clear;                                           //
      frmMain.RPCBroker1.RemoteProcedure := 'DVBAB FORM DATA BACKUP DELETE';    //
      frmMain.RPCBroker1.Param[0].Value := Piece(PNCSForm.xFMEdit2.IENS, ',', 1); //
      frmMain.RPCBroker1.Param[0].PType := literal;                             //
      frmMain.RPCBrokerCall;                                                    //
      frmMain.RPCBroker1.Call;                                                  //
      if frmMain.RPCBroker1.Results.Count > 0 then                              //
        if piece(frmMain.RPCBroker1.Results[0], '^', 1) = '1' then              //
          showmessageCAPRI(piece(frmMain.RPCBroker1.Results[0], '^', 2));       //
    end;
    ModalResult := mrOk;                                                        //rra 917335 - flag 396.7 for update when returns to TPNCSForm.xFormOutputOKClick

  { Send exam to VVA
     * Do not send an exam to VVA unless it is an C&P Exam.                     //CodeCR459 JRL 7/22/13
     * Do not send exam if a cosignature is needed (CosignerButton.Caption = '')
     * CosigMode = FALSE, then always send this exam to VVA
     * CosigMode = TRUE means this exam required a signature and the cosigner
       is reviewing the exam.
     * If a cosigner is signing the exam from the popup alert, or if an exam is
       being accessed from the Tools | My Unsigned Exams menu option, this means
       the patient may not have been selected yet and the global variables
       (name/ssn) are not populated.  If these variables are blank, then get
       the IEN for the patient stored in ptIENHidden.Caption, retrieve the
       name and ssn, and populate the global variables PatientName and
       PatientSSN so these values exist on the main form when the document is
       sent to VVA.  Otherwise, the transmission to VVA will error. Then reset
       the variables so blank so nothing is left behind from the transmit.

       Original SendToVVA code:                          CodeCR423 JRL 11/13/12
       Update SendToVVA code handling cosigned exams     CodeCR423 JRL 03/08/12
       Updated to handle sending to the wrong VVA folder           JRL 05/03/13
         because if the same issue as the cosigned exams
         coming from the Alert Popups or the Unsigned Exams
         menu item
       Updated to only send C&P Exams to VVA                       JRL 07/22/13
  }

    if CnPExam then                                                             // CodeCR459 JRL 7/22/13
    begin                                                                       // Only send C&P exams to VVA
      PopulatingNameSSN := FALSE;                                               // default
      SendExamToVVA := FALSE;                                                   // default

      SavePatientName := PatientName;                                           // Save the current selected patient
      SavePatientSSN := PatientSSN;                                             // in CAPRI to restore later
      selectedPatient := TPatient.Create;
                                                                                //
      FMGetsVVAPatientInfo.FieldNumbers.Clear;                                  // If a patient is selected from an
      FMGetsVVAPatientInfo.FieldNumbers.Add('.01');                             // name                       // alert popup or goes to the unsigned
      FMGetsVVAPatientInfo.FieldNumbers.Add('.09');                             // ssn                        // template screen from the tools
      FMGetsVVAPatientInfo.FieldNumbers.Add('.02');                             // gender
      FMGetsVVAPatientInfo.FieldNumbers.Add('.03');                             // date of birth - format ie, 12/24/1929
      FMGetsVVAPatientInfo.FieldNumbers.Add('991.01');                          // icn
      FMGetsVVAPatientInfo.FieldNumbers.Add('.313');                            // claim number
      FMGetsVVAPatientInfo.FileNumber := '2';                                   // menu, the patient exam being signed
      FMGetsVVAPatientInfo.IENS := ptIENHidden.Caption;                         // may be different from the patient
      FMGetsVVAPatientInfo.GetData;                                             // selected from normal CAPRI use.
      if FMGetsVVAPatientInfo.Results.Count > 0 then                            //
      begin                                                                     // Get Selected patient info from
        SelectedPatientName := FMGetsVVAPatientInfo.GetField('.01').FMDBExternal; // the IENs stored on the TIU form
        SelectedPatientSSN := FMGetsVVAPatientInfo.GetField('.09').FMDBExternal;

//      selectedPatient.FirstName := Piece(SelectedPatientName, ',', 1);
        selectedPatient.LastName := Piece(SelectedPatientName, ',', 1);
        selectedPatient.MiddleName := Piece(Piece(SelectedPatientName, ',', 2), ' ', 2);
//      selectedPatient.LastName := Piece(Piece(SelectedPatientName, ',', 2), ' ', 1);
        selectedPatient.FirstName := Piece(Piece(SelectedPatientName, ',', 2), ' ', 1);

        selectedPatient.Gender := FMGetsVVAPatientInfo.GetField('.02').FMDBInternal;
        selectedPatient.Birthdate := FMGetsVVAPatientInfo.GetField('.03').FMDBExternal;
        selectedPatient.Birthdate := Piece(selectedPatient.Birthdate, '/', 3) + '-' +
          Piece(selectedPatient.Birthdate, '/', 1) + '-' + Piece(selectedPatient.Birthdate, '/', 2);
        selectedPatient.IntegrationControlNumber := FMGetsVVAPatientInfo.GetField('991.01').FMDBExternal;
        selectedPatient.SocialSecurityNumber := SelectedPatientSSN;
        selectedPatient.ClaimNumber := FMGetsVVAPatientInfo.GetField('.313').FMDBExternal;
      end
      else
      begin
        SelectedPatientName := '';
        SelectedPatientSSN := '';
      end;

      if (PatientName = '') and (PatientSSN = '') and                           // -------------------------
        (SelectedPatientName = '') and (SelectedPatientSSN = '') then           // We don't know who this is,
      begin                                                                     // show an error.
        SendExamToVVA := FALSE;
        ShowMessageCapri('This exam must be manually transmitted to Virtual VA');
      end                                                                       // -------------------------
      else if (PatientName = SelectedPatientName) and (PatientSSN = SelectedPatientSSN) then
      begin                                                                     // Normal mode - name on the
        PopulatingNameSSN := FALSE;                                             // signature screen match name
        SendExamToVVA := TRUE;                                                  // signed into CAPRI
      end                                                                       // -------------------------
      else if (PatientName = '') or (PatientSSN = '') then                      // Probably got here from a
      begin                                                                     // Resolve Alert button since no
        PopulatingNameSSN := TRUE;                                              // CAPRI patient is selected.
        PatientName := SelectedPatientName;                                     // Populate the patient name
        PatientSSN := SelectedPatientSSN;                                       // temporarily before sending
        SendExamToVVA := TRUE;                                                  // to VVA
      end                                                                       //-------------------------
      else if (SelectedPatientName <> PatientName) and (SelectedPatientSSN <> PatientSSN) then
      begin                                                                     // Probably got here from the
        PopulatingNameSSN := TRUE;                                              // Tools Menu | Unsigned Templates.
        PatientName := SelectedPatientName;                                     // This means a CAPRI patient is
        PatientSSN := SelectedPatientSSN;                                       // selected but that is not the
        SendExamToVVA := TRUE;                                                  // patient being signed.  Populate
      end                                                                       // the patient name temporarily for
      else                                                                      // sending to VVA
      begin                                                                     // ---------------------------
        SendExamToVVA := FALSE;                                                 // We don't know who this is,
        ShowMessageCapri('This exam must be manually transmitted to Virtual VA'); // show an error.
      end;

      if CosignerButton.Caption <> '' then                                      // Cosignature needed, don't send
        SendExamToVVA := FALSE;                                                 // to VVA regardless of code above

      if SendExamToVVA then                                                     // CodeCR423 JRL 03/08/13
      begin
      // Get Report data to autmoatically send info to the VVA                  // CodeCR423 JRL 11/13/12
        TIUtoVVAProgressNotes := TStringList.Create;                            // CodeCR423 JRL 11/13/12
        try                                                                     // CodeCR423 JRL 11/13/12
          CheckTIUNotes := GetTIUText(TIUNoteIEN, TIUtoVVAProgressNotes);       // CodeCR423 JRL 11/13/12
          if CheckTIUNotes then                                                 // Notes returned                                 // CodeCR423 JRL 11/14/12
            frmMain.actFileTransmitVirtualVAExecute(Self);                      // CodeCR423 JRL 11/13/12
        finally                                                                 // CodeCR423 JRL 11/13/12
          FreeAndNil(TIUtoVVAProgressNotes);                                    // CodeCR423 JRL 11/13/12
        end;                                                                    // CodeCR423 JRL 11/13/12
      end;

    { if we're sending to VVA then we save to 1) VLER DAS and 2) VistA }
      if SendExamToVVA and (isCosignatureRequired = False) then
      begin
        if CoSigMode = True then
        begin
          LoadDBQForRendering(cosigTiuDocumentIEN);
          frmMain.NumExamTextForPDFs := pncsForm.Exams.Count;
          SetLength(frmMain.ExamTextForPDFs, frmMain.NumExamTextForPDFs);
          for i := 0 to pncsForm.Exams.Count - 1 do
          begin
            frmMain.ExamTextForPDFs[i] := TMemoryStream.create;
            FinalReport.SaveToStream(frmMain.ExamTextForPDFs[i]);
          end;
        end;
      // Created in Virtual VA code in case it is needed for cosignature text.
        FreeAndNil(FinalReport);                                                // CodeCR565 JRL 7/20/14

        if pncsForm = nil then
          MessageDlg('DBQ is not loaded; will NOT transmit to VLER DAS', mtError, [mbOk], 0)
        else
        begin
//      SendDbqsToVlerAndVista(selectedPatient);
          for i := 1 to pncsForm.Exams.Count do                                 // Setup ReTransmit array         // CodeCR562 JRL 7/17/14
            ExamSent[i] := FALSE;                                               // CodeCR562 JRL 7/17/14
          SendDbqsToVlerAndVista(selectedPatient, FALSE);                       // Send first time      // CodeCR562 JRL 7/17/14
          TrasmissionErrors := FALSE;                                           // CodeCR562 JRL 7/17/14
          for i := 1 to pncsForm.Exams.Count do                                 // CodeCR562 JRL 7/17/14
          begin                                                                 // CodeCR562 JRL 7/17/14
            if ExamSent[i] = FALSE then                                         // CodeCR562 JRL 7/17/14
              TrasmissionErrors := TRUE;                                        // CodeCR562 JRL 7/17/14
          end;                                                                  // CodeCR562 JRL 7/17/14
          if TrasmissionErrors then                                             // CodeCR562 JRL 7/17/14
          begin                                                                 // CodeCR562 JRL 7/17/14
            if MessageDlgCAPRI('Transmission to VLER failed, do you want to retransmit?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
              SendDbqsToVlerAndVista(selectedPatient, TRUE);                    // CodeCR562 JRL 7/17/14
          end;                                                                  // else                                                            // CodeCR562 JRL 7/17/14
       // free memory for stored PDFs here                                      // CodeCR562 JRL 7/18/14 moved code to accommodate retransmission // CodeCR565 JRL 7/15/14
          for i := 0 to frmMain.NumExamTextForPDFs - 1 do                       // CodeCR562 JRL 7/18/14 // CodeCR565 JRL 7/15/14
            FreeAndNil(frmMain.ExamTextForPDFs[i]);                             // CodeCR562 JRL 7/18/14      // CodeCR565 JRL 7/15/14
        end;                                                                    // CodeCR562 JRL 7/17/14
        if CoSigMode = True then
        begin
          UnloadDBQForRendering;
        end;
      end;

      if PopulatingNameSSN then                                                 // if we populated the global variables
      begin                                                                     // to send the exam to VVA, restore
        PatientName := SavePatientName;                                         // them now to avoid any other issues
        PatientSSN := SavePatientSSN;                                           // in CAPRI
      end;
      FreeAndNil(SelectedPatient);
    end;                                                                        // if CnPExam inner block

//  PatientInfo.Free;

//    ModalResult := mrOk;
  end;                                                                          // if CnPExam outer block

  ModalResult := mrOk;                                                          // rpk 4/21/2015

end;

procedure TTIUSignForm.LoadDBQForRendering(TiuDocumentIen: string);
var
  capriTemplateIEN: string;
  pncsPanelLoader: TPNCSPanelLoaderForm;
//  msg1 : string;              // LMS: Not needed
//  startpos,endpos : integer;
begin
  if pncsForm <> nil then
  begin
    pncsForm.CloseOutForm
  end;

  frmMain.RPCBroker1.Results.Clear;
  frmMain.RPCBroker1.Param.Clear;
  frmMain.RPCBroker1.RemoteProcedure := 'DVBA CAPRI GET EXAM IEN';
  frmMain.RPCBroker1.Param[0].Value := TiuDocumentIen;
  frmMain.RPCBroker1.Param[0].PType := literal;
  frmMain.RPCBrokerCall;
  frmMain.RPCBroker1.Call;

  if frmMain.RPCBroker1.Results.Count > 0 then
  begin
    try
      StrToInt(frmMain.RPCBroker1.Results[0]);
      capriTemplateIEN := frmMain.RPCBroker1.Results[0];
    except
      on E: Exception do
      begin
        MessageDlgCAPRI('Error: The DBQ was not found on VistA and thus will not be transmitted', mtError, [mbOK], 0);
        Exit;
      end;
    end;
  end;

  pncsPanelLoader := TPNCSPanelLoaderForm.Create(Self);
  pncsPanelLoader.TryLoad(capriTemplateIEN);
end;

procedure TTIUSignForm.UnloadDBQForRendering;
begin
  if pncsForm = nil then
    Exit;

  pncsForm.CloseWithoutSave;
  pncsForm.Close;

  FreeAndNil(pncsForm);
end;

procedure TTIUSignForm.SendDbqsToVlerAndVista(selectedPatient: TPatient; ReTransmit: Boolean);
const
  WEB_SERVICE_BUNDLE = 'WebServiceBundle';
  EXTENSION_ZIP = '.zip';
  EXTENSION_UUE = '.uue';
var
  i: Integer;

  singleExam: TCPWMExam;
  claimAttachment: TVlerDasAttachment;
  xmlEngine: TXmlEngine;

  xmlDocument: IXMLDocument;
  xmlDocumentNoAttachments: IXMLDocument;

  vlerDasClient: TfVlerDasClient;
  vlerDasThread: TVlerDasClientThread;
  vlerDasClientResult: TStringList;

  savedExamFiles: TStringList;
  tempFile: string;
  //  CookieMgr : TIdCookieManager;    // CodeCR566 LMS Not needed.
  vlerSplitExam: TSplitExam;                                                    // CodeCR565 JRL 7/10/14
  CnPTitle: string;                                                             // CodeCR565 JRL 7/13/14
  CurrentDateTime, DateOfNote: string;                                          // CodeCR565 JRL 7/14/14
  aSignature, aTitle, buffer: string;                                           // CodeCR565 JRL 7/15/14
  dt, tm: string;                                                               // CodeCR565 JRL 7/15/14
//  ErrorMsg: string;                                                             // CodeCR562 JRL 06/25/14
//  TransmitAgain: Boolean;                                                       // CodeCR562 JRL 7/16/14

begin

  if (ReTransmit = FALSE) and                                                   // setup the files the first time only            // CodeCR562 JRL 7/17/14
    (CoSigMode = FALSE) then                                                    // skip setup, file is already complete from vva   // CodeCR565 JRL 7/20/14
  begin                                                                         // CodeCR562 JRL 7/17/14
    FMGets3.FieldNumbers.Add('20.2');                                           // Get Signature Block Printed Name       // CodeCR565 JRL 7/24/14
    FMGets3.FieldNumbers.Add('20.3');                                           // Get Signature Block Title              // CodeCR565 JRL 7/24/14
    FMGets3.FileNumber := '200';                                                // CodeCR565 JRL 7/24/14
    FMGets3.IENS := AuthorIEN;                                                  // CodeCR565 JRL 7/24/14
    FMGets3.GetData;                                                            // CodeCR565 JRL 7/24/14
    if FMGets3.Results.Count = 0 then                                           // CodeCR565 JRL 7/24/14
    begin                                                                       // CodeCR565 JRL 7/24/14
      aSignature := '';                                                         // CodeCR565 JRL 7/24/14
      aTitle := '';                                                             // CodeCR565 JRL 7/24/14
    end                                                                         // CodeCR565 JRL 7/24/14
    else                                                                        // CodeCR565 JRL 7/24/14
    begin                                                                       // CodeCR565 JRL 7/24/14
      aSignature := FMGets3.GetField('20.2').FMDBExternal;                      // CodeCR565 JRL 7/24/14
      aTitle := FMGets3.GetField('20.3').FMDBExternal;                          // CodeCR565 JRL 7/24/14
    end;                                                                        // CodeCR565 JRL 7/24/14
    CnPTitle := PNTitles.Items[PNTitles.ItemIndex];                             // CodeCR565 JRL 7/13/14
    if CallRPC(frmMain.RPCBroker1, 'ORWU DT', ['NOW'], nil, False, True) then   // CodeCR565 JRL 7/13/14
    begin                                                                       // CodeCR565 JRL 7/15/14
      buffer := frmMain.RPCBroker1.Results[0];                                  // CodeCR565 JRL 7/13/14
      dt := Piece(buffer, '.', 1);                                              // CodeCR565 JRL 7/15/14
      tm := Piece(buffer, '.', 2);                                              // CodeCR565 JRL 7/15/14
      // This RPC returns a time that has no trailing zeros for seconds         // CodeCR565 JRL 8/8/14
      if length(tm) = 4 then                                                    // CodeCR565 JRL 8/8/14
        tm := tm + '00';                                                        // CodeCR565 JRL 8/8/14
      if length(tm) = 5 then                                                    // CodeCR565 JRL 8/8/14
        tm := tm + '0';                                                         // CodeCR565 JRL 8/8/14
      CurrentDateTime := Copy(dt, 4, 2) + '/' + Copy(dt, 6, 2) + '/20' + Copy(dt, 2, 2) + // CodeCR565 JRL 7/15/14
        ' ' + Copy(tm, 1, 2) + ':' + Copy(tm, 3, 2) + ':' + Copy(tm, 5, 2);     // CodeCR565 JRL 7/15/14
    end;                                                                        // CodeCR565 JRL 7/15/14

    if CheckBoxOpinion.Checked then                                             // CodeCR565 JRL 7/15/14
      DateOfNote := CurrentDateTime                                             // CodeCR565 JRL 7/15/14
    else                                                                        // CodeCR565 JRL 7/16/14
    begin                                                                       // CodeCR565 JRL 7/15/14
      if ListBox1.ItemIndex <> -1 then                                          // CodeCR565 JRL 7/15/14
      begin                                                                     // CodeCR565 JRL 7/24/14
        DateOfNote := ListBox1.Items[Listbox1.ItemIndex];                       // Appointments       // CodeCR565 JRL 7/15/14
        DateOfNote := Copy(DateOfNote, 1, Pos('@', DateOfNote) + 5) + '   ';    // CodeCR565 JRL 7/24/14
      end                                                                       // CodeCR565 JRL 7/24/14
      else if ListBox4.ItemIndex <> -1 then                                     // CodeCR565 JRL 7/16/14
      begin                                                                     // CodeCR565 JRL 7/24/14
        DateOfNote := ListBox4.Items[Listbox4.ItemIndex];                       // Admissions         // CodeCR565 JRL 7/15/14
        DateOfNote := Copy(DateOfNote, 1, Pos('  ', DateOfNote)) + '        ';  // CodeCR565 JRL 7/15/14
      end                                                                       // CodeCR565 JRL 7/24/14
      else                                                                      // CodeCR565 JRL 7/16/14
        DateOfNote := CurrentDateTime;                                          // Default                               // CodeCR565 JRL 7/15/14
    end;                                                                        // CodeCR565 JRL 7/16/14
    vlerSplitExam := TSplitExam.Create;                                         // CodeCR565 JRL 7/10/14
    vlerSplitExam.ProcessTextToPDF(aSignature, aTitle, CurrentDateTime, FMExProvider.Text, // CodeCR565 JRL 7/15/14
      CosignerButton.Caption, CnPTitle, DateOfNote);                            // CodeCR565 JRL 7/15/14
    FreeAndNil(vlerSplitExam);                                                  // CodeCR565 JRL 7/10/14
  end;                                                                          // if ReTransmit = FALSE                                                 // CodeCR562 JRL 7/17/14

  // Not used any more frmMain.VlerDasToken := GetRemoteAuthenticationToken(frmMain.RPCBroker1);     // CodeCR540 JRL 12/11/13
  savedExamFiles := TStringList.Create;

  // create partial claim attachment object; remaining completed once xml engine is available
  PdfMemoryStream := TMemoryStream.Create;                                      //CodeCR562 JRL 7/18/14
  // CookieMgr := TIdCookieManager.Create();        //CodeCR540 JRL 12/12/13    // CodeCR566 LMS Not needed.

  for i := 0 to pncsForm.Exams.Count - 1 do
  begin
    if (frmTIUCosign <> nil) and (frmTIUCosign.Showing) then
      frmTIUCosign.Repaint
    else if (pncsForm <> nil) and (pncsForm.Showing) then
      pncsForm.Repaint;

    singleExam := pncsForm.Exams[i];

    if singleExam.IsXmlBasedExam = False then                                   // skip exams without an XSD
    begin
      ExamSent[i + 1] := TRUE;                                                  // make sure legacy exams show as being sent so they don't throw off error count //CodeCR562 JRL 7/18/14
      continue;
    end;
    if ReTransmit and ExamSent[i + 1] = TRUE then                               // skip sending an exam that was already sent correctly // CodeCR562 JRL 7/17/14
      continue;                                                                 // CodeCR562 JRL 7/17/14

    // Get single PDF from memory
    PdfMemoryStream.Position := 0;                                              // CodeCR565 JRL 7/13/14
    PdfMemoryStream.LoadFromStream(frmMain.ExamTextForPDFs[i]);                 //Get Exam Text// CodeCR565 JRL 7/13/14

    if (PdfMemoryStream <> nil) and (PdfMemoryStream.Size > 0) then             // moved this code into the loop instead
    begin                                                                       // of happening before loop CodeCR565 JRL 7/10/14
      claimAttachment := TVlerDasAttachment.Create;
      claimAttachment.BinaryBase64Object := claimAttachment.EncodeToBase64(PdfMemoryStream);
      claimAttachment.BinaryDescriptionText := 'text is replaced below';
      claimAttachment.BinaryFormatStandardName := 'application/pdf';
      claimAttachment.BinaryLocationURI := 'text is replaced below';
      claimAttachment.BinarySizeValue := IntToStr(PdfMemoryStream.Size);
      claimAttachment.BinaryCategoryText := 'text is replaced below';
    end;

    try                                                                         // claimAttachment := TVlerDasAttachment.Create; rpk 5/28/2015

      xmlEngine := TXmlEngine.Create(singleExam);
      try                                                                       // rpk 5/28/2015
//    if claimAttachment <> nil then
        if (claimAttachment <> nil) and (xmlEngine <> nil) then                 // rpk 4/24/2015
        begin
          claimAttachment.BinaryDescriptionText := xmlEngine.GetDocumentTitleText;
          claimAttachment.BinaryCategoryText := xmlEngine.GetDocumentTitleText;
          claimAttachment.BinaryLocationURI := xmlEngine.GetUniqueFilename(xmlEngine.GetDocumentTitleText, 'pdf');
          xmlEngine.AddClaimAttachment(claimAttachment);
        end;

        xmlEngine.SetPatient(selectedPatient);
        xmlEngine.PopulateApproverInfo('', '', '', '', '');                     // CodeCR563 JRL 6/13/14
        xmlEngine.PopulateExamInfo('VHA_CAPRI', '', 'Inhouse', '', xmlEngine.GetW3cDateTime, '', 'Completed'); // CodeCR563 JRL 6/13/14

        // maintain order of following 2 lines.  The xmlDocument needs to be rendered last
        // in order for the xmlEngine.GetDocumentIdentificationID to have the correct value
        // to send in the SOAP header.
        xmlDocumentNoAttachments := xmlEngine.RenderToXml(pncsForm.xpanelBaseControl, False);
        xmlDocument := xmlEngine.RenderToXml(pncsForm.xpanelBaseControl);

        if PARAM_SAVE_XML = True then
        begin
          xmlDocument.SaveToFile(GetCurrentDir + '\exam-request-' + IntToStr(i) + '.xml');
          xmlDocumentNoAttachments.SaveToFile(GetCurrentDir + '\exam-request-noa-' + IntToStr(i) + '.xml');
        end;

        tempFile := GetTempDir + 'exam-request-' + IntToStr(i) + '.xml';        // CodeCR496 - LMS - 2014-07-14 refactor GetTempDir to one method call
        if FileExists(tempFile) then
          DeleteFile(tempFile);
        xmlDocumentNoAttachments.SaveToFile(tempFile);
        savedExamFiles.Add(tempFile);

    { send payload to vler das }
//    try
      //vlerDasClient := TfVlerDasClient.Create(Self);

        vlerDasClient := TfVlerDasClient.Create(frmMain);
        try                                                                     // rpk 4/24/2015
          vlerDasClient.SetDBQName(xmlEngine.GetDocumentTitleText);
      // vlerDasClient.SetCookieManager(CookieMgr);   // CodeCR566 LMS Not needed.

          vlerDasThread := TVlerDasClientThread.Create(vlerDasClient);
          try
                                                                                // rpk 5/28/2015
            vlerDasClientResult := TStringList.Create;
            try                                                                 // rpk 5/28/2015

              vlerDasThread.VlerDasClientResult := vlerDasClientResult;
              try                                                               // rpk 5/28/2015
                vlerDasThread.XmlDocument := xmlDocument;
                vlerDasThread.DocumentIdentificationID := xmlEngine.GetDocumentIdentificationID;
                vlerDasThread.Resume;
                vlerDasThread.WaitFor;
                ExamSent[i + 1] := CheckErrorsForRetransmitOption(vlerDasClientResult);
                if vlerDasThread.AnException <> nil then
                  raise vlerDasThread.AnException;
              except
                on E: Exception do
                begin
                  ExamSent[i + 1] := FALSE;                                     // exam didn't send
                end;
              end;

              if PARAM_SAVE_XML = True then
                vlerDasClientResult.SaveToFile(GetCurrentDir + '\exam-response-' + IntToStr(i) + '.xml');

              tempFile := GetTempDir + 'exam-response-' + IntToStr(i) + '.xml'; // CodeCR496 - LMS - 2014-07-14 refactor GetTempDir to one method call
              if FileExists(tempFile) then
                DeleteFile(tempFile);
              vlerDasClientResult.SaveToFile(tempFile);
            finally                                                             // try vlerDasClientResult := TStringList.Create;
              FreeAndNil(vlerDasClientResult);                                  // rpk 5/28/2015
            end;
            savedExamFiles.Add(tempFile);

          finally                                                               // try vlerDasThread := TVlerDasClientThread.Create(vlerDasClient);
            FreeAndNil(vlerDasThread);                                          // rpk 5/28/2015
          end;
        finally                                                                 // try vlerDasClient := TfVlerDasClient.Create(frmMain);
          FreeAndNil(vlerDasClient);                                            // rpk 4/24/2015
//          Screen.Cursor := crDefault;
        end;
      finally                                                                   // try xmlEngine := TXmlEngine.Create(singleExam);
        FreeAndNil(xmlEngine);                                                  // rpk 5/28/2015
      end;
    finally                                                                     // claimAttachment := TVlerDasAttachment.Create;
      FreeAndNil(claimAttachment);                                              // rpk 5/28/2015
    end;
  end;                                                                          // for i := 0 to pncsForm.Exams.Count - 1 do
  // FreeAndNil(CookieMgr);       //CodeCR540 JRL 12/12/13   // CodeCR566 LMS Not needed.

  Screen.Cursor := crDefault;                                                   // rpk 5/28/2015

  if savedExamFiles.Count > 0 then
  begin

    { bundle to include request and response status for each webservice invocation }
    MiniZip1.Zipfile := GetTempDir + WEB_SERVICE_BUNDLE + EXTENSION_ZIP;        // CodeCR496 - LMS - 2014-07-14
    if FileExists(MiniZip1.Zipfile) then
      DeleteFile(MiniZip1.Zipfile);

    for i := 0 to savedExamFiles.Count - 1 do
    begin
      MiniZip1.AddToZipFile(savedExamFiles[i], ExtractFileName(savedExamFiles[i]));
    end;

    { uu encode the zip file }
    if FileExists(GetTempDir + WEB_SERVICE_BUNDLE + EXTENSION_UUE) then         // CodeCR496 - LMS - 2014-07-14 refactor GetTempDir to one method call
      DeleteFile(GetTempDir + WEB_SERVICE_BUNDLE + EXTENSION_UUE);

    UUEncode(MiniZip1.Zipfile);

    { send the payload bundle to vista }
    SendDbqsToVista(parentExamIen, GetTempDir + WEB_SERVICE_BUNDLE + EXTENSION_UUE); // CodeCR496 - LMS - 2014-07-14 refactor GetTempDir to one method call

    { clean up our mess }
    for i := 0 to savedExamFiles.Count - 1 do
    begin
      if FileExists(savedExamFiles[i]) then
        DeleteFile(savedExamFiles[i]);
    end;

    if PARAM_SAVE_XML = True then
    begin
      if FileExists(GetTempDir + WEB_SERVICE_BUNDLE + EXTENSION_ZIP) then       // CodeCR496 - LMS - 2014-07-14 refactor GetTempDir to one method call
        CopyFile(PAnsiChar(GetTempDir + WEB_SERVICE_BUNDLE + EXTENSION_ZIP),
          PAnsiChar(GetCurrentDir + '\' + WEB_SERVICE_BUNDLE + EXTENSION_ZIP), False);
    end;

    if FileExists(GetTempDir + WEB_SERVICE_BUNDLE + EXTENSION_ZIP) then         // CodeCR496 - LMS - 2014-07-14
      DeleteFile(GetTempDir + WEB_SERVICE_BUNDLE + EXTENSION_ZIP);

    if FileExists(GetTempDir + WEB_SERVICE_BUNDLE + EXTENSION_UUE) then
      DeleteFile(GetTempDir + WEB_SERVICE_BUNDLE + EXTENSION_UUE);

  end;                                                                          // if savedExamFiles.Count > 0 then

  if PdfMemoryStream <> nil then
    FreeAndNil(PdfMemoryStream);

//  if claimAttachment <> nil then
//    FreeAndNil(claimAttachment);

  if savedExamFiles <> nil then
    FreeAndNil(savedExamFiles);

end;

procedure TTIUSignForm.SendDbqsToVista(anExamIEN, fileName: string);
var
  uuEncodedFile: TStrings;
  i: Integer;
begin
  uuEncodedFile := TStringList.Create;
  uuEncodedFile.LoadFromFile(fileName);

  with frmMain.RPCBroker1 do
  begin
    ClearResults := TRUE;
    ClearParameters := TRUE;
    RemoteProcedure := 'DVBA CAPRI EXAM XML';
    Param[0].Value := AnExamIEN;
    Param[0].PType := literal;
    Param[1].Value := CAPRI_InhouseExamXMLNote;
    Param[1].PType := literal;
    Param[2].PType := list;

    for I := 0 to uuEncodedFile.Count - 1 do
      Param[2].Mult[IntToStr(I + 1)] := uuEncodedFile[I];

    frmMain.RPCBrokerCall;
    try
      Call;
    except
      on EBrokerError do
        ShowMessageCAPRI('RPC DVBA CAPRI EXAM XML could not be accessed!');
    end;
  end;
  FreeAndNil(uuEncodedFile);
end;

{************************************************************************
 FormShow
 During cosignature, use "RS" index searching for a value of "U"ncosigned
 in the CAPRI TEMPLATES (#396.17) file to find the entry that corresponds
 to the entry (CoSigTIUNoteIEN) in the TIU DOCUMENT file and retrieve the
 TEMPLATES UTILIZED.  The first piece of the "2" node contains the TIU Note
 number.

 CodeCR108 - rpm 6/23/10 - redesign matching logic to prevent incorrect
                           matches and AV's.
 ************************************************************************}

procedure TTIUSignForm.FormShow(Sender: TObject);
var
  I: Integer;
  FMErr: TFMErrorObj;
  NoMatchMsg, FMErrMsg: string;
begin
  titleLst.AddStrings(PNTitles.Items);                                          //Store Unfiltered Title List for later reference //CodeCR459 JRL 5/21/13
  FMErrMsg := '';
  NoMatchMsg := 'NOTICE:  Couldn''t find a matching template to close in CAPRI.  '
    + 'The exam will be updated in AMIE, '
    + 'but no CAPRI templates will be modified.';

  if CoSigTIUNoteIEN <> '' then                                                 //Co-signature mode
  begin
    FMFind1UncosgndTmplt.Screen := 'I $P(^(2), "^", 1)=' + CoSigTIUNoteIEN;
    FMGetsSavedTemplateInfo.IENS := FMFind1UncosgndTmplt.GetIEN;
    if (FMFind1UncosgndTmplt.ErrorList.Count > 0) then
      for I := 0 to FMFind1UncosgndTmplt.ErrorList.Count - 1 do
      begin
        FMErr := FMFind1UncosgndTmplt.ErrorList.Items[I];
        FMErrMsg := 'FileMan error: ' + FMErr.ErrorText.Text + #13#10;
      end;
  end
  else                                                                          //NOT Co-signature mode
  begin
    FMGetsSavedTemplateInfo.IENS := Piece(PNCSForm.xFMEdit2.IENS, ',', 1);
    if TIUNoteIEN = '' then
      TIUNoteIEN := PNCSForm.XFMEdit10.Text;
  end;

  //Only attempt to retrieve the TEMPLATE UTILIZED when matched and no error
  if (FMGetsSavedTemplateInfo.IENS = '') then                                   //FileMan error
    ShowmessageCAPRI(FMErrMsg + NoMatchMsg)
  else if (FMGetsSavedTemplateInfo.IENS = '0,') then                            //No match found
    ShowmessageCAPRI(NoMatchMsg)
  else
    FMGetsSavedTemplateInfo.GetAndFill;
  cmbxCPRqstChange(self);                                                       { Setup form display }
end;

procedure TTIUSignForm.PNTitlesChange(Sender: TObject);
var
  x: integer;
begin
  frmMain.RPCBroker1.RemoteProcedure := 'TIU REQUIRES COSIGNATURE';
  frmMain.RPCBroker1.Param[0].PType := literal;
  for x := 0 to pncsForm.xFMPNTitles.Items.Count - 1 do
    if
      Pos(PNTitles.Items[PNTitles.ItemIndex] + '  11', pncsForm.xFMPNTitles.Items[x]) = 1 then
      frmMain.RPCBroker1.Param[0].Value := Copy(pncsForm.xFMPNTitles.Items[x], Pos('  IEN#', pncsForm.xFMPNTitles.Items[x]) + 6, 99);
  frmMain.RPCBroker1.Param[0].PType := literal;
  frmMain.RPCBroker1.Param[1].Value := '0';
  frmMain.RPCBroker1.Param[1].PType := literal;
  frmMain.RPCBroker1.Param[3].Value := AuthorIEN;
  frmMain.RPCBroker1.Param[3].PType := literal;
  frmmain.RPCBrokerCall;
  try
    frmMain.RPCBroker1.Call;
  except
    on EBrokerError do
      ShowMessageCAPRI('Connection to server could not be established!');
  end;
  if frmMain.RPCBroker1.Results[0] <> '0' then
  begin
    labelcosigner.enabled := true;
    cosignerbutton.enabled := true;
    ComboBoxExamLocation.itemIndex := 0;
    label5.visible := false;
    FMExProvider.visible := false;
    FMExProvider.Text := '';
    GroupBox1.Visible := False;
    FMExamRequestListbox.ItemIndex := -1;
    lstExamsRequested.Items.Clear;
    exit;
  end;
  labelcosigner.enabled := false;
  cosignerbutton.enabled := false;
  cosignerbutton.caption := '';
  label5.visible := true;
  FMExProvider.visible := true;
  GroupBox1.Visible := SameText(UpperCase(TIUSignForm.cmbxCPRqst.Text), 'YES'); //CodeCR459 JRL 5/21/13
end;

procedure TTIUSignForm.FMExProviderKeyPress(Sender: TObject;
  var Key: Char);
begin
  if Key = '^' then
    Key := char(0);
end;

procedure TTIUSignForm.FMExProviderExit(Sender: TObject);
begin
  FMExProvider.Text := Uppercase(FMExProvider.Text);
end;

procedure TTIUSignForm.ButtonTemplatesUtilizedClick(Sender: TObject);
var
  x: integer;
begin
  FormTemplatesIncluded := tFormTemplatesIncluded.Create(TIUSignForm);
  FormTemplatesIncluded.ListBoxScroller1.Items.Clear;
  if xFMTemplatesUtilized.Lines.Count > 0 then
    for x := 0 to xFMTemplatesUtilized.Lines.Count - 1 do
      FormTemplatesIncluded.ListBoxScroller1.Items.Add(Piece(xFMTemplatesUtilized.Lines[x], '^', 2));
  FormTemplatesIncluded.ShowModal;
  FormTemplatesIncluded.Release;
  FormTemplatesIncluded := nil;
end;

procedure TTIUSignForm.ButtonGetApptsClick(Sender: TObject);
var
  ptIEN: string;
  x: integer;
  aFMDateTime: TFMDateTime;
begin
  ptIEN := ptIENHidden.Caption;

  //CAPRI_CodeCR132  - jcs - 07/02/2010
  //Get Now
  if not CallRPC(frmMain.RPCBroker1, 'ORWU DT', ['NOW'], nil, False, True) then
    exit
  else
    aFMDateTime := MakeFMDateTime(frmMain.RPCBroker1.Results[0]);

  //Increment now by one day and return the date portion only
  aFMDateTime := Int(FMDateTimeOffsetBy(aFMDateTime, 1));

  //apply a screen so that we only return appts less then tomorrow
  FMListerAppt.Screen := 'I Y<' + FloatToStr(aFMDateTime);
  //end changes for CAPRI_CodeCR132  - jcs - 07/02/2010

  FMListerAppt.IENS := ',' + ptIEN;
  FMListerAppt.ListerFlags := [lfInternal];
  FMListBoxApptInternal.Items.Clear;
  FMListerAppt.GetList(FMListBoxApptInternal.Items);
//CodeCR364 - rpm 7/18/12 - changed FMListerAppt.Number property to "*",
//                          which returns all records at once to eliminate
//                          chance of infinite loops caused by LIST^DIC.
//  Try
//    If FMListerAppt.More = True Then
//      Repeat
//        FMlisterAppt.GetMore(FMListBoxApptInternal.Items);
//      Until FMListerAppt.More <> True;
//  Except
//  End;
  FMListerAppt.ListerFlags := [];
  FMListBoxApptExternal.Sorted := False;
  FMListerAppt.GetList(FMListBoxApptExternal.Items);
//CodeCR364 - rpm 7/18/12 - changed FMListerAppt.Number property to "*",
//                          which returns all records at once to eliminate
//                          chance of infinite loops caused by LIST^DIC.
//  Try
//    If FMListerAppt.More = True Then
//      Repeat
//        FMlisterAppt.GetMore(FMListBoxApptExternal.Items);
//      Until FMListerAppt.More <> True;
//  Except
//  End;
  if FMListBoxApptInternal.Items.Count > 0 then
    for x := 0 to FMListBoxApptInternal.Items.Count - 1 do
    begin
      FMListBoxApptInternal.ItemIndex := x;
      FMListBoxApptExternal.ItemIndex := x;
      FMListBoxApptInternal.Items[x] := FMListBoxApptInternal.GetSelectedRecord.IEN + '^' +
        FMDateTimeConvert(FMListBoxApptInternal.GetSelectedRecord.IEN) + '^' +
        FMListBoxApptInternal.Items[x];
    end;
end;

procedure TTIUSignForm.ButtonAllPreviousAppointmentsClick(Sender: TObject);
var
  x: integer;
begin
  ListBox1.Items.Clear;                                                         {Outpt Box}
  ListBox2.Items.Clear;                                                         {Hidden Box}
  ListBox3.Items.Clear;                                                         {Hidden Box}

  ButtonGetApptsClick(Application);
  if FMListBoxApptExternal.Items.Count > 0 then
  begin
    // Visible listbox
    for x := FMListBoxApptExternal.Items.Count - 1 downto 0 do
    begin
      FMListBoxApptExternal.ItemIndex := x;
      ListBox1.Items.Add(FMListBoxApptExternal.GetSelectedRecord.IEN + '^' + Piece(FMListBoxApptExternal.Items[x], '^', 1) + '  ' + Piece(FMListBoxApptExternal.Items[x], '^', 2));
    end;
    // Sort by date
    ListBox1.Sorted := True;
    // Convert date to user friendly date
    for x := FMListBoxApptExternal.Items.Count - 1 downto 0 do
    begin
      ListBox1.Items[x] := FMDateTimeConvert(Piece(ListBox1.Items[x], '^', 1)) + '  ' + Piece(ListBox1.Items[x], '^', 2);
    end;
    // Another sort by date so the two lists match order
    FMListBoxApptInternal.Sorted := true;
    ListBox1.Sorted := False;
    FMListBoxApptInternal.Sorted := false;

    // Now reverse the order of the lists so newest items show at the top, not the bottom
    for x := 0 to ListBox1.Items.Count - 1 do
    begin
      ListBox1.Items.Insert(0, '');
      ListBox1.Items[0] := ListBox1.Items[x + 1];
      ListBox1.Items.Delete(x + 1);
    end;
    for x := 0 to FMListBoxApptInternal.Items.Count - 1 do
    begin
      FMListBoxApptInternal.Items.Insert(0, '');
      FMListBoxApptInternal.Items[0] := FMListBoxApptInternal.Items[x + 1];
      FMListBoxApptInternal.Items.Delete(x + 1);
    end;

  end;

end;

function TTIUSignForm.FindMatchingApptData;
var
  tempdt: string;
  x: integer;
  rslt: string;
begin
  // Figure out the clinic IEN for the selected appt.
  rslt := '';
  result := '';
  ListBoxApptMatches.Items.Clear;
  tempdt := Copy(ListBox1.Items[ListBox1.ItemIndex], 1, Pos('  ', ListBox1.Items[ListBox1.ItemIndex]) - 1);
  // Find appt clinics that match the date/time
  // There may be more than 1
  for x := 0 to FMListboxApptInternal.Items.Count - 1 do
    if Piece(FMListboxApptInternal.Items[x], '^', 2) = tempdt then
      ListBoxApptMatches.Items.Add(Piece(FMListboxApptInternal.Items[x], '^', 1) + '^' + Piece(FMListboxApptInternal.Items[x], '^', 3));
  if ListBoxApptMatches.Items.Count = 0 then
  begin
//    Showmessage('Due to an internal error, a matching appointment could not be found for your selection.');
    ShowmessageCAPRI('Due to an internal error, a matching appointment could not be found for your selection.');
    exit;
  end;
  // Do a lookup for each item in the list and convert to text
  for x := 0 to ListBoxApptMatches.Items.Count - 1 do
  begin
    FMGetsHospitalLocation.IENS := Piece(ListBoxApptMatches.Items[x], '^', 2);
    FMGetsHospitalLocation.GetData;
    ListBoxApptMatches.Items[x] := tempdt + '  ' + FMGetsHospitalLocation.getfield('.01').fmdbexternal + '  ^' + ListBoxApptMatches.Items[x];
  end;
  // Find a match
  for x := 0 to ListBoxApptMatches.Items.Count - 1 do
    if Pos(Piece(ListBoxApptMatches.Items[x], '^', 1), ListBox1.Items[ListBox1.ItemIndex]) = 1 then
      rslt := Piece(ListBoxApptMatches.Items[x], '^', 2) + '^' + Piece(ListBoxApptMatches.Items[x], '^', 3);
  result := rslt;
end;

procedure TTIUSignForm.CheckBoxOpinionClick(Sender: TObject);
begin
  if CheckBoxOpinion.Checked then
  begin
    TabbedNotebook1.visible := false;
    if Panel1.Visible = False then
      GroupBox1.Visible := SameText(UpperCase(TIUSignForm.cmbxCPRqst.Text), 'YES'); //CodeCR459 JRL 5/21/13
    Panel1.Visible := True;
    ListBox1.ItemIndex := -1;
    ListBox4.ItemIndex := -1;
  end
  else
  begin
    TabbedNotebook1.visible := true;
    ListBox1.ItemIndex := -1;
    ListBox4.ItemIndex := -1;
    GroupBox1.Visible := False;
    PNTitles.ItemIndex := -1;
    Panel1.Visible := False;
  end;
end;


function TTIUSignForm.IsUserInputValid(aCoSignMode: Boolean): Boolean;
var
  ApptMatch, ErrMsg, SigErr: string;
  ExamCount: Integer;
  IsExamCountValid: Boolean;
begin
  ApptMatch := '';
  ErrMsg := '';
  SigErr := '';
  IsExamCountValid := True;

  if (aCosignMode = False) then
  begin
    if (Listbox1.ItemIndex = -1) and
      (Listbox4.ItemIndex = -1) and
      (not checkboxOpinion.checked) then
      ErrMsg := ErrMsg + 'Please pick an appointment or admission.' + #13#10;

    if Listbox1.ItemIndex > -1 then
    begin
      ApptMatch := findMatchingApptData;
      if ApptMatch = '' then
        ErrMsg := ErrMsg + 'Could not find the selected appt.  Please try a different appointment.' + #13#10;
    end;

    if PNTitles.ItemIndex = -1 then
      ErrMsg := ErrMsg + 'You must select a valid title.' + #13#10
    else
    begin
      PNTitlesChange(Application);
      if (CosignerButton.Enabled = True) and (FMEdit16.Text = '') then
        ErrMsg := ErrMsg + 'You require a co-signer for the title you''ve selected.' + #13#10;

      if PNTitles.Text = 'ADDENDUM' then
        ErrMsg := ErrMsg + 'You can''t use the title ADDENDUM.' + #13#10
          + 'Select a different one and try again.' + #13#10;
    end;
  end;

  if (labelCosigner.Enabled = False) then                                       {in cosign process or no cosigner required}
  begin
    if PNTitles.Text = 'DISCHARGE SUMMARY' then
      ErrMsg := ErrMsg + 'You can''t use the title DISCHARGE SUMMARY.' + #13#10
        + 'Select a different one and try again.' + #13#10;

    if SameText(UpperCase(TIUSignForm.cmbxCPRqst.Text), 'YES') then             // CodeCR459 JRL 5/21/13
    begin                                                                       // Added if and encapsulated
      ExamCount := GetSelectedExamCount;                                        // existing code
      if ExamCount = 0 then
        ErrMsg := ErrMsg + 'Please select an exam to complete.' + #13#10
      else
        IsExamCountValid := IsSelectedCountValid(ExamCount);
    end; { End If Template was for C&P Request }                                //CodeCR459 JRL 5/21/13

    if FMExProvider.Text = '' then
      ErrMsg := ErrMsg + 'Please enter an examining provider name.' + #13#10;

    {The next validation value is hard-coded to '0' in ButtonOK2Click}
    if ComboBoxExamLocation.ItemIndex = -1 then
      ErrMsg := ErrMsg + 'Please pick an exam location.' + #13#10;

    {The next validation value is hard-coded to '0' in ButtonOK2Click}
    if ComboBoxReleaseReport.ItemIndex = -1 then
      ErrMsg := ErrMsg + 'You must indicate whether this form will be released in AMIE.' + #13#10;

  end;

  //Validate Electronic Signature
  if not IsSignatureValid(SigErr) then
    ErrMsg := ErrMsg + SigErr;

  if (ErrMsg = '') and IsExamCountValid then
    Result := True
  else
    Result := False;

  if (ErrMsg <> '') then
    ShowMessageCAPRI(ErrMsg);
end;

function TTIUSignForm.GetSelectedExamCount: Integer;
var
  I, ExamCount: Integer;
begin
  ExamCount := 0;
  if lstExamsRequested.Items.Count > 0 then
    for I := 0 to lstExamsRequested.Items.Count - 1 do
      if lstExamsRequested.Selected[I] = True then
      begin
        inc(ExamCount);
      end;

  Result := ExamCount;
end;

function TTIUSignForm.IsSignatureValid(var aSigErr: string): Boolean;
begin
  Result := False;
  if Edit3.Text = '' then
    aSigErr := aSigErr + 'You must enter your electronic signature code.'
  else
  begin                                                                         {Value entered}
    frmMain.RPCBroker1.RemoteProcedure := 'ORWU VALIDSIG';
    frmMain.RPCBroker1.Param[1].Value := encrypt(Edit3.Text);
    frmMain.RPCBroker1.Param[1].PType := literal;
    try
      frmMain.RPCBroker1.Call;
    except
      on EBrokerError do
      begin
        ANURemoteProcedureCallInProgress := False;
        frmMain.AnimateLogo(False);
        frmMain.StatusBarLoadPt.Caption := 'RPC ORWU VALIDSIG could not be accessed!';
        frmMain.StatusBarLoadPt.Repaint;
        Application.Processmessages;
        aSigErr := aSigErr + 'RPC ORWU VALIDSIG could not be accessed!' + #13#10;
      end
    end;

    if (aSigErr = '') and (frmMain.RPCBroker1.Results.Count > 0) then
      if frmMain.RPCBroker1.Results[0] = '1' then
        Result := True
      else
      begin
        aSigErr := aSigErr + 'You have entered an invalid electronic signature code.' + #13#10;
        Edit3.Text := '';                                                       //clear invalid code
        Edit3.SetFocus;                                                         //put user in field for retry
      end;
  end;                                                                          {Value entered}

end;

function TTIUSignForm.CreateTIURecord(aVisitIDIEN: string; aTitleIEN: string): string;
var
  Tempstring2: string;
begin
  Result := '';

  frmMain.RPCBroker1.RemoteProcedure := 'TIU CREATE RECORD';
  frmMain.RPCBroker1.Param[0].Value := PNCSform.xPatientIENS.Caption;           // Patient
  frmMain.RPCBroker1.Param[0].PType := literal;
  frmMain.RPCBroker1.Param[1].Value := aTitleIEN;                               // Title
  frmMain.RPCBroker1.Param[1].PType := literal;
  frmMain.RPCBroker1.Param[2].Value := '';                                      // VDT
  frmMain.RPCBroker1.Param[2].PType := literal;
  frmMain.RPCBroker1.Param[3].Value := '';                                      // VLOC
  frmMain.RPCBroker1.Param[3].PType := literal;
  frmMain.RPCBroker1.Param[4].Value := '';                                      // VisitIDIEN;         //VSIT
  frmMain.RPCBroker1.Param[4].PType := literal;
  frmMain.RPCBroker1.Param[5].Mult['1202'] := AuthorIEN;
  frmMain.RPCBroker1.Param[5].Mult['1301'] := Piece(aVisitIDIEN, ';', 2);       // Reference Date
  frmMain.RPCBroker1.Param[5].Mult['1205'] := Piece(aVisitIDIEN, ';', 1);       // Location
  frmMain.RPCBroker1.Param[5].Mult['1208'] := FMEdit16.Text;                    // Cosigner
  frmMain.RPCBroker1.Param[5].Mult['1701'] := '';                               //Subject
  frmMain.RPCBroker1.Param[5].PType := list;
  frmMain.RPCBroker1.Param[6].Value := aVisitIDIEN;                             // Visit Location; Date/Time; Service category (Optional)
  frmMain.RPCBroker1.Param[6].PType := literal;
  frmMain.RPCBroker1.Param[7].Value := '1';                                     //Suppress?
  frmMain.RPCBroker1.Param[7].PType := literal;

//  ======================   DEBUG ONLY ======================================
  Tempstring2 := 'DEBUG INFO:' + char(13);
  TempString2 := TempString2 + 'BROKER CALL:  TIU CREATE RECORD' + char(13);
  TempString2 := TempString2 + '* Param 0' + char(13);
  TempString2 := TempString2 + frmMain.RPCBroker1.Param[0].Value + char(13);
  TempString2 := TempString2 + '* Param 1' + char(13);
  TempString2 := TempString2 + frmMain.RPCBroker1.Param[1].Value + char(13);
  TempString2 := TempString2 + '* Param 2' + char(13);
  TempString2 := TempString2 + frmMain.RPCBroker1.Param[2].Value + char(13);
  TempString2 := TempString2 + '* Param 3' + char(13);
  TempString2 := TempString2 + frmMain.RPCBroker1.Param[3].Value + char(13);
  TempString2 := TempString2 + '* Param 4' + char(13);
  TempString2 := TempString2 + frmMain.RPCBroker1.Param[4].Value + char(13);
  TempString2 := TempString2 + '* Param 5' + char(13);
  TempString2 := TempString2 + 'Mult[1202]=' + frmMain.RPCBroker1.Param[5].Mult['1202'] + char(13);
  TempString2 := TempString2 + 'Mult[1301]=' + frmMain.RPCBroker1.Param[5].Mult['1301'] + char(13);
  TempString2 := TempString2 + 'Mult[1205]=' + frmMain.RPCBroker1.Param[5].Mult['1205'] + char(13);
  TempString2 := TempString2 + 'Mult[1208]=' + frmMain.RPCBroker1.Param[5].Mult['1208'] + char(13);
  TempString2 := TempString2 + 'Mult[1701]=' + frmMain.RPCBroker1.Param[5].Mult['1701'] + char(13);
  TempString2 := TempString2 + '****  TEMPLATE NOTE FREE TEXT HAS BEEN EXCLUDED TO KEEP THIS INFO SCREEN CONCISE ****' + char(13);
  TempString2 := TempString2 + '* Param 6' + char(13);
  TempString2 := TempString2 + frmMain.RPCBroker1.Param[6].Value + char(13);
  TempString2 := TempString2 + '* Param 7' + char(13);
  TempString2 := TempString2 + frmMain.RPCBroker1.Param[7].Value + char(13);
//    Next line will show the params in a message, for debugging
//  Showmessage(TempString2);
//  ========================================================================}

  frmMain.RPCBrokerCall;
  try
    frmMain.RPCBroker1.Call;
  except
    on EBrokerError do
    begin
      ANURemoteProcedureCallInProgress := False;
      frmMain.AnimateLogo(False);
      frmMain.StatusBarLoadPt.Caption := 'RPC TIU CREATE RECORD could not be accessed!';
      frmMain.StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('RPC TIU CREATE RECORD could not be accessed!');
    end;
  end;

  if frmMain.RPCBroker1.Results.Count > 0 then
    Result := frmMain.RPCBroker1.Results[0];
end;

function TTIUSignForm.GetTIUText(aTIUNoteIEN: string; aTIUText: TStringList): Boolean;
begin
  Result := False;
  frmMain.RPCBroker1.RemoteProcedure := 'TIU GET RECORD TEXT';
  frmMain.RPCBroker1.Param[1].Value := aTIUNoteIEN;
  frmMain.RPCBroker1.Param[1].PType := literal;
  try frmMain.RPCBroker1.Call;
  except
    on EBrokerError do
    begin
      ANURemoteProcedureCallInProgress := False;
      frmMain.AnimateLogo(False);
      frmMain.StatusBarLoadPt.Caption := 'RPC TIU GET RECORD TEXT could not be accessed!';
      frmMain.StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('RPC TIU GET RECORD TEXT could not be accessed!');
      Exit;
    end;
  end;
  QuickCopy(frmMain.RPCBroker1.Results, aTIUText);
  Result := True;
end;

function TTIUSignForm.GetLineCount(aTIUText: TStringList): Integer;
var
  s: string;
  I, LineCount: Integer;
  EmptyLine: Boolean;
begin
  s := '';
  EmptyLine := false;
  LineCount := 0;
  // strip header and only show anything after the first blank line
  for I := 0 to aTIUText.Count - 1 do
  begin
    if EmptyLine = True then
    begin
      s := s + aTIUText[I] + #13;
      inc(LineCount);
    end;
    if trim(aTIUText[I]) = '' then
      EmptyLine := True;
  end;
  Result := LineCount;
end;

function TTIUSignForm.IsSelectedCountValid(anExamCount: Integer): Boolean;
var
  I: Integer;
  MsgStr: string;
begin
  Result := True;
  MsgStr := '';
  // Check that the selected # of forms is the same as the # used
  if (anExamCount < xFMTemplatesUtilized.Lines.Count) then
    MsgStr := 'You''ve selected LESS exams to close than the number of templates used to make the current document.' + #13#10#13#10
  else if (anExamCount > xFMTemplatesUtilized.Lines.Count) then
    MsgStr := 'You''ve selected MORE exams to close than the number of templates used to make the current document.' + #13#10#13#10;

  if (MsgStr <> '') and (CosignerButton.Caption = '') then
  begin                                                                         // Don't do this if co-signer is selected   tempString:=tempstring+'Templates used: '+char(13);
    for I := 0 to (xFMTemplatesUtilized.Lines.Count - 1) do
      MsgStr := MsgStr + '  '
        + Piece(xFMTemplatesUtilized.Lines[I], '^', 2) + #13#10;

    MsgStr := MsgStr + #13#10 + 'Exams selected for closure: ' + #13#10;

    for I := 0 to (lstExamsRequested.Items.Count - 1) do
      if lstExamsRequested.Selected[I] then
        MsgStr := MsgStr + '  ' + Piece(piece(lstExamsRequested.Items[I], '^', 1), '[', 1) + #13#10;

    MsgStr := MsgStr + #13#10 + 'This may be ok.  Do you want to continue with the signature process?';

    if (MessageDlgCAPRI(MsgStr, mtConfirmation, [mbYes, mbNo], 0) = mrYes) then
      Result := True
    else
      Result := False;

  end;
end;

function TTIUSignForm.SignTIURecord(aTIUNoteIEN, aSignature: string): Boolean;
begin
  Result := False;
  frmMain.RPCBroker1.Results.Clear;
  frmMain.RPCBroker1.Param.Clear;
  frmMain.RPCBroker1.RemoteProcedure := 'TIU SIGN RECORD';
  frmMain.RPCBroker1.Param[0].Value := aTIUNoteIEN;
  frmMain.RPCBroker1.Param[0].PType := literal;
  frmMain.RPCBroker1.Param[1].Value := Encrypt(aSignature);
  frmMain.RPCBroker1.Param[1].PType := literal;
  frmmain.RPCBrokerCall;
  try
    frmMain.RPCBroker1.Call;
  except
    on EBrokerError do
      ShowMessageCAPRI('Connection to server could not be established!');
  end;

  if frmMain.RPCBroker1.Results.Count > 0 then
    if (piece(frmMain.RPCBroker1.Results[0], '^', 1) = '0') then
      Result := True
    else
      ShowmessageCAPRI('TIU Signature Process failed!' + #13#10
        + piece(frmMain.RPCBroker1.Results[0], '^', 2));
end;

procedure TTIUSignForm.SetExamInTemplate(aCosignMode: Boolean);
var
  DFN: string;
  I: Integer;
begin
  if aCosignMode then
    DFN := ptIENHidden.Caption
  else
    DFN := pncsform.xFMEdit2.IENS;

  for I := 0 to lstExamsRequested.Items.Count - 1 do
    if lstExamsRequested.Selected[I] = true then
    begin
      FMFiler1.AddFDA('396.1718', '+1,' + Piece(DFN, '^', 1), '.01', Piece(lstExamsRequested.Items[I], '^', 2));
      FMFiler1.Update;
    end;
end;

procedure TTIUSignForm.SetAMIEResults(aTIUNoteIEN, aVisitIDIEN, anAppointment: string);
var
  I: Integer;
  Institution, Division, OriginalExamInfo: string;
  TIUText: TStringList;
begin
  OriginalExamInfo := '';
  Institution := '';
  Division := '';

  //determine Institution and Division
  if anAppointment <> '' then
  begin
    frmMain.FMGetsHospitalLocation.IENS := anAppointment;
    frmMain.FMGetsHospitalLocation.GetData;
    try
      Institution := frmMain.FMGetsHospitalLocation.GetField('3').FMDBExternal;
    except
    end;
    try
      Division := frmMain.FMGetsHospitalLocation.GetField('3.5').FMDBExternal;
    except
    end;
  end;

  for I := 0 to lstExamsRequested.Items.Count - 1 do
  begin
    if lstExamsRequested.Selected[I] = true then
    begin
      FMMemoAMIEResults.IENS := Piece(lstExamsRequested.Items[I], '^', 2);
      if OriginalExamInfo = '' then
      begin
        // Pull back note from TIU with header and save back to AMIE
        // Only put report in first exam type
        TIUText := TStringList.Create;
        try
          GetTIUText(aTIUNoteIEN, TIUText);
          TIUText.Insert(4, '    DIVISION: ' + Division);
          TIUText.Insert(4, ' INSTITUTION: ' + Institution);
          FMMemoAMIEResults.Lines := TIUText;
        finally
          FreeAndNil(TIUText);
        end;
        OriginalExamInfo := Piece(Piece(lstExamsRequested.Items[I], '^', 1), '[', 1);
      end
      else
      begin
        // Reference the saved report here
        FMMemoAMIEResults.Lines.clear;
        FMMemoAMIEResults.Lines.add('Please refer to the exam report contained in:');
        FMMemoAMIEResults.Lines.add(OriginalExamInfo);
      end;
      FMExProvider.IENS := FMMemoAMIEResults.IENS;
      if FMExProvider.FMModified then
        if FMExProvider.Validate then
        begin
          FMFiler1.AddChgdControl(FMExProvider);
          FMExProvider.Text := FMExProvider.FMCtrlExternal;
        end
        else
        begin
          frmMain.FMValidator1.DisplayErrors;
          FMExProvider.Text := FMExProvider.FMTag;
        end;
      FMFiler1.AddChgdControl(FMMemoAMIEResults);

      if ComboBoxReleaseReport.ItemIndex = 0 then
      begin
        // Set Status
        frmMain.FMValidator1.SetUp('396.4', FMMemoAMIEResults.IENS, '.04', 'C');
        FMFiler1.AddFDA('396.4', FMMemoAMIEResults.IENS, '.04', 'C');
        frmMain.FMValidator1.SetUp('396.4', FMMemoAMIEResults.IENS, '75', aTIUNoteIEN);
        FMFiler1.AddFDA('396.4', FMMemoAMIEResults.IENS, '75', aTIUNoteIEN);
      end;
      // Set Location
      frmMain.FMValidator1.SetUp('396.4', FMMemoAMIEResults.IENS, '.09', Copy(ComboBoxExamLocation.Text, 1, 1));
      FMFiler1.AddFDA('396.4', FMMemoAMIEResults.IENS, '.09', Copy(ComboBoxExamLocation.Text, 1, 1));

      //Date of Exam
      frmMain.FMValidator1.SetUp('396.4', FMMemoAMIEResults.IENS, '.06', Piece(VisitIDien, ';', 2));
      FMFiler1.AddFDA('396.4', FMMemoAMIEResults.IENS, '.06', Piece(aVisitIDien, ';', 2));

      //I6587267FY16  rra - populate the CAPRI TEMPLATE ID field with the CAPRI TEMPLATE ien - Patch 193 7/19/16
      frmMain.FMValidator1.SetUp('396.4', FMMemoAMIEResults.IENS, '1', pncsform.xFMEdit2.IENS);
      FMFiler1.AddFDA('396.4', FMMemoAMIEResults.IENS, '1', pncsform.xFMEdit2.IENS);
            
      if FMFiler1.AnythingToFile then
        if FMFiler1.DataProblemCheck then
          FMFiler1.ProcessDataProblemList
        else
          FMFiler1.Update;
    end;
  end;
end;

function TTIUSignForm.GetApptPointer(aTIUNoteIEN: string): string;
begin
  frmMain.FMGetsTIU.IENS := aTIUNoteIEN;
  frmMain.FMGetsTIU.GetAndFill;
  try
    Result := frmMain.FMGetsTIU.GetField('1205').FMDBInternal;
  except
    Result := '';
  end;
end;

function TTIUSignForm.IsExamOKtoRelease: Boolean;
var
  I: Integer;
  Open, TransferredOut, Transcribed, InComplete: Boolean;
begin
  Open := False;
  TransferredOut := False;
  Transcribed := False;
  InComplete := False;
  // All Exams complete?
  if (lstExamsRequested.Items.Count > 0) then
    InComplete := True;
  // Check each exam result and be sure it's released and not "transcribed"
  // prior to releasing the whole request
  for I := 0 to lstExamsRequestedHidden.Items.Count - 1 do
  begin
    //verify that status is not OPEN or TRANSFERRED OUT
    if (POS('[OPEN]', lstExamsRequestedHidden.Items[I]) > 0) then
      Open := True;
    if (POS('[TRANSFERRED OUT]', lstExamsRequestedHidden.Items[I]) > 0) then
      TransferredOut := True;
    // Verify ALL existing exams do not have a date transcription complete
    // value - file 396.4, field 90
    // If any have a date, then we don't want to auto release
    FMGetsExamInfo.IENS := Piece(lstExamsRequestedHidden.Items[I], '^', 1);
    FMGetsExamInfo.GetData;
    if FMGetsExamInfo.GetField('90').FMDBExternal <> '' then
      Transcribed := True;
  end;

  if Transcribed or Open or TransferredOut or InComplete then
  begin
    Result := False;
    if Transcribed then
      ShowMessageCAPRI('INFO: This case cannot be closed because ' +
        'there are one or more transcribed exams.  ' +
        'You may wish to notify the C&P clinic that ' +
        'the exam request may be ready for manual release.')
    else
      ShowMessageCAPRI('INFO: This case is not ready to be closed due to ' +
        'open or transferred out exams.');
  end
  else
    Result := True;
end;

procedure TTIUSignForm.ReleaseExamToRO;
var
  Patch193Installed : Boolean;
begin
  // Need to check the patch before calling RPC.  If patch is checked during the
  // routine, we lose the original RPC data
  if IsPatchInstalled('DVBA*2.7*193') then
     Patch193Installed := TRUE
  else
     Patch193Installed := FALSE; 

  // Do the release update here
  frmMain.RPCBroker1.RemoteProcedure := 'ORWU DT';
  frmMain.RPCBroker1.Param[1].Value := 'NOW';
  frmMain.RPCBroker1.Param[1].PType := literal;
  frmMain.RPCBrokerCall;
  try
    frmMain.RPCBroker1.Call;
  except
    on EBrokerError do
    begin
      ANURemoteProcedureCallInProgress := False;
      frmMain.AnimateLogo(False);
      frmMain.StatusBarLoadPt.Caption := 'RPC ORWU DT could not be accessed!';
      frmMain.StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('ORWU DT could not be accessed!');
    end;
  end;
  // AMIE thinks Other Documents Required is a necessary field, but the RO doesn't
  // fill it in, so this code fails if validated.
  frmMain.FMValidator1.SetUp('396.3', FMExamRequestListbox.GetSelectedRecord.IEN, '6', frmMain.RPCBroker1.Results[0]); //Date completed
  frmMain.FMValidator1.SetUp('396.3', FMExamRequestListbox.GetSelectedRecord.IEN, '13', frmMain.RPCBroker1.Results[0]); // Date released
  frmMain.FMValidator1.SetUp('396.3', FMExamRequestListbox.GetSelectedRecord.IEN, '14', AuthorIEN); // Released by

  // Request Status field has changed from a set of codes to a pointer.  Update
  // field with 'RELEASED TO RO, NOT PRINTED' IEN of 4.  Patch 193 JRL 4/28/16
  // Do not validate IEN here - may return an error.
  if NOT Patch193Installed then
     frmMain.FMValidator1.SetUp('396.3', FMExamRequestListbox.GetSelectedRecord.IEN, '17', 'R'); // Released by

  FMFiler1.AddFDA('396.3', FMExamRequestListbox.GetSelectedRecord.IEN, '6', frmMain.RPCBroker1.Results[0]);
  FMFiler1.AddFDA('396.3', FMExamRequestListbox.GetSelectedRecord.IEN, '13', frmMain.RPCBroker1.Results[0]);
  FMFiler1.AddFDA('396.3', FMExamRequestListbox.GetSelectedRecord.IEN, '14', AuthorIEN);
  // Request Status field has changed from a set of codes to a pointer.  Updating 
  // field with 'RELEASED TO RO, NOT PRINTED' IEN of 4.  Patch 193 JRL 4/28/16
  if Patch193Installed then
    FMFiler1.AddFDA('396.3', FMExamRequestListbox.GetSelectedRecord.IEN, '17', '4')
  else
    FMFiler1.AddFDA('396.3', FMExamRequestListbox.GetSelectedRecord.IEN, '17', 'R');

  if FMFiler1.AnythingToFile then
    if FMFiler1.DataProblemCheck then
      FMFiler1.ProcessDataProblemList
    else
    begin
      FMFiler1.Update;
// CodeCR471 JRL 4/26/13 - Remove email notification.  This now happens as each
//                         exam is signed and not at the end of the Request
//      //CodeCR266 - rpm 1/18/12 - Send email notification
//      frmMain.MailManBuffer.Lines.Clear;
//      frmMain.MailManBuffer.Lines.Add('');
//      SendNotification(frmMain.MailManBuffer.Lines,
//                       AuthorIEN,
//                       'CAPRI: Release of 2507 Request',
//                       'DVBA C 2507 EXAM READY',
//                       FMExamRequestListbox.GetSelectedRecord.IEN);

      ShowmessageCAPRI('The selected exam request has been released to the Regional Office.');
    end;
end;

procedure TTIUSignForm.SetMatchingTemplateComplete(aTIUNoteIEN: string);
var
  I: Integer;
  frmUncosigned: TfrmUncosigned;
begin
  frmUncosigned := TfrmUncosigned.Create(TIUSignForm);
  try
    frmUncosigned.buttonsearchclick(application);
    I := -1;
    if frmUncosigned.FMListBoxTemplates.Items.Count > 0 then
      repeat
        inc(I);
        if I > frmUncosigned.FMListBoxTemplates.Items.Count - 1 then
          I := -1;
      until (aTIUNoteIEN = findLastPiece(frmUncosigned.FMListBoxTemplates.Items[I])) or (I = -1) or (I = frmUncosigned.FMListBoxTemplates.Items.Count - 1);
    if I > 0 then
    begin
      // Update CAPRI template status to complete
      frmUncosigned.FMListBoxTemplates.ItemIndex := I;
      // Patch 193 JRL 4/29/16
      // Changed Request Status field to pointer field.  Using IEN to populate
      // status here.
      If IsPatchInstalled('DVBA*2.7*193') then 
        frmMain.FMFiler1.AddFDA('396.17', frmUncosigned.FMListBoxTemplates.GetSelectedRecord.IEN, '11', '5')
      else
        frmMain.FMFiler1.AddFDA('396.17', frmUncosigned.FMListBoxTemplates.GetSelectedRecord.IEN, '11', 'C');

      frmMain.FMFiler1.Update;
    end
    else
    begin
      ShowmessageCAPRI('NOTICE:  Couldn''t find a matching template to close in CAPRI.  The exam has been updated in AMIE, but no CAPRI templates have been modified.');
    end;
  finally
    FreeAndNil(frmUncosigned);
  end;
end;

function TTIUSignForm.IsTIUTextValid(aTIUNoteIEN: string): Boolean;
var
  TIUText: TStringList;
  LineCount: Integer;
begin
  Result := False;

  TIUText := TStringList.Create;
  try
    GetTIUText(TIUNoteIEN, TIUText);
    LineCount := GetLineCount(TIUText);
    if LineCount < PNCSForm.xSampleReportOutput.Lines.count then
      ShowmessageCAPRI('ERROR!   The signature process has been halted because CAPRI ' +
        'has detected that the uploaded document is missing lines.  ' +
        'Please check the document in CPRS.  You may need to perform this ' +
        'exam release using manual processes.  Please notify the national CAPRI ' +
        'team of this problem.')
    else
      Result := True;
  finally
    FreeAndNil(TIUText);
  end;
end;

function TTIUSignForm.GetTIUTitleIEN: string;
var
  I: Integer;
  title: String;  // 1259707 rra
begin
//  for I := 0 to pncsForm.xFMPNTitles.Items.Count - 1 do
//    if Pos(PNTitles.Items[PNTitles.ItemIndex] + '  11', pncsForm.xFMPNTitles.Items[I]) > 0 then
//      Result := Copy(pncsForm.xFMPNTitles.Items[I], Pos('  IEN#', pncsForm.xFMPNTitles.Items[I]) + 6, 99);

//1259707 rra modify selection logic to evaluate full name - Patch 193 7/19/16
  for I := 0 to pncsForm.xFMPNTitles.Items.Count - 1 do
  begin
    title := Copy(pncsForm.xFMPNTitles.Items[I], 1, Pos('  11',pncsForm.xFMPNTitles.Items[I])-1);
    if title = PNTitles.Items[PNTitles.ItemIndex] then
      Result := Copy(pncsForm.xFMPNTitles.Items[I], Pos('  IEN#', pncsForm.xFMPNTitles.Items[I]) + 6, 99);
  end;
end;

function TTIUSignForm.DeleteTIURecord(aTIUNoteIEN, aSignature: string): Boolean;
begin
  Result := False;

  frmMain.RPCBroker1.RemoteProcedure := 'TIU DELETE RECORD';
  frmMain.RPCBroker1.Param[0].Value := aTIUNoteIEN;
  frmMain.RPCBroker1.Param[0].PType := literal;
  frmMain.RPCBroker1.Param[1].Value := Encrypt(aSignature);
  frmMain.RPCBroker1.Param[1].PType := literal;
  try
    frmMain.RPCBroker1.Call;
  except
    on EBrokerError do
      ShowMessageCAPRI('Connection to server could not be established!');
  end;

  if frmMain.RPCBroker1.Results.Count > 0 then
  begin
    if Piece(frmMain.RPCBroker1.Results[0], '^', 1) <> '0' then                 //Error
    begin
      ShowMessageCAPRI('WARNING:  Document could not be deleted.  ' +
        Piece(frmMain.RPCBroker1.Results[0], '^', 2))
    end;
  end;
end;

{==============================================================================
 Added Routine for CodeCR459 JRL 5/21/13
 ==============================================================================}

procedure TTIUSignForm.cmbxCPRqstChange(Sender: TObject);
var
  CPExam: Boolean;
begin
  CPExam := SameText(UpperCase(TIUSignForm.cmbxCPRqst.Text), 'YES');
  { Display/Hide AMIE Info }
  GroupBox1.Visible := (CPExam and Panel1.Visible);
  pnlNotACnPExam.Visible := not CPExam;                                         // JRL 7/22/13
  { Update Available Titles }
  PopTitleList(CPExam);
end;

{==============================================================================
 Added Routine for CodeCR459 JRL 5/21/13
 ==============================================================================}

procedure TTIUSignForm.PopTitleList(forCPRqst: Boolean);
var
  i: Integer;
begin
  Screen.Cursor := crHourGlass;
  if forCPRqst then
  begin
    for i := PNTitles.Items.Count - 1 downto 0 do
      if ((Pos('C&P', TIUSignForm.PNTitles.Items[i]) = 0) and
        (Pos('PENSION', TIUSignForm.PNTitles.Items[i]) = 0) and
        (Pos('COMPENSATION', TIUSignForm.PNTitles.Items[i]) = 0) and
        (Pos('COMP AND PEN', TIUSignForm.PNTitles.Items[i]) = 0) and
        (Pos('COMP &', TIUSignForm.PNTitles.Items[i]) = 0)) then
        TIUSignForm.PNTitles.Items.Delete(i)
  end                                                                           { End If Template Satisfies C&P Request }
  else
  begin
    PNTitles.Items.Clear;
    for i := 0 to titleLst.Count - 1 do
      PNTitles.Items.Add(titleLst[i]);                                          { Add All Titles w/o filtering }
  end;                                                                          { End Else If NOT C&P Request Specific - Wide Open Titles }
  Screen.Cursor := crDefault;
end;

{==============================================================================
Added Routine for CodeCR562 JRL 7/16/14 - Retransmit DBQs that fail

Instead of searching for all the error conditions, this routine only searches
for success.  If it doesn't have SUCCESS in the message, it is considered that
the exam did not transmit and failed.
==============================================================================}

function TTIUSignForm.CheckErrorsForRetransmitOption(
  vlerDasClientResult: TStringList): Boolean;
const
  SUCCESS = 'SUCCESS';
//  SUCCESS = 'SUCCESS: Request Processed';
//  ERROR1 = 'Error connecting with SSL';
//  ERROR2 = '<PROXY-ERROR>';
//  ERROR3 = 'HTTP/1.1 503 Service Unavailable';
//  ERROR4 = '<proxy-error>ProxyAuthFailed</proxy-error>';
//  ERROR5 = '<proxy-error>AuthTimeout</proxy-error>';
//  ERROR6 = '<proxy-error>Connection abruptly ended</proxy-error>';
//  ERROR7 = '<proxy-error>TokenExpired</proxy-error>';
var
  TransmissionResult: string;
begin
  Result := FALSE;                                                              // ExamSent = FALSE

  if (vlerDasClientResult.Count > 0) then begin
    TransmissionResult := UpperCase(vlerDasClientResult[0]);
    if Pos(SUCCESS, TransmissionResult) > 0 then
      Result := TRUE;                                                           // SUCCESS - Exam Sent!
  end;
end;

function TTIUSignForm.ReleaseVendorExamResultsToVLER(selectedRequestID: string): Boolean;
var
  frmCntrctdExmMain: TfrmCntrctdExmMain;
  frmManageReportsCCR: TfrmManageReportsCCR;
  tbool: Boolean;
begin
  Result := True;                                                               // rpk 10/30/2014

  frmCntrctdExmMain := TfrmCntrctdExmMain.Create(nil);
  try
    frmManageReportsCCR := frmCntrctdExmMain.CreateManageReportsCCR;            // rpk 10/29/2014
    try
      try
//      if not frmManageReportsCCR.ReleaseVendorExamResultsToVLER(selectedRequestID) then begin
        tbool := frmManageReportsCCR.ReleaseVendorExamResultsToVLER(selectedRequestID); // rpk 10/30/2014
      except
        Result := False;
        Exception.CreateFmt('Error processing exam request %s; contact support to resolve.',
          [selectedRequestID]);
      end;
    finally
      FreeAndNil(frmManageReportsCCR);
    end;
  finally
    FreeAndNil(frmCntrctdExmMain);
  end;
end;                                                                            // ReleaseVendorExamResultsToVLER

end.

