unit uncosignedutility;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  DialogsCAPRI,
  Dialogs,
  StdCtrls,
  Fmcntrls,
  Diaccess,
  Fmcmpnts,
  Gauges,
  TRPCB,
  ComCtrls,
  ExtCtrls,
  CAPRISupport,
  OrFN,
  ORDtTm;

type
  TfrmUncosigned = class(TForm)
    FMListerTemplates: TFMLister;
    FMExamRequestLister1: TFMLister;
    FMGetsExamInfo: TFMGets;
    Panel1: TPanel;
    Label1: TLabel;
    FMListBoxTemplates: TFMListBox;
    ButtonSearch: TButton;
    Button1: TButton;
    LabelReady: TLabel;
    Gauge1: TGauge;
    PanelNoteText: TPanel;
    Label13: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    ComboBoxReleaseReport: TComboBox;
    memoDocs: TRichEdit;
    Button2: TButton;
    GroupBox1: TGroupBox;
    Label2: TLabel;
    Label9: TLabel;
    Label15: TLabel;
    FMExamRequestListbox: TFMListBox;
    lstExamsRequested: TListBox;
    lstExamsRequestedHidden: TListBox;
    Button4: TButton;
    FMExProvider: TFMEdit;
    ComboBoxExamLocation: TComboBox;
    FMMemoAMIEResults: TFMMemo;
    Button3: TButton;
    FMGetsExamRequestInfo: TFMGets;
    FMEdit1: TFMEdit;
    procedure ButtonSearchClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FMExamRequestListboxClick(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FMExProviderKeyPress(Sender: TObject; var Key: Char);
    procedure FMExProviderExit(Sender: TObject);
    procedure FMListBoxTemplatesDrawItem(Control: TWinControl;
      Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure FMListBoxTemplatesClick(Sender: TObject);
    procedure FMListBoxTemplatesDblClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmUncosigned: TfrmUncosigned;
  ContinueCosSearch: Boolean;
  TIUNoteIEN: string;
implementation

uses main, CCOWRPCBrokerCAPRI;

{$R *.DFM}

procedure TfrmUncosigned.ButtonSearchClick(Sender: TObject);
var
  x, y: integer;
  ready: integer;
  headertext: ansistring;

  function findLastPiece(s: string): string;
  var
    x: integer;
  begin
    result := '';
    x := length(s) - 1;
    if x > 0 then
      repeat begin
          if s[x] = ' ' then
            result := copy(s, x + 1, length(s));
          dec(x);
      end until (result <> '') or (x = 0);
  end;

begin
  if ANURemoteProcedureCallInProgress = True then
    exit;

  button1.enabled := false;
  ready := 0;
  FMListerTemplates.GetList(FMListBoxTemplates.Items);
  if FMListerTemplates.More = true then
    repeat begin
        FMListerTemplates.GetList(FMListBoxTemplates.Items);
        frmUncosigned.Repaint;
    end until FMListerTemplates.More = false;

  Gauge1.Progress := 0;
  Gauge1.Visible := True;
  if FMListBoxTemplates.Items.Count > 0 then
    Gauge1.MaxValue := FMListBoxTemplates.Items.Count - 1;
  if FMListBoxTemplates.Items.Count > 0 then
    for x := 0 to FMListBoxTemplates.Items.Count - 1 do begin
      Gauge1.Progress := x;
      lstExamsRequested.Items.Clear;
      TIUNoteIEN := findLastPiece(FMListBoxTemplates.Items[x]);
      // Determine if a note still needs signature or co-signature or not.
      frmMain.RPCBroker1.Results.Clear;
      frmMain.RPCBroker1.RemoteProcedure := 'TIU GET RECORD TEXT';
      frmMain.RPCBroker1.Param[0].Value := TIUNoteIEN; //TIU Document number
      frmMain.RPCBroker1.Param[0].PType := literal;
      frmMain.RPCBrokerCall;
      try
        frmMain.RPCBroker1.Call;
      except
        on EBrokerError do begin
          ANURemoteProcedureCallInProgress := False;
          frmMain.AnimateLogo(False);
          frmMain.StatusBarLoadPt.Caption := 'TIU GET RECORD TEXT could not be accessed!';
          frmMain.StatusBarLoadPt.Repaint;
          Application.Processmessages;
          ShowMessageCAPRI('TIU GET RECORD TEXT could not be accessed!');
        end;
      end;
      //QuickCopy(RPCBroker1.Results,Dest);
      // Get header
      y := 0;
      headertext := '';
      if frmMain.RPCBroker1.Results.Count > 3 then
        repeat
          headertext := headertext + frmMain.RPCBroker1.Results[y] + char(13);
          inc(y);
        until (y > frmMain.RPCBroker1.Results.Count) or (frmMain.RPCBroker1.Results[y] = '');

      if frmMain.RPCBroker1.Results.Count > 3 then
        if pos('STATUS: COMPLETED', uppercase(headertext)) > 0 then begin
          fmListBoxTemplates.Items[x] := '*' + fmListBoxTemplates.Items[x];
          inc(ready);
        end;
    end;

  Gauge1.Visible := False;

  if Ready = 1 then
    LabelReady.Caption := '1 document ready'
  else
    LabelReady.Caption := inttostr(ready) + ' documents ready';

  //jcs - modified logic, removed try/except
  if IsSetFocusValid(FMListBoxTemplates) then
    FMListBoxTemplates.SetFocus;

end;

procedure TfrmUncosigned.Button1Click(Sender: TObject);
var
  x, y: integer;
  Date1, Date2, Date3: string;
  function findLastPiece(s: string): string;
  var
    x: integer;
  begin
    result := '';
    x := length(s) - 1;
    if x > 0 then
      repeat begin
          if s[x] = ' ' then
            result := copy(s, x + 1, length(s));
          dec(x);
      end until (result <> '') or (x = 0);
  end;
begin
  if FMListBoxTemplates.Items.Count < 1 then begin
    ShowMessageCAPRI('There are no documents requiring cosignature resolution.');
    exit;
  end;
  frmUncosigned.borderIcons := [];

  //If FMListBoxTemplates.Items.Count>0 then
    //For x:=0 to FMListBoxTemplates.Items.Count-1 do begin;

  x := FMListBoxTemplates.ItemIndex;

  lstExamsRequested.Items.Clear;
  TIUNoteIEN := findLastPiece(FMListBoxTemplates.Items[x]);
  // Determine if a note still needs signature or co-signature or not.
  frmMain.RPCBroker1.Results.Clear;
  frmMain.RPCBroker1.RemoteProcedure := 'TIU GET RECORD TEXT';
  frmMain.RPCBroker1.Param[0].Value := TIUNoteIEN; //TIU Document number
  frmMain.RPCBroker1.Param[0].PType := literal;
  frmMain.RPCBrokerCall;
  try
    frmMain.RPCBroker1.Call;
  except
    on EBrokerError do begin
      ANURemoteProcedureCallInProgress := False;
      frmMain.AnimateLogo(False);
      frmMain.StatusBarLoadPt.Caption := 'TIU GET RECORD TEXT could not be accessed!';
      frmMain.StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('TIU GET RECORD TEXT could not be accessed!');
    end;
  end;
  //QuickCopy(RPCBroker1.Results,Dest);
  if frmMain.RPCBroker1.Results.Count > 3 then begin
    //ShowMessageCAPRI(inttostr(x)+' is completed');
    memoDocs.Lines.Clear;
    FMExamRequestListbox.Items.Clear;
    lstExamsRequested.Items.Clear;
    QuickCopy(frmMain.RPCBroker1.Results, memoDocs);
    panelNoteText.Visible := True;
    PanelNoteText.BringToFront;

    FMListBoxTemplates.ItemIndex := x;
    FMGetsExamInfo.IENS := FMListBoxTemplates.GetSelectedRecord.IEN;
    FMGetsExamInfo.GetAndFill;
    {Get AMIE Exam Requests}
    FMExamRequestLister1.PartList.Clear;
    FMExamRequestLister1.PartList.Add(FMGetsExamInfo.GetField('.01').FMDBInternal);
    FMExamRequestListbox.GetList;
    // Make sure data is correct for PatientIEN
    if FMExamRequestListbox.Items.Count > 0 then
      for y := FMExamRequestListbox.Items.Count - 1 downto 0 do begin
        if Pos(FMGetsExamInfo.GetField('.01').FMDBInternal + '  ', FMExamRequestListbox.Items[y]) <> 1 then
          FMExamRequestListbox.Items.Delete(y);
      end;
    // Reformat data
    // Don't show complete or cancelled exams
    if FMExamRequestListbox.Items.Count > 0 then
      for y := FMExamRequestListbox.Items.Count - 1 downto 0 do begin
        FMExamRequestListbox.Items[y] := Copy(FMExamRequestListbox.Items[y], Pos('  ', FMExamRequestListbox.Items[y]) + 4, 255); // Strip patient IEN;
        Date1 := Copy(FMExamRequestListbox.Items[y], 1, Pos('  ', FMExamRequestListbox.Items[y]) - 1);
        FMExamRequestListbox.Items[y] := Copy(FMExamRequestListbox.Items[y], Pos('  ', FMExamRequestListbox.Items[y]) + 4, 500);
        Date2 := Copy(FMExamRequestListbox.Items[y], 1, Pos('  ', FMExamRequestListbox.Items[y]) - 1);
        FMExamRequestListbox.Items[y] := Copy(FMExamRequestListbox.Items[y], Pos('  ', FMExamRequestListbox.Items[y]) + 4, 500);
        Date3 := Copy(FMExamRequestListbox.Items[y], 1, 254);
        if Date2 <> '' then
          FMExamRequestListbox.Items[y] := Copy(FMDateTimeConvert(Date1) + '                    ', 1, 20) + '  |  ' + FMDateTimeConvert(Date2)
        else
          if Date3 <> '' then
            FMExamRequestListbox.Items[y] := Copy(FMDateTimeConvert(Date1) + '                    ', 1, 20) + '  |  ' + FMDateTimeConvert(Date3) + ' [EXAM CANCELED]'
          else
            FMExamRequestListbox.Items[y] := Copy(FMDateTimeConvert(Date1) + '                    ', 1, 20) + '    ';
        //Fix single digit date and move over
        if Copy(FMExamRequestListbox.Items[y], 6, 1) = ',' then
          FMExamRequestListbox.Items[y] := Copy(FMExamRequestListbox.Items[y], 1, 4) + ' ' + Copy(FMExamRequestListbox.Items[y], 5, 15) + Copy(FMExamRequestListbox.Items[y], 21, 99);
        if (Date2 <> '') or (Date3 <> '') then
          FMExamRequestListbox.Items.Delete(y);
      end;

    repeat
      Application.ProcessMessages;
    until ContinueCosSearch = True;
    ContinueCosSearch := False;

  end;
  //end;
  frmUncosigned.borderIcons := [biSystemMenu];
  try
  memodocs.setfocus except
  end;
  ButtonSearchClick(Application);
end;

procedure TfrmUncosigned.FormActivate(Sender: TObject);
begin
  frmUncosigned.Height := frmMain.height - 80;
  frmUncosigned.Top := frmMain.Top + (frmMain.Height - frmUncosigned.Height) div 2;
end;

procedure TfrmUncosigned.Button2Click(Sender: TObject);
begin
  ContinueCosSearch := True;
  PanelNoteText.Visible := False;
end;

procedure TfrmUncosigned.Button3Click(Sender: TObject);
var
  x, zz: integer;
  foundflag: boolean;
  OriginalExamInfo: string;
  OKToCloseFlag: Boolean;
  TranscribedFound: Boolean;
begin
  comboBoxExamLocation.ItemIndex := 0;
  foundflag := false;
  ComboBoxReleaseReport.ItemIndex := 0;
  if lstExamsRequested.Items.Count > 0 then
    for x := 0 to lstExamsRequested.Items.Count - 1 do
      if lstExamsRequested.Selected[x] = True then
        FoundFlag := True;
  if foundflag = false then begin
    ShowMessageCAPRI('Please select an exam to complete.');
    exit;
  end;
  if FMExProvider.Text = '' then begin
    ShowMessageCAPRI('Please enter an examining provider name.');
    exit;
  end;
  if ComboBoxExamLocation.ItemIndex = -1 then begin
    ShowMessageCAPRI('Please pick an exam location.');
    exit;
  end;

  /////////////////////////////////////////////////////
  OriginalExamInfo := '';

  for zz := 0 to lstExamsRequested.Items.Count - 1 do begin
    if lstExamsRequested.Selected[zz] = true then begin
      FMMemoAMIEResults.IENS := Piece(lstExamsRequested.Items[zz], '^', 2);
      if originalexaminfo = '' then begin
        // Only put report in first exam type
        QuickCopy(MemoDocs, FMMemoAMIEResults);
        originalexaminfo := Piece(Piece(lstExamsRequested.Items[zz], '^', 1), '[', 1);
      end
      else begin
        // Reference the saved report here
        FMMemoAMIEResults.Lines.clear;
        FMMemoAMIEResults.Lines.add('Please refer to the exam report contained in:');
        FMMemoAMIEResults.Lines.add(originalexaminfo);
      end;
      FMExProvider.IENS := FMMemoAMIEResults.IENS;
      if FMExProvider.FMModified then
        if FMExProvider.Validate then begin
          frmMain.FMFiler1.AddChgdControl(FMExProvider);
          FMExProvider.Text := FMExProvider.FMCtrlExternal;
        end
        else begin
          frmMain.FMValidator1.DisplayErrors;
          FMExProvider.Text := FMExProvider.FMTag;
        end;
      frmMain.FMFiler1.AddChgdControl(FMMemoAMIEResults);
      if ComboBoxReleaseReport.ItemIndex = 0 then begin
        // Set Status
        frmMain.FMValidator1.SetUp('396.4', FMMemoAMIEResults.IENS, '.04', 'C');
        frmMain.FMFiler1.AddFDA('396.4', FMMemoAMIEResults.IENS, '.04', 'C');
        frmMain.FMValidator1.SetUp('396.4', FMMemoAMIEResults.IENS, '75', TIUNoteIEN);
        frmMain.FMFiler1.AddFDA('396.4', FMMemoAMIEResults.IENS, '75', TIUNoteIEN);
      end;
      // Set Location
      frmMain.FMValidator1.SetUp('396.4', FMMemoAMIEResults.IENS, '.09', Copy(ComboBoxExamLocation.Text, 1, 1));
      frmMain.FMFiler1.AddFDA('396.4', FMMemoAMIEResults.IENS, '.09', Copy(ComboBoxExamLocation.Text, 1, 1));
      (*
             // Fee Exam?
             frmMain.FMValidator1.SetUp('396.4',FMMemoAMIEResults.IENS,'.08',Copy(ComboBoxFeeExam.Text,1,1));
             frmMain.FMFiler1.AddFDA('396.4',FMMemoAMIEResults.IENS,'.08',Copy(ComboBoxFeeExam.Text,1,1));
      *)
             // Date of Exam
             //frmMain.FMValidator1.SetUp('396.4',FMMemoAMIEResults.IENS,'.06',FloatToStr(ORDateCombo1.FMDate));
             //frmMain.FMFiler1.AddFDA('396.4',FMMemoAMIEResults.IENS,'.06',FloatToStr(ORDateCombo1.FMDate));
      (*
             // Date Released
             frmMain.RPCBroker1.RemoteProcedure := 'ORWU DT';
             frmMain.RPCBroker1.Param[1].Value := 'NOW';
             frmMain.RPCBroker1.Param[1].PType := literal;
             frmMain.RPCBrokerCall;  try frmMain.RPCBroker1.Call;
               except
             On EBrokerError do begin;  ANURemoteProcedureCallInProgress:=False;
               ShowMessageCAPRI('ORWU DT could not be accessed!');
               application.terminate;
             end; end;
             frmMain.FMValidator1.SetUp('396.4',FMMemoAMIEResults.IENS,'13',frmMain.RPCBroker1.Results[0]);
             frmMain.FMFiler1.AddFDA('396.4',FMMemoAMIEResults.IENS,'13',frmMain.RPCBroker1.Results[0]);
      *)

      if frmMain.FMFiler1.AnythingToFile then
        frmMain.FMFiler1.Update;
    end;

    (*
    if frmMain.FMFiler1.AnythingToFile then
      if frmMain.FMFiler1.DataProblemCheck then
        frmMain.FMFiler1.ProcessDataProblemList
      else
        frmMain.FMFiler1.Update;
  end;
  *)
  end;

  // Do a check and see if it's ok to release the results to the RO
  FMExamRequestListboxClick(Application);
  // Be sure that nothing is still open
  if lstExamsRequested.Items.Count = 0 then begin
    // Check each exam result and be sure it's released prior
    // to releasing the whole request
    OKToCloseFlag := True;
    for x := 0 to lstExamsRequestedHidden.Items.Count - 1 do begin
      // Check if exam should be released but isn't
      if (POS('[OPEN]', lstExamsRequestedHidden.Items[x]) > 0) then
        if (POS('[TRANSFERRED OUT]', lstExamsRequestedHidden.Items[x]) > 0) then
          OKToCloseFlag := False;
    end;

    // Check to be sure ALL existing exams do not have a date transcription complete
    // value - file 396.4, field 90
    // If any have a date, then we don't want to auto release
    TranscribedFound := False;
    if lstExamsRequestedHidden.Items.Count > 0 then
      for x := 0 to lstExamsRequestedHidden.Items.Count - 1 do begin
        FMGetsExamRequestInfo.IENS := Piece(lstExamsRequestedHidden.Items[x], '^', 1);
        FMGetsExamRequestInfo.GetData;
        //ShowmessageCAPRI(FMGetsExamRequestInfo.GetField('90').FMDInternal);
        if FMGetsExamRequestInfo.GetField('90').FMDBExternal <> '' then
          TranscribedFound := True;
      end;

    if (OKToCloseFlag = True) and (transcribedfound = false) then begin
      // Do the release update here
      frmMain.RPCBroker1.RemoteProcedure := 'ORWU DT';
      frmMain.RPCBroker1.Param[1].Value := 'NOW';
      frmMain.RPCBroker1.Param[1].PType := literal;
      frmMain.RPCBrokerCall;
      try
        frmMain.RPCBroker1.Call;
      except
        on EBrokerError do begin
          ANURemoteProcedureCallInProgress := False;
          frmMain.AnimateLogo(False);
          frmMain.StatusBarLoadPt.Caption := 'RPC ORWU DT could not be accessed!';
          frmMain.StatusBarLoadPt.Repaint;
          Application.Processmessages;
          ShowMessageCAPRI('ORWU DT could not be accessed!');
        end;
      end;
      frmMain.FMValidator1.SetUp('396.3', FMExamRequestListbox.GetSelectedRecord.IEN, '6', frmMain.RPCBroker1.Results[0]); //Date completed
      frmMain.FMValidator1.SetUp('396.3', FMExamRequestListbox.GetSelectedRecord.IEN, '13', frmMain.RPCBroker1.Results[0]); // Date released
      frmMain.FMValidator1.SetUp('396.3', FMExamRequestListbox.GetSelectedRecord.IEN, '14', AuthorIEN); // Released by
      // Patch 193 JRL 5/5/16
      // Changed Request Status field to pointer field.  Using IEN to populate
      // status here. Don't validate IEN, it will fail.  
      // frmMain.FMValidator1.Setup('396.3', whichIEN, '17', '4');  // Request Status IEN fails validation, comment out
      if NOT IsPatchInstalled('DVBA*2.7*193') then                               // Patch 193        
        frmMain.FMValidator1.SetUp('396.3', FMExamRequestListbox.GetSelectedRecord.IEN, '17', 'R'); // Patch 193

      frmMain.FMFiler1.AddFDA('396.3', FMExamRequestListbox.GetSelectedRecord.IEN, '6', frmMain.RPCBroker1.Results[0]);
      frmMain.FMFiler1.AddFDA('396.3', FMExamRequestListbox.GetSelectedRecord.IEN, '13', frmMain.RPCBroker1.Results[0]);
      frmMain.FMFiler1.AddFDA('396.3', FMExamRequestListbox.GetSelectedRecord.IEN, '14', AuthorIEN);

      // Patch 193 JRL 5/5/16
      // Changed Request Status field to pointer field.  Using IEN to populate status here. 
      if IsPatchInstalled('DVBA*2.7*193') then 
        frmMain.FMFiler1.AddFDA('396.3', FMExamRequestListbox.GetSelectedRecord.IEN, '17', '4')
      else      
        frmMain.FMFiler1.AddFDA('396.3', FMExamRequestListbox.GetSelectedRecord.IEN, '17', 'R');

      if frmMain.FMFiler1.AnythingToFile then
      begin
        frmMain.FMFiler1.Update;
        //CodeCR266 - rpm 1/18/12 - Send email notification
        frmMain.MailManBuffer.Lines.Clear;
        frmMain.MailManBuffer.Lines.Add('');
        SendNotification(frmMain.MailManBuffer.Lines,
                         AuthorIEN,
                         'CAPRI: Release of 2507 Request',
                         'DVBA C 2507 EXAM READY',
                         FMExamRequestListbox.GetSelectedRecord.IEN);
      end;
    end
    else begin
      ShowMessageCAPRI('Case not ready to be closed.');
    end;
    if TranscribedFound = True then begin
      ShowmessageCAPRI('WARNING:  This exam request appears to contain one or more transcribed exams.  CAPRI will be unable to release it.  Please use AMIE to review and release this exam request.');
    end;
  end;
  frmMain.RPCBrokerCall;
  frmMain.FMFiler1.AddFDA('396.17', FMListBoxTemplates.GetSelectedRecord.IEN, '11', 'C');
  frmMain.RPCBrokerCall;
  sleep(500);
  fmfile;
  /////////////////////////////////////////////////////
  ContinueCosSearch := True;
  PanelNoteText.Visible := False;
end;

procedure TfrmUncosigned.FMExamRequestListboxClick(Sender: TObject);
var
  x: integer;
begin
  if FMExamRequestListBox.ItemIndex = -1 then
    exit;

  // Find Exams
  frmMain.RPCBroker1.Results.Clear;
  frmMain.RPCBroker1.RemoteProcedure := 'DVBAB FIND EXAMS';
  frmMain.RPCBroker1.Param[0].Value := FMExamRequestListbox.GetSelectedRecord.IEN;
  frmMain.RPCBroker1.Param[0].PType := literal;
  frmmain.RPCBrokerCall;
  try
    frmMain.RPCBroker1.Call;
  except
    on EBrokerError do
      ShowMessageCAPRI('RPC DVBAB FIND EXAMS could not be accessed!');
  end;
  lstExamsRequestedHidden.Items := frmMain.RPCBroker1.Results;
  lstExamsRequested.Items.Clear;
  if lstExamsRequestedHidden.Items.Count > 0 then
    for x := 0 to lstExamsRequestedHidden.Items.Count - 1 do begin
      lstExamsRequested.Items.Add(Copy(lstExamsRequestedHidden.Items[x], Pos('^', lstExamsRequestedHidden.Items[x]) + 1, 254) + '                                                                                                           ^' + Piece(lstExamsRequestedHidden.Items[x], '^', 1));
    end;
  if lstExamsRequested.Items.Count > 0 then
    for x := lstExamsRequested.Items.Count - 1 downto 0 do begin
      // Check for text already stored and remove as a choice if text
      // is there due to transcription
      FMMemoAMIEResults.Lines.Clear;
      FMGetsExamInfo.IENS := Piece(lstExamsRequested.Items[x], '^', 2);
      FMGetsExamInfo.GetAndFill;
      if (pos('[OPEN]', lstExamsRequested.Items[x]) = 0) or
        (FMMemoAMIEResults.Lines.Count > 0)
        then
        lstExamsRequested.Items.Delete(x);
    end;
end;

procedure TfrmUncosigned.Button4Click(Sender: TObject);
begin
  if MessageDlgCAPRI('If you mark this template complete, you will need to manually cut/paste in a VistA terminal window if you still wish to copy this document into AMIE.  Are you sure you want to mark this template complete?',
    mtConfirmation, [mbYes, mbNo], 0) = mrYes then begin
    // Do something here...
    frmMain.FMFiler1.AddFDA('396.17', FMListBoxTemplates.GetSelectedRecord.IEN, '11', 'C'); 
    frmMain.FMFiler1.Update
  end;
  ContinueCosSearch := True;
  PanelNoteText.Visible := False;
end;

procedure TfrmUncosigned.FMExProviderKeyPress(Sender: TObject;
  var Key: Char);
begin
  if Key = '^' then
    Key := char(0);
end;

procedure TfrmUncosigned.FMExProviderExit(Sender: TObject);
begin
  FMExProvider.Text := Uppercase(FMExProvider.Text);
end;

procedure TfrmUncosigned.FMListBoxTemplatesDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
  TempText: string;
begin
  inherited;
  with (Control as TFMListBox).Canvas do { draw on control canvas, not on the form } begin
    Font.Color := clRed; {Set to default color}
    TempText := (Control as TFMListBox).Items[Index];
    if Copy((Control as TFMListBox).Items[Index], 1, 1) = '*' then begin
      Font.Color := clWindowText; {Change color to show unsigned}
      TempText := Copy((Control as TFMListBox).Items[Index], 2, Length((Control as TFMListBox).Items[Index]) - 1);
      TempText := 'READY: ' + TempText;
    end;
    Brush.Color := clwindow;
    if state = [odSelected, odFocused] then
      Brush.Color := clBtnFace;
    FillRect(Rect); { clear the rectangle }
    TextOut(Rect.Left, Rect.Top, TempText); { display the text }
  end;
end;

procedure TfrmUncosigned.FMListBoxTemplatesClick(Sender: TObject);
begin
  if Copy(FMListBoxTemplates.Items[FMListBoxTemplates.ItemIndex], 1, 1) = '*' then
    button1.enabled := true
  else
    button1.enabled := false;
end;

procedure TfrmUncosigned.FMListBoxTemplatesDblClick(Sender: TObject);
begin
  if Button1.Enabled = True then
    Button1Click(Application);
end;

end.
