unit wait;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  DialogsCAPRI,
  Dialogs,
  ExtCtrls,
  ComCtrls,
  StdCtrls,
  Gauges;

type
  TWaitForm = class(TForm)
    Label1: TLabel;
    Animate1: TAnimate;
    Shape1: TShape;
    Shape2: TShape;
    Gauge1: TGauge;
    StaticText1: TStaticText;
    ImageDisk: TImage;
    ImageNetwork: TImage;
    procedure FormDestroy(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormHide(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  WaitForm: TWaitForm;

implementation

uses main;

{$R *.DFM}

procedure TWaitForm.FormDestroy(Sender: TObject);
begin
  ContextorChangeMessage := '';
  CCOWBreakLink := False;
end;

procedure TWaitForm.FormActivate(Sender: TObject);
begin
  // Something's going on that's critical, so don't allow shut-down on
  // patient context change.
  ContextorChangeMessage := 'The application is performing a critical function.  If you continue before it finishes, CAPRI will drop out of the clinical context.';
  CCOWBreakLink := True;
end;

procedure TWaitForm.FormHide(Sender: TObject);
begin
  ContextorChangeMessage := '';
  CCOWBreakLink := False;
end;

end.
